SystemOrganization addCategory: #Spirit!
SystemOrganization addCategory: #'Spirit-Core'!
SystemOrganization addCategory: #'Spirit-HistoryAnalyzer'!
SystemOrganization addCategory: #'Spirit-HotSpotsIdentifier'!
SystemOrganization addCategory: #'Spirit-Tests'!
SystemOrganization addCategory: #'Spirit-UI'!
SystemOrganization addCategory: #'Spirit-Util'!

WizardControl subclass: #HeatMapWizard
	instanceVariableNames: 'mooseModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!HeatMapWizard methodsFor: 'wizard' stamp: 'SantiagoVidal 6/13/2012 11:04'!
openWizard: aMooseModel
	|firstPane radioButtonsPart|
	mooseModel:=aMooseModel.
	"wizard := WizardControl new."
	self renderer: MerlinMorphicWizardRenderer new.
	firstPane:=WizardSinglePane new.
	
	
	radioButtonsPart := RadioButtonsPart  new inGroupboxNamed: 'Select how to create the heat map';
							options: {#'Using # of hot spots by packages                                                               '. #'Using # of hot spots by packages + affected external components            '}";
							callback: [ :returnedValue |
								selectedImportingMethod:=returnedValue.
								self removeExtraPanesAfter: 1.
								self createSecondPane.
							]".
	
	firstPane row: radioButtonsPart associatedTo: #optionSelected.
	self addPane: firstPane.
	"self createSecondPane."
	self open.! !

!HeatMapWizard methodsFor: 'wizard' stamp: 'SantiagoVidal 6/18/2012 10:53'!
performTerminateButtonAction
	"|view|"
	|objectToTransfer|
	objectToTransfer:=OrderedCollection new.
	super performTerminateButtonAction.
	
	"(mooseModel hotSpotsDetected =nil) ifTrue:[mooseModel detectHotSpots].
	view := ROMondrianViewBuilder new."
	objectToTransfer add:(mooseModel selection).
	((self wizardInformations at: #optionSelected)=#'Using # of hot spots by packages                                                               ') ifTrue:[
		objectToTransfer add:HeatMap.
		(mooseModel pane port: #heatMapSelection) value: objectToTransfer.
		"|hm|
		hm:=(HeatMap new).
		hm mooseModel: mooseModel.
		hm createVisualizationIn:view."
		
		] 
	ifFalse:[
		objectToTransfer add: HeatMapWithAffectedComponents.
		(mooseModel pane port: #heatMapSelection) value: objectToTransfer.
		"|hm|
		hm:=(HeatMapWithAffectedComponents new).
		hm mooseModel: mooseModel.
		hm createVisualizationIn:view"
	].
	"view open."
	! !

WizardControl subclass: #HismoImporter
	instanceVariableNames: 'versions selectedDirectory selectedImportingMethod selectedSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!HismoImporter methodsFor: 'GoferImporter' stamp: 'SantiagoVidal 2/15/2012 10:21'!
createGoferImporter
	|pane listPartPart|
	pane:=WizardMiddlePane new.
	listPartPart:=ListPart  new
									inGroupboxNamed: 'Select a project';
									list: #('System 1' 'System 2' 'System 3' 'System 4');
									defaultValue: 1;
									callback: [ :returnedValue | 
										selectedSystem := returnedValue.
										self createGoferImporterLastPane 
									];
									"useLatePopulateContents: false;"
									yourself.
	pane row: listPartPart.
	self addPane:pane.! !

!HismoImporter methodsFor: 'GoferImporter' stamp: 'SantiagoVidal 2/15/2012 10:18'!
createGoferImporterLastPane
	|pane hismoNamePart selectedVersionsPart|
	pane := WizardLastPane new.
	
	hismoNamePart := TextFieldPart new 
		inGroupboxNamed: 'Type the name of the Hismo model'.
	
	selectedVersionsPart := MultiSelectionItemSelectorPart new
		inGroupboxNamed: 'Select the MSEs';
		initialList: #('1.0' '1.5' '2.0');
		yourself.
	
	pane addPart: hismoNamePart associatedTo: #hismoModelName.
	pane addPart: selectedVersionsPart associatedTo: #selectedVersions.
	self addPane:pane.! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 4/9/2012 11:21'!
createHismoModel
	|hismo|
	MooseModel root allModelHistories do:[:aHismoModel|
		(aHismoModel name =self hismoModelName) ifTrue:[^aHismoModel].
	].
	hismo:=HismoModelHistory new.
	hismo name: self hismoModelName.
	hismo install.
	^hismo.! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 4/13/2012 16:23'!
createHismoModelFromMSE:selectedVersions orderedKeys: keys
	|hismoModel|
	"versions is a dictionary with version name and version fullName"
	
	hismoModel := self createHismoModel.
	
	keys do: [ :aVersion |
		
		| stream mooseModel importingContext|
		
		stream := StandardFileStream readOnlyFileNamed: (selectedVersions at: aVersion).
		importingContext:=self importingContext.
		importingContext ifNotNil: [ 
			
			mooseModel :=MooseModel new importFromMSEStream: stream withImportingContext:"filteredBy: "importingContext. 
			self loadUnimportedMetrics: stream refinedModel: mooseModel.
			 ] ifNil:[
			mooseModel := MooseModel new importFromMSEStream: stream.
			
			].
		
		mooseModel name: aVersion.
		hismoModel addLastVersionForMooseModel: mooseModel ].
	
	
	
	^ hismoModel! !

!HismoImporter methodsFor: 'MoosePanelImporter' stamp: 'SantiagoVidal 2/8/2012 14:41'!
createHismoModelFromMooseModels:models
	|hismoModel|
	
	hismoModel := HismoModelHistory new.
	
	models do:[:model|
		hismoModel addLastVersionForMooseModel: model.			
	].
	hismoModel name: self hismoModelName.
	hismoModel install.
	^ hismoModel! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 3/20/2012 15:20'!
createMSEImporter
	|pane hismoNamePart directoryPart|
	pane:=WizardMiddlePane new.
	hismoNamePart := TextFieldPart new 
		inGroupboxNamed: 'Type the name of the Hismo model'.

	directoryPart := DirectoryChoosePart new 
		inGroupboxNamed: 'Select the directory with the MSE files';
		callback: [ :returnedValue | 
			selectedDirectory := returnedValue.
			self createMSEImporterMiddlePane ];
		yourself.

	pane addPart: hismoNamePart associatedTo: #hismoModelName.
	pane row: directoryPart.
	self addPane:pane.! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 4/8/2012 19:02'!
createMSEImporterLastPane
	|pane selectedVersionsPart versionsSorted|
	versions := ((selectedDirectory matchingEntries: '*.mse') 
		collect: [ :each | each name -> each fullName ] ) asDictionary.
	
	versionsSorted := SortedCollection sortBlock: [:c1 :c2 | ((c1 subStrings:'.' )at:1)asInteger <= ((c2 subStrings:'.' )at:1)asInteger].
	versionsSorted addAll: versions keys.
	
	
	pane := WizardLastPane new.
	selectedVersionsPart := MultiSelectionItemSelectorPart new
		inGroupboxNamed: 'Select the MSEs';
		initialList: versionsSorted;
		yourself.
	
	pane addPart: selectedVersionsPart associatedTo: #selectedVersions.
	self addPane:pane.! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 3/20/2012 16:19'!
createMSEImporterMiddlePane
	|pane useFilterPart|
	
		
	pane := WizardMiddlePane new.
	
	useFilterPart := MultiCheckboxesPart  new
		inGroupboxNamed: 'Import entities using a filter?';
		labels: #('use filter');
		deselectAllOptions;
		callback: [ :outputValue |
			self setFilterPartForPane: pane whenFilterIsSelected: outputValue value.];
		yourself.
		
	pane addPart: useFilterPart associatedTo: #useFilter.
	self addPane:pane.
	self createMSEImporterLastPane.! !

!HismoImporter methodsFor: 'MoosePanelImporter' stamp: 'SantiagoVidal 2/8/2012 14:20'!
createMoosePanelImporter
	|pane hismoNamePart selectedModelsPart|
	pane := WizardLastPane new.
	hismoNamePart := TextFieldPart new 
		inGroupboxNamed: 'Type the name of the Hismo model'.
	selectedModelsPart := MultiSelectionItemSelectorPart new
		inGroupboxNamed: 'Select the MSEs';
		initialList: (MooseModel root allModels collect: [ :each | each name ] );
		yourself.
	
	pane addPart: hismoNamePart associatedTo: #hismoModelName.
	pane row: selectedModelsPart associatedTo: #selectedModels.
	self addPane:pane.! !

!HismoImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/15/2012 10:20'!
createSecondPane
	
	(selectedImportingMethod =#'Repository(Gofer)            ') 
		ifTrue:[self createGoferImporter.]
		ifFalse:[
			(selectedImportingMethod =#'Models from Moose Panel')
				ifTrue:[self createMoosePanelImporter.]
				ifFalse:[self createMSEImporter.].
		]! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 2/7/2012 13:48'!
fullNameForVersion: aVersion

	^ versions at: aVersion! !

!HismoImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/7/2012 13:27'!
hismoModelName

	| hismoModelName |
	
	hismoModelName := wizardInformations at: #hismoModelName.
	hismoModelName isEmptyOrNil ifTrue: [^ 'HismoModel'].
	^ hismoModelName! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 4/3/2012 14:34'!
importingContext

	| importingContext contextSelected useFilter |
	
	useFilter := wizardInformations at: #useFilter.
	useFilter first value ifFalse: [^ nil ].
	
	contextSelected := (wizardInformations at: #contextSelected) 
		select: [ :each | each value = true ] thenCollect: [ :each | each key asSymbol ].
	
	importingContext := FAMIXStandardImportingContext new.
	importingContext importAll: contextSelected.
	^ importingContext! !

!HismoImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/7/2012 13:35'!
initialize
	
	super initialize.
	
	selectedDirectory := FileDirectory default.
	selectedImportingMethod:='MSE Files                         '.! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 4/9/2012 14:44'!
loadUnimportedMetrics: stream refinedModel: aMooseModel
	|mooseModelAux|
	mooseModelAux := MooseModel new importFromMSEStream: (StandardFileStream readOnlyFileNamed: (stream name)).
	mooseModelAux allClasses do:[:aClass|
		|refinedClass LOC|
		refinedClass:=(aMooseModel allClasses select:[:each| each name=aClass name]) at:1.
		LOC:=aClass numberOfLinesOfCode.
		refinedClass numberOfLinesOfCode: LOC.
		
	].
	Smalltalk garbageCollect.! !

!HismoImporter methodsFor: 'MoosePanelImporter' stamp: 'SantiagoVidal 2/8/2012 14:30'!
mooseModelWithName: modelName
	MooseModel root allModels do:[:model| 
		(model name =modelName)ifTrue:[
			^model.	
		]
	].! !

!HismoImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/15/2012 10:32'!
openWizard
	|firstPane radioButtonsPart|
	"wizard := WizardControl new."
	self renderer: MerlinMorphicWizardRenderer new.
	firstPane:=WizardFirstPane new.
	
	
	radioButtonsPart := RadioButtonsPart  new inGroupboxNamed: 'Select how to import the Hismo model';
							options: {#'MSE Files                         '. #'Repository(Gofer)            '. #'Models from Moose Panel'};
							callback: [ :returnedValue |
								selectedImportingMethod:=returnedValue.
								self removeExtraPanesAfter: 1.
								self createSecondPane.
							].
	
	firstPane row: radioButtonsPart "associatedTo: #optionSelected".
	self addPane: firstPane.
	self createSecondPane.
	self open.! !

!HismoImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/26/2012 16:31'!
performTerminateButtonAction
	
	super performTerminateButtonAction.
	
	(selectedImportingMethod =#'Monticello                        ') 
		ifTrue:[self terminateGoferImporter.]
		ifFalse:[
			(selectedImportingMethod =#'Models from Moose Panel')
				ifTrue:[self terminateMoosePanelImporter]
				ifFalse:[self terminateMSEImporter.].
		].! !

!HismoImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/8/2012 13:47'!
removeExtraPanesAfter:aNumber
	[self wizardPanes size > aNumber] whileTrue: [
		self removePaneAt: (self wizardPanes size).
	].! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 3/20/2012 16:02'!
setFilterPartForPane: wizardPane whenFilterIsSelected: filterIsSelected

	| filterPart |
	
	wizardPane removeSubComponentAt: 2.
	filterIsSelected
		ifTrue: [
			"TODO: use MultiDependentCheckboxesPart. For now, the FAMIXStandardImportingContext new entityDependencies is not OK (wrong dependencies).
			Fix and use labelsAndDependencies: 'FAMIXStandardImportingContext new entityDependencies''"
			filterPart := MultiCheckboxesPart new 
			inGroupboxNamed: 'Select the entities to be imported';
			labels: FAMIXStandardImportingContext new entityDependencies keys.
			wizardPane addPart: filterPart associatedTo: #contextSelected].
	wizardPane refresh.! !

!HismoImporter methodsFor: 'GoferImporter' stamp: 'SantiagoVidal 2/15/2012 10:22'!
terminateGoferImporter! !

!HismoImporter methodsFor: 'MSEImporter' stamp: 'SantiagoVidal 4/8/2012 19:16'!
terminateMSEImporter
	| selectedVersions versionsSelected mooseModels|
	
	selectedVersions := SortedCollection sortBlock: [:c1 :c2 | ((c1 subStrings:'.' )at:1)asInteger <= ((c2 subStrings:'.' )at:1)asInteger].
	selectedVersions addAll: (self wizardInformations at: #selectedVersions).
	
	versionsSelected:=(selectedVersions collect: [ :each | each -> (self fullNameForVersion: each)]) asDictionary.
	
	self createHismoModelFromMSE: versionsSelected orderedKeys:selectedVersions.
	"versionsSelected keys do:[:file|
		self halt.
		mooseModels add: (self createMooseModelFromMSE: (versionsSelected at: file)).
	]."! !

!HismoImporter methodsFor: 'MoosePanelImporter' stamp: 'SantiagoVidal 2/8/2012 14:43'!
terminateMoosePanelImporter
	| selectedModels modelsSelected mooseModels|
	selectedModels := self wizardInformations at: #selectedModels.
	modelsSelected:=(selectedModels collect: [ :each | self mooseModelWithName: each."MooseModel root model: "]).
	
	self createHismoModelFromMooseModels: modelsSelected.
	"versionsSelected keys do:[:file|
		self halt.
		mooseModels add: (self createMooseModelFromMSE: (versionsSelected at: file)).
	]."! !

WizardControl subclass: #LogicalArchitecture
	instanceVariableNames: 'mooseModel showDependencies usedView edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

LogicalArchitecture subclass: #HeatMap
	instanceVariableNames: 'occurrencesByPackage codeSmellsToVisualize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 09:37'!
codeSmellsToVisualize
	^codeSmellsToVisualize! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 09:37'!
codeSmellsToVisualize: aCollection
	codeSmellsToVisualize:=aCollection.! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 11:11'!
createVisualizationIn: view
	(mooseModel hotSpotsDetected =nil) ifTrue:[mooseModel detectHotSpots].
	occurrencesByPackage:=IdentityDictionary new.
	self updateOccurrencesByPackages: mooseModel hotSpotsDetected.
	"view := ROMondrianViewBuilder new."
	self visualizeLogicalArchitectureIn:view.
	"view open."
	! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 18:04'!
getColorForPackage: aPackage
	|totalHotSpotsForThePackage max gAndB|
	totalHotSpotsForThePackage:=occurrencesByPackage at:aPackage ifAbsent:[^Color r:1.0 g:1.0 b:1.0].
	(totalHotSpotsForThePackage==0) ifTrue:[^Color r:1.0 g:1.0 b:1.0].
	max:=occurrencesByPackage values "max" sum.
	gAndB:=(((totalHotSpotsForThePackage*100)/max)-100)abs.
	^Color r:1.0 g:gAndB b:gAndB! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 10:59'!
initialize
	super initialize.
	codeSmellsToVisualize:=OrderedCollection new.
	codeSmellsToVisualize add: BrainClass.
		codeSmellsToVisualize add: BrainMethod.
		codeSmellsToVisualize add: DataClass.
		codeSmellsToVisualize add: DispersedCoupling.
		codeSmellsToVisualize add: FeatureEnvy.
		codeSmellsToVisualize add: GodClass.
		codeSmellsToVisualize add: IntensiveCoupling.
		codeSmellsToVisualize add: RefusedParentRequest.
		codeSmellsToVisualize add: ShotgunSurgery.
		codeSmellsToVisualize add: TraditionBreaker.! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 09:34'!
updateColors
	"usedView edges do: #remove."
	"usedView nodes do: #remove."
	occurrencesByPackage:=IdentityDictionary new.
	"self halt."
	self updateOccurrencesByPackages: mooseModel hotSpotsDetected.
	self updateTheColorsOfNodes: (usedView nodes).
	
	
	
	
	"self createVisualizationIn: usedView."
	
	
	usedView raw signalUpdate.! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 10:27'!
updateOccurrencesByPackages: hotSpotsDetectedDictionary
	hotSpotsDetectedDictionary keys do:[:anEntity|
		(hotSpotsDetectedDictionary at: anEntity) do:[:aHotSpotInstance|
			(codeSmellsToVisualize includes: (aHotSpotInstance kind)) ifTrue:[
				self updateOcurrencesForEntity: (aHotSpotInstance famixEntity) valueToAdd: (1.0).
			]
			
		]
		
	].! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 19:37'!
updateOcurrencesForEntity: anEntity valueToAdd: additionValue
	(anEntity isMethod) ifTrue:[
			occurrencesByPackage at: (anEntity parentType container) put: ((occurrencesByPackage at:(anEntity parentType container) ifAbsentPut:0.0)+additionValue).
			
		] ifFalse:[
			(anEntity isClass) ifTrue:[
				
				occurrencesByPackage at: (anEntity container) put: ((occurrencesByPackage at:(anEntity container) ifAbsentPut:0.0)+additionValue).
				
			]]! !

!HeatMap methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/16/2012 16:56'!
updateTheColorsOfNodes: nodes

	nodes do:[:aNode|
		"aNode shape rectangle fillColor: [ :cls | self getColorForPackage: cls ].
		self halt.	"
			|color|
			color:=self getColorForPackage:(aNode model).
			(aNode shapes at:1) color: (color).
			aNode signalUpdate.
			self updateTheColorsOfNodes: (aNode elements)
	].! !

HeatMap subclass: #HeatMapWithAffectedComponents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!HeatMapWithAffectedComponents methodsFor: 'wizard' stamp: 'SantiagoVidal 6/13/2012 11:14'!
createVisualizationIn: view

	occurrencesByPackage:=IdentityDictionary new.
	self updateOccurrencesByPackages: mooseModel hotSpotsDetected.
	self updateOcurrencesByAffectedComponents: mooseModel hotSpotsDetected.

	self visualizeLogicalArchitectureIn:view.

	! !

!HeatMapWithAffectedComponents methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 10:52'!
updateOcurrencesByAffectedComponents: hotSpotsDetectedDictionary
	hotSpotsDetectedDictionary keys do:[:anEntity|
		(hotSpotsDetectedDictionary at: anEntity) do:[:aHotSpotInstance|
			(codeSmellsToVisualize includes: (aHotSpotInstance kind)) ifTrue:[
				aHotSpotInstance entitiesAffected do:[:affectedEntity|
					self updateOcurrencesForEntity: (affectedEntity) valueToAdd: (0.5).
			
				]
			]
			"(aHotSpotInstance famixEntity isMethod) ifTrue:[
			occurrencesByPackage at: (aHotSpotInstance famixEntity parentType container) put: ((occurrencesByPackage at:(aHotSpotInstance famixEntity parentType container) ifAbsentPut:0.0)+1.0).
			
		] ifFalse:[
			(aHotSpotInstance famixEntity isClass) ifTrue:[
				
				occurrencesByPackage at: (aHotSpotInstance famixEntity container) put: ((occurrencesByPackage at:(aHotSpotInstance famixEntity container) ifAbsentPut:0.0)+1.0).
				
			]
		]"
		]
		
	].! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 18:32'!
addEdgesRecursevely: nodes in: view
	nodes do:[:aNode|
		|invocations|
		invocations:=aNode model invokedNamespaces select:[:a|a isStub not].
		invocations do:[:anInvokedPackage|
			|edgeAux|
			view shape line color: Color black.
			edgeAux:=view edgeFromAssociation: aNode model -> anInvokedPackage.
			(edgeAux =nil) ifFalse: [
				edges add:(edgeAux).
			].
		].
		self addEdgesRecursevely: (aNode elementsCollect: [:anElement| anElement ]) in: view
	].! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/6/2012 09:15'!
addNodesRecursevely: packages in: view
	|packages2|
	packages2:=self removePackagesWithoutClasses: packages.
	
	view shape rectangle fillColor: [ :cls | self getColorForPackage: cls ];
	popupText:[ :v | (v class == 'ab' class) ifTrue: [ v ] ifFalse: [ String streamContents: [:s | v printName: s] ] ].
	
	
	
	view nodes: packages2 forEach: [ :aPackage |
		self addNodesRecursevely: aPackage children in: view.
	].
	view gridLayout.
	! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/6/2012 09:15'!
getColorForPackage: aPackage
	^Color white.! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 18:29'!
initialize
	super initialize.
	showDependencies:=true.
	edges:=OrderedCollection new.! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/8/2012 11:18'!
mooseModel: aMooseModel
	mooseModel:=aMooseModel.! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/6/2012 09:16'!
removePackagesWithoutClasses: packages
	|newPackages|
	
	newPackages:=OrderedCollection new.
	
	packages do:[:aPackage|			
		(aPackage classes size >0 "or:[aPackage children size>1]") ifTrue: [newPackages add:aPackage] 
		ifFalse: [
			newPackages addAll:(self removePackagesWithoutClasses: ((OrderedCollection new) add:(aPackage children))).
		]
	].
	
	^newPackages.! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 09:35'!
showHideDependencies
	showDependencies ifTrue: [
		usedView raw addAll: edges.
		usedView raw signalUpdate.
	] ifFalse: [
		usedView edges do: #remove.
		usedView raw signalUpdate.
	].! !

!LogicalArchitecture methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 09:33'!
visualizeLogicalArchitectureIn: view
	|parentPackages thePackages|
	"self halt."
	usedView:=view.
	thePackages:=(mooseModel allNamespaces select: [:each | each isStub not]).
	

	parentPackages:=((thePackages flatCollectAsSet: #withAllParentScopes)select:[:aNameSpace| aNameSpace parentScope=nil]) asOrderedCollection.
	self addNodesRecursevely: parentPackages in: view.
	

	(showDependencies) ifTrue:[
		self addEdgesRecursevely: view nodes in: view.
	].
	"view edgeFromAssociation: 'begining' -> 'ending'."
	
	
	
	"ROEaselMorphic new populateMenuOn: view."
	view addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].
	view addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].
	
	view addMenu: 'Show/Hide Dependencies' callBack: [ showDependencies:=(showDependencies not). 
	self showHideDependencies]. "Falta abrir el view"
	"We also do a small scrolling to not have the buttons over the nodes"
	view raw translateBy: 0 @ 30.
! !

MooseModel subclass: #SpiritModel
	instanceVariableNames: 'hotSpotsDetected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!SpiritModel methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 09:33'!
detectHotSpots
	|aDictionary|
	aDictionary:=SPAnalizer new analyseMooseModel: self.
	self hotSpotsDetected: aDictionary.! !

!SpiritModel methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 09:31'!
hotSpotsDetected
	^hotSpotsDetected! !

!SpiritModel methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 09:31'!
hotSpotsDetected: aDictionary
	hotSpotsDetected:=aDictionary! !

!SpiritModel methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 18:37'!
initialize
	super initialize.
	hotSpotsDetected:=nil.! !

TestCase subclass: #ObtainingAllModelClassesHistoriesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Tests'!

!ObtainingAllModelClassesHistoriesTest methodsFor: 'utils' stamp: 'SantiagoVidal 9/30/2011 11:22'!
mondrianSampleModel
^
'(
	(FAMIX.Comment (id: 1)
		(container (ref: 2))
		(content ''"Iterate over all the incoming and outgoing edges of myself"''))
	(FAMIX.Access (id: 3)
		(accessor (ref: 4))
		(sourceAnchor (ref: 5))
		(variable (ref: 6)))
	(FAMIX.Access (id: 7)
		(accessor (ref: 8))
		(sourceAnchor (ref: 9))
		(variable (ref: 10)))
	(FAMIX.Invocation (id: 11)
		(receiver (ref: 12))
		(sender (ref: 13))
		(signature ''topLeft()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 15)
		(accessor (ref: 16))
		(sourceAnchor (ref: 17))
		(variable (ref: 18)))
	(FAMIX.Access (id: 19)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 22)))
	(FAMIX.Access (id: 23)
		(accessor (ref: 24))
		(sourceAnchor (ref: 25))
		(variable (ref: 26)))
	(FAMIX.Invocation (id: 27)
		(receiver (ref: 28))
		(sender (ref: 29))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 30)))
	(FAMIX.Invocation (id: 31)
		(sender (ref: 32))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 34)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 37)))
	(FAMIX.Reference (id: 38)
		(source (ref: 39))
		(sourceAnchor (ref: 40))
		(target (ref: 41)))
	(FAMIX.Parameter (id: 42)
		(name ''anEdge'')
		(parentBehaviouralEntity (ref: 43)))
	(FAMIX.Method (id: 44)
		(name ''fromPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''fromPositions:'')
		(sourceAnchor (ref: 46)))
	(FAMIX.Access (id: 47)
		(accessor (ref: 48))
		(isWrite true)
		(sourceAnchor (ref: 49))
		(variable (ref: 50)))
	(FAMIX.Access (id: 51)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 52)))
	(FAMIX.Comment (id: 53)
		(container (ref: 54))
		(content ''"This method should be used to change the shape of myself.
	This method takes care of updating the cache"''))
	(FAMIX.Access (id: 55)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 56)))
	(FAMIX.Method (id: 57)
		(name ''clear'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''clear'')
		(sourceAnchor (ref: 59)))
	(FAMIX.Access (id: 60)
		(accessor (ref: 61))
		(sourceAnchor (ref: 62))
		(variable (ref: 63)))
	(FAMIX.Access (id: 64)
		(accessor (ref: 65))
		(sourceAnchor (ref: 66))
		(variable (ref: 67)))
	(FAMIX.LocalVariable (id: 68)
		(name ''each'')
		(parentBehaviouralEntity (ref: 69)))
	(FAMIX.Access (id: 70)
		(accessor (ref: 71))
		(isWrite true)
		(sourceAnchor (ref: 72))
		(variable (ref: 73)))
	(FAMIX.Invocation (id: 74)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''yellow()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 78)
		(receiver (ref: 79))
		(sender (ref: 80))
		(signature ''resetDefaults()'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Invocation (id: 82)
		(receiver (ref: 83))
		(sender (ref: 84))
		(signature ''deselect()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 86)
		(receiver (ref: 87))
		(sender (ref: 88))
		(signature ''bounds()'')
		(sourceAnchor (ref: 89)))
	(FAMIX.Reference (id: 90)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 94)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 97)))
	(FAMIX.Invocation (id: 98)
		(sender (ref: 99))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Access (id: 101)
		(accessor (ref: 102))
		(sourceAnchor (ref: 103))
		(variable (ref: 104)))
	(FAMIX.Parameter (id: 105)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 106)))
	(FAMIX.Invocation (id: 107)
		(receiver (ref: 41))
		(sender (ref: 108))
		(signature ''new()'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Access (id: 110)
		(accessor (ref: 111))
		(isWrite true)
		(sourceAnchor (ref: 112))
		(variable (ref: 113)))
	(FAMIX.Comment (id: 114)
		(container (ref: 69))
		(content ''"Layout the receiver and all its children."''))
	(FAMIX.Invocation (id: 115)
		(sender (ref: 116))
		(signature ''&(Object)'')
		(sourceAnchor (ref: 117)))
	(FAMIX.Comment (id: 118)
		(container (ref: 13))
		(content ''"self shapeBounds at: self shape put: newBounds."''))
	(FAMIX.Access (id: 119)
		(accessor (ref: 120))
		(sourceAnchor (ref: 121))
		(variable (ref: 122)))
	(FAMIX.Access (id: 123)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 126)))
	(FAMIX.Access (id: 127)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 130)))
	(FAMIX.Method (id: 65)
		(name ''selectionBoxCorner1'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''selectionBoxCorner1'')
		(sourceAnchor (ref: 66)))
	(FAMIX.Invocation (id: 132)
		(sender (ref: 13))
		(signature ''asInteger()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Class (id: 133)
		(name ''SortedCollection class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 134)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Parameter (id: 135)
		(name ''aStream'')
		(parentBehaviouralEntity (ref: 136)))
	(FAMIX.Access (id: 137)
		(accessor (ref: 138))
		(sourceAnchor (ref: 139))
		(variable (ref: 140)))
	(FAMIX.Access (id: 141)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 142)))
	(FAMIX.Invocation (id: 143)
		(sender (ref: 48))
		(signature ''resetElementsToDisplayCacheRecursively()'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Invocation (id: 144)
		(sender (ref: 145))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Invocation (id: 147)
		(receiver (ref: 148))
		(sender (ref: 149))
		(signature ''copyFrom:(Object)'')
		(sourceAnchor (ref: 150)))
	(FAMIX.Reference (id: 151)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 152)
		(receiver (ref: 153))
		(sender (ref: 154))
		(signature ''nodes:using:(Object,Object)'')
		(sourceAnchor (ref: 155)))
	(FAMIX.Invocation (id: 156)
		(receiver (ref: 148))
		(sender (ref: 149))
		(signature ''shallowCopy()'')
		(sourceAnchor (ref: 150)))
	(FAMIX.Invocation (id: 157)
		(receiver (ref: 158))
		(sender (ref: 159))
		(signature ''propertyValueAt:(Object)'')
		(sourceAnchor (ref: 160)))
	(FAMIX.Access (id: 161)
		(accessor (ref: 162))
		(sourceAnchor (ref: 163))
		(variable (ref: 164)))
	(FAMIX.Access (id: 165)
		(accessor (ref: 166))
		(sourceAnchor (ref: 167))
		(variable (ref: 168)))
	(FAMIX.Method (id: 169)
		(name ''fromPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''fromPositions:'')
		(sourceAnchor (ref: 171)))
	(FAMIX.Access (id: 172)
		(accessor (ref: 173))
		(sourceAnchor (ref: 174))
		(variable (ref: 175)))
	(FAMIX.Access (id: 176)
		(accessor (ref: 177))
		(sourceAnchor (ref: 178))
		(variable (ref: 179)))
	(FAMIX.Invocation (id: 180)
		(receiver (ref: 181))
		(sender (ref: 182))
		(signature ''isRoot()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Invocation (id: 184)
		(receiver (ref: 185))
		(sender (ref: 186))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 187)))
	(FAMIX.LocalVariable (id: 188)
		(name ''node'')
		(parentBehaviouralEntity (ref: 189)))
	(FAMIX.Invocation (id: 190)
		(receiver (ref: 191))
		(sender (ref: 192))
		(signature ''incomingEdges()'')
		(sourceAnchor (ref: 193)))
	(FAMIX.Invocation (id: 194)
		(sender (ref: 84))
		(signature ''shouldDeselect()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Method (id: 195)
		(name ''defaultNodeShapeClass'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 10)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''defaultNodeShapeClass'')
		(sourceAnchor (ref: 197)))
	(FAMIX.Invocation (id: 198)
		(receiver (ref: 199))
		(sender (ref: 200))
		(signature ''model()'')
		(sourceAnchor (ref: 201)))
	(FAMIX.Invocation (id: 202)
		(receiver (ref: 203))
		(sender (ref: 204))
		(signature ''root()'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Access (id: 206)
		(accessor (ref: 207))
		(isWrite true)
		(sourceAnchor (ref: 208))
		(variable (ref: 209)))
	(FAMIX.Invocation (id: 210)
		(receiver (ref: 211))
		(sender (ref: 212))
		(signature ''new()'')
		(sourceAnchor (ref: 213)))
	(FAMIX.Invocation (id: 214)
		(sender (ref: 215))
		(signature ''height()'')
		(sourceAnchor (ref: 216)))
	(FAMIX.Access (id: 217)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 218)))
	(FAMIX.Invocation (id: 219)
		(receiver (ref: 220))
		(sender (ref: 221))
		(signature ''zOrder()'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Access (id: 223)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 226)))
	(FAMIX.Invocation (id: 227)
		(sender (ref: 39))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 228)
		(accessor (ref: 229))
		(sourceAnchor (ref: 230))
		(variable (ref: 231)))
	(FAMIX.Method (id: 232)
		(name ''withAllNodesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''withAllNodesDo:'')
		(sourceAnchor (ref: 234)))
	(FAMIX.Invocation (id: 235)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 236)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 239)))
	(FAMIX.Comment (id: 240)
		(container (ref: 84))
		(content ''"this subscription is triggered by updateWindow"''))
	(FAMIX.Invocation (id: 241)
		(receiver (ref: 242))
		(sender (ref: 243))
		(signature ''deselect()'')
		(sourceAnchor (ref: 244)))
	(FAMIX.Method (id: 61)
		(name ''numberOfCacheKeys'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''numberOfCacheKeys'')
		(sourceAnchor (ref: 62)))
	(FAMIX.Access (id: 245)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 246)))
	(FAMIX.Access (id: 247)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Parameter (id: 251)
		(name ''aNumber'')
		(parentBehaviouralEntity (ref: 252)))
	(FAMIX.Method (id: 253)
		(name ''defaultNodeShapeClass'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''defaultNodeShapeClass'')
		(sourceAnchor (ref: 254)))
	(FAMIX.Access (id: 255)
		(accessor (ref: 256))
		(sourceAnchor (ref: 257))
		(variable (ref: 258)))
	(FAMIX.Invocation (id: 259)
		(sender (ref: 260))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Invocation (id: 262)
		(receiver (ref: 263))
		(sender (ref: 264))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 265)))
	(FAMIX.Invocation (id: 266)
		(receiver (ref: 267))
		(sender (ref: 268))
		(signature ''new()'')
		(sourceAnchor (ref: 269)))
	(FAMIX.Access (id: 270)
		(accessor (ref: 271))
		(sourceAnchor (ref: 272))
		(variable (ref: 273)))
	(FAMIX.Access (id: 274)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 277)))
	(FAMIX.Invocation (id: 278)
		(sender (ref: 128))
		(signature '',(Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 279)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Invocation (id: 281)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 285)
		(accessor (ref: 286))
		(isWrite true)
		(sourceAnchor (ref: 287))
		(variable (ref: 288)))
	(FAMIX.Access (id: 289)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 292)))
	(FAMIX.Access (id: 293)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 296)))
	(FAMIX.Access (id: 297)
		(accessor (ref: 48))
		(isWrite true)
		(sourceAnchor (ref: 49))
		(variable (ref: 56)))
	(FAMIX.Invocation (id: 298)
		(receiver (ref: 299))
		(sender (ref: 300))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 301)))
	(FAMIX.Invocation (id: 302)
		(receiver (ref: 52))
		(sender (ref: 13))
		(signature ''width()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 303)
		(accessor (ref: 304))
		(isWrite true)
		(sourceAnchor (ref: 305))
		(variable (ref: 306)))
	(FAMIX.Comment (id: 307)
		(container (ref: 308))
		(content ''"Returns the MONode corresponding to the values contained in aCollection"''))
	(FAMIX.Method (id: 309)
		(name ''userDefinedEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''userDefinedEdges'')
		(sourceAnchor (ref: 310)))
	(FAMIX.Invocation (id: 311)
		(sender (ref: 312))
		(signature ''at:ifPresent:(Object,Object)'')
		(sourceAnchor (ref: 313)))
	(FAMIX.Parameter (id: 314)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 315)))
	(FAMIX.Invocation (id: 316)
		(receiver (ref: 317))
		(sender (ref: 318))
		(signature ''resetFormCacheResursively()'')
		(sourceAnchor (ref: 319)))
	(FAMIX.Invocation (id: 320)
		(receiver (ref: 18))
		(sender (ref: 16))
		(signature ''owner()'')
		(sourceAnchor (ref: 17)))
	(FAMIX.Method (id: 138)
		(name ''isVisibleInBounds:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''isVisibleInBounds:'')
		(sourceAnchor (ref: 139)))
	(FAMIX.Invocation (id: 321)
		(receiver (ref: 322))
		(sender (ref: 80))
		(signature ''new()'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Invocation (id: 323)
		(sender (ref: 182))
		(signature ''extent()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Method (id: 324)
		(name ''layout:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''layout:'')
		(sourceAnchor (ref: 325)))
	(FAMIX.Access (id: 326)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 329)))
	(FAMIX.Invocation (id: 330)
		(receiver (ref: 331))
		(sender (ref: 32))
		(signature ''announce:(Object)'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Method (id: 332)
		(name ''computeExtentFor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''computeExtentFor:'')
		(sourceAnchor (ref: 333)))
	(FAMIX.Invocation (id: 334)
		(receiver (ref: 335))
		(sender (ref: 189))
		(signature ''resetCacheResursively()'')
		(sourceAnchor (ref: 336)))
	(FAMIX.Access (id: 337)
		(accessor (ref: 338))
		(sourceAnchor (ref: 339))
		(variable (ref: 340)))
	(FAMIX.Parameter (id: 341)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 342)))
	(FAMIX.Access (id: 343)
		(accessor (ref: 344))
		(sourceAnchor (ref: 345))
		(variable (ref: 346)))
	(FAMIX.Access (id: 347)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 348)))
	(FAMIX.Access (id: 349)
		(accessor (ref: 350))
		(sourceAnchor (ref: 351))
		(variable (ref: 352)))
	(FAMIX.Invocation (id: 353)
		(sender (ref: 354))
		(signature ''asInteger()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 356)
		(accessor (ref: 304))
		(sourceAnchor (ref: 305))
		(variable (ref: 357)))
	(FAMIX.Reference (id: 358)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 41)))
	(FAMIX.Access (id: 359)
		(accessor (ref: 360))
		(sourceAnchor (ref: 361))
		(variable (ref: 362)))
	(FAMIX.Method (id: 116)
		(name ''hasSelectionBox'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''hasSelectionBox'')
		(sourceAnchor (ref: 117)))
	(FAMIX.Access (id: 363)
		(accessor (ref: 364))
		(sourceAnchor (ref: 365))
		(variable (ref: 366)))
	(FAMIX.Invocation (id: 367)
		(sender (ref: 368))
		(signature ''collect:(Object)'')
		(sourceAnchor (ref: 369)))
	(FAMIX.Access (id: 370)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Invocation (id: 372)
		(receiver (ref: 373))
		(sender (ref: 374))
		(signature ''inject:into:(Object,Object)'')
		(sourceAnchor (ref: 375)))
	(FAMIX.Access (id: 376)
		(accessor (ref: 377))
		(sourceAnchor (ref: 378))
		(variable (ref: 379)))
	(FAMIX.Access (id: 380)
		(accessor (ref: 381))
		(sourceAnchor (ref: 382))
		(variable (ref: 383)))
	(FAMIX.Access (id: 384)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 385)))
	(FAMIX.Invocation (id: 386)
		(receiver (ref: 387))
		(sender (ref: 388))
		(signature ''allSubclasses()'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Access (id: 390)
		(accessor (ref: 391))
		(sourceAnchor (ref: 392))
		(variable (ref: 393)))
	(FAMIX.Method (id: 394)
		(name ''popup'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''popup'')
		(sourceAnchor (ref: 395)))
	(FAMIX.Invocation (id: 396)
		(receiver (ref: 397))
		(sender (ref: 398))
		(signature ''cache()'')
		(sourceAnchor (ref: 399)))
	(FAMIX.Method (id: 400)
		(name ''resetMetricCaches'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''resetMetricCaches'')
		(sourceAnchor (ref: 401)))
	(FAMIX.Access (id: 402)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 403)))
	(FAMIX.Method (id: 404)
		(name ''numberOfAttributesInherited'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 405))
		(signature ''numberOfAttributesInherited'')
		(sourceAnchor (ref: 406)))
	(FAMIX.LocalVariable (id: 407)
		(name ''element'')
		(parentBehaviouralEntity (ref: 408)))
	(FAMIX.Access (id: 409)
		(accessor (ref: 410))
		(sourceAnchor (ref: 411))
		(variable (ref: 412)))
	(FAMIX.Access (id: 413)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 416)))
	(FAMIX.Access (id: 417)
		(accessor (ref: 71))
		(sourceAnchor (ref: 72))
		(variable (ref: 418)))
	(FAMIX.Access (id: 419)
		(accessor (ref: 332))
		(sourceAnchor (ref: 333))
		(variable (ref: 420)))
	(FAMIX.Access (id: 421)
		(accessor (ref: 304))
		(sourceAnchor (ref: 305))
		(variable (ref: 357)))
	(FAMIX.Invocation (id: 422)
		(sender (ref: 423))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 424)))
	(FAMIX.LocalVariable (id: 425)
		(name ''b'')
		(parentBehaviouralEntity (ref: 426)))
	(FAMIX.Invocation (id: 427)
		(receiver (ref: 428))
		(sender (ref: 35))
		(signature ''origin()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Comment (id: 429)
		(container (ref: 430))
		(content ''"Iterates over all the subnodes of the receiver."''))
	(FAMIX.Parameter (id: 431)
		(name ''toGlobal'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Invocation (id: 432)
		(sender (ref: 433))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 434)))
	(FAMIX.Parameter (id: 435)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 173)))
	(FAMIX.Access (id: 436)
		(accessor (ref: 437))
		(sourceAnchor (ref: 438))
		(variable (ref: 439)))
	(FAMIX.Invocation (id: 440)
		(receiver (ref: 441))
		(sender (ref: 124))
		(signature ''allEdges()'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Access (id: 442)
		(accessor (ref: 443))
		(isWrite true)
		(sourceAnchor (ref: 444))
		(variable (ref: 445)))
	(FAMIX.Invocation (id: 446)
		(sender (ref: 32))
		(signature ''allSelectedNodes()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Invocation (id: 447)
		(receiver (ref: 448))
		(sender (ref: 108))
		(signature ''initialize()'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Access (id: 449)
		(accessor (ref: 195))
		(sourceAnchor (ref: 197))
		(variable (ref: 450)))
	(FAMIX.Comment (id: 451)
		(container (ref: 43))
		(content ''"Add anEdge to the children edges of the receiver."''))
	(FAMIX.Access (id: 452)
		(accessor (ref: 453))
		(sourceAnchor (ref: 454))
		(variable (ref: 455)))
	(FAMIX.Access (id: 456)
		(accessor (ref: 95))
		(isWrite true)
		(sourceAnchor (ref: 96))
		(variable (ref: 457)))
	(FAMIX.Invocation (id: 458)
		(sender (ref: 327))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 459)
		(receiver (ref: 460))
		(sender (ref: 29))
		(signature ''new()'')
		(sourceAnchor (ref: 30)))
	(FAMIX.Access (id: 461)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Invocation (id: 463)
		(sender (ref: 260))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Reference (id: 464)
		(source (ref: 465))
		(sourceAnchor (ref: 466))
		(target (ref: 41)))
	(FAMIX.Parameter (id: 467)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 468)))
	(FAMIX.Parameter (id: 469)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 470)))
	(FAMIX.Class (id: 471)
		(name ''MOBulletTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 472)
		(accessor (ref: 473))
		(sourceAnchor (ref: 474))
		(variable (ref: 475)))
	(FAMIX.Invocation (id: 476)
		(receiver (ref: 477))
		(sender (ref: 478))
		(signature ''target()'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Invocation (id: 480)
		(receiver (ref: 481))
		(sender (ref: 482))
		(signature ''computeExtentFor:(Object)'')
		(sourceAnchor (ref: 483)))
	(FAMIX.Invocation (id: 484)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Comment (id: 485)
		(container (ref: 470))
		(content ''"Add an edge going from (aFromBlock moValue: anObject) to (aToBlock moValue: anObject)"''))
	(FAMIX.Access (id: 486)
		(accessor (ref: 487))
		(sourceAnchor (ref: 488))
		(variable (ref: 489)))
	(FAMIX.Access (id: 490)
		(accessor (ref: 20))
		(isWrite true)
		(sourceAnchor (ref: 21))
		(variable (ref: 491)))
	(FAMIX.Access (id: 492)
		(accessor (ref: 493))
		(isWrite true)
		(sourceAnchor (ref: 494))
		(variable (ref: 495)))
	(FAMIX.Parameter (id: 496)
		(name ''aGraphElement'')
		(parentBehaviouralEntity (ref: 497)))
	(FAMIX.Method (id: 498)
		(name ''selectElementsFromBox'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''selectElementsFromBox'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Access (id: 500)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Invocation (id: 503)
		(sender (ref: 13))
		(signature ''*(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 504)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 507)))
	(FAMIX.Access (id: 508)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 428)))
	(FAMIX.Access (id: 509)
		(accessor (ref: 510))
		(sourceAnchor (ref: 511))
		(variable (ref: 512)))
	(FAMIX.LocalVariable (id: 513)
		(name ''sum'')
		(parentBehaviouralEntity (ref: 514)))
	(FAMIX.Invocation (id: 515)
		(sender (ref: 516))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Access (id: 518)
		(accessor (ref: 473))
		(sourceAnchor (ref: 474))
		(variable (ref: 519)))
	(FAMIX.Invocation (id: 520)
		(receiver (ref: 521))
		(sender (ref: 128))
		(signature ''label()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 522)
		(accessor (ref: 498))
		(isWrite true)
		(sourceAnchor (ref: 499))
		(variable (ref: 523)))
	(FAMIX.Access (id: 524)
		(accessor (ref: 525))
		(sourceAnchor (ref: 526))
		(variable (ref: 527)))
	(FAMIX.Reference (id: 528)
		(source (ref: 529))
		(sourceAnchor (ref: 530))
		(target (ref: 531)))
	(FAMIX.Method (id: 410)
		(name ''position'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''position'')
		(sourceAnchor (ref: 411)))
	(FAMIX.Invocation (id: 532)
		(sender (ref: 145))
		(signature ''layout()'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Invocation (id: 533)
		(receiver (ref: 534))
		(sender (ref: 374))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 375)))
	(FAMIX.Invocation (id: 535)
		(receiver (ref: 536))
		(sender (ref: 537))
		(signature ''shape()'')
		(sourceAnchor (ref: 538)))
	(FAMIX.Reference (id: 539)
		(source (ref: 540))
		(sourceAnchor (ref: 541))
		(target (ref: 542)))
	(FAMIX.Method (id: 543)
		(name ''symbol:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''symbol:'')
		(sourceAnchor (ref: 545)))
	(FAMIX.Invocation (id: 546)
		(receiver (ref: 547))
		(sender (ref: 505))
		(signature ''translateBy:during:(Object,Object)'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Access (id: 548)
		(accessor (ref: 549))
		(sourceAnchor (ref: 550))
		(variable (ref: 551)))
	(FAMIX.Access (id: 552)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 553)))
	(FAMIX.Comment (id: 554)
		(container (ref: 248))
		(content ''"Enable one to add a subview for a given node"''))
	(FAMIX.Access (id: 555)
		(accessor (ref: 556))
		(sourceAnchor (ref: 557))
		(variable (ref: 558)))
	(FAMIX.Invocation (id: 559)
		(sender (ref: 560))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 561)))
	(FAMIX.Method (id: 562)
		(name ''totalNumberOfNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''totalNumberOfNodes'')
		(sourceAnchor (ref: 563)))
	(FAMIX.Access (id: 564)
		(accessor (ref: 565))
		(sourceAnchor (ref: 566))
		(variable (ref: 567)))
	(FAMIX.Parameter (id: 567)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 565)))
	(FAMIX.Access (id: 568)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 569)))
	(FAMIX.Method (id: 54)
		(name ''adoptNewShape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 10)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''adoptNewShape:'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Invocation (id: 571)
		(sender (ref: 182))
		(signature ''origin()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 572)
		(accessor (ref: 573))
		(sourceAnchor (ref: 574))
		(variable (ref: 575)))
	(FAMIX.Access (id: 576)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 579)
		(accessor (ref: 580))
		(sourceAnchor (ref: 581))
		(variable (ref: 582)))
	(FAMIX.Method (id: 583)
		(name ''new'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''new'')
		(sourceAnchor (ref: 584)))
	(FAMIX.Invocation (id: 585)
		(sender (ref: 354))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Invocation (id: 586)
		(receiver (ref: 587))
		(sender (ref: 54))
		(signature ''shape()'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Invocation (id: 588)
		(receiver (ref: 589))
		(sender (ref: 215))
		(signature ''bounds()'')
		(sourceAnchor (ref: 216)))
	(FAMIX.Access (id: 590)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 591)))
	(FAMIX.Method (id: 592)
		(name ''defaultAnnouncer'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultAnnouncer'')
		(sourceAnchor (ref: 594)))
	(FAMIX.Comment (id: 595)
		(container (ref: 596))
		(content ''"Enable metric caches"''))
	(FAMIX.Invocation (id: 597)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''hasNode()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Parameter (id: 598)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 166)))
	(FAMIX.Access (id: 599)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 600)))
	(FAMIX.Access (id: 601)
		(accessor (ref: 602))
		(sourceAnchor (ref: 603))
		(variable (ref: 604)))
	(FAMIX.Invocation (id: 605)
		(receiver (ref: 606))
		(sender (ref: 207))
		(signature ''edgesDo:(Object)'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Access (id: 607)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 608)))
	(FAMIX.Invocation (id: 609)
		(receiver (ref: 610))
		(sender (ref: 611))
		(signature ''asString()'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Invocation (id: 613)
		(receiver (ref: 614))
		(sender (ref: 615))
		(signature ''notNil()'')
		(sourceAnchor (ref: 616)))
	(FAMIX.Access (id: 617)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 619)))
	(FAMIX.Invocation (id: 620)
		(sender (ref: 248))
		(signature ''origin:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 621)
		(accessor (ref: 622))
		(sourceAnchor (ref: 623))
		(variable (ref: 624)))
	(FAMIX.Invocation (id: 625)
		(sender (ref: 426))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 626)
		(accessor (ref: 627))
		(isWrite true)
		(sourceAnchor (ref: 628))
		(variable (ref: 629)))
	(FAMIX.Reference (id: 630)
		(source (ref: 631))
		(sourceAnchor (ref: 632))
		(target (ref: 633)))
	(FAMIX.Access (id: 634)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 600)))
	(FAMIX.Invocation (id: 635)
		(sender (ref: 108))
		(signature ''new()'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Access (id: 636)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Access (id: 637)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 640)))
	(FAMIX.Parameter (id: 641)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 354)))
	(FAMIX.Access (id: 642)
		(accessor (ref: 149))
		(sourceAnchor (ref: 150))
		(variable (ref: 148)))
	(FAMIX.Method (id: 24)
		(name ''bounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''bounds'')
		(sourceAnchor (ref: 25)))
	(FAMIX.Access (id: 643)
		(accessor (ref: 644))
		(sourceAnchor (ref: 645))
		(variable (ref: 646)))
	(FAMIX.Parameter (id: 647)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 138)))
	(FAMIX.Invocation (id: 648)
		(receiver (ref: 649))
		(sender (ref: 354))
		(signature ''width:(Object)'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 650)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 651)))
	(FAMIX.Access (id: 652)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 653)))
	(FAMIX.Parameter (id: 654)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 99)))
	(FAMIX.Invocation (id: 655)
		(sender (ref: 283))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Invocation (id: 656)
		(receiver (ref: 657))
		(sender (ref: 658))
		(signature ''~=(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Access (id: 660)
		(accessor (ref: 661))
		(sourceAnchor (ref: 662))
		(variable (ref: 663)))
	(FAMIX.Access (id: 664)
		(accessor (ref: 136))
		(sourceAnchor (ref: 665))
		(variable (ref: 135)))
	(FAMIX.Invocation (id: 666)
		(receiver (ref: 231))
		(sender (ref: 229))
		(signature ''extent:(Object)'')
		(sourceAnchor (ref: 230)))
	(FAMIX.Comment (id: 667)
		(container (ref: 668))
		(content ''"- aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each entity of the collection and return one edge source each time.
	- aToBlock will be called similarly to return a collection of destination correpsonding to each source.
	Note that there is no restriction on the entities of aCollection, as long as aFromBlock returns a node and aToBlock returns a collection of nodes.
	For example:
	  aView edges: someFamixInvocations from: #sender toAll: #candidates

	Or:
	
	| collection |
	collection := #(1 2 3 4 5 6 7 8 9 10).
	view shape label.
	view nodes: collection.
	view edges: collection from: #yourself toAll: (collection select: #odd).
	view circleLayout
		
	aToBlock should return a collection, edges will be drawn from the entity returned by aFromBlock to this collection"''))
	(FAMIX.Invocation (id: 669)
		(sender (ref: 611))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Access (id: 670)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 587)))
	(FAMIX.Invocation (id: 671)
		(sender (ref: 672))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 673)))
	(FAMIX.Invocation (id: 674)
		(receiver (ref: 675))
		(sender (ref: 676))
		(signature ''edges:from:toAll:using:fromGlobal:toGlobal:(Object,Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 677)))
	(FAMIX.Invocation (id: 678)
		(sender (ref: 611))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Comment (id: 679)
		(container (ref: 680))
		(content ''"True if I am a form shape. This method is intended to be overriden."''))
	(FAMIX.Invocation (id: 681)
		(sender (ref: 84))
		(signature ''allSelectedNodes()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Access (id: 682)
		(accessor (ref: 683))
		(sourceAnchor (ref: 684))
		(variable (ref: 685)))
	(FAMIX.Access (id: 686)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 687)))
	(FAMIX.Access (id: 688)
		(accessor (ref: 689))
		(sourceAnchor (ref: 690))
		(variable (ref: 691)))
	(FAMIX.Comment (id: 692)
		(container (ref: 693))
		(content ''"Install the default event handler for the root"''))
	(FAMIX.Invocation (id: 694)
		(receiver (ref: 181))
		(sender (ref: 182))
		(signature ''bounds()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 695)
		(accessor (ref: 696))
		(sourceAnchor (ref: 697))
		(variable (ref: 698)))
	(FAMIX.Invocation (id: 699)
		(sender (ref: 700))
		(signature ''topCenter()'')
		(sourceAnchor (ref: 701)))
	(FAMIX.Parameter (id: 702)
		(name ''aStream'')
		(parentBehaviouralEntity (ref: 200)))
	(FAMIX.Method (id: 703)
		(name ''dominanceTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''dominanceTreeLayout'')
		(sourceAnchor (ref: 704)))
	(FAMIX.Invocation (id: 705)
		(receiver (ref: 629))
		(sender (ref: 627))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 628)))
	(FAMIX.Reference (id: 706)
		(source (ref: 707))
		(sourceAnchor (ref: 708))
		(target (ref: 41)))
	(FAMIX.Method (id: 414)
		(name ''getRenderedFormSized:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''getRenderedFormSized:'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Invocation (id: 709)
		(receiver (ref: 12))
		(sender (ref: 13))
		(signature ''bottomRight()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 710)
		(sender (ref: 354))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 711)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 712)))
	(FAMIX.Access (id: 713)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Invocation (id: 714)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Invocation (id: 715)
		(sender (ref: 182))
		(signature ''extent()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 716)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 717)))
	(FAMIX.Method (id: 111)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''initialize'')
		(sourceAnchor (ref: 112)))
	(FAMIX.Access (id: 718)
		(accessor (ref: 719))
		(sourceAnchor (ref: 720))
		(variable (ref: 721)))
	(FAMIX.Parameter (id: 722)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 408)))
	(FAMIX.Method (id: 723)
		(name ''deepFindNodeWithEntity:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''deepFindNodeWithEntity:'')
		(sourceAnchor (ref: 724)))
	(FAMIX.Invocation (id: 725)
		(receiver (ref: 521))
		(sender (ref: 128))
		(signature ''setLabel:(Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 726)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Invocation (id: 727)
		(sender (ref: 182))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 728)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 729)))
	(FAMIX.Invocation (id: 730)
		(receiver (ref: 731))
		(sender (ref: 732))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 733)))
	(FAMIX.Invocation (id: 734)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''purple()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Comment (id: 735)
		(container (ref: 248))
		(content ''"Not sure why we need a reset cache."''))
	(FAMIX.Parameter (id: 736)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 737)))
	(FAMIX.Invocation (id: 738)
		(receiver (ref: 142))
		(sender (ref: 20))
		(signature ''sortBlock:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 739)
		(accessor (ref: 740))
		(sourceAnchor (ref: 741))
		(variable (ref: 742)))
	(FAMIX.Reference (id: 743)
		(source (ref: 470))
		(sourceAnchor (ref: 744))
		(target (ref: 41)))
	(FAMIX.Access (id: 745)
		(accessor (ref: 746))
		(sourceAnchor (ref: 747))
		(variable (ref: 748)))
	(FAMIX.Access (id: 749)
		(accessor (ref: 173))
		(sourceAnchor (ref: 174))
		(variable (ref: 750)))
	(FAMIX.Parameter (id: 751)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 752)))
	(FAMIX.Invocation (id: 753)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''shape()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Class (id: 754)
		(name ''MOTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Reference (id: 755)
		(source (ref: 756))
		(sourceAnchor (ref: 757))
		(target (ref: 758)))
	(FAMIX.Parameter (id: 759)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 676)))
	(FAMIX.Invocation (id: 760)
		(receiver (ref: 649))
		(sender (ref: 354))
		(signature ''height:(Object)'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Method (id: 761)
		(name ''widthFor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''widthFor:'')
		(sourceAnchor (ref: 762)))
	(FAMIX.Access (id: 763)
		(accessor (ref: 162))
		(sourceAnchor (ref: 163))
		(variable (ref: 764)))
	(FAMIX.Access (id: 765)
		(accessor (ref: 766))
		(isWrite true)
		(sourceAnchor (ref: 767))
		(variable (ref: 768)))
	(FAMIX.Access (id: 769)
		(accessor (ref: 770))
		(sourceAnchor (ref: 771))
		(variable (ref: 772)))
	(FAMIX.Invocation (id: 773)
		(sender (ref: 562))
		(signature ''size()'')
		(sourceAnchor (ref: 563)))
	(FAMIX.Method (id: 774)
		(name ''displayWithoutCacheOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''displayWithoutCacheOn:'')
		(sourceAnchor (ref: 775)))
	(FAMIX.Access (id: 776)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 779)))
	(FAMIX.Comment (id: 780)
		(container (ref: 294))
		(content ''"Same than edges:from:to:using: however, the lookup of the edges may be adjusted. 
	fromGlobal and toGlobal are boolean"''))
	(FAMIX.Access (id: 781)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 782)))
	(FAMIX.LocalVariable (id: 331)
		(name ''node'')
		(parentBehaviouralEntity (ref: 32)))
	(FAMIX.Reference (id: 783)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 784)
		(sender (ref: 785))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 786)))
	(FAMIX.Parameter (id: 787)
		(name ''aZeroArgBlock'')
		(parentBehaviouralEntity (ref: 465)))
	(FAMIX.Access (id: 788)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Invocation (id: 789)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Parameter (id: 790)
		(name ''toGlobal'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Invocation (id: 791)
		(sender (ref: 283))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 792)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 793)))
	(FAMIX.Comment (id: 794)
		(container (ref: 795))
		(content ''" aCollectionOfEntities is the collection of from which the edges are defined from."''))
	(FAMIX.Invocation (id: 796)
		(receiver (ref: 797))
		(sender (ref: 798))
		(signature ''edges:from:toAll:(Object,Object,Object)'')
		(sourceAnchor (ref: 799)))
	(FAMIX.Access (id: 800)
		(accessor (ref: 801))
		(sourceAnchor (ref: 802))
		(variable (ref: 803)))
	(FAMIX.Access (id: 804)
		(accessor (ref: 154))
		(sourceAnchor (ref: 155))
		(variable (ref: 805)))
	(FAMIX.Class (id: 806)
		(name ''Collection'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 2)
		(numberOfLinesOfCode 25)
		(numberOfMethods 2)
		(numberOfParents 0)
		(numberOfStatements -2)
		(totalNumberOfChildren 0)
		(weightedMethodCount -2))
	(FAMIX.Invocation (id: 807)
		(receiver (ref: 808))
		(sender (ref: 809))
		(signature ''domain()'')
		(sourceAnchor (ref: 810)))
	(FAMIX.Access (id: 811)
		(accessor (ref: 243))
		(sourceAnchor (ref: 244))
		(variable (ref: 812)))
	(FAMIX.Invocation (id: 813)
		(sender (ref: 814))
		(signature ''size()'')
		(sourceAnchor (ref: 815)))
	(FAMIX.Invocation (id: 816)
		(receiver (ref: 817))
		(sender (ref: 719))
		(signature ''edgeShape()'')
		(sourceAnchor (ref: 720)))
	(FAMIX.LocalVariable (id: 818)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 819)))
	(FAMIX.Method (id: 510)
		(name ''fromPositions'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''fromPositions'')
		(sourceAnchor (ref: 511)))
	(FAMIX.Access (id: 820)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 425)))
	(FAMIX.Invocation (id: 821)
		(receiver (ref: 239))
		(sender (ref: 237))
		(signature ''value()'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Comment (id: 822)
		(container (ref: 497))
		(content ''"Return the relative bounds of aGraphElement"''))
	(FAMIX.Parameter (id: 823)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 676)))
	(FAMIX.Access (id: 824)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 825)))
	(FAMIX.Parameter (id: 826)
		(name ''aOneArgumentBlock'')
		(parentBehaviouralEntity (ref: 827)))
	(FAMIX.Reference (id: 828)
		(source (ref: 48))
		(sourceAnchor (ref: 49))
		(target (ref: 41)))
	(FAMIX.Access (id: 829)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.LocalVariable (id: 830)
		(name ''realStep'')
		(parentBehaviouralEntity (ref: 327)))
	(FAMIX.Access (id: 831)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 832)))
	(FAMIX.Invocation (id: 833)
		(sender (ref: 516))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 517)))
	(FAMIX.LocalVariable (id: 834)
		(name ''newNode'')
		(parentBehaviouralEntity (ref: 80)))
	(FAMIX.Invocation (id: 835)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 836)
		(accessor (ref: 837))
		(sourceAnchor (ref: 838))
		(variable (ref: 839)))
	(FAMIX.Comment (id: 840)
		(container (ref: 493))
		(content ''"We take the first class, not perfect, but it should be enough for now"''))
	(FAMIX.Access (id: 841)
		(accessor (ref: 354))
		(isWrite true)
		(sourceAnchor (ref: 355))
		(variable (ref: 649)))
	(FAMIX.Access (id: 842)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 843)))
	(FAMIX.Invocation (id: 844)
		(receiver (ref: 845))
		(sender (ref: 145))
		(signature ''root()'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Invocation (id: 846)
		(sender (ref: 493))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Parameter (id: 847)
		(name ''aCache'')
		(parentBehaviouralEntity (ref: 848)))
	(FAMIX.Invocation (id: 849)
		(receiver (ref: 850))
		(sender (ref: 777))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Access (id: 851)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 852)))
	(FAMIX.Invocation (id: 853)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 854)
		(accessor (ref: 592))
		(sourceAnchor (ref: 594))
		(variable (ref: 855)))
	(FAMIX.Invocation (id: 856)
		(receiver (ref: 857))
		(sender (ref: 858))
		(signature ''edges:fromAll:toAll:using:fromGlobal:toGlobal:(Object,Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 859)))
	(FAMIX.Access (id: 860)
		(accessor (ref: 861))
		(sourceAnchor (ref: 862))
		(variable (ref: 263)))
	(FAMIX.LocalVariable (id: 863)
		(name ''keyShape'')
		(parentBehaviouralEntity (ref: 207)))
	(FAMIX.Invocation (id: 864)
		(receiver (ref: 865))
		(sender (ref: 866))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Access (id: 868)
		(accessor (ref: 315))
		(sourceAnchor (ref: 869))
		(variable (ref: 314)))
	(FAMIX.Class (id: 170)
		(name ''MOEdge'')
		(fanIn 0)
		(fanOut 1)
		(hierarchyNestingLevel 2)
		(numberOfAttributes 5)
		(numberOfComments 6)
		(numberOfLinesOfCode 72)
		(numberOfMethods 28)
		(numberOfParents 1)
		(numberOfStatements -28)
		(totalNumberOfChildren 0)
		(weightedMethodCount -28))
	(FAMIX.Invocation (id: 870)
		(receiver (ref: 871))
		(sender (ref: 872))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 873)))
	(FAMIX.Invocation (id: 874)
		(receiver (ref: 875))
		(sender (ref: 95))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Invocation (id: 876)
		(receiver (ref: 877))
		(sender (ref: 878))
		(signature ''attributes()'')
		(sourceAnchor (ref: 879)))
	(FAMIX.Invocation (id: 880)
		(receiver (ref: 331))
		(sender (ref: 32))
		(signature ''deselect()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Invocation (id: 881)
		(receiver (ref: 882))
		(sender (ref: 48))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Parameter (id: 883)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 884)))
	(FAMIX.Access (id: 885)
		(accessor (ref: 886))
		(sourceAnchor (ref: 887))
		(variable (ref: 888)))
	(FAMIX.Method (id: 889)
		(name ''canvas'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''canvas'')
		(sourceAnchor (ref: 890)))
	(FAMIX.Invocation (id: 891)
		(sender (ref: 777))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Invocation (id: 892)
		(receiver (ref: 712))
		(sender (ref: 182))
		(signature ''bounds()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 893)
		(accessor (ref: 894))
		(sourceAnchor (ref: 895))
		(variable (ref: 896)))
	(FAMIX.Access (id: 897)
		(accessor (ref: 312))
		(sourceAnchor (ref: 313))
		(variable (ref: 898)))
	(FAMIX.Access (id: 899)
		(accessor (ref: 900))
		(sourceAnchor (ref: 901))
		(variable (ref: 902)))
	(FAMIX.Access (id: 903)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 904)))
	(FAMIX.Invocation (id: 905)
		(receiver (ref: 649))
		(sender (ref: 354))
		(signature ''width()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 906)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 79)))
	(FAMIX.Invocation (id: 907)
		(receiver (ref: 908))
		(sender (ref: 801))
		(signature ''elementsToDisplay()'')
		(sourceAnchor (ref: 802)))
	(FAMIX.LocalVariable (id: 477)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 478)))
	(FAMIX.Comment (id: 909)
		(container (ref: 910))
		(content ''"True if I am the default line shape class. I am meant to be overriden. Note that it is assumed to have only one class that answers true"''))
	(FAMIX.Access (id: 911)
		(accessor (ref: 912))
		(sourceAnchor (ref: 913))
		(variable (ref: 914)))
	(FAMIX.Access (id: 915)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 916)))
	(FAMIX.Access (id: 917)
		(accessor (ref: 676))
		(sourceAnchor (ref: 677))
		(variable (ref: 918)))
	(FAMIX.Comment (id: 919)
		(container (ref: 84))
		(content ''"@@WHY this handlers are set here? And not in MORoot"''))
	(FAMIX.Parameter (id: 920)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 268)))
	(FAMIX.Method (id: 312)
		(name ''shapeBoundsAt:ifPresent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shapeBoundsAt:ifPresent:'')
		(sourceAnchor (ref: 313)))
	(FAMIX.Access (id: 921)
		(accessor (ref: 221))
		(isWrite true)
		(sourceAnchor (ref: 222))
		(variable (ref: 922)))
	(FAMIX.Method (id: 866)
		(name ''zOrder'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''zOrder'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Access (id: 923)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 924)))
	(FAMIX.Access (id: 925)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 882)))
	(FAMIX.Class (id: 926)
		(name ''MOMouseUp class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 927)
		(receiver (ref: 181))
		(sender (ref: 740))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 741)))
	(FAMIX.Method (id: 215)
		(name ''height'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''height'')
		(sourceAnchor (ref: 216)))
	(FAMIX.Invocation (id: 928)
		(sender (ref: 929))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Comment (id: 931)
		(container (ref: 932))
		(content ''"Currently, an edge cannot have inner nodes"''))
	(FAMIX.Access (id: 933)
		(accessor (ref: 934))
		(sourceAnchor (ref: 935))
		(variable (ref: 936)))
	(FAMIX.Access (id: 937)
		(accessor (ref: 938))
		(isWrite true)
		(sourceAnchor (ref: 939))
		(variable (ref: 940)))
	(FAMIX.Invocation (id: 941)
		(receiver (ref: 942))
		(sender (ref: 943))
		(signature ''new()'')
		(sourceAnchor (ref: 944)))
	(FAMIX.Invocation (id: 945)
		(receiver (ref: 946))
		(sender (ref: 947))
		(signature ''left()'')
		(sourceAnchor (ref: 948)))
	(FAMIX.Invocation (id: 949)
		(receiver (ref: 950))
		(sender (ref: 951))
		(signature ''radius()'')
		(sourceAnchor (ref: 952)))
	(FAMIX.Access (id: 953)
		(accessor (ref: 108))
		(isWrite true)
		(sourceAnchor (ref: 109))
		(variable (ref: 954)))
	(FAMIX.Access (id: 955)
		(accessor (ref: 707))
		(sourceAnchor (ref: 708))
		(variable (ref: 956)))
	(FAMIX.Invocation (id: 957)
		(receiver (ref: 958))
		(sender (ref: 959))
		(signature ''edges()'')
		(sourceAnchor (ref: 960)))
	(FAMIX.Parameter (id: 961)
		(name ''collection'')
		(parentBehaviouralEntity (ref: 169)))
	(FAMIX.Invocation (id: 962)
		(receiver (ref: 940))
		(sender (ref: 963))
		(signature ''isLineShape()'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Invocation (id: 965)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Access (id: 966)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 12)))
	(FAMIX.Access (id: 967)
		(accessor (ref: 20))
		(isWrite true)
		(sourceAnchor (ref: 21))
		(variable (ref: 852)))
	(FAMIX.Access (id: 968)
		(accessor (ref: 969))
		(sourceAnchor (ref: 970))
		(variable (ref: 971)))
	(FAMIX.LocalVariable (id: 972)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 756)))
	(FAMIX.Invocation (id: 973)
		(receiver (ref: 850))
		(sender (ref: 974))
		(signature ''hash()'')
		(sourceAnchor (ref: 975)))
	(FAMIX.Access (id: 976)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 977)))
	(FAMIX.Invocation (id: 978)
		(sender (ref: 611))
		(signature ''copy()'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Access (id: 979)
		(accessor (ref: 478))
		(sourceAnchor (ref: 479))
		(variable (ref: 980)))
	(FAMIX.Access (id: 981)
		(accessor (ref: 24))
		(isWrite true)
		(sourceAnchor (ref: 25))
		(variable (ref: 306)))
	(FAMIX.Comment (id: 982)
		(container (ref: 983))
		(content ''"This method is used by elementAt:"''))
	(FAMIX.Invocation (id: 984)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''shape()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 985)
		(receiver (ref: 986))
		(sender (ref: 700))
		(signature ''bounds()'')
		(sourceAnchor (ref: 701)))
	(FAMIX.Invocation (id: 987)
		(sender (ref: 988))
		(signature ''at:(Object)'')
		(sourceAnchor (ref: 989)))
	(FAMIX.Method (id: 990)
		(name ''toPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''toPositions:'')
		(sourceAnchor (ref: 991)))
	(FAMIX.Invocation (id: 992)
		(sender (ref: 993))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Invocation (id: 995)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''cyan()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 996)
		(receiver (ref: 997))
		(sender (ref: 177))
		(signature ''new()'')
		(sourceAnchor (ref: 178)))
	(FAMIX.Invocation (id: 998)
		(receiver (ref: 649))
		(sender (ref: 354))
		(signature ''height()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 999)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 653)))
	(FAMIX.Invocation (id: 1000)
		(receiver (ref: 712))
		(sender (ref: 182))
		(signature ''bounds()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 1001)
		(accessor (ref: 1002))
		(isWrite true)
		(sourceAnchor (ref: 1003))
		(variable (ref: 1004)))
	(FAMIX.Invocation (id: 1005)
		(receiver (ref: 1006))
		(sender (ref: 1007))
		(signature ''fromPositions()'')
		(sourceAnchor (ref: 1008)))
	(FAMIX.Access (id: 1009)
		(accessor (ref: 1010))
		(sourceAnchor (ref: 1011))
		(variable (ref: 1012)))
	(FAMIX.Method (id: 1013)
		(name ''selections'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''selections'')
		(sourceAnchor (ref: 1014)))
	(FAMIX.Invocation (id: 1015)
		(receiver (ref: 1016))
		(sender (ref: 48))
		(signature ''assert:description:(Object,Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Invocation (id: 1017)
		(receiver (ref: 1018))
		(sender (ref: 1019))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 1020)))
	(FAMIX.Invocation (id: 1021)
		(receiver (ref: 263))
		(sender (ref: 430))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1022)))
	(FAMIX.Access (id: 1023)
		(accessor (ref: 668))
		(sourceAnchor (ref: 1024))
		(variable (ref: 1025)))
	(FAMIX.Parameter (id: 646)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 644)))
	(FAMIX.Method (id: 1026)
		(name ''extent'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''extent'')
		(sourceAnchor (ref: 1027)))
	(FAMIX.Access (id: 1028)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 1029)))
	(FAMIX.Access (id: 1030)
		(accessor (ref: 128))
		(isWrite true)
		(sourceAnchor (ref: 129))
		(variable (ref: 1031)))
	(FAMIX.Comment (id: 1032)
		(container (ref: 1033))
		(content ''"Answer the nodes that are directly contained by myself"''))
	(FAMIX.LocalVariable (id: 1034)
		(name ''classes'')
		(parentBehaviouralEntity (ref: 934)))
	(FAMIX.Invocation (id: 1035)
		(sender (ref: 248))
		(signature ''updateBounds()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 1036)
		(accessor (ref: 774))
		(sourceAnchor (ref: 775))
		(variable (ref: 1037)))
	(FAMIX.Invocation (id: 1038)
		(receiver (ref: 1039))
		(sender (ref: 732))
		(signature ''new()'')
		(sourceAnchor (ref: 733)))
	(FAMIX.Invocation (id: 1040)
		(receiver (ref: 1041))
		(sender (ref: 260))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 1042)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1045)))
	(FAMIX.Invocation (id: 1046)
		(receiver (ref: 1047))
		(sender (ref: 224))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Invocation (id: 1048)
		(receiver (ref: 1049))
		(sender (ref: 1050))
		(signature ''removeNodeWithValue:(Object)'')
		(sourceAnchor (ref: 1051)))
	(FAMIX.Parameter (id: 1052)
		(name ''fromGlobal'')
		(parentBehaviouralEntity (ref: 661)))
	(FAMIX.Invocation (id: 1053)
		(sender (ref: 13))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Parameter (id: 1054)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1055)))
	(FAMIX.Method (id: 1056)
		(name ''isCacheLoaded'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''isCacheLoaded'')
		(sourceAnchor (ref: 1057)))
	(FAMIX.Class (id: 58)
		(name ''MONode'')
		(fanIn 1)
		(fanOut 1)
		(hierarchyNestingLevel 2)
		(numberOfAttributes 8)
		(numberOfComments 50)
		(numberOfLinesOfCode 432)
		(numberOfMethods 86)
		(numberOfParents 1)
		(numberOfStatements -86)
		(totalNumberOfChildren 1)
		(weightedMethodCount -86))
	(FAMIX.Parameter (id: 1058)
		(name ''node'')
		(parentBehaviouralEntity (ref: 819)))
	(FAMIX.Invocation (id: 1059)
		(receiver (ref: 1060))
		(sender (ref: 562))
		(signature ''withAllSubnodes()'')
		(sourceAnchor (ref: 563)))
	(FAMIX.Invocation (id: 1061)
		(sender (ref: 182))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 1062)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 843)))
	(FAMIX.Invocation (id: 1063)
		(receiver (ref: 1064))
		(sender (ref: 505))
		(signature ''newElement:on:(Object,Object)'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Invocation (id: 1065)
		(receiver (ref: 717))
		(sender (ref: 69))
		(signature ''origin()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Access (id: 1066)
		(accessor (ref: 549))
		(sourceAnchor (ref: 550))
		(variable (ref: 288)))
	(FAMIX.Access (id: 1067)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 1068)))
	(FAMIX.Access (id: 1069)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Access (id: 1070)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Access (id: 1071)
		(accessor (ref: 400))
		(isWrite true)
		(sourceAnchor (ref: 401))
		(variable (ref: 1072)))
	(FAMIX.Access (id: 1073)
		(accessor (ref: 866))
		(sourceAnchor (ref: 867))
		(variable (ref: 1074)))
	(FAMIX.Access (id: 1075)
		(accessor (ref: 1076))
		(sourceAnchor (ref: 1077))
		(variable (ref: 1078)))
	(FAMIX.Invocation (id: 1079)
		(sender (ref: 1080))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Comment (id: 1082)
		(container (ref: 95))
		(content ''"Same than edges:from:toAll:using: but the lookup can be particularized
	fromGlobal and toGlobal are boolean values"''))
	(FAMIX.Reference (id: 1083)
		(source (ref: 943))
		(sourceAnchor (ref: 944))
		(target (ref: 942)))
	(FAMIX.Class (id: 1084)
		(name ''Dictionary class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Method (id: 1085)
		(name ''nodeForDomainValues:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodeForDomainValues:'')
		(sourceAnchor (ref: 1086)))
	(FAMIX.Method (id: 1087)
		(name ''edges:from:to:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 4)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:to:using:'')
		(sourceAnchor (ref: 1088)))
	(FAMIX.LocalVariable (id: 126)
		(name ''tmpNodes'')
		(parentBehaviouralEntity (ref: 124)))
	(FAMIX.Invocation (id: 1089)
		(sender (ref: 16))
		(signature ''resetFormCacheUpToTheRoot()'')
		(sourceAnchor (ref: 17)))
	(FAMIX.Reference (id: 1090)
		(source (ref: 498))
		(sourceAnchor (ref: 499))
		(target (ref: 1091)))
	(FAMIX.Invocation (id: 1092)
		(receiver (ref: 587))
		(sender (ref: 54))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Parameter (id: 1093)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 224)))
	(FAMIX.Access (id: 1094)
		(accessor (ref: 801))
		(sourceAnchor (ref: 802))
		(variable (ref: 908)))
	(FAMIX.Access (id: 1095)
		(accessor (ref: 1096))
		(sourceAnchor (ref: 1097))
		(variable (ref: 1098)))
	(FAMIX.Invocation (id: 1099)
		(receiver (ref: 1100))
		(sender (ref: 1101))
		(signature ''model()'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Invocation (id: 1103)
		(sender (ref: 1104))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Access (id: 1106)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 1107)))
	(FAMIX.Access (id: 1108)
		(accessor (ref: 938))
		(sourceAnchor (ref: 939))
		(variable (ref: 940)))
	(FAMIX.Access (id: 1109)
		(accessor (ref: 1110))
		(sourceAnchor (ref: 1111))
		(variable (ref: 1112)))
	(FAMIX.Invocation (id: 1113)
		(receiver (ref: 633))
		(sender (ref: 1114))
		(signature ''defaultNodeShapeClass()'')
		(sourceAnchor (ref: 1115)))
	(FAMIX.Access (id: 1116)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Method (id: 108)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 10)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''initialize'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Parameter (id: 1117)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 795)))
	(FAMIX.Comment (id: 1118)
		(container (ref: 676))
		(content ''"Same than edges:from:toAll: but a shape is provided"''))
	(FAMIX.Parameter (id: 1119)
		(name ''objects'')
		(parentBehaviouralEntity (ref: 1050)))
	(FAMIX.Invocation (id: 1120)
		(receiver (ref: 512))
		(sender (ref: 1026))
		(signature ''extentFor:(Object)'')
		(sourceAnchor (ref: 1027)))
	(FAMIX.Parameter (id: 1121)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 622)))
	(FAMIX.LocalVariable (id: 329)
		(name ''n'')
		(parentBehaviouralEntity (ref: 327)))
	(FAMIX.Invocation (id: 1122)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''blue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 1123)
		(accessor (ref: 1124))
		(sourceAnchor (ref: 1125))
		(variable (ref: 1126)))
	(FAMIX.Reference (id: 1127)
		(source (ref: 264))
		(sourceAnchor (ref: 265))
		(target (ref: 41)))
	(FAMIX.Method (id: 611)
		(name ''removeAttributesMatching:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''removeAttributesMatching:'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Invocation (id: 1128)
		(sender (ref: 756))
		(signature ''on:do:(Object,Object)'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Access (id: 1129)
		(accessor (ref: 801))
		(isWrite true)
		(sourceAnchor (ref: 802))
		(variable (ref: 803)))
	(FAMIX.Class (id: 544)
		(name ''MOElementShapeProperties'')
		(fanIn 0)
		(fanOut 1)
		(hierarchyNestingLevel 1)
		(numberOfAttributes 2)
		(numberOfComments 0)
		(numberOfLinesOfCode 22)
		(numberOfMethods 8)
		(numberOfParents 1)
		(numberOfStatements -8)
		(totalNumberOfChildren 0)
		(weightedMethodCount -8))
	(FAMIX.Access (id: 1130)
		(accessor (ref: 102))
		(isWrite true)
		(sourceAnchor (ref: 103))
		(variable (ref: 104)))
	(FAMIX.Parameter (id: 1131)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 1132)))
	(FAMIX.Access (id: 1133)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1016)))
	(FAMIX.Access (id: 1134)
		(accessor (ref: 350))
		(sourceAnchor (ref: 351))
		(variable (ref: 1135)))
	(FAMIX.LocalVariable (id: 1136)
		(name ''assoc'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Invocation (id: 1137)
		(receiver (ref: 1138))
		(sender (ref: 414))
		(signature ''on:(Object)'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Invocation (id: 1139)
		(receiver (ref: 41))
		(sender (ref: 91))
		(signature ''new()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Method (id: 1140)
		(name ''attributeAt:put:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''attributeAt:put:'')
		(sourceAnchor (ref: 1141)))
	(FAMIX.Access (id: 1142)
		(accessor (ref: 1143))
		(isWrite true)
		(sourceAnchor (ref: 1144))
		(variable (ref: 168)))
	(FAMIX.Invocation (id: 1145)
		(receiver (ref: 1146))
		(sender (ref: 1147))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 1148)))
	(FAMIX.Invocation (id: 1149)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''bounds()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 1150)
		(accessor (ref: 947))
		(isWrite true)
		(sourceAnchor (ref: 948))
		(variable (ref: 1151)))
	(FAMIX.Invocation (id: 1152)
		(receiver (ref: 1153))
		(sender (ref: 638))
		(signature ''edges:from:toAll:(Object,Object,Object)'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Access (id: 1154)
		(accessor (ref: 1155))
		(sourceAnchor (ref: 1156))
		(variable (ref: 1157)))
	(FAMIX.Access (id: 1158)
		(accessor (ref: 136))
		(sourceAnchor (ref: 665))
		(variable (ref: 1159)))
	(FAMIX.Invocation (id: 1160)
		(receiver (ref: 1161))
		(sender (ref: 777))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Access (id: 1162)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 42)))
	(FAMIX.Access (id: 1164)
		(accessor (ref: 374))
		(sourceAnchor (ref: 375))
		(variable (ref: 373)))
	(FAMIX.Access (id: 1165)
		(accessor (ref: 537))
		(sourceAnchor (ref: 538))
		(variable (ref: 104)))
	(FAMIX.Access (id: 1166)
		(accessor (ref: 327))
		(isWrite true)
		(sourceAnchor (ref: 328))
		(variable (ref: 830)))
	(FAMIX.Invocation (id: 1167)
		(receiver (ref: 922))
		(sender (ref: 221))
		(signature ''asOrderedCollection()'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Access (id: 1168)
		(accessor (ref: 1169))
		(sourceAnchor (ref: 1170))
		(variable (ref: 1171)))
	(FAMIX.Access (id: 1172)
		(accessor (ref: 1124))
		(sourceAnchor (ref: 1125))
		(variable (ref: 1173)))
	(FAMIX.Parameter (id: 805)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 154)))
	(FAMIX.Access (id: 1174)
		(accessor (ref: 264))
		(sourceAnchor (ref: 265))
		(variable (ref: 1175)))
	(FAMIX.Invocation (id: 1176)
		(sender (ref: 777))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 778)))
	(FAMIX.LocalVariable (id: 1177)
		(name ''node'')
		(parentBehaviouralEntity (ref: 318)))
	(FAMIX.Parameter (id: 1178)
		(name ''fromGlobal'')
		(parentBehaviouralEntity (ref: 795)))
	(FAMIX.Invocation (id: 1179)
		(receiver (ref: 1180))
		(sender (ref: 1181))
		(signature ''allNodes()'')
		(sourceAnchor (ref: 1182)))
	(FAMIX.Access (id: 1183)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 1184)))
	(FAMIX.Method (id: 934)
		(name ''defaultLineShapeClass'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 10)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''defaultLineShapeClass'')
		(sourceAnchor (ref: 935)))
	(FAMIX.Invocation (id: 1185)
		(receiver (ref: 1186))
		(sender (ref: 1101))
		(signature ''root()'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Invocation (id: 1187)
		(receiver (ref: 37))
		(sender (ref: 35))
		(signature ''height:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Invocation (id: 1188)
		(receiver (ref: 299))
		(sender (ref: 1189))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1190)))
	(FAMIX.Parameter (id: 1191)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1096)))
	(FAMIX.Invocation (id: 1192)
		(receiver (ref: 158))
		(sender (ref: 159))
		(signature ''getSource()'')
		(sourceAnchor (ref: 160)))
	(FAMIX.Access (id: 1193)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 1194)))
	(FAMIX.Comment (id: 1195)
		(container (ref: 84))
		(content ''"This method is called when the nodes have been added to the view"''))
	(FAMIX.Invocation (id: 1196)
		(sender (ref: 482))
		(signature ''asNonFractionalPoint()'')
		(sourceAnchor (ref: 483)))
	(FAMIX.Method (id: 540)
		(name ''bottomFlowLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''bottomFlowLayout'')
		(sourceAnchor (ref: 541)))
	(FAMIX.LocalVariable (id: 1197)
		(name ''each'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Access (id: 1198)
		(accessor (ref: 1199))
		(sourceAnchor (ref: 1200))
		(variable (ref: 181)))
	(FAMIX.Parameter (id: 1201)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 1155)))
	(FAMIX.Method (id: 1202)
		(name ''containsPoint:for:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''containsPoint:for:'')
		(sourceAnchor (ref: 1203)))
	(FAMIX.Access (id: 1204)
		(accessor (ref: 173))
		(sourceAnchor (ref: 174))
		(variable (ref: 435)))
	(FAMIX.Class (id: 41)
		(name ''OrderedCollection class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 1205)
		(accessor (ref: 683))
		(sourceAnchor (ref: 684))
		(variable (ref: 954)))
	(FAMIX.Access (id: 1206)
		(accessor (ref: 1207))
		(sourceAnchor (ref: 1208))
		(variable (ref: 1209)))
	(FAMIX.Invocation (id: 1210)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''brown()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Parameter (id: 1194)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Access (id: 1211)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1212)))
	(FAMIX.Invocation (id: 1213)
		(receiver (ref: 1214))
		(sender (ref: 1215))
		(signature ''setDefaultHandlersMouseDown()'')
		(sourceAnchor (ref: 1216)))
	(FAMIX.Invocation (id: 1217)
		(sender (ref: 1218))
		(signature ''includesKey:(Object)'')
		(sourceAnchor (ref: 1219)))
	(FAMIX.Access (id: 1220)
		(accessor (ref: 683))
		(sourceAnchor (ref: 684))
		(variable (ref: 67)))
	(FAMIX.Invocation (id: 1221)
		(sender (ref: 537))
		(signature ''absoluteBoundsFor:(Object)'')
		(sourceAnchor (ref: 538)))
	(FAMIX.Method (id: 173)
		(name ''allEdgesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allEdgesDo:'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Access (id: 1222)
		(accessor (ref: 1223))
		(sourceAnchor (ref: 1224))
		(variable (ref: 1225)))
	(FAMIX.Parameter (id: 1226)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1227)))
	(FAMIX.Invocation (id: 1228)
		(receiver (ref: 1229))
		(sender (ref: 1223))
		(signature ''owner()'')
		(sourceAnchor (ref: 1224)))
	(FAMIX.Invocation (id: 1230)
		(sender (ref: 611))
		(signature ''keys()'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Comment (id: 1231)
		(container (ref: 1232))
		(content ''"Answer the owning element of this element, or nil if this is the root."''))
	(FAMIX.Access (id: 1233)
		(accessor (ref: 1087))
		(sourceAnchor (ref: 1088))
		(variable (ref: 1234)))
	(FAMIX.Parameter (id: 946)
		(name ''childrenBounds'')
		(parentBehaviouralEntity (ref: 947)))
	(FAMIX.Invocation (id: 1235)
		(sender (ref: 128))
		(signature ''ifNotEmpty:ifEmpty:(Object,Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Comment (id: 1236)
		(container (ref: 1237))
		(content ''"Enable one to add a subview for a given nodes"''))
	(FAMIX.Access (id: 1238)
		(accessor (ref: 482))
		(sourceAnchor (ref: 483))
		(variable (ref: 481)))
	(FAMIX.Invocation (id: 1239)
		(sender (ref: 498))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Access (id: 1240)
		(accessor (ref: 408))
		(sourceAnchor (ref: 1241))
		(variable (ref: 722)))
	(FAMIX.Invocation (id: 1242)
		(receiver (ref: 1243))
		(sender (ref: 414))
		(signature ''root()'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Comment (id: 1244)
		(container (ref: 327))
		(content ''"It moves the element by aPoint. 
	If bounded is true and the owner is not the root, 
	then the bounds are limited by the owner bounds.
	If the element is placed in the root, then the root''''s bounds are updated"''))
	(FAMIX.Invocation (id: 1245)
		(receiver (ref: 633))
		(sender (ref: 1246))
		(signature ''defaultLineShapeClass()'')
		(sourceAnchor (ref: 1247)))
	(FAMIX.Invocation (id: 1248)
		(sender (ref: 327))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Reference (id: 1249)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 1250)
		(sender (ref: 658))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Invocation (id: 1251)
		(receiver (ref: 1252))
		(sender (ref: 988))
		(signature ''attributes()'')
		(sourceAnchor (ref: 989)))
	(FAMIX.Invocation (id: 1253)
		(sender (ref: 304))
		(signature ''at:put:(Object,Object)'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Access (id: 1254)
		(accessor (ref: 108))
		(sourceAnchor (ref: 109))
		(variable (ref: 1255)))
	(FAMIX.Access (id: 1256)
		(accessor (ref: 540))
		(sourceAnchor (ref: 541))
		(variable (ref: 1257)))
	(FAMIX.Invocation (id: 1258)
		(sender (ref: 377))
		(signature ''updateWindow()'')
		(sourceAnchor (ref: 378)))
	(FAMIX.LocalVariable (id: 852)
		(name ''t1'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Comment (id: 1259)
		(container (ref: 1260))
		(content ''"Answer an instance of the receiver which in some sense is initialized.  In the case of Morphs, this will yield an instance that can be attached to the Hand after having received the same kind of basic initialization that would be obtained from an instance chosen from the ''''new morph'''' menu.   Return nil if the receiver is reluctant for some reason to return such a thing"''))
	(FAMIX.Parameter (id: 1261)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 102)))
	(FAMIX.Access (id: 1262)
		(accessor (ref: 1263))
		(sourceAnchor (ref: 1264))
		(variable (ref: 1265)))
	(FAMIX.Invocation (id: 1266)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 1267)
		(receiver (ref: 1268))
		(sender (ref: 1269))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1270)))
	(FAMIX.Access (id: 1271)
		(accessor (ref: 1272))
		(sourceAnchor (ref: 1273))
		(variable (ref: 181)))
	(FAMIX.Comment (id: 1274)
		(container (ref: 1275))
		(content ''"Each element has a shape to graphically render itself"''))
	(FAMIX.Invocation (id: 1276)
		(receiver (ref: 1277))
		(sender (ref: 1278))
		(signature ''new()'')
		(sourceAnchor (ref: 1279)))
	(FAMIX.Invocation (id: 1280)
		(receiver (ref: 1281))
		(sender (ref: 498))
		(signature ''announce:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.LocalVariable (id: 793)
		(name ''targetModels'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Reference (id: 1282)
		(source (ref: 1283))
		(sourceAnchor (ref: 1284))
		(target (ref: 471)))
	(FAMIX.Access (id: 1285)
		(accessor (ref: 1140))
		(sourceAnchor (ref: 1141))
		(variable (ref: 1286)))
	(FAMIX.Invocation (id: 1287)
		(receiver (ref: 1288))
		(sender (ref: 39))
		(signature ''edges()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 1289)
		(accessor (ref: 1290))
		(sourceAnchor (ref: 1291))
		(variable (ref: 1292)))
	(FAMIX.Invocation (id: 1293)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''doExecute:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Parameter (id: 1295)
		(name ''aLayout'')
		(parentBehaviouralEntity (ref: 324)))
	(FAMIX.Parameter (id: 1296)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Invocation (id: 1297)
		(receiver (ref: 591))
		(sender (ref: 283))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Method (id: 1298)
		(name ''firstSubnodeThat:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''firstSubnodeThat:'')
		(sourceAnchor (ref: 1299)))
	(FAMIX.Access (id: 1300)
		(accessor (ref: 827))
		(sourceAnchor (ref: 1301))
		(variable (ref: 1302)))
	(FAMIX.Access (id: 1303)
		(accessor (ref: 300))
		(sourceAnchor (ref: 301))
		(variable (ref: 299)))
	(FAMIX.Method (id: 1304)
		(name ''resetFormCacheSimply'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetFormCacheSimply'')
		(sourceAnchor (ref: 1305)))
	(FAMIX.Class (id: 1306)
		(name ''Float class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Reference (id: 1307)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 1308)
		(accessor (ref: 1309))
		(sourceAnchor (ref: 1310))
		(variable (ref: 263)))
	(FAMIX.Access (id: 1311)
		(accessor (ref: 264))
		(sourceAnchor (ref: 265))
		(variable (ref: 263)))
	(FAMIX.Invocation (id: 1312)
		(receiver (ref: 41))
		(sender (ref: 48))
		(signature ''new()'')
		(sourceAnchor (ref: 49)))
	(FAMIX.LocalVariable (id: 1313)
		(name ''targetModel'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Parameter (id: 12)
		(name ''newBounds'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Access (id: 1314)
		(accessor (ref: 1315))
		(sourceAnchor (ref: 1316))
		(variable (ref: 1317)))
	(FAMIX.Invocation (id: 1318)
		(sender (ref: 1272))
		(signature ''<(Object)'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Invocation (id: 1319)
		(sender (ref: 1140))
		(signature ''at:put:(Object,Object)'')
		(sourceAnchor (ref: 1141)))
	(FAMIX.Access (id: 1320)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Comment (id: 1321)
		(container (ref: 224))
		(content ''"	aShape canHandleChildren ifFalse: [ self error: ''''Inner nodes cannot be added. The shape cannot handle children'''' ]."''))
	(FAMIX.Access (id: 1322)
		(accessor (ref: 35))
		(isWrite true)
		(sourceAnchor (ref: 36))
		(variable (ref: 1323)))
	(FAMIX.Access (id: 1324)
		(accessor (ref: 300))
		(sourceAnchor (ref: 301))
		(variable (ref: 299)))
	(FAMIX.Access (id: 1325)
		(accessor (ref: 1315))
		(sourceAnchor (ref: 1316))
		(variable (ref: 1326)))
	(FAMIX.Access (id: 1327)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 1329)))
	(FAMIX.Access (id: 1330)
		(accessor (ref: 35))
		(isWrite true)
		(sourceAnchor (ref: 36))
		(variable (ref: 1331)))
	(FAMIX.Access (id: 1332)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Method (id: 1333)
		(name ''canHandleChildren'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''canHandleChildren'')
		(sourceAnchor (ref: 1334)))
	(FAMIX.Class (id: 1335)
		(name ''MOVerticalNarrowTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Comment (id: 1336)
		(container (ref: 256))
		(content ''"Answer a new object translated by amount, which can be
	a Point or a scalar value."''))
	(FAMIX.Invocation (id: 1337)
		(sender (ref: 1338))
		(signature ''*(Object)'')
		(sourceAnchor (ref: 1339)))
	(FAMIX.Invocation (id: 1340)
		(receiver (ref: 63))
		(sender (ref: 61))
		(signature ''attributes()'')
		(sourceAnchor (ref: 62)))
	(FAMIX.Method (id: 1341)
		(name ''affectedNodes:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''affectedNodes:'')
		(sourceAnchor (ref: 1342)))
	(FAMIX.Invocation (id: 1343)
		(receiver (ref: 1344))
		(sender (ref: 1345))
		(signature ''new()'')
		(sourceAnchor (ref: 1346)))
	(FAMIX.Invocation (id: 1347)
		(receiver (ref: 1348))
		(sender (ref: 1349))
		(signature ''new()'')
		(sourceAnchor (ref: 1350)))
	(FAMIX.Invocation (id: 1351)
		(receiver (ref: 825))
		(sender (ref: 39))
		(signature ''value()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 1352)
		(receiver (ref: 1353))
		(sender (ref: 1354))
		(signature ''withAllNodesDo:(Object)'')
		(sourceAnchor (ref: 1355)))
	(FAMIX.Invocation (id: 1356)
		(receiver (ref: 168))
		(sender (ref: 1357))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 1358)))
	(FAMIX.Access (id: 1359)
		(accessor (ref: 934))
		(sourceAnchor (ref: 935))
		(variable (ref: 1034)))
	(FAMIX.Method (id: 381)
		(name ''announce:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''announce:'')
		(sourceAnchor (ref: 382)))
	(FAMIX.Access (id: 1360)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 1361)))
	(FAMIX.Parameter (id: 1362)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Access (id: 1363)
		(accessor (ref: 468))
		(sourceAnchor (ref: 1364))
		(variable (ref: 1365)))
	(FAMIX.Parameter (id: 1366)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 878)))
	(FAMIX.Access (id: 1367)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 619)))
	(FAMIX.Access (id: 1368)
		(accessor (ref: 938))
		(sourceAnchor (ref: 939))
		(variable (ref: 1369)))
	(FAMIX.Access (id: 1370)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 220)))
	(FAMIX.Parameter (id: 1371)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 1290)))
	(FAMIX.Access (id: 1372)
		(accessor (ref: 837))
		(isWrite true)
		(sourceAnchor (ref: 838))
		(variable (ref: 1373)))
	(FAMIX.Class (id: 1374)
		(name ''CompiledMethod'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 8)
		(numberOfMethods 2)
		(numberOfParents 0)
		(numberOfStatements -2)
		(totalNumberOfChildren 0)
		(weightedMethodCount -2))
	(FAMIX.LocalVariable (id: 1375)
		(name ''v'')
		(parentBehaviouralEntity (ref: 1237)))
	(FAMIX.Method (id: 1143)
		(name ''origin:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''origin:'')
		(sourceAnchor (ref: 1144)))
	(FAMIX.Invocation (id: 1377)
		(sender (ref: 1378))
		(signature ''removeEdge:(Object)'')
		(sourceAnchor (ref: 1379)))
	(FAMIX.Access (id: 1380)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 1381)))
	(FAMIX.LocalVariable (id: 1382)
		(name ''collection'')
		(parentBehaviouralEntity (ref: 154)))
	(FAMIX.Access (id: 1383)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 1384)))
	(FAMIX.Class (id: 1385)
		(name ''Color'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 10)
		(numberOfLinesOfCode 70)
		(numberOfMethods 4)
		(numberOfParents 0)
		(numberOfStatements -4)
		(totalNumberOfChildren 0)
		(weightedMethodCount -4))
	(FAMIX.Access (id: 1386)
		(accessor (ref: 312))
		(sourceAnchor (ref: 313))
		(variable (ref: 898)))
	(FAMIX.Comment (id: 1387)
		(container (ref: 1388))
		(content ''"Return the height of the shape, for the giving graph element"''))
	(FAMIX.Access (id: 1389)
		(accessor (ref: 189))
		(sourceAnchor (ref: 336))
		(variable (ref: 335)))
	(FAMIX.Access (id: 1390)
		(accessor (ref: 243))
		(sourceAnchor (ref: 244))
		(variable (ref: 242)))
	(FAMIX.Invocation (id: 1391)
		(sender (ref: 556))
		(signature ''not()'')
		(sourceAnchor (ref: 557)))
	(FAMIX.Access (id: 1392)
		(accessor (ref: 1393))
		(sourceAnchor (ref: 1394))
		(variable (ref: 113)))
	(FAMIX.Invocation (id: 1395)
		(sender (ref: 426))
		(signature ''computeBoundsFor:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Invocation (id: 1396)
		(sender (ref: 1397))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Comment (id: 1399)
		(container (ref: 48))
		(content ''"same than edges:from:to:using:fromglobal:toGlobal: but on multiple edges
	aFromBlock has to return a collection of starting node
	fromGlobal and toGlobal must be boolean"''))
	(FAMIX.Comment (id: 1400)
		(container (ref: 1397))
		(content ''"Display the cache form on the provided canvas. No translation has been realized on it "''))
	(FAMIX.Invocation (id: 1401)
		(receiver (ref: 1402))
		(sender (ref: 516))
		(signature ''key()'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Access (id: 1403)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 1404)
		(accessor (ref: 318))
		(sourceAnchor (ref: 319))
		(variable (ref: 1177)))
	(FAMIX.Access (id: 1405)
		(accessor (ref: 1406))
		(sourceAnchor (ref: 1407))
		(variable (ref: 1408)))
	(FAMIX.Access (id: 1409)
		(accessor (ref: 912))
		(sourceAnchor (ref: 913))
		(variable (ref: 1410)))
	(FAMIX.Access (id: 1411)
		(accessor (ref: 1412))
		(sourceAnchor (ref: 1413))
		(variable (ref: 1414)))
	(FAMIX.Access (id: 1415)
		(accessor (ref: 993))
		(sourceAnchor (ref: 994))
		(variable (ref: 1416)))
	(FAMIX.Method (id: 1417)
		(name ''shape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''shape:'')
		(sourceAnchor (ref: 1418)))
	(FAMIX.Invocation (id: 1419)
		(receiver (ref: 1420))
		(sender (ref: 947))
		(signature ''left()'')
		(sourceAnchor (ref: 948)))
	(FAMIX.Method (id: 1421)
		(name ''absoluteBoundsFor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''absoluteBoundsFor:'')
		(sourceAnchor (ref: 1422)))
	(FAMIX.Access (id: 1423)
		(accessor (ref: 430))
		(sourceAnchor (ref: 1022))
		(variable (ref: 1424)))
	(FAMIX.Comment (id: 1425)
		(container (ref: 1426))
		(content ''"Simulate the graphical morph rendering"''))
	(FAMIX.Class (id: 1427)
		(name ''Point'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 2)
		(numberOfLinesOfCode 11)
		(numberOfMethods 3)
		(numberOfParents 0)
		(numberOfStatements -3)
		(totalNumberOfChildren 0)
		(weightedMethodCount -3))
	(FAMIX.LocalVariable (id: 916)
		(name ''val'')
		(parentBehaviouralEntity (ref: 308)))
	(FAMIX.Access (id: 1428)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 52)))
	(FAMIX.Access (id: 1429)
		(accessor (ref: 858))
		(sourceAnchor (ref: 859))
		(variable (ref: 857)))
	(FAMIX.Parameter (id: 97)
		(name ''fromGlobal'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Access (id: 1430)
		(accessor (ref: 1189))
		(isWrite true)
		(sourceAnchor (ref: 1190))
		(variable (ref: 299)))
	(FAMIX.Invocation (id: 1431)
		(receiver (ref: 1432))
		(sender (ref: 271))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 272)))
	(FAMIX.Invocation (id: 1433)
		(receiver (ref: 1434))
		(sender (ref: 1435))
		(signature ''increaseZoomBy:(Object)'')
		(sourceAnchor (ref: 1436)))
	(FAMIX.Invocation (id: 1437)
		(sender (ref: 128))
		(signature ''on:do:(Object,Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 1438)
		(accessor (ref: 149))
		(sourceAnchor (ref: 150))
		(variable (ref: 1439)))
	(FAMIX.Access (id: 1440)
		(accessor (ref: 1441))
		(sourceAnchor (ref: 1442))
		(variable (ref: 1443)))
	(FAMIX.Invocation (id: 1444)
		(receiver (ref: 1445))
		(sender (ref: 1446))
		(signature ''nodeShape()'')
		(sourceAnchor (ref: 1447)))
	(FAMIX.Invocation (id: 1448)
		(sender (ref: 827))
		(signature ''copy()'')
		(sourceAnchor (ref: 1301)))
	(FAMIX.Parameter (id: 1449)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 1087)))
	(FAMIX.Invocation (id: 1450)
		(sender (ref: 1451))
		(signature ''/(Object)'')
		(sourceAnchor (ref: 1452)))
	(FAMIX.LocalVariable (id: 1453)
		(name ''sum'')
		(parentBehaviouralEntity (ref: 404)))
	(FAMIX.Invocation (id: 1454)
		(receiver (ref: 641))
		(sender (ref: 354))
		(signature ''y()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 1455)
		(accessor (ref: 478))
		(sourceAnchor (ref: 479))
		(variable (ref: 1456)))
	(FAMIX.Access (id: 1457)
		(accessor (ref: 1458))
		(sourceAnchor (ref: 1459))
		(variable (ref: 1460)))
	(FAMIX.Comment (id: 1461)
		(container (ref: 1155))
		(content ''"-  aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	- aToBlock will be called on each element of the collection and return the destination node.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"''))
	(FAMIX.Invocation (id: 1462)
		(sender (ref: 275))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Access (id: 1463)
		(accessor (ref: 264))
		(sourceAnchor (ref: 265))
		(variable (ref: 263)))
	(FAMIX.Comment (id: 1464)
		(container (ref: 1087))
		(content ''"Same than edges:from:to: but with using a shape"''))
	(FAMIX.Invocation (id: 1465)
		(receiver (ref: 93))
		(sender (ref: 1104))
		(signature ''lightBlue()'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Access (id: 1466)
		(accessor (ref: 195))
		(sourceAnchor (ref: 197))
		(variable (ref: 1467)))
	(FAMIX.Access (id: 1468)
		(accessor (ref: 974))
		(sourceAnchor (ref: 975))
		(variable (ref: 1161)))
	(FAMIX.Method (id: 1469)
		(name ''horizontalTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''horizontalTreeLayout'')
		(sourceAnchor (ref: 1470)))
	(FAMIX.Access (id: 1471)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 403)))
	(FAMIX.Method (id: 162)
		(name ''allEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allEdges'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Comment (id: 1472)
		(container (ref: 207))
		(content ''"The owner must update its bounds. It must scale as well"''))
	(FAMIX.Method (id: 482)
		(name ''computeBoundsFor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''computeBoundsFor:'')
		(sourceAnchor (ref: 483)))
	(FAMIX.Invocation (id: 1473)
		(receiver (ref: 997))
		(sender (ref: 99))
		(signature ''new()'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Parameter (id: 1474)
		(name ''aGraphElement'')
		(parentBehaviouralEntity (ref: 1475)))
	(FAMIX.Invocation (id: 1476)
		(sender (ref: 13))
		(signature ''/(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 689)
		(name ''edges:fromAll:to:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:fromAll:to:'')
		(sourceAnchor (ref: 690)))
	(FAMIX.Access (id: 1477)
		(accessor (ref: 661))
		(sourceAnchor (ref: 662))
		(variable (ref: 1052)))
	(FAMIX.Invocation (id: 1478)
		(receiver (ref: 1016))
		(sender (ref: 48))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Invocation (id: 1479)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Invocation (id: 1480)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''owner()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Method (id: 1481)
		(name ''root'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''root'')
		(sourceAnchor (ref: 1482)))
	(FAMIX.Access (id: 1483)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 428)))
	(FAMIX.Access (id: 1484)
		(accessor (ref: 1147))
		(sourceAnchor (ref: 1148))
		(variable (ref: 1485)))
	(FAMIX.Invocation (id: 1486)
		(sender (ref: 498))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Invocation (id: 1487)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 1488)
		(receiver (ref: 834))
		(sender (ref: 80))
		(signature ''model:(Object)'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Access (id: 1489)
		(accessor (ref: 1269))
		(isWrite true)
		(sourceAnchor (ref: 1270))
		(variable (ref: 1268)))
	(FAMIX.Parameter (id: 1490)
		(name ''aFigure'')
		(parentBehaviouralEntity (ref: 1491)))
	(FAMIX.Invocation (id: 1492)
		(sender (ref: 327))
		(signature ''keys()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 1493)
		(receiver (ref: 1045))
		(sender (ref: 1043))
		(signature ''shape()'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.LocalVariable (id: 1317)
		(name ''k'')
		(parentBehaviouralEntity (ref: 1315)))
	(FAMIX.Invocation (id: 1494)
		(receiver (ref: 477))
		(sender (ref: 478))
		(signature ''source()'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Access (id: 1495)
		(accessor (ref: 1055))
		(sourceAnchor (ref: 1496))
		(variable (ref: 1497)))
	(FAMIX.Access (id: 1498)
		(accessor (ref: 1499))
		(sourceAnchor (ref: 1500))
		(variable (ref: 1501)))
	(FAMIX.Access (id: 1502)
		(accessor (ref: 1503))
		(sourceAnchor (ref: 1504))
		(variable (ref: 1505)))
	(FAMIX.Method (id: 814)
		(name ''numberOfAttributes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 405))
		(signature ''numberOfAttributes'')
		(sourceAnchor (ref: 815)))
	(FAMIX.LocalVariable (id: 1506)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1507)))
	(FAMIX.Invocation (id: 1508)
		(sender (ref: 69))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Comment (id: 1509)
		(container (ref: 102))
		(content ''"This method is ugly. It should not be. A cache is not made to be directly manipulated"''))
	(FAMIX.Comment (id: 1510)
		(container (ref: 1511))
		(content ''"since a root does not have a owner/parent, and it has no shape, there is no point in looking up the 
	cacheShapeBounds"''))
	(FAMIX.Access (id: 1512)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 1513)))
	(FAMIX.Access (id: 1514)
		(accessor (ref: 473))
		(sourceAnchor (ref: 474))
		(variable (ref: 475)))
	(FAMIX.Reference (id: 1515)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 1516)
		(receiver (ref: 1045))
		(sender (ref: 1043))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Invocation (id: 1517)
		(sender (ref: 39))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 1518)
		(accessor (ref: 1519))
		(sourceAnchor (ref: 1520))
		(variable (ref: 1521)))
	(FAMIX.Access (id: 1522)
		(accessor (ref: 1523))
		(sourceAnchor (ref: 1524))
		(variable (ref: 1525)))
	(FAMIX.Access (id: 1526)
		(accessor (ref: 1527))
		(sourceAnchor (ref: 1528))
		(variable (ref: 1529)))
	(FAMIX.Method (id: 993)
		(name ''removeAllEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeAllEdges'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Invocation (id: 1530)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''red()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 1531)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 875)))
	(FAMIX.Access (id: 1532)
		(accessor (ref: 1417))
		(isWrite true)
		(sourceAnchor (ref: 1418))
		(variable (ref: 940)))
	(FAMIX.LocalVariable (id: 1533)
		(name ''ratioH'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.LocalVariable (id: 1534)
		(name ''n'')
		(parentBehaviouralEntity (ref: 1354)))
	(FAMIX.Access (id: 1535)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 1153)))
	(FAMIX.Access (id: 1536)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Access (id: 1537)
		(accessor (ref: 388))
		(sourceAnchor (ref: 389))
		(variable (ref: 1538)))
	(FAMIX.Access (id: 1539)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 521)))
	(FAMIX.Access (id: 1540)
		(accessor (ref: 470))
		(sourceAnchor (ref: 744))
		(variable (ref: 1541)))
	(FAMIX.Invocation (id: 1542)
		(sender (ref: 404))
		(signature ''size()'')
		(sourceAnchor (ref: 406)))
	(FAMIX.Invocation (id: 1543)
		(receiver (ref: 1365))
		(sender (ref: 468))
		(signature ''edges:from:to:using:(Object,Object,Object,Object)'')
		(sourceAnchor (ref: 1364)))
	(FAMIX.Access (id: 1544)
		(accessor (ref: 1124))
		(sourceAnchor (ref: 1125))
		(variable (ref: 1173)))
	(FAMIX.Access (id: 1545)
		(accessor (ref: 1155))
		(sourceAnchor (ref: 1156))
		(variable (ref: 1157)))
	(FAMIX.Access (id: 1546)
		(accessor (ref: 374))
		(sourceAnchor (ref: 375))
		(variable (ref: 534)))
	(FAMIX.Method (id: 1547)
		(name ''deselect'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''deselect'')
		(sourceAnchor (ref: 1548)))
	(FAMIX.Access (id: 1549)
		(accessor (ref: 1550))
		(sourceAnchor (ref: 1551))
		(variable (ref: 1552)))
	(FAMIX.Invocation (id: 1553)
		(sender (ref: 866))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Access (id: 1554)
		(accessor (ref: 1555))
		(isWrite true)
		(sourceAnchor (ref: 1556))
		(variable (ref: 1557)))
	(FAMIX.Access (id: 1558)
		(accessor (ref: 1559))
		(sourceAnchor (ref: 1560))
		(variable (ref: 1561)))
	(FAMIX.Invocation (id: 1562)
		(sender (ref: 8))
		(signature ''yourself()'')
		(sourceAnchor (ref: 9)))
	(FAMIX.Method (id: 43)
		(name ''addEdge:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''addEdge:'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Method (id: 1559)
		(name ''addOutgoingEdge:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''addOutgoingEdge:'')
		(sourceAnchor (ref: 1560)))
	(FAMIX.Access (id: 1563)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.LocalVariable (id: 1564)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 929)))
	(FAMIX.Method (id: 1565)
		(name ''zOrder'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''zOrder'')
		(sourceAnchor (ref: 1566)))
	(FAMIX.Invocation (id: 1567)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''origin()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 1568)
		(accessor (ref: 1298))
		(sourceAnchor (ref: 1299))
		(variable (ref: 1569)))
	(FAMIX.Method (id: 1080)
		(name ''length'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''length'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Invocation (id: 1570)
		(receiver (ref: 1571))
		(sender (ref: 360))
		(signature ''edges:fromAll:to:using:fromGlobal:toGlobal:(Object,Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 361)))
	(FAMIX.Parameter (id: 914)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 912)))
	(FAMIX.Access (id: 1572)
		(accessor (ref: 24))
		(sourceAnchor (ref: 25))
		(variable (ref: 306)))
	(FAMIX.Access (id: 1573)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 1329)))
	(FAMIX.Invocation (id: 1574)
		(sender (ref: 248))
		(signature ''computeExtentFor:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Reference (id: 1575)
		(source (ref: 774))
		(sourceAnchor (ref: 775))
		(target (ref: 1064)))
	(FAMIX.Access (id: 1576)
		(accessor (ref: 1169))
		(sourceAnchor (ref: 1170))
		(variable (ref: 1577)))
	(FAMIX.Invocation (id: 1578)
		(receiver (ref: 1579))
		(sender (ref: 1202))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 1203)))
	(FAMIX.Access (id: 1580)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Method (id: 1199)
		(name ''clearLookupCacheRecursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''clearLookupCacheRecursively'')
		(sourceAnchor (ref: 1200)))
	(FAMIX.Access (id: 1581)
		(accessor (ref: 1582))
		(sourceAnchor (ref: 1583))
		(variable (ref: 1584)))
	(FAMIX.Method (id: 1585)
		(name ''defaultNodeShapeInstance'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultNodeShapeInstance'')
		(sourceAnchor (ref: 1586)))
	(FAMIX.Access (id: 1587)
		(accessor (ref: 622))
		(sourceAnchor (ref: 623))
		(variable (ref: 1588)))
	(FAMIX.Invocation (id: 1589)
		(receiver (ref: 1590))
		(sender (ref: 1426))
		(signature ''getRenderedFormSized:(Object)'')
		(sourceAnchor (ref: 1591)))
	(FAMIX.Method (id: 243)
		(name ''deselectAll'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''deselectAll'')
		(sourceAnchor (ref: 244)))
	(FAMIX.Invocation (id: 1592)
		(sender (ref: 318))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 319)))
	(FAMIX.LocalVariable (id: 600)
		(name ''edges'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Access (id: 1593)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 1594)))
	(FAMIX.Access (id: 1595)
		(accessor (ref: 350))
		(sourceAnchor (ref: 351))
		(variable (ref: 352)))
	(FAMIX.Invocation (id: 1596)
		(receiver (ref: 527))
		(sender (ref: 525))
		(signature ''allNodes()'')
		(sourceAnchor (ref: 526)))
	(FAMIX.Access (id: 1597)
		(accessor (ref: 1491))
		(sourceAnchor (ref: 1598))
		(variable (ref: 812)))
	(FAMIX.Invocation (id: 1599)
		(receiver (ref: 1600))
		(sender (ref: 13))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 1601)
		(receiver (ref: 1229))
		(sender (ref: 1223))
		(signature ''resetElementsToLookup()'')
		(sourceAnchor (ref: 1224)))
	(FAMIX.Access (id: 1602)
		(accessor (ref: 374))
		(sourceAnchor (ref: 375))
		(variable (ref: 1603)))
	(FAMIX.Invocation (id: 1604)
		(receiver (ref: 1072))
		(sender (ref: 1605))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1606)))
	(FAMIX.Access (id: 1607)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 1608)))
	(FAMIX.Access (id: 1609)
		(accessor (ref: 707))
		(sourceAnchor (ref: 708))
		(variable (ref: 1610)))
	(FAMIX.Method (id: 884)
		(name ''affectedNodesOf:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''affectedNodesOf:'')
		(sourceAnchor (ref: 1611)))
	(FAMIX.Access (id: 1612)
		(accessor (ref: 560))
		(sourceAnchor (ref: 561))
		(variable (ref: 1613)))
	(FAMIX.LocalVariable (id: 1614)
		(name ''oldShape'')
		(parentBehaviouralEntity (ref: 54)))
	(FAMIX.Comment (id: 1615)
		(container (ref: 756))
		(content ''"Transcript show: ''''debug setDefaultHandlersMouseDown 2 : '''', selectionBoxCorner1 printString, '''' '''', selectionBoxCorner2 printString ; cr."''))
	(FAMIX.Access (id: 1616)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 1617)))
	(FAMIX.Access (id: 1618)
		(accessor (ref: 2))
		(sourceAnchor (ref: 1619))
		(variable (ref: 1620)))
	(FAMIX.Access (id: 1621)
		(accessor (ref: 1388))
		(sourceAnchor (ref: 1622))
		(variable (ref: 1623)))
	(FAMIX.Invocation (id: 1624)
		(sender (ref: 611))
		(signature ''removeKey:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Comment (id: 1625)
		(container (ref: 740))
		(content ''"Remove the receiver from the parent element."''))
	(FAMIX.Parameter (id: 1626)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 668)))
	(FAMIX.Invocation (id: 1627)
		(receiver (ref: 575))
		(sender (ref: 573))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 574)))
	(FAMIX.Parameter (id: 1628)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1629)))
	(FAMIX.Invocation (id: 1630)
		(receiver (ref: 1631))
		(sender (ref: 1338))
		(signature ''expandToIncludePoint:(Object)'')
		(sourceAnchor (ref: 1339)))
	(FAMIX.Invocation (id: 1632)
		(sender (ref: 498))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Parameter (id: 1561)
		(name ''anEdge'')
		(parentBehaviouralEntity (ref: 1559)))
	(FAMIX.Access (id: 1633)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1016)))
	(FAMIX.Access (id: 1634)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1288)))
	(FAMIX.Parameter (id: 721)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 719)))
	(FAMIX.Parameter (id: 1635)
		(name ''childrenBounds'')
		(parentBehaviouralEntity (ref: 1555)))
	(FAMIX.Reference (id: 1636)
		(source (ref: 1559))
		(sourceAnchor (ref: 1560))
		(target (ref: 41)))
	(FAMIX.LocalVariable (id: 608)
		(name ''a'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Invocation (id: 1637)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''yellow()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Parameter (id: 1638)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Invocation (id: 1639)
		(receiver (ref: 768))
		(sender (ref: 1640))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1641)))
	(FAMIX.Access (id: 1642)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 1029)))
	(FAMIX.LocalVariable (id: 1643)
		(name ''b'')
		(parentBehaviouralEntity (ref: 1043)))
	(FAMIX.Parameter (id: 1644)
		(name ''aOneArgumentBlock'')
		(parentBehaviouralEntity (ref: 1645)))
	(FAMIX.LocalVariable (id: 1646)
		(name ''newRelativePosition'')
		(parentBehaviouralEntity (ref: 182)))
	(FAMIX.Invocation (id: 1647)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''edges:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 1648)
		(receiver (ref: 1649))
		(sender (ref: 1650))
		(signature ''model()'')
		(sourceAnchor (ref: 1651)))
	(FAMIX.Access (id: 1652)
		(accessor (ref: 1087))
		(sourceAnchor (ref: 1088))
		(variable (ref: 1653)))
	(FAMIX.Access (id: 1654)
		(accessor (ref: 414))
		(isWrite true)
		(sourceAnchor (ref: 415))
		(variable (ref: 1655)))
	(FAMIX.Invocation (id: 1656)
		(sender (ref: 207))
		(signature ''keys()'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Comment (id: 1657)
		(container (ref: 327))
		(content ''"the root has to be extended in any case"''))
	(FAMIX.Invocation (id: 1658)
		(sender (ref: 252))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 1659)))
	(FAMIX.Access (id: 1660)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 1661)))
	(FAMIX.Access (id: 1662)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 832)))
	(FAMIX.Invocation (id: 1663)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 1664)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1600)))
	(FAMIX.Reference (id: 1665)
		(source (ref: 627))
		(sourceAnchor (ref: 628))
		(target (ref: 41)))
	(FAMIX.Method (id: 1666)
		(name ''doIncrementallyExecute:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''doIncrementallyExecute:'')
		(sourceAnchor (ref: 1667)))
	(FAMIX.Access (id: 1668)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 830)))
	(FAMIX.Invocation (id: 1669)
		(sender (ref: 1272))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Invocation (id: 1670)
		(sender (ref: 128))
		(signature ''includes:(Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Invocation (id: 1671)
		(receiver (ref: 924))
		(sender (ref: 224))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Method (id: 1672)
		(name ''resetFormCacheUpToTheRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''resetFormCacheUpToTheRoot'')
		(sourceAnchor (ref: 1673)))
	(FAMIX.Invocation (id: 1674)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''lightGreen()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 1675)
		(accessor (ref: 1676))
		(isWrite true)
		(sourceAnchor (ref: 1677))
		(variable (ref: 1678)))
	(FAMIX.LocalVariable (id: 1679)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 414)))
	(FAMIX.Parameter (id: 772)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 770)))
	(FAMIX.Invocation (id: 1680)
		(receiver (ref: 1681))
		(sender (ref: 658))
		(signature ''root()'')
		(sourceAnchor (ref: 659)))
	(FAMIX.LocalVariable (id: 1682)
		(name ''n'')
		(parentBehaviouralEntity (ref: 124)))
	(FAMIX.Access (id: 1683)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Access (id: 1684)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 1685)))
	(FAMIX.Invocation (id: 1686)
		(sender (ref: 453))
		(signature '',(Object)'')
		(sourceAnchor (ref: 454)))
	(FAMIX.Access (id: 1687)
		(accessor (ref: 39))
		(isWrite true)
		(sourceAnchor (ref: 40))
		(variable (ref: 1688)))
	(FAMIX.Invocation (id: 1689)
		(receiver (ref: 1690))
		(sender (ref: 1406))
		(signature ''cache()'')
		(sourceAnchor (ref: 1407)))
	(FAMIX.Invocation (id: 1691)
		(receiver (ref: 1692))
		(sender (ref: 1010))
		(signature ''root()'')
		(sourceAnchor (ref: 1011)))
	(FAMIX.Access (id: 1693)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1694)))
	(FAMIX.Invocation (id: 1695)
		(receiver (ref: 1696))
		(sender (ref: 43))
		(signature ''edges()'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Access (id: 1697)
		(accessor (ref: 785))
		(sourceAnchor (ref: 786))
		(variable (ref: 1698)))
	(FAMIX.LocalVariable (id: 1209)
		(name ''el'')
		(parentBehaviouralEntity (ref: 1207)))
	(FAMIX.Reference (id: 1699)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 1700)
		(receiver (ref: 1384))
		(sender (ref: 275))
		(signature ''outgoingEdges()'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Invocation (id: 1701)
		(sender (ref: 327))
		(signature ''translateBy:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 1702)
		(accessor (ref: 318))
		(sourceAnchor (ref: 319))
		(variable (ref: 317)))
	(FAMIX.Method (id: 1550)
		(name ''deselect'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''deselect'')
		(sourceAnchor (ref: 1551)))
	(FAMIX.Comment (id: 1703)
		(container (ref: 91))
		(content ''"red"''))
	(FAMIX.Access (id: 1704)
		(accessor (ref: 827))
		(sourceAnchor (ref: 1301))
		(variable (ref: 1705)))
	(FAMIX.Method (id: 959)
		(name ''removeEdge:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeEdge:'')
		(sourceAnchor (ref: 960)))
	(FAMIX.Access (id: 1706)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Access (id: 1707)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Class (id: 460)
		(name ''MOForceBasedLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 1708)
		(accessor (ref: 1709))
		(sourceAnchor (ref: 1710))
		(variable (ref: 1711)))
	(FAMIX.Invocation (id: 1712)
		(receiver (ref: 954))
		(sender (ref: 116))
		(signature ''notNil()'')
		(sourceAnchor (ref: 117)))
	(FAMIX.Invocation (id: 1713)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 1714)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 1041)))
	(FAMIX.Class (id: 1715)
		(name ''MOGridLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 1716)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 793)))
	(FAMIX.Access (id: 1717)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 587)))
	(FAMIX.Parameter (id: 1718)
		(name ''fromGlobal'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Access (id: 1719)
		(accessor (ref: 1720))
		(sourceAnchor (ref: 1721))
		(variable (ref: 1722)))
	(FAMIX.Access (id: 1723)
		(accessor (ref: 1724))
		(sourceAnchor (ref: 1725))
		(variable (ref: 812)))
	(FAMIX.LocalVariable (id: 1726)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 207)))
	(FAMIX.Access (id: 1727)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 1728)))
	(FAMIX.Reference (id: 1729)
		(source (ref: 1104))
		(sourceAnchor (ref: 1105))
		(target (ref: 93)))
	(FAMIX.LocalVariable (id: 1331)
		(name ''maxHeight'')
		(parentBehaviouralEntity (ref: 35)))
	(FAMIX.Invocation (id: 1730)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''clearLookupCacheRecursively()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 1731)
		(accessor (ref: 1341))
		(sourceAnchor (ref: 1342))
		(variable (ref: 1732)))
	(FAMIX.Invocation (id: 1733)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''brown()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 1734)
		(receiver (ref: 698))
		(sender (ref: 696))
		(signature ''initialize()'')
		(sourceAnchor (ref: 697)))
	(FAMIX.Comment (id: 1735)
		(container (ref: 381))
		(content ''"^ self announcer announce: ann"''))
	(FAMIX.Invocation (id: 1736)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 1737)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''bounds()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Parameter (id: 416)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 414)))
	(FAMIX.Invocation (id: 1738)
		(sender (ref: 35))
		(signature ''ifEmpty:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Invocation (id: 1739)
		(sender (ref: 963))
		(signature ''new()'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Access (id: 1740)
		(accessor (ref: 433))
		(sourceAnchor (ref: 434))
		(variable (ref: 1741)))
	(FAMIX.Invocation (id: 1742)
		(sender (ref: 275))
		(signature ''remove:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Comment (id: 1743)
		(container (ref: 556))
		(content ''"True if I am an instance of one of the subclass of MOLineShape"''))
	(FAMIX.Access (id: 1744)
		(accessor (ref: 1278))
		(isWrite true)
		(sourceAnchor (ref: 1279))
		(variable (ref: 1745)))
	(FAMIX.Invocation (id: 1746)
		(receiver (ref: 1747))
		(sender (ref: 516))
		(signature ''cache()'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Access (id: 1748)
		(accessor (ref: 327))
		(isWrite true)
		(sourceAnchor (ref: 328))
		(variable (ref: 1749)))
	(FAMIX.Access (id: 1750)
		(accessor (ref: 740))
		(sourceAnchor (ref: 741))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 1751)
		(receiver (ref: 1157))
		(sender (ref: 1155))
		(signature ''edges:from:to:using:(Object,Object,Object,Object)'')
		(sourceAnchor (ref: 1156)))
	(FAMIX.Invocation (id: 1752)
		(sender (ref: 69))
		(signature ''corner()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 1753)
		(sender (ref: 777))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Access (id: 1754)
		(accessor (ref: 360))
		(sourceAnchor (ref: 361))
		(variable (ref: 1755)))
	(FAMIX.Invocation (id: 1756)
		(sender (ref: 1757))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 1758)))
	(FAMIX.Access (id: 1759)
		(accessor (ref: 1354))
		(sourceAnchor (ref: 1355))
		(variable (ref: 1760)))
	(FAMIX.Method (id: 1761)
		(name ''firstSubnodeThat:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''firstSubnodeThat:ifAbsent:'')
		(sourceAnchor (ref: 1762)))
	(FAMIX.Access (id: 1763)
		(accessor (ref: 229))
		(sourceAnchor (ref: 230))
		(variable (ref: 1764)))
	(FAMIX.Invocation (id: 1765)
		(receiver (ref: 1766))
		(sender (ref: 498))
		(signature ''hasSelectionBox()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Invocation (id: 1767)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''userDefinedEdges()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 1768)
		(accessor (ref: 173))
		(sourceAnchor (ref: 174))
		(variable (ref: 750)))
	(FAMIX.Method (id: 1769)
		(name ''removeElementToDisplay:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeElementToDisplay:'')
		(sourceAnchor (ref: 1770)))
	(FAMIX.Access (id: 1771)
		(accessor (ref: 1511))
		(sourceAnchor (ref: 1772))
		(variable (ref: 1773)))
	(FAMIX.Parameter (id: 1774)
		(name ''aCommandClass'')
		(parentBehaviouralEntity (ref: 1775)))
	(FAMIX.Access (id: 1776)
		(accessor (ref: 1777))
		(sourceAnchor (ref: 1778))
		(variable (ref: 1779)))
	(FAMIX.Access (id: 1780)
		(accessor (ref: 1218))
		(sourceAnchor (ref: 1219))
		(variable (ref: 1781)))
	(FAMIX.Invocation (id: 1782)
		(receiver (ref: 1569))
		(sender (ref: 1298))
		(signature ''firstSubnodeThat:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1299)))
	(FAMIX.Access (id: 1783)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 1153)))
	(FAMIX.Invocation (id: 1784)
		(receiver (ref: 181))
		(sender (ref: 1785))
		(signature ''resetElementsToDisplayCache()'')
		(sourceAnchor (ref: 1786)))
	(FAMIX.Access (id: 1787)
		(accessor (ref: 423))
		(sourceAnchor (ref: 424))
		(variable (ref: 1788)))
	(FAMIX.Method (id: 661)
		(name ''edgesFrom:fromGlobal:toGlobal:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 8)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgesFrom:fromGlobal:toGlobal:'')
		(sourceAnchor (ref: 662)))
	(FAMIX.Access (id: 1789)
		(accessor (ref: 963))
		(sourceAnchor (ref: 964))
		(variable (ref: 940)))
	(FAMIX.Method (id: 1272)
		(name ''shouldCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''shouldCache'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Parameter (id: 553)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 237)))
	(FAMIX.Access (id: 1790)
		(accessor (ref: 1237))
		(sourceAnchor (ref: 1791))
		(variable (ref: 1792)))
	(FAMIX.Class (id: 1793)
		(name ''MOSugiyamaLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 1794)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1795)))
	(FAMIX.Invocation (id: 1796)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''purple()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 1797)
		(accessor (ref: 1507))
		(sourceAnchor (ref: 1798))
		(variable (ref: 1799)))
	(FAMIX.Invocation (id: 1800)
		(receiver (ref: 1801))
		(sender (ref: 224))
		(signature ''model()'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Invocation (id: 1802)
		(receiver (ref: 1803))
		(sender (ref: 1804))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1805)))
	(FAMIX.LocalVariable (id: 904)
		(name ''a'')
		(parentBehaviouralEntity (ref: 221)))
	(FAMIX.Method (id: 1806)
		(name ''setOwner:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''setOwner:'')
		(sourceAnchor (ref: 1807)))
	(FAMIX.Invocation (id: 1808)
		(receiver (ref: 1809))
		(sender (ref: 473))
		(signature ''shape:key:(Object,Object)'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Invocation (id: 1810)
		(receiver (ref: 1811))
		(sender (ref: 1555))
		(signature ''top()'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Invocation (id: 1812)
		(receiver (ref: 41))
		(sender (ref: 95))
		(signature ''new()'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 1813)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 1814)))
	(FAMIX.Parameter (id: 1815)
		(name ''aZeroArgBlock'')
		(parentBehaviouralEntity (ref: 894)))
	(FAMIX.LocalVariable (id: 1816)
		(name ''deltaOrigin'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Invocation (id: 1817)
		(receiver (ref: 1818))
		(sender (ref: 189))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 336)))
	(FAMIX.Invocation (id: 1819)
		(sender (ref: 1820))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Parameter (id: 1822)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1823)))
	(FAMIX.Invocation (id: 1824)
		(receiver (ref: 1825))
		(sender (ref: 1826))
		(signature ''originalPrintOn:(Object)'')
		(sourceAnchor (ref: 1827)))
	(FAMIX.Invocation (id: 1828)
		(sender (ref: 124))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Access (id: 1829)
		(accessor (ref: 878))
		(sourceAnchor (ref: 879))
		(variable (ref: 1366)))
	(FAMIX.Access (id: 1830)
		(accessor (ref: 1831))
		(sourceAnchor (ref: 1832))
		(variable (ref: 1833)))
	(FAMIX.Method (id: 693)
		(name ''setDefaultHandlersMouseMove'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''setDefaultHandlersMouseMove'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Access (id: 1834)
		(accessor (ref: 723))
		(sourceAnchor (ref: 724))
		(variable (ref: 1835)))
	(FAMIX.LocalVariable (id: 1225)
		(name ''ow'')
		(parentBehaviouralEntity (ref: 1223)))
	(FAMIX.Invocation (id: 1836)
		(sender (ref: 947))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 948)))
	(FAMIX.LocalVariable (id: 403)
		(name ''each'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Method (id: 1837)
		(name ''corner'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''corner'')
		(sourceAnchor (ref: 1838)))
	(FAMIX.Method (id: 1839)
		(name ''resetElementsToDisplayCacheRecursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''resetElementsToDisplayCacheRecursively'')
		(sourceAnchor (ref: 1840)))
	(FAMIX.Access (id: 1841)
		(accessor (ref: 1605))
		(isWrite true)
		(sourceAnchor (ref: 1606))
		(variable (ref: 1072)))
	(FAMIX.Access (id: 1842)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 1843)))
	(FAMIX.Invocation (id: 1844)
		(receiver (ref: 22))
		(sender (ref: 20))
		(signature ''perform:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Invocation (id: 1845)
		(receiver (ref: 317))
		(sender (ref: 318))
		(signature ''nodes()'')
		(sourceAnchor (ref: 319)))
	(FAMIX.Method (id: 719)
		(name ''edges:fromAll:toAll:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:fromAll:toAll:'')
		(sourceAnchor (ref: 720)))
	(FAMIX.Access (id: 1846)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 924)))
	(FAMIX.Access (id: 1847)
		(accessor (ref: 1215))
		(sourceAnchor (ref: 1216))
		(variable (ref: 1214)))
	(FAMIX.Invocation (id: 1848)
		(receiver (ref: 383))
		(sender (ref: 381))
		(signature ''element()'')
		(sourceAnchor (ref: 382)))
	(FAMIX.Access (id: 1849)
		(accessor (ref: 884))
		(sourceAnchor (ref: 1611))
		(variable (ref: 582)))
	(FAMIX.Reference (id: 1850)
		(source (ref: 1851))
		(sourceAnchor (ref: 1852))
		(target (ref: 1715)))
	(FAMIX.Access (id: 1853)
		(accessor (ref: 149))
		(sourceAnchor (ref: 150))
		(variable (ref: 148)))
	(FAMIX.Invocation (id: 1854)
		(sender (ref: 1855))
		(signature ''scaleBy:(Object)'')
		(sourceAnchor (ref: 1856)))
	(FAMIX.Method (id: 29)
		(name ''forceBasedLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''forceBasedLayout'')
		(sourceAnchor (ref: 30)))
	(FAMIX.Access (id: 1857)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 1858)))
	(FAMIX.Access (id: 1859)
		(accessor (ref: 1860))
		(sourceAnchor (ref: 1861))
		(variable (ref: 1862)))
	(FAMIX.Comment (id: 1863)
		(container (ref: 388))
		(content ''"Return the default node shape"''))
	(FAMIX.Invocation (id: 1864)
		(receiver (ref: 1865))
		(sender (ref: 498))
		(signature ''owner()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Access (id: 1866)
		(accessor (ref: 1867))
		(sourceAnchor (ref: 1868))
		(variable (ref: 1869)))
	(FAMIX.LocalVariable (id: 1870)
		(name ''edges'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.LocalVariable (id: 1779)
		(name ''each'')
		(parentBehaviouralEntity (ref: 1777)))
	(FAMIX.Parameter (id: 1871)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 858)))
	(FAMIX.Access (id: 1872)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 42)))
	(FAMIX.Class (id: 196)
		(name ''MOShape'')
		(fanIn 0)
		(fanOut 1)
		(hierarchyNestingLevel 1)
		(numberOfAttributes 3)
		(numberOfComments 26)
		(numberOfLinesOfCode 127)
		(numberOfMethods 26)
		(numberOfParents 1)
		(numberOfStatements -26)
		(totalNumberOfChildren 0)
		(weightedMethodCount -26))
	(FAMIX.Access (id: 1873)
		(accessor (ref: 229))
		(sourceAnchor (ref: 230))
		(variable (ref: 1874)))
	(FAMIX.Invocation (id: 1875)
		(receiver (ref: 1600))
		(sender (ref: 13))
		(signature ''shape()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Reference (id: 1876)
		(source (ref: 20))
		(sourceAnchor (ref: 21))
		(target (ref: 133)))
	(FAMIX.Method (id: 1877)
		(name ''interaction'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''interaction'')
		(sourceAnchor (ref: 1878)))
	(FAMIX.Access (id: 1879)
		(accessor (ref: 1412))
		(isWrite true)
		(sourceAnchor (ref: 1413))
		(variable (ref: 1880)))
	(FAMIX.Access (id: 1881)
		(accessor (ref: 1640))
		(isWrite true)
		(sourceAnchor (ref: 1641))
		(variable (ref: 768)))
	(FAMIX.Access (id: 1882)
		(accessor (ref: 947))
		(sourceAnchor (ref: 948))
		(variable (ref: 946)))
	(FAMIX.Access (id: 1883)
		(accessor (ref: 1104))
		(sourceAnchor (ref: 1105))
		(variable (ref: 954)))
	(FAMIX.Access (id: 1884)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1885)))
	(FAMIX.LocalVariable (id: 1886)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 565)))
	(FAMIX.Invocation (id: 1887)
		(receiver (ref: 523))
		(sender (ref: 498))
		(signature ''containsRect:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Access (id: 1888)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Invocation (id: 1889)
		(receiver (ref: 1890))
		(sender (ref: 308))
		(signature ''copyWithout:(Object)'')
		(sourceAnchor (ref: 618)))
	(FAMIX.Access (id: 1891)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 1892)))
	(FAMIX.Method (id: 1357)
		(name ''translate:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''translate:'')
		(sourceAnchor (ref: 1358)))
	(FAMIX.Method (id: 912)
		(name ''nodes:forEach:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodes:forEach:'')
		(sourceAnchor (ref: 913)))
	(FAMIX.Method (id: 932)
		(name ''resetFormCacheResursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetFormCacheResursively'')
		(sourceAnchor (ref: 1893)))
	(FAMIX.Method (id: 342)
		(name ''moValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1894))
		(signature ''moValue:'')
		(sourceAnchor (ref: 1895)))
	(FAMIX.Reference (id: 1896)
		(source (ref: 703))
		(sourceAnchor (ref: 704))
		(target (ref: 1897)))
	(FAMIX.Method (id: 204)
		(name ''globalLookupNode:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''globalLookupNode:'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Invocation (id: 1898)
		(receiver (ref: 1705))
		(sender (ref: 827))
		(signature ''adoptNewShape:(Object)'')
		(sourceAnchor (ref: 1301)))
	(FAMIX.LocalVariable (id: 1899)
		(name ''each'')
		(parentBehaviouralEntity (ref: 672)))
	(FAMIX.Parameter (id: 1900)
		(name ''bounded'')
		(parentBehaviouralEntity (ref: 1901)))
	(FAMIX.Access (id: 1902)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 875)))
	(FAMIX.Access (id: 1903)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1904)))
	(FAMIX.Access (id: 1905)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 1906)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1600)))
	(FAMIX.Access (id: 1907)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Comment (id: 1908)
		(container (ref: 212))
		(content ''"Having IdentityDictionary instead of SmallDictionary works the same, it is faster although"''))
	(FAMIX.Access (id: 1909)
		(accessor (ref: 1820))
		(sourceAnchor (ref: 1821))
		(variable (ref: 1910)))
	(FAMIX.Method (id: 1124)
		(name ''lookupNode:globally:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''lookupNode:globally:'')
		(sourceAnchor (ref: 1125)))
	(FAMIX.Invocation (id: 1911)
		(sender (ref: 1272))
		(signature ''not()'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Access (id: 1912)
		(accessor (ref: 1026))
		(sourceAnchor (ref: 1027))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 1913)
		(sender (ref: 592))
		(signature ''viewRenderer:(Object)'')
		(sourceAnchor (ref: 594)))
	(FAMIX.Parameter (id: 1212)
		(name ''target'')
		(parentBehaviouralEntity (ref: 658)))
	(FAMIX.Method (id: 1345)
		(name ''withEdges:'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constructor'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''withEdges:'')
		(sourceAnchor (ref: 1346)))
	(FAMIX.Parameter (id: 1914)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 304)))
	(FAMIX.Access (id: 1915)
		(accessor (ref: 391))
		(sourceAnchor (ref: 392))
		(variable (ref: 1916)))
	(FAMIX.Invocation (id: 1917)
		(receiver (ref: 41))
		(sender (ref: 627))
		(signature ''new()'')
		(sourceAnchor (ref: 628)))
	(FAMIX.Invocation (id: 1918)
		(sender (ref: 615))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 616)))
	(FAMIX.Invocation (id: 1919)
		(receiver (ref: 1749))
		(sender (ref: 327))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 1920)
		(accessor (ref: 1921))
		(sourceAnchor (ref: 1922))
		(variable (ref: 614)))
	(FAMIX.Access (id: 1923)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 1614)))
	(FAMIX.Access (id: 1924)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 1925)))
	(FAMIX.Method (id: 756)
		(name ''setDefaultHandlersMouseDown'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 4)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 17)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''setDefaultHandlersMouseDown'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Method (id: 785)
		(name ''allSelectedNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allSelectedNodes'')
		(sourceAnchor (ref: 786)))
	(FAMIX.Access (id: 1926)
		(accessor (ref: 644))
		(sourceAnchor (ref: 645))
		(variable (ref: 1927)))
	(FAMIX.Parameter (id: 1928)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Access (id: 1929)
		(accessor (ref: 1147))
		(sourceAnchor (ref: 1148))
		(variable (ref: 1146)))
	(FAMIX.Access (id: 1930)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 1931)
		(receiver (ref: 702))
		(sender (ref: 200))
		(signature ''print:(Object)'')
		(sourceAnchor (ref: 201)))
	(FAMIX.Access (id: 1932)
		(accessor (ref: 414))
		(isWrite true)
		(sourceAnchor (ref: 415))
		(variable (ref: 1933)))
	(FAMIX.Access (id: 1934)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1935)))
	(FAMIX.Access (id: 1936)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1766)))
	(FAMIX.Invocation (id: 1937)
		(sender (ref: 39))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 1938)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Invocation (id: 1939)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''owner()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 1940)
		(receiver (ref: 1091))
		(sender (ref: 498))
		(signature ''new()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Access (id: 1941)
		(accessor (ref: 1096))
		(sourceAnchor (ref: 1097))
		(variable (ref: 1098)))
	(FAMIX.Access (id: 1942)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1600)))
	(FAMIX.Access (id: 1943)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 1614)))
	(FAMIX.LocalVariable (id: 439)
		(name ''v'')
		(parentBehaviouralEntity (ref: 437)))
	(FAMIX.Access (id: 1944)
		(accessor (ref: 1354))
		(sourceAnchor (ref: 1355))
		(variable (ref: 1353)))
	(FAMIX.Invocation (id: 1945)
		(receiver (ref: 1722))
		(sender (ref: 1720))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1721)))
	(FAMIX.Invocation (id: 1946)
		(receiver (ref: 1212))
		(sender (ref: 658))
		(signature ''notNil()'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Invocation (id: 1947)
		(receiver (ref: 977))
		(sender (ref: 929))
		(signature ''allIncomingEdges()'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Access (id: 1948)
		(accessor (ref: 1949))
		(sourceAnchor (ref: 1950))
		(variable (ref: 1951)))
	(FAMIX.Comment (id: 1952)
		(container (ref: 1019))
		(content ''"Return true if the element is visible within the bounds, absolute bounds are tested for this"''))
	(FAMIX.Access (id: 1953)
		(accessor (ref: 565))
		(sourceAnchor (ref: 566))
		(variable (ref: 1886)))
	(FAMIX.Class (id: 1809)
		(name ''MOElementShapeProperties class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 1954)
		(accessor (ref: 1104))
		(sourceAnchor (ref: 1105))
		(variable (ref: 1955)))
	(FAMIX.Access (id: 1956)
		(accessor (ref: 1559))
		(sourceAnchor (ref: 1560))
		(variable (ref: 1957)))
	(FAMIX.Access (id: 1958)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 717)))
	(FAMIX.Parameter (id: 1959)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 1761)))
	(FAMIX.Access (id: 1960)
		(accessor (ref: 689))
		(sourceAnchor (ref: 690))
		(variable (ref: 1961)))
	(FAMIX.Comment (id: 1962)
		(container (ref: 414))
		(content ''"Simulate the graphical morph rendering"''))
	(FAMIX.Method (id: 473)
		(name ''cacheNamed:of:ifAbsentInitializeWith:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''cacheNamed:of:ifAbsentInitializeWith:'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Method (id: 286)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''initialize'')
		(sourceAnchor (ref: 287)))
	(FAMIX.Access (id: 1963)
		(accessor (ref: 398))
		(sourceAnchor (ref: 399))
		(variable (ref: 397)))
	(FAMIX.Invocation (id: 1964)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''bounds()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 1965)
		(receiver (ref: 1966))
		(sender (ref: 1967))
		(signature ''nodes()'')
		(sourceAnchor (ref: 1968)))
	(FAMIX.Access (id: 1969)
		(accessor (ref: 719))
		(sourceAnchor (ref: 720))
		(variable (ref: 1970)))
	(FAMIX.Invocation (id: 1971)
		(receiver (ref: 1972))
		(sender (ref: 1973))
		(signature ''new()'')
		(sourceAnchor (ref: 1974)))
	(FAMIX.Access (id: 1975)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 425)))
	(FAMIX.Invocation (id: 1976)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 1977)
		(accessor (ref: 1527))
		(isWrite true)
		(sourceAnchor (ref: 1528))
		(variable (ref: 1978)))
	(FAMIX.Parameter (id: 1979)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Invocation (id: 1980)
		(receiver (ref: 1485))
		(sender (ref: 1147))
		(signature ''computeElementsToDisplay()'')
		(sourceAnchor (ref: 1148)))
	(FAMIX.Invocation (id: 1981)
		(receiver (ref: 296))
		(sender (ref: 294))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Invocation (id: 1982)
		(receiver (ref: 122))
		(sender (ref: 304))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Access (id: 1983)
		(accessor (ref: 1984))
		(sourceAnchor (ref: 1985))
		(variable (ref: 812)))
	(FAMIX.Access (id: 1986)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 843)))
	(FAMIX.Method (id: 338)
		(name ''displayWithoutCacheOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''displayWithoutCacheOn:'')
		(sourceAnchor (ref: 339)))
	(FAMIX.Access (id: 1987)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 431)))
	(FAMIX.Class (id: 211)
		(name ''SmallDictionary class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 1988)
		(accessor (ref: 1989))
		(sourceAnchor (ref: 1990))
		(variable (ref: 288)))
	(FAMIX.Invocation (id: 1991)
		(receiver (ref: 126))
		(sender (ref: 124))
		(signature ''noneSatisfy:(Object)'')
		(sourceAnchor (ref: 125)))
	(FAMIX.LocalVariable (id: 1795)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 756)))
	(FAMIX.Invocation (id: 1992)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.LocalVariable (id: 1993)
		(name ''node'')
		(parentBehaviouralEntity (ref: 932)))
	(FAMIX.Method (id: 166)
		(name ''extent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''extent:'')
		(sourceAnchor (ref: 167)))
	(FAMIX.Invocation (id: 1994)
		(sender (ref: 1315))
		(signature ''keys()'')
		(sourceAnchor (ref: 1316)))
	(FAMIX.Access (id: 1995)
		(accessor (ref: 1996))
		(sourceAnchor (ref: 1997))
		(variable (ref: 1998)))
	(FAMIX.Access (id: 1999)
		(accessor (ref: 1826))
		(sourceAnchor (ref: 1827))
		(variable (ref: 2000)))
	(FAMIX.Parameter (id: 2001)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 312)))
	(FAMIX.Method (id: 1237)
		(name ''forNodes:do:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''forNodes:do:'')
		(sourceAnchor (ref: 1791)))
	(FAMIX.Method (id: 1104)
		(name ''displaySelectionBoxIfNecessaryOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 8)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''displaySelectionBoxIfNecessaryOn:'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Class (id: 1348)
		(name ''MORadialTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 2002)
		(sender (ref: 84))
		(signature ''announcer()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Access (id: 2003)
		(accessor (ref: 374))
		(sourceAnchor (ref: 375))
		(variable (ref: 2004)))
	(FAMIX.Class (id: 1897)
		(name ''MODominanceTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 2005)
		(sender (ref: 770))
		(signature ''symbol:(Object)'')
		(sourceAnchor (ref: 771)))
	(FAMIX.Parameter (id: 2006)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 473)))
	(FAMIX.Access (id: 2007)
		(accessor (ref: 707))
		(sourceAnchor (ref: 708))
		(variable (ref: 2008)))
	(FAMIX.Invocation (id: 2009)
		(sender (ref: 248))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 2010)
		(accessor (ref: 391))
		(sourceAnchor (ref: 392))
		(variable (ref: 1916)))
	(FAMIX.Access (id: 2011)
		(accessor (ref: 2012))
		(sourceAnchor (ref: 2013))
		(variable (ref: 2014)))
	(FAMIX.Method (id: 2015)
		(name ''threadholdSize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''threadholdSize'')
		(sourceAnchor (ref: 2016)))
	(FAMIX.Invocation (id: 2017)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''shape()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 2018)
		(receiver (ref: 42))
		(sender (ref: 43))
		(signature ''target()'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Access (id: 2019)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 654)))
	(FAMIX.Invocation (id: 2020)
		(receiver (ref: 2021))
		(sender (ref: 693))
		(signature ''position()'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Comment (id: 2022)
		(container (ref: 482))
		(content ''"Return the bounds with a relative origin"''))
	(FAMIX.Reference (id: 2023)
		(source (ref: 1640))
		(sourceAnchor (ref: 1641))
		(target (ref: 2024)))
	(FAMIX.Invocation (id: 2025)
		(receiver (ref: 416))
		(sender (ref: 414))
		(signature ''extent()'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Access (id: 2026)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.Invocation (id: 2027)
		(sender (ref: 1043))
		(signature ''computeBoundsFor:(Object)'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Access (id: 2028)
		(accessor (ref: 204))
		(sourceAnchor (ref: 205))
		(variable (ref: 2029)))
	(FAMIX.Invocation (id: 2030)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 2031)
		(receiver (ref: 1382))
		(sender (ref: 154))
		(signature ''first()'')
		(sourceAnchor (ref: 155)))
	(FAMIX.Invocation (id: 2032)
		(sender (ref: 1085))
		(signature ''nodeForDomainValues:(Object)'')
		(sourceAnchor (ref: 1086)))
	(FAMIX.Parameter (id: 2033)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 2034)))
	(FAMIX.Method (id: 573)
		(name ''resetDefaults'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''resetDefaults'')
		(sourceAnchor (ref: 574)))
	(FAMIX.Method (id: 1227)
		(name ''shape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''shape:'')
		(sourceAnchor (ref: 2035)))
	(FAMIX.Invocation (id: 2036)
		(sender (ref: 426))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Comment (id: 2037)
		(container (ref: 426))
		(content ''"Special treatment with forms shape"''))
	(FAMIX.Access (id: 2038)
		(accessor (ref: 537))
		(sourceAnchor (ref: 538))
		(variable (ref: 536)))
	(FAMIX.Access (id: 2039)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2040)))
	(FAMIX.Parameter (id: 2041)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 2042)))
	(FAMIX.LocalVariable (id: 523)
		(name ''rectangle'')
		(parentBehaviouralEntity (ref: 498)))
	(FAMIX.Invocation (id: 2043)
		(receiver (ref: 450))
		(sender (ref: 195))
		(signature ''ifEmpty:(Object)'')
		(sourceAnchor (ref: 197)))
	(FAMIX.Access (id: 2044)
		(accessor (ref: 1867))
		(isWrite true)
		(sourceAnchor (ref: 1868))
		(variable (ref: 2045)))
	(FAMIX.Access (id: 2046)
		(accessor (ref: 1804))
		(sourceAnchor (ref: 1805))
		(variable (ref: 1803)))
	(FAMIX.Parameter (id: 2047)
		(name ''aBoolean'')
		(parentBehaviouralEntity (ref: 1124)))
	(FAMIX.Method (id: 35)
		(name ''updateBounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 21)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''updateBounds'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Method (id: 71)
		(name ''fromPositions'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''fromPositions'')
		(sourceAnchor (ref: 72)))
	(FAMIX.Parameter (id: 1041)
		(name ''valueOrArray'')
		(parentBehaviouralEntity (ref: 260)))
	(FAMIX.Method (id: 2048)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''initialize'')
		(sourceAnchor (ref: 2049)))
	(FAMIX.Invocation (id: 2050)
		(receiver (ref: 2051))
		(sender (ref: 354))
		(signature ''bounds()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 2052)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 2053)))
	(FAMIX.Invocation (id: 2054)
		(sender (ref: 237))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Invocation (id: 2055)
		(sender (ref: 4))
		(signature ''addSelection:(Object)'')
		(sourceAnchor (ref: 5)))
	(FAMIX.Class (id: 2056)
		(name ''Rectangle class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 2057)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Access (id: 2058)
		(accessor (ref: 723))
		(sourceAnchor (ref: 724))
		(variable (ref: 2059)))
	(FAMIX.Invocation (id: 2060)
		(receiver (ref: 641))
		(sender (ref: 354))
		(signature ''x()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Invocation (id: 2061)
		(receiver (ref: 2062))
		(sender (ref: 514))
		(signature ''allSuperclasses()'')
		(sourceAnchor (ref: 2063)))
	(FAMIX.Access (id: 2064)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 587)))
	(FAMIX.Access (id: 2065)
		(accessor (ref: 215))
		(sourceAnchor (ref: 216))
		(variable (ref: 589)))
	(FAMIX.Access (id: 2066)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1045)))
	(FAMIX.Invocation (id: 2067)
		(sender (ref: 315))
		(signature ''target:(Object)'')
		(sourceAnchor (ref: 869)))
	(FAMIX.Access (id: 2068)
		(accessor (ref: 894))
		(sourceAnchor (ref: 895))
		(variable (ref: 2069)))
	(FAMIX.Reference (id: 2070)
		(source (ref: 414))
		(sourceAnchor (ref: 415))
		(target (ref: 2071)))
	(FAMIX.Access (id: 2072)
		(accessor (ref: 1260))
		(sourceAnchor (ref: 2073))
		(variable (ref: 2074)))
	(FAMIX.Invocation (id: 2075)
		(sender (ref: 39))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 2076)
		(accessor (ref: 493))
		(sourceAnchor (ref: 494))
		(variable (ref: 2077)))
	(FAMIX.Invocation (id: 2078)
		(receiver (ref: 1173))
		(sender (ref: 1124))
		(signature ''localLookupNode:(Object)'')
		(sourceAnchor (ref: 1125)))
	(FAMIX.Access (id: 2079)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1045)))
	(FAMIX.Access (id: 2080)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 2081)))
	(FAMIX.Invocation (id: 2082)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 2083)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 2084)))
	(FAMIX.Access (id: 2085)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 521)))
	(FAMIX.Method (id: 1354)
		(name ''allIncomingEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allIncomingEdges'')
		(sourceAnchor (ref: 1355)))
	(FAMIX.Access (id: 2086)
		(accessor (ref: 676))
		(sourceAnchor (ref: 677))
		(variable (ref: 823)))
	(FAMIX.Access (id: 2087)
		(accessor (ref: 1080))
		(sourceAnchor (ref: 1081))
		(variable (ref: 2088)))
	(FAMIX.Comment (id: 2089)
		(container (ref: 32))
		(content ''"Set a number of useful handlers for nodes"''))
	(FAMIX.Comment (id: 2090)
		(container (ref: 756))
		(content ''"We increase the size of the canvas"''))
	(FAMIX.Access (id: 2091)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 56)))
	(FAMIX.Reference (id: 2092)
		(source (ref: 602))
		(sourceAnchor (ref: 603))
		(target (ref: 41)))
	(FAMIX.Access (id: 2093)
		(accessor (ref: 2094))
		(isWrite true)
		(sourceAnchor (ref: 2095))
		(variable (ref: 2096)))
	(FAMIX.Comment (id: 2097)
		(container (ref: 2098))
		(content ''"Do nothing., the root does not have a cache"''))
	(FAMIX.Invocation (id: 2099)
		(sender (ref: 290))
		(signature ''isRectangle()'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Invocation (id: 2100)
		(sender (ref: 900))
		(signature ''affectedNodes:(Object)'')
		(sourceAnchor (ref: 901)))
	(FAMIX.Access (id: 2101)
		(accessor (ref: 988))
		(sourceAnchor (ref: 989))
		(variable (ref: 2102)))
	(FAMIX.Invocation (id: 2103)
		(receiver (ref: 971))
		(sender (ref: 615))
		(signature ''notNil()'')
		(sourceAnchor (ref: 616)))
	(FAMIX.Invocation (id: 2104)
		(sender (ref: 478))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Invocation (id: 2105)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''green()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 2106)
		(accessor (ref: 1720))
		(isWrite true)
		(sourceAnchor (ref: 1721))
		(variable (ref: 1722)))
	(FAMIX.Access (id: 2107)
		(accessor (ref: 1855))
		(sourceAnchor (ref: 1856))
		(variable (ref: 2108)))
	(FAMIX.Parameter (id: 1711)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 1709)))
	(FAMIX.Parameter (id: 1874)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 229)))
	(FAMIX.Access (id: 2109)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1288)))
	(FAMIX.Method (id: 505)
		(name ''displayWithoutCacheOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 3)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 13)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''displayWithoutCacheOn:'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Access (id: 2110)
		(accessor (ref: 740))
		(sourceAnchor (ref: 741))
		(variable (ref: 742)))
	(FAMIX.Invocation (id: 2111)
		(sender (ref: 525))
		(signature ''detect:ifNone:(Object,Object)'')
		(sourceAnchor (ref: 526)))
	(FAMIX.Method (id: 2112)
		(name ''shape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shape:'')
		(sourceAnchor (ref: 2113)))
	(FAMIX.Access (id: 2114)
		(accessor (ref: 668))
		(sourceAnchor (ref: 1024))
		(variable (ref: 2115)))
	(FAMIX.Parameter (id: 1961)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 689)))
	(FAMIX.Access (id: 2116)
		(accessor (ref: 116))
		(sourceAnchor (ref: 117))
		(variable (ref: 67)))
	(FAMIX.Parameter (id: 362)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 360)))
	(FAMIX.Method (id: 525)
		(name ''nodeForDomainValue:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''nodeForDomainValue:ifAbsent:'')
		(sourceAnchor (ref: 526)))
	(FAMIX.Comment (id: 2117)
		(container (ref: 195))
		(content ''"Return the default node shape class"''))
	(FAMIX.Invocation (id: 2118)
		(receiver (ref: 608))
		(sender (ref: 20))
		(signature ''perform:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 2119)
		(accessor (ref: 1341))
		(isWrite true)
		(sourceAnchor (ref: 1342))
		(variable (ref: 582)))
	(FAMIX.Comment (id: 2120)
		(container (ref: 360))
		(content ''" aCollectionOfEntities is the collection of from which the edges are defined from."''))
	(FAMIX.Invocation (id: 2121)
		(sender (ref: 963))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Method (id: 2098)
		(name ''resetFormCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''resetFormCache'')
		(sourceAnchor (ref: 2122)))
	(FAMIX.Comment (id: 2123)
		(container (ref: 1043))
		(content ''"Answer the relative bounds of the receiver."''))
	(FAMIX.Parameter (id: 2124)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 543)))
	(FAMIX.Access (id: 2125)
		(accessor (ref: 1202))
		(sourceAnchor (ref: 1203))
		(variable (ref: 1579)))
	(FAMIX.Access (id: 2126)
		(accessor (ref: 858))
		(sourceAnchor (ref: 859))
		(variable (ref: 2127)))
	(FAMIX.Method (id: 374)
		(name ''maxValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 806))
		(signature ''maxValue:'')
		(sourceAnchor (ref: 375)))
	(FAMIX.Method (id: 13)
		(name ''setBoundsTo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 25)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''setBoundsTo:'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Parameter (id: 2059)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 723)))
	(FAMIX.Invocation (id: 2128)
		(receiver (ref: 2071))
		(sender (ref: 414))
		(signature ''newCanvas:(Object)'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Access (id: 2129)
		(accessor (ref: 271))
		(sourceAnchor (ref: 272))
		(variable (ref: 1432)))
	(FAMIX.Invocation (id: 2130)
		(receiver (ref: 640))
		(sender (ref: 638))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Method (id: 1555)
		(name ''defaultAdjustHeightFor:and:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''defaultAdjustHeightFor:and:'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Invocation (id: 2131)
		(receiver (ref: 1257))
		(sender (ref: 540))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 541)))
	(FAMIX.Access (id: 2132)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 2133)))
	(FAMIX.LocalVariable (id: 1933)
		(name ''form'')
		(parentBehaviouralEntity (ref: 414)))
	(FAMIX.Invocation (id: 2134)
		(receiver (ref: 1265))
		(sender (ref: 1263))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1264)))
	(FAMIX.Access (id: 2135)
		(accessor (ref: 1757))
		(isWrite true)
		(sourceAnchor (ref: 1758))
		(variable (ref: 865)))
	(FAMIX.Method (id: 2136)
		(name ''isRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''isRoot'')
		(sourceAnchor (ref: 2137)))
	(FAMIX.Invocation (id: 2138)
		(receiver (ref: 2139))
		(sender (ref: 1839))
		(signature ''withAllNodesDo:(Object)'')
		(sourceAnchor (ref: 1840)))
	(FAMIX.Access (id: 2140)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 2141)
		(receiver (ref: 1016))
		(sender (ref: 48))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Reference (id: 2142)
		(source (ref: 108))
		(sourceAnchor (ref: 109))
		(target (ref: 41)))
	(FAMIX.Access (id: 2143)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 825)))
	(FAMIX.Access (id: 2144)
		(accessor (ref: 1223))
		(sourceAnchor (ref: 1224))
		(variable (ref: 1229)))
	(FAMIX.Parameter (id: 2145)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1202)))
	(FAMIX.LocalVariable (id: 2146)
		(name ''nodeLookedUp'')
		(parentBehaviouralEntity (ref: 99)))
	(FAMIX.Invocation (id: 2147)
		(receiver (ref: 2148))
		(sender (ref: 248))
		(signature ''value()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 2149)
		(accessor (ref: 668))
		(sourceAnchor (ref: 1024))
		(variable (ref: 2150)))
	(FAMIX.Invocation (id: 2151)
		(receiver (ref: 1161))
		(sender (ref: 974))
		(signature ''hash()'')
		(sourceAnchor (ref: 975)))
	(FAMIX.Invocation (id: 2152)
		(sender (ref: 128))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Invocation (id: 2153)
		(receiver (ref: 1904))
		(sender (ref: 658))
		(signature ''setAnnouncer:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Access (id: 2154)
		(accessor (ref: 2034))
		(sourceAnchor (ref: 2155))
		(variable (ref: 2156)))
	(FAMIX.Invocation (id: 2157)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''initializeConnectionPositions:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 2158)
		(receiver (ref: 687))
		(sender (ref: 308))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 618)))
	(FAMIX.Access (id: 2159)
		(accessor (ref: 1547))
		(sourceAnchor (ref: 1548))
		(variable (ref: 2160)))
	(FAMIX.LocalVariable (id: 1184)
		(name ''v2'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Method (id: 1775)
		(name ''addUserCommand:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''addUserCommand:'')
		(sourceAnchor (ref: 2161)))
	(FAMIX.Method (id: 1263)
		(name ''springLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''springLayout'')
		(sourceAnchor (ref: 1264)))
	(FAMIX.Method (id: 106)
		(name ''edgesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''edgesDo:'')
		(sourceAnchor (ref: 2162)))
	(FAMIX.Invocation (id: 2163)
		(receiver (ref: 1326))
		(sender (ref: 1315))
		(signature ''attributes()'')
		(sourceAnchor (ref: 1316)))
	(FAMIX.Invocation (id: 2164)
		(sender (ref: 1761))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 1762)))
	(FAMIX.Invocation (id: 2165)
		(receiver (ref: 702))
		(sender (ref: 200))
		(signature ''nextPutAll:(Object)'')
		(sourceAnchor (ref: 201)))
	(FAMIX.Invocation (id: 2166)
		(receiver (ref: 1814))
		(sender (ref: 84))
		(signature ''root()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 2167)
		(receiver (ref: 273))
		(sender (ref: 271))
		(signature ''computeElementsToDisplay()'')
		(sourceAnchor (ref: 272)))
	(FAMIX.Access (id: 2168)
		(accessor (ref: 963))
		(sourceAnchor (ref: 964))
		(variable (ref: 2169)))
	(FAMIX.LocalVariable (id: 2170)
		(name ''v'')
		(parentBehaviouralEntity (ref: 99)))
	(FAMIX.Invocation (id: 2171)
		(receiver (ref: 2172))
		(sender (ref: 2173))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 2174)))
	(FAMIX.Invocation (id: 2175)
		(sender (ref: 32))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Reference (id: 2176)
		(source (ref: 414))
		(sourceAnchor (ref: 415))
		(target (ref: 1138)))
	(FAMIX.Comment (id: 2177)
		(container (ref: 212))
		(content ''"cacheShapeBounds := IdentityDictionary new"''))
	(FAMIX.Access (id: 2178)
		(accessor (ref: 182))
		(isWrite true)
		(sourceAnchor (ref: 183))
		(variable (ref: 1646)))
	(FAMIX.Reference (id: 2179)
		(source (ref: 1720))
		(sourceAnchor (ref: 1721))
		(target (ref: 41)))
	(FAMIX.Access (id: 2180)
		(accessor (ref: 516))
		(sourceAnchor (ref: 517))
		(variable (ref: 1402)))
	(FAMIX.Access (id: 2181)
		(accessor (ref: 756))
		(isWrite true)
		(sourceAnchor (ref: 757))
		(variable (ref: 67)))
	(FAMIX.Invocation (id: 2182)
		(receiver (ref: 2088))
		(sender (ref: 1080))
		(signature ''source()'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Access (id: 2183)
		(accessor (ref: 154))
		(sourceAnchor (ref: 155))
		(variable (ref: 153)))
	(FAMIX.Access (id: 2184)
		(accessor (ref: 2185))
		(isWrite true)
		(sourceAnchor (ref: 2186))
		(variable (ref: 832)))
	(FAMIX.Method (id: 2187)
		(name ''moX:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1427))
		(signature ''moX:'')
		(sourceAnchor (ref: 2188)))
	(FAMIX.Parameter (id: 2189)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 525)))
	(FAMIX.Method (id: 237)
		(name ''cacheNamed:of:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''cacheNamed:of:'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Invocation (id: 2190)
		(receiver (ref: 352))
		(sender (ref: 350))
		(signature ''edges:from:to:(Object,Object,Object)'')
		(sourceAnchor (ref: 351)))
	(FAMIX.Invocation (id: 2191)
		(sender (ref: 756))
		(signature ''on:do:(Object,Object)'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Invocation (id: 2192)
		(receiver (ref: 512))
		(sender (ref: 774))
		(signature ''acceptVisitor:(Object)'')
		(sourceAnchor (ref: 775)))
	(FAMIX.Invocation (id: 2193)
		(sender (ref: 275))
		(signature ''remove:(Object)'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Invocation (id: 2194)
		(receiver (ref: 764))
		(sender (ref: 162))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Access (id: 2195)
		(accessor (ref: 2048))
		(isWrite true)
		(sourceAnchor (ref: 2049))
		(variable (ref: 2196)))
	(FAMIX.Access (id: 2197)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 547)))
	(FAMIX.Invocation (id: 2198)
		(sender (ref: 516))
		(signature ''associationsDo:(Object)'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Method (id: 1503)
		(name ''translateBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''translateBy:'')
		(sourceAnchor (ref: 1504)))
	(FAMIX.Access (id: 2199)
		(accessor (ref: 145))
		(sourceAnchor (ref: 146))
		(variable (ref: 845)))
	(FAMIX.Access (id: 2200)
		(accessor (ref: 1851))
		(sourceAnchor (ref: 1852))
		(variable (ref: 2201)))
	(FAMIX.Parameter (id: 2202)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 2203)))
	(FAMIX.Parameter (id: 591)
		(name ''valueOrArray'')
		(parentBehaviouralEntity (ref: 283)))
	(FAMIX.Access (id: 2204)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1904)))
	(FAMIX.Class (id: 2205)
		(name ''MOSpringLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 2206)
		(receiver (ref: 729))
		(sender (ref: 294))
		(signature ''root()'')
		(sourceAnchor (ref: 295)))
	(FAMIX.LocalVariable (id: 2207)
		(name ''node'')
		(parentBehaviouralEntity (ref: 929)))
	(FAMIX.Access (id: 2208)
		(accessor (ref: 2209))
		(sourceAnchor (ref: 2210))
		(variable (ref: 2211)))
	(FAMIX.Access (id: 2212)
		(accessor (ref: 1855))
		(sourceAnchor (ref: 1856))
		(variable (ref: 2108)))
	(FAMIX.Parameter (id: 1799)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 1507)))
	(FAMIX.Comment (id: 2213)
		(container (ref: 91))
		(content ''"orange"''))
	(FAMIX.Invocation (id: 2214)
		(receiver (ref: 803))
		(sender (ref: 801))
		(signature ''copyWithoutAll:(Object)'')
		(sourceAnchor (ref: 802)))
	(FAMIX.Invocation (id: 2215)
		(receiver (ref: 420))
		(sender (ref: 332))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 333)))
	(FAMIX.Access (id: 2216)
		(accessor (ref: 1155))
		(sourceAnchor (ref: 1156))
		(variable (ref: 2217)))
	(FAMIX.Reference (id: 2218)
		(source (ref: 99))
		(sourceAnchor (ref: 100))
		(target (ref: 997)))
	(FAMIX.Invocation (id: 2219)
		(sender (ref: 237))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Access (id: 2220)
		(accessor (ref: 350))
		(sourceAnchor (ref: 351))
		(variable (ref: 2221)))
	(FAMIX.Access (id: 2222)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 587)))
	(FAMIX.Access (id: 2223)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 1655)))
	(FAMIX.Access (id: 2224)
		(accessor (ref: 1272))
		(sourceAnchor (ref: 1273))
		(variable (ref: 263)))
	(FAMIX.Access (id: 2225)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Invocation (id: 2226)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''valueWithArguments:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Method (id: 668)
		(name ''edges:from:toAll:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 20)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:toAll:'')
		(sourceAnchor (ref: 1024)))
	(FAMIX.Access (id: 2227)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 875)))
	(FAMIX.LocalVariable (id: 1538)
		(name ''classes'')
		(parentBehaviouralEntity (ref: 388)))
	(FAMIX.Access (id: 2228)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1533)))
	(FAMIX.Invocation (id: 2229)
		(receiver (ref: 1445))
		(sender (ref: 1446))
		(signature ''nodes:using:(Object,Object)'')
		(sourceAnchor (ref: 1447)))
	(FAMIX.Method (id: 1757)
		(name ''zOrder'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''zOrder'')
		(sourceAnchor (ref: 1758)))
	(FAMIX.Parameter (id: 2230)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 2231)))
	(FAMIX.LocalVariable (id: 1764)
		(name ''currentExtent'')
		(parentBehaviouralEntity (ref: 229)))
	(FAMIX.Access (id: 2232)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 2170)))
	(FAMIX.Method (id: 1458)
		(name ''interaction'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''interaction'')
		(sourceAnchor (ref: 1459)))
	(FAMIX.Class (id: 1039)
		(name ''MOFADELayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 2233)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 1313)))
	(FAMIX.Invocation (id: 2234)
		(receiver (ref: 512))
		(sender (ref: 505))
		(signature ''acceptVisitor:(Object)'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Method (id: 304)
		(name ''shapeBoundsAt:put:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shapeBoundsAt:put:'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Parameter (id: 2235)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 338)))
	(FAMIX.Access (id: 2236)
		(accessor (ref: 631))
		(sourceAnchor (ref: 632))
		(variable (ref: 2237)))
	(FAMIX.Parameter (id: 2238)
		(name ''aNumber'')
		(parentBehaviouralEntity (ref: 1855)))
	(FAMIX.Access (id: 2239)
		(accessor (ref: 212))
		(isWrite true)
		(sourceAnchor (ref: 213))
		(variable (ref: 306)))
	(FAMIX.Invocation (id: 2240)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''getTranslationStep:bounded:(Object,Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 2241)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 2242)
		(accessor (ref: 2243))
		(sourceAnchor (ref: 2244))
		(variable (ref: 2245)))
	(FAMIX.Parameter (id: 1288)
		(name ''aNodeElement'')
		(parentBehaviouralEntity (ref: 39)))
	(FAMIX.Invocation (id: 2246)
		(receiver (ref: 531))
		(sender (ref: 529))
		(signature ''new()'')
		(sourceAnchor (ref: 530)))
	(FAMIX.Reference (id: 2247)
		(source (ref: 1605))
		(sourceAnchor (ref: 1606))
		(target (ref: 1084)))
	(FAMIX.Parameter (id: 2248)
		(name ''aValue'')
		(parentBehaviouralEntity (ref: 1406)))
	(FAMIX.Method (id: 1155)
		(name ''edges:from:to:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:to:'')
		(sourceAnchor (ref: 1156)))
	(FAMIX.Invocation (id: 2249)
		(sender (ref: 84))
		(signature ''announcer()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 2250)
		(sender (ref: 1777))
		(signature ''nodes()'')
		(sourceAnchor (ref: 1778)))
	(FAMIX.Method (id: 580)
		(name ''affectedNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''affectedNodes'')
		(sourceAnchor (ref: 581)))
	(FAMIX.Access (id: 2251)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Access (id: 2252)
		(accessor (ref: 478))
		(sourceAnchor (ref: 479))
		(variable (ref: 477)))
	(FAMIX.Invocation (id: 2253)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''removeAllEdges()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 2254)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''resetMetricCachesResursively()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 2255)
		(accessor (ref: 2256))
		(sourceAnchor (ref: 2257))
		(variable (ref: 2258)))
	(FAMIX.Access (id: 2259)
		(accessor (ref: 304))
		(sourceAnchor (ref: 305))
		(variable (ref: 1914)))
	(FAMIX.Access (id: 2260)
		(accessor (ref: 951))
		(sourceAnchor (ref: 952))
		(variable (ref: 950)))
	(FAMIX.Access (id: 2261)
		(accessor (ref: 1338))
		(sourceAnchor (ref: 1339))
		(variable (ref: 2262)))
	(FAMIX.Invocation (id: 2263)
		(sender (ref: 327))
		(signature ''extent()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 2264)
		(receiver (ref: 1617))
		(sender (ref: 505))
		(signature ''displayWithoutCacheOn:(Object)'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Invocation (id: 2265)
		(receiver (ref: 2266))
		(sender (ref: 32))
		(signature ''root()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Invocation (id: 2267)
		(sender (ref: 951))
		(signature ''*(Object)'')
		(sourceAnchor (ref: 952)))
	(FAMIX.Access (id: 2268)
		(accessor (ref: 2269))
		(sourceAnchor (ref: 2270))
		(variable (ref: 2271)))
	(FAMIX.Method (id: 556)
		(name ''isNodeShape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isNodeShape'')
		(sourceAnchor (ref: 557)))
	(FAMIX.Method (id: 2272)
		(name ''center'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''center'')
		(sourceAnchor (ref: 2273)))
	(FAMIX.Invocation (id: 2274)
		(receiver (ref: 1635))
		(sender (ref: 1555))
		(signature ''height()'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Access (id: 2275)
		(accessor (ref: 801))
		(sourceAnchor (ref: 802))
		(variable (ref: 803)))
	(FAMIX.Access (id: 2276)
		(accessor (ref: 2277))
		(sourceAnchor (ref: 2278))
		(variable (ref: 2279)))
	(FAMIX.Comment (id: 2280)
		(container (ref: 1085))
		(content ''"Returns the MONode corresponding to the values contained in aCollection"''))
	(FAMIX.Access (id: 2281)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 1814)))
	(FAMIX.Invocation (id: 2282)
		(sender (ref: 993))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Comment (id: 2283)
		(container (ref: 264))
		(content ''"Add anElement to the children of the receiver."''))
	(FAMIX.Invocation (id: 2284)
		(receiver (ref: 793))
		(sender (ref: 95))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Invocation (id: 2285)
		(sender (ref: 693))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Invocation (id: 2286)
		(sender (ref: 932))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1893)))
	(FAMIX.Invocation (id: 2287)
		(sender (ref: 1769))
		(signature ''remove:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1770)))
	(FAMIX.Invocation (id: 2288)
		(sender (ref: 124))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Invocation (id: 2289)
		(receiver (ref: 818))
		(sender (ref: 819))
		(signature ''setIfNilToPositions:(Object)'')
		(sourceAnchor (ref: 2290)))
	(FAMIX.Access (id: 2291)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 850)))
	(FAMIX.Access (id: 2292)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Access (id: 2293)
		(accessor (ref: 1087))
		(sourceAnchor (ref: 1088))
		(variable (ref: 1449)))
	(FAMIX.Comment (id: 2294)
		(container (ref: 300))
		(content ''"Answer the list of incoming edges to myself"''))
	(FAMIX.Access (id: 2295)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 657)))
	(FAMIX.Method (id: 2296)
		(name ''horizontalNarrowTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''horizontalNarrowTreeLayout'')
		(sourceAnchor (ref: 2297)))
	(FAMIX.Invocation (id: 2298)
		(receiver (ref: 306))
		(sender (ref: 24))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 25)))
	(FAMIX.Invocation (id: 2299)
		(receiver (ref: 407))
		(sender (ref: 408))
		(signature ''shape()'')
		(sourceAnchor (ref: 1241)))
	(FAMIX.Access (id: 2300)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 2301)
		(accessor (ref: 304))
		(sourceAnchor (ref: 305))
		(variable (ref: 2302)))
	(FAMIX.Invocation (id: 2303)
		(receiver (ref: 1136))
		(sender (ref: 13))
		(signature ''value()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 2304)
		(accessor (ref: 212))
		(isWrite true)
		(sourceAnchor (ref: 213))
		(variable (ref: 1432)))
	(FAMIX.Access (id: 2305)
		(accessor (ref: 252))
		(sourceAnchor (ref: 1659))
		(variable (ref: 168)))
	(FAMIX.Invocation (id: 2306)
		(receiver (ref: 322))
		(sender (ref: 253))
		(signature ''defaultNodeShapeClass()'')
		(sourceAnchor (ref: 254)))
	(FAMIX.Access (id: 2307)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 79)))
	(FAMIX.Access (id: 2308)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1047)))
	(FAMIX.Invocation (id: 2309)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 2310)
		(receiver (ref: 1153))
		(sender (ref: 638))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Access (id: 2311)
		(accessor (ref: 1769))
		(sourceAnchor (ref: 1770))
		(variable (ref: 2312)))
	(FAMIX.Comment (id: 2313)
		(container (ref: 248))
		(content ''"For some strange reason, doing an applyLayout reset to 0@0 the origin of the node, it should not"''))
	(FAMIX.Invocation (id: 2314)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Method (id: 437)
		(name ''removePopupIfExist'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''removePopupIfExist'')
		(sourceAnchor (ref: 438)))
	(FAMIX.Access (id: 2315)
		(accessor (ref: 207))
		(isWrite true)
		(sourceAnchor (ref: 208))
		(variable (ref: 306)))
	(FAMIX.Reference (id: 2316)
		(source (ref: 177))
		(sourceAnchor (ref: 178))
		(target (ref: 997)))
	(FAMIX.Reference (id: 2317)
		(source (ref: 154))
		(sourceAnchor (ref: 155))
		(target (ref: 41)))
	(FAMIX.Invocation (id: 2318)
		(receiver (ref: 1047))
		(sender (ref: 224))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Invocation (id: 2319)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''pink()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 2320)
		(accessor (ref: 1901))
		(sourceAnchor (ref: 2321))
		(variable (ref: 2322)))
	(FAMIX.Parameter (id: 2323)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 54)))
	(FAMIX.Access (id: 2324)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 52)))
	(FAMIX.LocalVariable (id: 2325)
		(name ''each'')
		(parentBehaviouralEntity (ref: 525)))
	(FAMIX.Access (id: 2326)
		(accessor (ref: 35))
		(isWrite true)
		(sourceAnchor (ref: 36))
		(variable (ref: 1331)))
	(FAMIX.LocalVariable (id: 2327)
		(name ''each'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Access (id: 2328)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 1178)))
	(FAMIX.Comment (id: 2330)
		(container (ref: 1215))
		(content ''"Install the default event handler for the root"''))
	(FAMIX.Method (id: 827)
		(name ''copyShapeWithoutUpdatingAndDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''copyShapeWithoutUpdatingAndDo:'')
		(sourceAnchor (ref: 1301)))
	(FAMIX.Invocation (id: 2331)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Method (id: 700)
		(name ''endPoint'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''endPoint'')
		(sourceAnchor (ref: 701)))
	(FAMIX.Class (id: 1138)
		(name ''FormCanvas class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 2332)
		(receiver (ref: 685))
		(sender (ref: 683))
		(signature ''assert:description:(Object,Object)'')
		(sourceAnchor (ref: 684)))
	(FAMIX.Invocation (id: 2333)
		(sender (ref: 516))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Method (id: 1101)
		(name ''localLookupNode:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''localLookupNode:'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Invocation (id: 2334)
		(receiver (ref: 73))
		(sender (ref: 71))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 72)))
	(FAMIX.Reference (id: 2335)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 2336)
		(receiver (ref: 1577))
		(sender (ref: 1169))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 1170)))
	(FAMIX.Invocation (id: 2337)
		(sender (ref: 204))
		(signature ''root()'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Access (id: 2338)
		(accessor (ref: 1026))
		(sourceAnchor (ref: 1027))
		(variable (ref: 2339)))
	(FAMIX.Invocation (id: 2340)
		(receiver (ref: 1588))
		(sender (ref: 622))
		(signature ''attributes()'')
		(sourceAnchor (ref: 623)))
	(FAMIX.Access (id: 2341)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 2207)))
	(FAMIX.Access (id: 2342)
		(accessor (ref: 2112))
		(sourceAnchor (ref: 2113))
		(variable (ref: 2343)))
	(FAMIX.Access (id: 2344)
		(accessor (ref: 2345))
		(isWrite true)
		(sourceAnchor (ref: 2346))
		(variable (ref: 971)))
	(FAMIX.Invocation (id: 2347)
		(receiver (ref: 793))
		(sender (ref: 95))
		(signature ''isNil()'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 2348)
		(accessor (ref: 1650))
		(sourceAnchor (ref: 1651))
		(variable (ref: 1649)))
	(FAMIX.Access (id: 2349)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 2350)
		(accessor (ref: 2296))
		(sourceAnchor (ref: 2297))
		(variable (ref: 2351)))
	(FAMIX.Invocation (id: 2352)
		(receiver (ref: 2353))
		(sender (ref: 689))
		(signature ''edges:fromAll:to:using:(Object,Object,Object,Object)'')
		(sourceAnchor (ref: 690)))
	(FAMIX.Reference (id: 2354)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 2355)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Comment (id: 2356)
		(container (ref: 91))
		(content ''"brown"''))
	(FAMIX.Invocation (id: 2357)
		(sender (ref: 290))
		(signature ''at:ifAbsentPut:(Object,Object)'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Access (id: 2358)
		(accessor (ref: 2042))
		(sourceAnchor (ref: 2359))
		(variable (ref: 2360)))
	(FAMIX.Access (id: 2361)
		(accessor (ref: 1446))
		(sourceAnchor (ref: 1447))
		(variable (ref: 2362)))
	(FAMIX.Class (id: 542)
		(name ''MOBottomFlowLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 2363)
		(accessor (ref: 1559))
		(sourceAnchor (ref: 1560))
		(variable (ref: 1957)))
	(FAMIX.Method (id: 275)
		(name ''removeNodeWithValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 8)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeNodeWithValue:'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Access (id: 2364)
		(accessor (ref: 1002))
		(sourceAnchor (ref: 1003))
		(variable (ref: 2365)))
	(FAMIX.Invocation (id: 2366)
		(receiver (ref: 748))
		(sender (ref: 746))
		(signature ''expandToIncludePoint:(Object)'')
		(sourceAnchor (ref: 747)))
	(FAMIX.Method (id: 2367)
		(name ''removeAllNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeAllNodes'')
		(sourceAnchor (ref: 2368)))
	(FAMIX.Access (id: 2369)
		(accessor (ref: 264))
		(sourceAnchor (ref: 265))
		(variable (ref: 2370)))
	(FAMIX.Access (id: 2371)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 142)))
	(FAMIX.Reference (id: 2372)
		(source (ref: 294))
		(sourceAnchor (ref: 295))
		(target (ref: 41)))
	(FAMIX.Access (id: 2373)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 649)))
	(FAMIX.Invocation (id: 2374)
		(receiver (ref: 1646))
		(sender (ref: 182))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.LocalVariable (id: 1890)
		(name ''result'')
		(parentBehaviouralEntity (ref: 308)))
	(FAMIX.Invocation (id: 2375)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 2376)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 2377)))
	(FAMIX.Invocation (id: 2378)
		(sender (ref: 84))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 2379)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''cyan()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 2380)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 2381)))
	(FAMIX.Invocation (id: 2382)
		(receiver (ref: 1107))
		(sender (ref: 426))
		(signature ''applyLayout()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 2383)
		(accessor (ref: 993))
		(isWrite true)
		(sourceAnchor (ref: 994))
		(variable (ref: 2384)))
	(FAMIX.Parameter (id: 280)
		(name ''aSortBlockOrSymbol'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Invocation (id: 2385)
		(receiver (ref: 2386))
		(sender (ref: 368))
		(signature ''allLiterals()'')
		(sourceAnchor (ref: 369)))
	(FAMIX.Invocation (id: 2387)
		(sender (ref: 84))
		(signature ''subscribe:do:(Object,Object)'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Method (id: 983)
		(name ''resetElementsToLookup'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetElementsToLookup'')
		(sourceAnchor (ref: 2388)))
	(FAMIX.Invocation (id: 2389)
		(receiver (ref: 1935))
		(sender (ref: 756))
		(signature ''updateWindow()'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Access (id: 2390)
		(accessor (ref: 195))
		(sourceAnchor (ref: 197))
		(variable (ref: 1467)))
	(FAMIX.Invocation (id: 2391)
		(receiver (ref: 263))
		(sender (ref: 430))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1022)))
	(FAMIX.Access (id: 2392)
		(accessor (ref: 1406))
		(sourceAnchor (ref: 1407))
		(variable (ref: 2393)))
	(FAMIX.Invocation (id: 2394)
		(sender (ref: 237))
		(signature ''shape()'')
		(sourceAnchor (ref: 238)))
	(FAMIX.LocalVariable (id: 2395)
		(name ''sourceModel'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Invocation (id: 2396)
		(sender (ref: 248))
		(signature ''containsRect:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Method (id: 878)
		(name ''removeAttribute:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''removeAttribute:'')
		(sourceAnchor (ref: 879)))
	(FAMIX.Access (id: 2397)
		(accessor (ref: 1181))
		(sourceAnchor (ref: 1182))
		(variable (ref: 1180)))
	(FAMIX.Access (id: 2398)
		(accessor (ref: 149))
		(sourceAnchor (ref: 150))
		(variable (ref: 2399)))
	(FAMIX.Access (id: 2400)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1186)))
	(FAMIX.Comment (id: 2401)
		(container (ref: 39))
		(content ''"Execute the layout, myself, on the subnodes of the node element"''))
	(FAMIX.Invocation (id: 2402)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Reference (id: 2403)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 2404)
		(sender (ref: 43))
		(signature ''addIncomingEdge:(Object)'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.LocalVariable (id: 1760)
		(name ''coll'')
		(parentBehaviouralEntity (ref: 1354)))
	(FAMIX.Access (id: 2405)
		(accessor (ref: 2406))
		(sourceAnchor (ref: 2407))
		(variable (ref: 2408)))
	(FAMIX.Access (id: 2409)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 2410)))
	(FAMIX.Access (id: 2411)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 2412)))
	(FAMIX.LocalVariable (id: 83)
		(name ''node'')
		(parentBehaviouralEntity (ref: 84)))
	(FAMIX.Comment (id: 2413)
		(container (ref: 1010))
		(content ''"Returns the MONode corresponding to the value anObject"''))
	(FAMIX.Invocation (id: 2414)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 2415)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 687)))
	(FAMIX.Access (id: 2416)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 2417)))
	(FAMIX.Invocation (id: 2418)
		(receiver (ref: 2419))
		(sender (ref: 1777))
		(signature ''root()'')
		(sourceAnchor (ref: 1778)))
	(FAMIX.Invocation (id: 2420)
		(receiver (ref: 79))
		(sender (ref: 80))
		(signature ''root()'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Class (id: 633)
		(name ''MOShape class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 2421)
		(receiver (ref: 41))
		(sender (ref: 264))
		(signature ''new()'')
		(sourceAnchor (ref: 265)))
	(FAMIX.LocalVariable (id: 2422)
		(name ''e'')
		(parentBehaviouralEntity (ref: 221)))
	(FAMIX.Invocation (id: 2423)
		(receiver (ref: 604))
		(sender (ref: 106))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 2162)))
	(FAMIX.Invocation (id: 2424)
		(receiver (ref: 133))
		(sender (ref: 20))
		(signature ''new:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 2425)
		(accessor (ref: 204))
		(sourceAnchor (ref: 205))
		(variable (ref: 203)))
	(FAMIX.Invocation (id: 2426)
		(receiver (ref: 513))
		(sender (ref: 514))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 2063)))
	(FAMIX.Invocation (id: 2427)
		(sender (ref: 260))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Comment (id: 2428)
		(container (ref: 1837))
		(content ''"Alexandre Bergel, Feb 2, 2009: copied from Visual works"''))
	(FAMIX.Invocation (id: 2429)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''bounds()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 2430)
		(receiver (ref: 1809))
		(sender (ref: 1406))
		(signature ''shape:key:(Object,Object)'')
		(sourceAnchor (ref: 1407)))
	(FAMIX.Invocation (id: 2431)
		(receiver (ref: 42))
		(sender (ref: 43))
		(signature ''setOwner:(Object)'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Invocation (id: 2432)
		(receiver (ref: 12))
		(sender (ref: 13))
		(signature ''topLeft()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 1283)
		(name ''bulletTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''bulletTreeLayout'')
		(sourceAnchor (ref: 1284)))
	(FAMIX.Access (id: 2433)
		(accessor (ref: 549))
		(sourceAnchor (ref: 550))
		(variable (ref: 288)))
	(FAMIX.Invocation (id: 2434)
		(receiver (ref: 41))
		(sender (ref: 707))
		(signature ''new()'')
		(sourceAnchor (ref: 708)))
	(FAMIX.Invocation (id: 2435)
		(sender (ref: 2436))
		(signature ''width()'')
		(sourceAnchor (ref: 2437)))
	(FAMIX.Parameter (id: 687)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 308)))
	(FAMIX.Invocation (id: 2438)
		(receiver (ref: 2439))
		(sender (ref: 248))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 2440)
		(sender (ref: 443))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 2441)
		(accessor (ref: 819))
		(sourceAnchor (ref: 2290))
		(variable (ref: 818)))
	(FAMIX.Parameter (id: 547)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 505)))
	(FAMIX.Access (id: 2442)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 852)))
	(FAMIX.Access (id: 2443)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1688)))
	(FAMIX.Comment (id: 2444)
		(container (ref: 2445))
		(content ''"used in the test"''))
	(FAMIX.Invocation (id: 2446)
		(receiver (ref: 1416))
		(sender (ref: 993))
		(signature ''allNodes()'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Access (id: 2447)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 1243)))
	(FAMIX.Access (id: 2448)
		(accessor (ref: 294))
		(isWrite true)
		(sourceAnchor (ref: 295))
		(variable (ref: 2449)))
	(FAMIX.Invocation (id: 2450)
		(receiver (ref: 2451))
		(sender (ref: 1519))
		(signature ''element:(Object)'')
		(sourceAnchor (ref: 1520)))
	(FAMIX.Invocation (id: 2452)
		(sender (ref: 35))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Method (id: 2453)
		(name ''resetMetricCachesUpToTheRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''resetMetricCachesUpToTheRoot'')
		(sourceAnchor (ref: 2454)))
	(FAMIX.Access (id: 2455)
		(accessor (ref: 404))
		(sourceAnchor (ref: 406))
		(variable (ref: 2456)))
	(FAMIX.Invocation (id: 2457)
		(receiver (ref: 2458))
		(sender (ref: 932))
		(signature ''nodes()'')
		(sourceAnchor (ref: 1893)))
	(FAMIX.Comment (id: 2459)
		(container (ref: 672))
		(content ''"Evaluate aBlock all its children."''))
	(FAMIX.LocalVariable (id: 450)
		(name ''classes'')
		(parentBehaviouralEntity (ref: 195)))
	(FAMIX.Class (id: 2460)
		(name ''Object'')
		(fanIn 5)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 2)
		(numberOfMethods 1)
		(numberOfParents 0)
		(numberOfStatements -1)
		(totalNumberOfChildren 8)
		(weightedMethodCount -1))
	(FAMIX.Method (id: 88)
		(name ''bounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''bounds'')
		(sourceAnchor (ref: 89)))
	(FAMIX.Invocation (id: 2461)
		(sender (ref: 388))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Invocation (id: 2462)
		(sender (ref: 514))
		(signature ''inject:into:(Object,Object)'')
		(sourceAnchor (ref: 2063)))
	(FAMIX.Access (id: 2463)
		(accessor (ref: 1451))
		(sourceAnchor (ref: 1452))
		(variable (ref: 2464)))
	(FAMIX.Access (id: 2465)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 2466)))
	(FAMIX.Access (id: 2467)
		(accessor (ref: 470))
		(sourceAnchor (ref: 744))
		(variable (ref: 2468)))
	(FAMIX.Access (id: 2469)
		(accessor (ref: 106))
		(sourceAnchor (ref: 2162))
		(variable (ref: 105)))
	(FAMIX.Access (id: 2470)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 863)))
	(FAMIX.Invocation (id: 2471)
		(receiver (ref: 79))
		(sender (ref: 80))
		(signature ''assert:description:(Object,Object)'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Invocation (id: 2472)
		(receiver (ref: 299))
		(sender (ref: 1189))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 1190)))
	(FAMIX.Method (id: 1519)
		(name ''announce:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''announce:'')
		(sourceAnchor (ref: 1520)))
	(FAMIX.Invocation (id: 2473)
		(receiver (ref: 435))
		(sender (ref: 173))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Access (id: 2474)
		(accessor (ref: 1555))
		(sourceAnchor (ref: 1556))
		(variable (ref: 1811)))
	(FAMIX.Invocation (id: 2475)
		(receiver (ref: 2476))
		(sender (ref: 315))
		(signature ''new()'')
		(sourceAnchor (ref: 869)))
	(FAMIX.Reference (id: 2477)
		(source (ref: 505))
		(sourceAnchor (ref: 506))
		(target (ref: 1064)))
	(FAMIX.Parameter (id: 2478)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 468)))
	(FAMIX.Invocation (id: 2479)
		(receiver (ref: 104))
		(sender (ref: 102))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 103)))
	(FAMIX.Access (id: 2480)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 1161)))
	(FAMIX.Access (id: 2481)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1935)))
	(FAMIX.Comment (id: 2482)
		(container (ref: 468))
		(content ''"Add an edge going from (aFromBlock moValue: anObject) to (aToBlock moValue: anObject) using a user defined shape"''))
	(FAMIX.Method (id: 1645)
		(name ''copyShapeAndDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''copyShapeAndDo:'')
		(sourceAnchor (ref: 2483)))
	(FAMIX.LocalVariable (id: 242)
		(name ''each'')
		(parentBehaviouralEntity (ref: 243)))
	(FAMIX.Parameter (id: 1424)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 430)))
	(FAMIX.Access (id: 2484)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Comment (id: 2485)
		(container (ref: 91))
		(content ''"yellow"''))
	(FAMIX.Invocation (id: 2486)
		(sender (ref: 124))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Access (id: 2487)
		(accessor (ref: 381))
		(sourceAnchor (ref: 382))
		(variable (ref: 383)))
	(FAMIX.Invocation (id: 2488)
		(receiver (ref: 2056))
		(sender (ref: 1104))
		(signature ''encompassing:(Object)'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Method (id: 1278)
		(name ''layout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''layout'')
		(sourceAnchor (ref: 1279)))
	(FAMIX.Method (id: 1860)
		(name ''acceptVisitor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''acceptVisitor:'')
		(sourceAnchor (ref: 1861)))
	(FAMIX.Access (id: 2489)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1865)))
	(FAMIX.Access (id: 2490)
		(accessor (ref: 497))
		(sourceAnchor (ref: 2491))
		(variable (ref: 496)))
	(FAMIX.Access (id: 2492)
		(accessor (ref: 1345))
		(sourceAnchor (ref: 1346))
		(variable (ref: 1344)))
	(FAMIX.Invocation (id: 2493)
		(receiver (ref: 104))
		(sender (ref: 537))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 538)))
	(FAMIX.Access (id: 2494)
		(accessor (ref: 1775))
		(sourceAnchor (ref: 2161))
		(variable (ref: 2495)))
	(FAMIX.Invocation (id: 2496)
		(sender (ref: 2012))
		(signature ''size()'')
		(sourceAnchor (ref: 2013)))
	(FAMIX.Access (id: 2497)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 1933)))
	(FAMIX.Invocation (id: 2498)
		(sender (ref: 1547))
		(signature ''deselect:(Object)'')
		(sourceAnchor (ref: 1548)))
	(FAMIX.Invocation (id: 2499)
		(receiver (ref: 2133))
		(sender (ref: 221))
		(signature ''allEdgesDo:(Object)'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Access (id: 2500)
		(accessor (ref: 408))
		(sourceAnchor (ref: 1241))
		(variable (ref: 2501)))
	(FAMIX.Invocation (id: 2502)
		(sender (ref: 1555))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Method (id: 20)
		(name ''sortedAs:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 21)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 806))
		(signature ''sortedAs:'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Method (id: 200)
		(name ''printOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''printOn:'')
		(sourceAnchor (ref: 201)))
	(FAMIX.Access (id: 2503)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1100)))
	(FAMIX.Comment (id: 2504)
		(container (ref: 1421))
		(content ''"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."''))
	(FAMIX.Access (id: 2505)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Invocation (id: 2506)
		(receiver (ref: 754))
		(sender (ref: 2507))
		(signature ''new()'')
		(sourceAnchor (ref: 2508)))
	(FAMIX.Parameter (id: 2509)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 470)))
	(FAMIX.Access (id: 2510)
		(accessor (ref: 327))
		(isWrite true)
		(sourceAnchor (ref: 328))
		(variable (ref: 306)))
	(FAMIX.Access (id: 2511)
		(accessor (ref: 2512))
		(sourceAnchor (ref: 2513))
		(variable (ref: 954)))
	(FAMIX.Access (id: 2514)
		(accessor (ref: 318))
		(sourceAnchor (ref: 319))
		(variable (ref: 2515)))
	(FAMIX.Invocation (id: 2516)
		(receiver (ref: 922))
		(sender (ref: 221))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Comment (id: 2517)
		(container (ref: 565))
		(content ''"Edges are defined for each element of aCollectionOfEntities to the destination node given by aToBlock"''))
	(FAMIX.Invocation (id: 2518)
		(receiver (ref: 2519))
		(sender (ref: 368))
		(signature ''isKindOf:(Object)'')
		(sourceAnchor (ref: 369)))
	(FAMIX.LocalVariable (id: 335)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 189)))
	(FAMIX.Class (id: 2520)
		(name ''MOContentChanged class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 2521)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 37)))
	(FAMIX.Invocation (id: 2522)
		(sender (ref: 516))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Invocation (id: 2523)
		(sender (ref: 693))
		(signature ''on:do:(Object,Object)'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Access (id: 2524)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Invocation (id: 2525)
		(sender (ref: 128))
		(signature ''copyUpTo:(Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Parameter (id: 218)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 80)))
	(FAMIX.Access (id: 2526)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 507)))
	(FAMIX.Invocation (id: 2527)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 2528)
		(accessor (ref: 207))
		(isWrite true)
		(sourceAnchor (ref: 208))
		(variable (ref: 104)))
	(FAMIX.Invocation (id: 2529)
		(receiver (ref: 2530))
		(sender (ref: 95))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 2531)
		(accessor (ref: 2532))
		(sourceAnchor (ref: 2533))
		(variable (ref: 1678)))
	(FAMIX.Invocation (id: 2534)
		(receiver (ref: 2386))
		(sender (ref: 368))
		(signature ''methodClass()'')
		(sourceAnchor (ref: 369)))
	(FAMIX.Access (id: 2535)
		(accessor (ref: 304))
		(sourceAnchor (ref: 305))
		(variable (ref: 122)))
	(FAMIX.Invocation (id: 2536)
		(receiver (ref: 2537))
		(sender (ref: 2538))
		(signature ''resetMetricCaches()'')
		(sourceAnchor (ref: 2539)))
	(FAMIX.Access (id: 2540)
		(accessor (ref: 2209))
		(isWrite true)
		(sourceAnchor (ref: 2210))
		(variable (ref: 288)))
	(FAMIX.Method (id: 929)
		(name ''resetCacheInEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetCacheInEdges'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Access (id: 2541)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1047)))
	(FAMIX.Class (id: 45)
		(name ''MOLayout'')
		(fanIn 0)
		(fanOut 1)
		(hierarchyNestingLevel 1)
		(numberOfAttributes 5)
		(numberOfComments 5)
		(numberOfLinesOfCode 102)
		(numberOfMethods 27)
		(numberOfParents 1)
		(numberOfStatements -27)
		(totalNumberOfChildren 0)
		(weightedMethodCount -27))
	(FAMIX.Invocation (id: 2542)
		(sender (ref: 1290))
		(signature ''intersects:(Object)'')
		(sourceAnchor (ref: 1291)))
	(FAMIX.Parameter (id: 2148)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 248)))
	(FAMIX.Invocation (id: 2543)
		(receiver (ref: 2544))
		(sender (ref: 1650))
		(signature ''withAllSubnodes()'')
		(sourceAnchor (ref: 1651)))
	(FAMIX.Reference (id: 2545)
		(source (ref: 1104))
		(sourceAnchor (ref: 1105))
		(target (ref: 2056)))
	(FAMIX.Access (id: 2546)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 507)))
	(FAMIX.Invocation (id: 2547)
		(receiver (ref: 2548))
		(sender (ref: 1645))
		(signature ''root()'')
		(sourceAnchor (ref: 2483)))
	(FAMIX.Access (id: 2549)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 922)))
	(FAMIX.Invocation (id: 2550)
		(receiver (ref: 209))
		(sender (ref: 207))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Comment (id: 2551)
		(container (ref: 638))
		(content ''"both aFromBlock and aToBlock must return a collection
	fromGlobal and toGlobal are boolean values"''))
	(FAMIX.Invocation (id: 2552)
		(receiver (ref: 940))
		(sender (ref: 938))
		(signature ''isNodeShape()'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Access (id: 2553)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 2084)))
	(FAMIX.Access (id: 2554)
		(accessor (ref: 2345))
		(isWrite true)
		(sourceAnchor (ref: 2346))
		(variable (ref: 104)))
	(FAMIX.Parameter (id: 1788)
		(name ''symbols'')
		(parentBehaviouralEntity (ref: 423)))
	(FAMIX.LocalVariable (id: 2555)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 84)))
	(FAMIX.Invocation (id: 2556)
		(receiver (ref: 1034))
		(sender (ref: 934))
		(signature ''ifEmpty:(Object)'')
		(sourceAnchor (ref: 935)))
	(FAMIX.Parameter (id: 843)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 99)))
	(FAMIX.Comment (id: 2557)
		(container (ref: 91))
		(content ''"blue"''))
	(FAMIX.Access (id: 2558)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 2559)))
	(FAMIX.Method (id: 2560)
		(name ''shouldCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''shouldCache'')
		(sourceAnchor (ref: 2561)))
	(FAMIX.LocalVariable (id: 2562)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 204)))
	(FAMIX.Invocation (id: 2563)
		(sender (ref: 364))
		(signature ''size()'')
		(sourceAnchor (ref: 365)))
	(FAMIX.Method (id: 465)
		(name ''node:forIt:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''node:forIt:'')
		(sourceAnchor (ref: 466)))
	(FAMIX.Access (id: 2564)
		(accessor (ref: 1237))
		(sourceAnchor (ref: 1791))
		(variable (ref: 2565)))
	(FAMIX.Invocation (id: 2566)
		(sender (ref: 354))
		(signature ''asInteger()'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Comment (id: 2567)
		(container (ref: 20))
		(content ''"Answer a SortedCollection whose elements are the elements of the 
	receiver. The sort order is defined by the argument, aSortBlock."''))
	(FAMIX.Invocation (id: 2568)
		(receiver (ref: 2325))
		(sender (ref: 525))
		(signature ''model()'')
		(sourceAnchor (ref: 526)))
	(FAMIX.Parameter (id: 1741)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 433)))
	(FAMIX.Access (id: 2569)
		(accessor (ref: 1839))
		(sourceAnchor (ref: 1840))
		(variable (ref: 2139)))
	(FAMIX.Access (id: 2570)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 729)))
	(FAMIX.Access (id: 2571)
		(accessor (ref: 2187))
		(sourceAnchor (ref: 2188))
		(variable (ref: 2572)))
	(FAMIX.Parameter (id: 2573)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 443)))
	(FAMIX.Access (id: 2574)
		(accessor (ref: 2243))
		(isWrite true)
		(sourceAnchor (ref: 2244))
		(variable (ref: 768)))
	(FAMIX.Invocation (id: 2575)
		(receiver (ref: 471))
		(sender (ref: 1283))
		(signature ''new()'')
		(sourceAnchor (ref: 1284)))
	(FAMIX.Invocation (id: 2576)
		(receiver (ref: 239))
		(sender (ref: 237))
		(signature ''key()'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Method (id: 2577)
		(name ''decreaseZoom'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''decreaseZoom'')
		(sourceAnchor (ref: 2578)))
	(FAMIX.Invocation (id: 2579)
		(sender (ref: 173))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Access (id: 2580)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 2581)))
	(FAMIX.Invocation (id: 2582)
		(receiver (ref: 875))
		(sender (ref: 95))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Method (id: 2445)
		(name ''cacheForm'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''cacheForm'')
		(sourceAnchor (ref: 2583)))
	(FAMIX.Invocation (id: 2584)
		(sender (ref: 426))
		(signature ''extent:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.LocalVariable (id: 1513)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 929)))
	(FAMIX.Parameter (id: 1414)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1412)))
	(FAMIX.Access (id: 2585)
		(accessor (ref: 938))
		(sourceAnchor (ref: 939))
		(variable (ref: 1369)))
	(FAMIX.Invocation (id: 2586)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''pink()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 2587)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.Access (id: 2588)
		(accessor (ref: 537))
		(sourceAnchor (ref: 538))
		(variable (ref: 104)))
	(FAMIX.Comment (id: 2589)
		(container (ref: 1666))
		(content ''"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."''))
	(FAMIX.Access (id: 2590)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 1814)))
	(FAMIX.Parameter (id: 2591)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 408)))
	(FAMIX.Invocation (id: 2592)
		(sender (ref: 283))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Invocation (id: 2593)
		(sender (ref: 658))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Invocation (id: 2594)
		(receiver (ref: 2595))
		(sender (ref: 627))
		(signature ''outgoingEdges()'')
		(sourceAnchor (ref: 628)))
	(FAMIX.Access (id: 2596)
		(accessor (ref: 2597))
		(sourceAnchor (ref: 2598))
		(variable (ref: 2599)))
	(FAMIX.Access (id: 2600)
		(accessor (ref: 2269))
		(isWrite true)
		(sourceAnchor (ref: 2270))
		(variable (ref: 888)))
	(FAMIX.Access (id: 2601)
		(accessor (ref: 2602))
		(isWrite true)
		(sourceAnchor (ref: 2603))
		(variable (ref: 1268)))
	(FAMIX.Parameter (id: 2604)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 737)))
	(FAMIX.Access (id: 2605)
		(accessor (ref: 2173))
		(sourceAnchor (ref: 2174))
		(variable (ref: 2172)))
	(FAMIX.Comment (id: 2606)
		(container (ref: 683))
		(content ''"Return the selection box, note that the two corners cannot be nil"''))
	(FAMIX.Invocation (id: 2607)
		(receiver (ref: 2608))
		(sender (ref: 2436))
		(signature ''bounds()'')
		(sourceAnchor (ref: 2437)))
	(FAMIX.Invocation (id: 2609)
		(sender (ref: 32))
		(signature ''select()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Invocation (id: 2610)
		(receiver (ref: 181))
		(sender (ref: 1199))
		(signature ''clearLookupCacheRecursively()'')
		(sourceAnchor (ref: 1200)))
	(FAMIX.Invocation (id: 2611)
		(receiver (ref: 1957))
		(sender (ref: 2612))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 2613)))
	(FAMIX.LocalVariable (id: 1603)
		(name ''each'')
		(parentBehaviouralEntity (ref: 374)))
	(FAMIX.Invocation (id: 2614)
		(receiver (ref: 2615))
		(sender (ref: 2616))
		(signature ''isVisible:(Object)'')
		(sourceAnchor (ref: 2617)))
	(FAMIX.Comment (id: 2618)
		(container (ref: 505))
		(content ''"a Node is displayed at the coordinate given by its _absolute_ position. The relative position
	 cannot be used because of the zOrder. An outter node may not be necessarily be displayed before 
	 its inner nodes"''))
	(FAMIX.Access (id: 2619)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Access (id: 2620)
		(accessor (ref: 611))
		(sourceAnchor (ref: 612))
		(variable (ref: 2621)))
	(FAMIX.Invocation (id: 2622)
		(sender (ref: 84))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Reference (id: 2623)
		(source (ref: 20))
		(sourceAnchor (ref: 21))
		(target (ref: 2624)))
	(FAMIX.Invocation (id: 2625)
		(receiver (ref: 1899))
		(sender (ref: 672))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 673)))
	(FAMIX.Reference (id: 2626)
		(source (ref: 128))
		(sourceAnchor (ref: 129))
		(target (ref: 2627)))
	(FAMIX.Method (id: 145)
		(name ''layout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''layout'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Reference (id: 2628)
		(source (ref: 145))
		(sourceAnchor (ref: 146))
		(target (ref: 1277)))
	(FAMIX.Access (id: 2629)
		(accessor (ref: 819))
		(sourceAnchor (ref: 2290))
		(variable (ref: 2630)))
	(FAMIX.Access (id: 2631)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 306)))
	(FAMIX.Invocation (id: 2632)
		(receiver (ref: 2633))
		(sender (ref: 404))
		(signature ''allSuperclasses()'')
		(sourceAnchor (ref: 406)))
	(FAMIX.Access (id: 2634)
		(accessor (ref: 294))
		(isWrite true)
		(sourceAnchor (ref: 295))
		(variable (ref: 2635)))
	(FAMIX.Access (id: 2636)
		(accessor (ref: 1550))
		(sourceAnchor (ref: 1551))
		(variable (ref: 1552)))
	(FAMIX.Comment (id: 2637)
		(container (ref: 658))
		(content ''"An edge is between two different nodes "''))
	(FAMIX.Method (id: 795)
		(name ''edges:from:to:fromGlobal:toGlobal:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 5)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:to:fromGlobal:toGlobal:'')
		(sourceAnchor (ref: 2329)))
	(FAMIX.Comment (id: 2638)
		(container (ref: 934))
		(content ''"Return the default line shape class"''))
	(FAMIX.Access (id: 2639)
		(accessor (ref: 1085))
		(sourceAnchor (ref: 1086))
		(variable (ref: 2640)))
	(FAMIX.Access (id: 2641)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 2642)
		(receiver (ref: 1685))
		(sender (ref: 290))
		(signature ''assert:(Object)'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Invocation (id: 2643)
		(receiver (ref: 793))
		(sender (ref: 95))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Parameter (id: 2644)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 465)))
	(FAMIX.Invocation (id: 2645)
		(receiver (ref: 41))
		(sender (ref: 162))
		(signature ''new()'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Comment (id: 2646)
		(container (ref: 1650))
		(content ''"Returns the MONode corresponding to the value anObject"''))
	(FAMIX.Access (id: 2647)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 2648)))
	(FAMIX.Method (id: 696)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''initialize'')
		(sourceAnchor (ref: 697)))
	(FAMIX.Method (id: 537)
		(name ''absoluteBounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''absoluteBounds'')
		(sourceAnchor (ref: 538)))
	(FAMIX.Reference (id: 2649)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Reference (id: 2650)
		(source (ref: 732))
		(sourceAnchor (ref: 733))
		(target (ref: 1039)))
	(FAMIX.Invocation (id: 2651)
		(sender (ref: 32))
		(signature ''popupText()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Invocation (id: 2652)
		(receiver (ref: 954))
		(sender (ref: 683))
		(signature ''notNil()'')
		(sourceAnchor (ref: 684)))
	(FAMIX.Invocation (id: 2653)
		(sender (ref: 866))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Method (id: 1451)
		(name ''radius'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''radius'')
		(sourceAnchor (ref: 1452)))
	(FAMIX.Reference (id: 2654)
		(source (ref: 162))
		(sourceAnchor (ref: 163))
		(target (ref: 41)))
	(FAMIX.Access (id: 2655)
		(accessor (ref: 1345))
		(sourceAnchor (ref: 1346))
		(variable (ref: 2656)))
	(FAMIX.Comment (id: 2657)
		(container (ref: 91))
		(content ''"pink"''))
	(FAMIX.Method (id: 1406)
		(name ''cacheNamed:of:put:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''cacheNamed:of:put:'')
		(sourceAnchor (ref: 1407)))
	(FAMIX.Access (id: 2658)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 42)))
	(FAMIX.Access (id: 2659)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 2021)))
	(FAMIX.LocalVariable (id: 1384)
		(name ''node'')
		(parentBehaviouralEntity (ref: 275)))
	(FAMIX.Access (id: 2660)
		(accessor (ref: 2661))
		(sourceAnchor (ref: 2662))
		(variable (ref: 2663)))
	(FAMIX.Invocation (id: 2664)
		(sender (ref: 327))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 2665)
		(receiver (ref: 2666))
		(sender (ref: 99))
		(signature ''model()'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Method (id: 2667)
		(name ''isVisible'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''isVisible'')
		(sourceAnchor (ref: 2668)))
	(FAMIX.Invocation (id: 2669)
		(receiver (ref: 2670))
		(sender (ref: 88))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 89)))
	(FAMIX.Access (id: 2671)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1281)))
	(FAMIX.Invocation (id: 2672)
		(sender (ref: 84))
		(signature ''subscribe:do:(Object,Object)'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 2673)
		(receiver (ref: 67))
		(sender (ref: 116))
		(signature ''notNil()'')
		(sourceAnchor (ref: 117)))
	(FAMIX.Access (id: 2674)
		(accessor (ref: 327))
		(isWrite true)
		(sourceAnchor (ref: 328))
		(variable (ref: 104)))
	(FAMIX.Invocation (id: 2675)
		(sender (ref: 84))
		(signature ''changed()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Comment (id: 2676)
		(container (ref: 2453))
		(content ''"We do nothing since we are the root"''))
	(FAMIX.Access (id: 2677)
		(accessor (ref: 248))
		(isWrite true)
		(sourceAnchor (ref: 249))
		(variable (ref: 2040)))
	(FAMIX.Invocation (id: 2678)
		(receiver (ref: 181))
		(sender (ref: 207))
		(signature ''isRoot()'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Class (id: 2679)
		(name ''MOHorizontalNarrowTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Parameter (id: 918)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 676)))
	(FAMIX.Access (id: 2680)
		(accessor (ref: 1855))
		(sourceAnchor (ref: 1856))
		(variable (ref: 2681)))
	(FAMIX.Access (id: 2682)
		(accessor (ref: 1055))
		(sourceAnchor (ref: 1496))
		(variable (ref: 1054)))
	(FAMIX.Access (id: 2683)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 68)))
	(FAMIX.Access (id: 2684)
		(accessor (ref: 1446))
		(sourceAnchor (ref: 1447))
		(variable (ref: 1445)))
	(FAMIX.Method (id: 1246)
		(name ''defaultLineShapeClass'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''defaultLineShapeClass'')
		(sourceAnchor (ref: 1247)))
	(FAMIX.LocalVariable (id: 2377)
		(name ''nodes'')
		(parentBehaviouralEntity (ref: 80)))
	(FAMIX.Invocation (id: 2685)
		(receiver (ref: 2686))
		(sender (ref: 2256))
		(signature ''defaultToPositions()'')
		(sourceAnchor (ref: 2257)))
	(FAMIX.Invocation (id: 2687)
		(receiver (ref: 445))
		(sender (ref: 2688))
		(signature ''notNil()'')
		(sourceAnchor (ref: 2689)))
	(FAMIX.Access (id: 2690)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 2412)))
	(FAMIX.Comment (id: 2691)
		(container (ref: 756))
		(content ''"Transcript show: ''''debug setDefaultHandlersMouseDown 1 : '''', selectionBoxCorner1 printString, '''' '''', selectionBoxCorner2 printString, ''''   '''', self hasSelectedNodes printString ; cr."''))
	(FAMIX.Access (id: 2692)
		(accessor (ref: 866))
		(sourceAnchor (ref: 867))
		(variable (ref: 1074)))
	(FAMIX.Reference (id: 2693)
		(source (ref: 1104))
		(sourceAnchor (ref: 1105))
		(target (ref: 93)))
	(FAMIX.LocalVariable (id: 610)
		(name ''k'')
		(parentBehaviouralEntity (ref: 611)))
	(FAMIX.Invocation (id: 2694)
		(receiver (ref: 2014))
		(sender (ref: 2012))
		(signature ''metricCaches()'')
		(sourceAnchor (ref: 2013)))
	(FAMIX.Invocation (id: 2695)
		(receiver (ref: 1513))
		(sender (ref: 929))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Invocation (id: 2696)
		(sender (ref: 2697))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 2698)))
	(FAMIX.Invocation (id: 2699)
		(receiver (ref: 2700))
		(sender (ref: 32))
		(signature ''new()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 2701)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Invocation (id: 2702)
		(sender (ref: 2538))
		(signature ''resetMetricCachesUpToTheRoot()'')
		(sourceAnchor (ref: 2539)))
	(FAMIX.Invocation (id: 2703)
		(receiver (ref: 2573))
		(sender (ref: 443))
		(signature ''origin()'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Parameter (id: 2704)
		(name ''regexp'')
		(parentBehaviouralEntity (ref: 611)))
	(FAMIX.Access (id: 2705)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 2706)))
	(FAMIX.Method (id: 398)
		(name ''metricCaches'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''metricCaches'')
		(sourceAnchor (ref: 399)))
	(FAMIX.Comment (id: 2707)
		(container (ref: 2708))
		(content ''"True if I am a line shape. This method is intended to be overriden."''))
	(FAMIX.Invocation (id: 2709)
		(sender (ref: 2710))
		(signature ''not()'')
		(sourceAnchor (ref: 2711)))
	(FAMIX.Access (id: 2712)
		(accessor (ref: 2112))
		(isWrite true)
		(sourceAnchor (ref: 2113))
		(variable (ref: 512)))
	(FAMIX.LocalVariable (id: 2595)
		(name ''n'')
		(parentBehaviouralEntity (ref: 627)))
	(FAMIX.Access (id: 2713)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 56)))
	(FAMIX.Access (id: 2714)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.Access (id: 2715)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 2266)))
	(FAMIX.Invocation (id: 2716)
		(receiver (ref: 2717))
		(sender (ref: 1967))
		(signature ''translateBy:(Object)'')
		(sourceAnchor (ref: 1968)))
	(FAMIX.Method (id: 2718)
		(name ''layout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''layout'')
		(sourceAnchor (ref: 2719)))
	(FAMIX.Invocation (id: 2720)
		(receiver (ref: 768))
		(sender (ref: 1519))
		(signature ''announce:(Object)'')
		(sourceAnchor (ref: 1520)))
	(FAMIX.Access (id: 2721)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1600)))
	(FAMIX.Invocation (id: 2722)
		(receiver (ref: 41))
		(sender (ref: 465))
		(signature ''with:(Object)'')
		(sourceAnchor (ref: 466)))
	(FAMIX.Method (id: 1785)
		(name ''resetFormCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetFormCache'')
		(sourceAnchor (ref: 1786)))
	(FAMIX.Invocation (id: 2723)
		(sender (ref: 1650))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 1651)))
	(FAMIX.Access (id: 2724)
		(accessor (ref: 798))
		(sourceAnchor (ref: 799))
		(variable (ref: 797)))
	(FAMIX.Invocation (id: 2725)
		(receiver (ref: 512))
		(sender (ref: 2726))
		(signature ''toPositions:(Object)'')
		(sourceAnchor (ref: 2727)))
	(FAMIX.Access (id: 2728)
		(accessor (ref: 2034))
		(sourceAnchor (ref: 2155))
		(variable (ref: 2729)))
	(FAMIX.Invocation (id: 2730)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Method (id: 2731)
		(name ''title'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''title'')
		(sourceAnchor (ref: 2732)))
	(FAMIX.Access (id: 2733)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 79)))
	(FAMIX.Access (id: 2734)
		(accessor (ref: 88))
		(sourceAnchor (ref: 89))
		(variable (ref: 87)))
	(FAMIX.Method (id: 1511)
		(name ''absoluteBounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''absoluteBounds'')
		(sourceAnchor (ref: 1772)))
	(FAMIX.Invocation (id: 2735)
		(receiver (ref: 263))
		(sender (ref: 1033))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 2736)))
	(FAMIX.Invocation (id: 2737)
		(receiver (ref: 787))
		(sender (ref: 465))
		(signature ''value()'')
		(sourceAnchor (ref: 466)))
	(FAMIX.Invocation (id: 2738)
		(receiver (ref: 663))
		(sender (ref: 661))
		(signature ''edges:from:to:fromGlobal:toGlobal:(Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 662)))
	(FAMIX.Invocation (id: 2739)
		(receiver (ref: 357))
		(sender (ref: 304))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Invocation (id: 2740)
		(sender (ref: 658))
		(signature ''addEdge:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Parameter (id: 2741)
		(name ''anAnnouncer'')
		(parentBehaviouralEntity (ref: 766)))
	(FAMIX.Access (id: 2742)
		(accessor (ref: 2187))
		(isWrite true)
		(sourceAnchor (ref: 2188))
		(variable (ref: 2743)))
	(FAMIX.Invocation (id: 2744)
		(receiver (ref: 2745))
		(sender (ref: 186))
		(signature ''new()'')
		(sourceAnchor (ref: 187)))
	(FAMIX.Parameter (id: 10)
		(name ''aTitle'')
		(parentBehaviouralEntity (ref: 8)))
	(FAMIX.Invocation (id: 2746)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 2747)
		(accessor (ref: 827))
		(sourceAnchor (ref: 1301))
		(variable (ref: 1302)))
	(FAMIX.Invocation (id: 2748)
		(sender (ref: 43))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Access (id: 2749)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1904)))
	(FAMIX.Access (id: 2750)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1801)))
	(FAMIX.Comment (id: 2751)
		(container (ref: 1147))
		(content ''"This method is used by elementAt:"''))
	(FAMIX.Access (id: 2752)
		(accessor (ref: 1357))
		(sourceAnchor (ref: 1358))
		(variable (ref: 2753)))
	(FAMIX.Invocation (id: 2754)
		(receiver (ref: 258))
		(sender (ref: 256))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 257)))
	(FAMIX.Invocation (id: 2755)
		(receiver (ref: 1031))
		(sender (ref: 128))
		(signature '',(Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 2756)
		(accessor (ref: 549))
		(sourceAnchor (ref: 550))
		(variable (ref: 2757)))
	(FAMIX.Invocation (id: 2758)
		(receiver (ref: 1910))
		(sender (ref: 1820))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Access (id: 2759)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.Method (id: 858)
		(name ''edges:fromAll:toAll:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 4)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:fromAll:toAll:using:'')
		(sourceAnchor (ref: 859)))
	(FAMIX.Method (id: 2203)
		(name ''shapeBoundsAt:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shapeBoundsAt:'')
		(sourceAnchor (ref: 2760)))
	(FAMIX.Access (id: 2761)
		(accessor (ref: 963))
		(isWrite true)
		(sourceAnchor (ref: 964))
		(variable (ref: 940)))
	(FAMIX.Method (id: 872)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''initialize'')
		(sourceAnchor (ref: 873)))
	(FAMIX.Invocation (id: 2762)
		(sender (ref: 173))
		(signature ''copy()'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Access (id: 2763)
		(accessor (ref: 498))
		(isWrite true)
		(sourceAnchor (ref: 499))
		(variable (ref: 1910)))
	(FAMIX.Access (id: 2764)
		(accessor (ref: 57))
		(isWrite true)
		(sourceAnchor (ref: 59))
		(variable (ref: 604)))
	(FAMIX.Invocation (id: 2765)
		(receiver (ref: 2766))
		(sender (ref: 2616))
		(signature ''edgesDo:(Object)'')
		(sourceAnchor (ref: 2617)))
	(FAMIX.Parameter (id: 2767)
		(name ''aBlockOrSelector'')
		(parentBehaviouralEntity (ref: 798)))
	(FAMIX.Method (id: 2768)
		(name ''hasInteraction'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''hasInteraction'')
		(sourceAnchor (ref: 2769)))
	(FAMIX.Invocation (id: 2770)
		(receiver (ref: 2548))
		(sender (ref: 1645))
		(signature ''copyShapeWithoutUpdatingAndDo:(Object)'')
		(sourceAnchor (ref: 2483)))
	(FAMIX.Access (id: 2771)
		(accessor (ref: 1104))
		(sourceAnchor (ref: 1105))
		(variable (ref: 1955)))
	(FAMIX.Access (id: 2772)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 2773)))
	(FAMIX.Invocation (id: 2774)
		(receiver (ref: 1608))
		(sender (ref: 95))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Method (id: 596)
		(name ''enableCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''enableCache'')
		(sourceAnchor (ref: 2775)))
	(FAMIX.Access (id: 2776)
		(accessor (ref: 106))
		(sourceAnchor (ref: 2162))
		(variable (ref: 604)))
	(FAMIX.Access (id: 2777)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 832)))
	(FAMIX.Method (id: 2778)
		(name ''model'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''model'')
		(sourceAnchor (ref: 2779)))
	(FAMIX.Reference (id: 2780)
		(source (ref: 1349))
		(sourceAnchor (ref: 1350))
		(target (ref: 1348)))
	(FAMIX.Access (id: 2781)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 52)))
	(FAMIX.Access (id: 2782)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1681)))
	(FAMIX.Access (id: 2783)
		(accessor (ref: 1406))
		(sourceAnchor (ref: 1407))
		(variable (ref: 1690)))
	(FAMIX.Invocation (id: 2784)
		(sender (ref: 204))
		(signature ''firstSubnodeThat:(Object)'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Invocation (id: 2785)
		(receiver (ref: 2786))
		(sender (ref: 1901))
		(signature ''getBoundedTranslationStep:(Object)'')
		(sourceAnchor (ref: 2321)))
	(FAMIX.Access (id: 2787)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 1696)))
	(FAMIX.Invocation (id: 2788)
		(sender (ref: 13))
		(signature ''asInteger()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 2789)
		(sender (ref: 622))
		(signature ''at:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 623)))
	(FAMIX.Invocation (id: 2790)
		(sender (ref: 959))
		(signature ''remove:(Object)'')
		(sourceAnchor (ref: 960)))
	(FAMIX.Invocation (id: 2791)
		(sender (ref: 723))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 724)))
	(FAMIX.Invocation (id: 2792)
		(receiver (ref: 1369))
		(sender (ref: 938))
		(signature ''defaultLineShapeInstance()'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Invocation (id: 2793)
		(sender (ref: 514))
		(signature ''size()'')
		(sourceAnchor (ref: 2063)))
	(FAMIX.Method (id: 900)
		(name ''forNodes:'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constructor'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''forNodes:'')
		(sourceAnchor (ref: 901)))
	(FAMIX.Invocation (id: 2794)
		(receiver (ref: 2795))
		(sender (ref: 2796))
		(signature ''deepApplyLayout()'')
		(sourceAnchor (ref: 2797)))
	(FAMIX.Access (id: 2798)
		(accessor (ref: 1666))
		(sourceAnchor (ref: 1667))
		(variable (ref: 2799)))
	(FAMIX.Invocation (id: 2800)
		(receiver (ref: 263))
		(sender (ref: 1272))
		(signature ''notNil()'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Access (id: 2801)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2148)))
	(FAMIX.Comment (id: 2802)
		(container (ref: 644))
		(content ''"Returns the MONode corresponding to the value anObject"''))
	(FAMIX.Access (id: 2803)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Access (id: 2804)
		(accessor (ref: 342))
		(sourceAnchor (ref: 1895))
		(variable (ref: 341)))
	(FAMIX.Method (id: 1640)
		(name ''announcer'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''announcer'')
		(sourceAnchor (ref: 1641)))
	(FAMIX.Invocation (id: 2805)
		(receiver (ref: 1029))
		(sender (ref: 32))
		(signature ''element()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 2806)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Access (id: 2807)
		(accessor (ref: 1290))
		(sourceAnchor (ref: 1291))
		(variable (ref: 1371)))
	(FAMIX.Method (id: 2808)
		(name ''isVisible:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''isVisible:'')
		(sourceAnchor (ref: 2809)))
	(FAMIX.Invocation (id: 2810)
		(receiver (ref: 2811))
		(sender (ref: 423))
		(signature ''toPositions:(Object)'')
		(sourceAnchor (ref: 424)))
	(FAMIX.Invocation (id: 2812)
		(receiver (ref: 158))
		(sender (ref: 159))
		(signature ''propertyValueAt:(Object)'')
		(sourceAnchor (ref: 160)))
	(FAMIX.Reference (id: 2813)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 2814)
		(accessor (ref: 44))
		(sourceAnchor (ref: 46))
		(variable (ref: 2815)))
	(FAMIX.Parameter (id: 2816)
		(name ''aBlockOrSelector'')
		(parentBehaviouralEntity (ref: 661)))
	(FAMIX.Access (id: 2817)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1766)))
	(FAMIX.Invocation (id: 2818)
		(receiver (ref: 41))
		(sender (ref: 1559))
		(signature ''new()'')
		(sourceAnchor (ref: 1560)))
	(FAMIX.Invocation (id: 2819)
		(receiver (ref: 1191))
		(sender (ref: 1096))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 1097)))
	(FAMIX.Access (id: 2820)
		(accessor (ref: 1232))
		(sourceAnchor (ref: 2821))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 2822)
		(sender (ref: 8))
		(signature ''title:(Object)'')
		(sourceAnchor (ref: 9)))
	(FAMIX.Access (id: 2823)
		(accessor (ref: 388))
		(sourceAnchor (ref: 389))
		(variable (ref: 387)))
	(FAMIX.Access (id: 2824)
		(accessor (ref: 493))
		(sourceAnchor (ref: 494))
		(variable (ref: 495)))
	(FAMIX.Invocation (id: 2825)
		(receiver (ref: 179))
		(sender (ref: 1831))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1832)))
	(FAMIX.Method (id: 1823)
		(name ''cacheFromPoint:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''cacheFromPoint:'')
		(sourceAnchor (ref: 2826)))
	(FAMIX.Access (id: 2827)
		(accessor (ref: 368))
		(sourceAnchor (ref: 369))
		(variable (ref: 2386)))
	(FAMIX.Access (id: 2828)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1935)))
	(FAMIX.Invocation (id: 2829)
		(sender (ref: 204))
		(signature ''nodeWith:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Access (id: 2830)
		(accessor (ref: 497))
		(sourceAnchor (ref: 2491))
		(variable (ref: 2831)))
	(FAMIX.Invocation (id: 2832)
		(sender (ref: 1007))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1008)))
	(FAMIX.Access (id: 2833)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Invocation (id: 2834)
		(sender (ref: 1019))
		(signature ''intersects:(Object)'')
		(sourceAnchor (ref: 1020)))
	(FAMIX.Access (id: 2835)
		(accessor (ref: 516))
		(sourceAnchor (ref: 517))
		(variable (ref: 1747)))
	(FAMIX.Invocation (id: 2836)
		(sender (ref: 2837))
		(signature ''origin()'')
		(sourceAnchor (ref: 2838)))
	(FAMIX.Invocation (id: 2839)
		(receiver (ref: 2840))
		(sender (ref: 1378))
		(signature ''owner()'')
		(sourceAnchor (ref: 1379)))
	(FAMIX.Access (id: 2841)
		(accessor (ref: 154))
		(isWrite true)
		(sourceAnchor (ref: 155))
		(variable (ref: 1382)))
	(FAMIX.Invocation (id: 2842)
		(receiver (ref: 2266))
		(sender (ref: 32))
		(signature ''interaction()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 2843)
		(accessor (ref: 88))
		(isWrite true)
		(sourceAnchor (ref: 89))
		(variable (ref: 2670)))
	(FAMIX.Access (id: 2844)
		(accessor (ref: 565))
		(sourceAnchor (ref: 566))
		(variable (ref: 2845)))
	(FAMIX.Access (id: 2846)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 1197)))
	(FAMIX.Access (id: 2847)
		(accessor (ref: 1237))
		(sourceAnchor (ref: 1791))
		(variable (ref: 1375)))
	(FAMIX.LocalVariable (id: 1031)
		(name ''rootLabel'')
		(parentBehaviouralEntity (ref: 128)))
	(FAMIX.Invocation (id: 2848)
		(sender (ref: 437))
		(signature ''ifNotNilDo:(Object)'')
		(sourceAnchor (ref: 438)))
	(FAMIX.Access (id: 2849)
		(accessor (ref: 108))
		(isWrite true)
		(sourceAnchor (ref: 109))
		(variable (ref: 812)))
	(FAMIX.Access (id: 2850)
		(accessor (ref: 111))
		(sourceAnchor (ref: 112))
		(variable (ref: 2851)))
	(FAMIX.Access (id: 2852)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.Invocation (id: 2853)
		(receiver (ref: 1416))
		(sender (ref: 993))
		(signature ''allEdgesDo:(Object)'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Invocation (id: 2854)
		(receiver (ref: 834))
		(sender (ref: 80))
		(signature ''setAnnouncer:(Object)'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Access (id: 2855)
		(accessor (ref: 318))
		(sourceAnchor (ref: 319))
		(variable (ref: 317)))
	(FAMIX.Method (id: 809)
		(name ''edgesFrom:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgesFrom:'')
		(sourceAnchor (ref: 810)))
	(FAMIX.Invocation (id: 2856)
		(receiver (ref: 2266))
		(sender (ref: 32))
		(signature ''interaction()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Invocation (id: 2857)
		(sender (ref: 260))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Invocation (id: 2858)
		(receiver (ref: 521))
		(sender (ref: 128))
		(signature ''label()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Invocation (id: 2859)
		(sender (ref: 20))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Reference (id: 2860)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 2861)
		(sender (ref: 84))
		(signature ''canvas()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Comment (id: 2862)
		(container (ref: 426))
		(content ''"if the node has sub nodes, then we need to apply the layout, else, we do nothing"''))
	(FAMIX.Invocation (id: 2863)
		(receiver (ref: 2864))
		(sender (ref: 275))
		(signature ''edges()'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Access (id: 2865)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1016)))
	(FAMIX.Invocation (id: 2866)
		(receiver (ref: 246))
		(sender (ref: 13))
		(signature ''width()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 2867)
		(sender (ref: 182))
		(signature ''rect:(Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Invocation (id: 2868)
		(receiver (ref: 569))
		(sender (ref: 237))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Method (id: 1110)
		(name ''horizontalDominanceTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''horizontalDominanceTreeLayout'')
		(sourceAnchor (ref: 1111)))
	(FAMIX.Invocation (id: 2869)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''layout()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 2870)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 2146)))
	(FAMIX.Invocation (id: 2871)
		(receiver (ref: 2872))
		(sender (ref: 560))
		(signature ''scaleBy:(Object)'')
		(sourceAnchor (ref: 561)))
	(FAMIX.LocalVariable (id: 2873)
		(name ''s'')
		(parentBehaviouralEntity (ref: 938)))
	(FAMIX.Invocation (id: 2874)
		(receiver (ref: 729))
		(sender (ref: 294))
		(signature ''addEdgeIn:from:to:model:shape:(Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Access (id: 2875)
		(accessor (ref: 2))
		(sourceAnchor (ref: 1619))
		(variable (ref: 1620)))
	(FAMIX.LocalVariable (id: 277)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 275)))
	(FAMIX.Invocation (id: 2876)
		(receiver (ref: 2169))
		(sender (ref: 963))
		(signature ''defaultNodeShapeClass()'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Invocation (id: 2877)
		(sender (ref: 128))
		(signature ''announcer()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 2878)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Invocation (id: 2879)
		(receiver (ref: 2353))
		(sender (ref: 689))
		(signature ''edgeShape()'')
		(sourceAnchor (ref: 690)))
	(FAMIX.Access (id: 2880)
		(accessor (ref: 312))
		(sourceAnchor (ref: 313))
		(variable (ref: 2001)))
	(FAMIX.Access (id: 2881)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 2882)
		(accessor (ref: 189))
		(sourceAnchor (ref: 336))
		(variable (ref: 1818)))
	(FAMIX.Invocation (id: 2883)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''bounds()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Access (id: 2884)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 12)))
	(FAMIX.Method (id: 2885)
		(name ''symbol'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''symbol'')
		(sourceAnchor (ref: 2886)))
	(FAMIX.Access (id: 2887)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 521)))
	(FAMIX.Invocation (id: 2888)
		(receiver (ref: 832))
		(sender (ref: 99))
		(signature ''at:put:(Object,Object)'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Invocation (id: 2889)
		(receiver (ref: 653))
		(sender (ref: 35))
		(signature ''bounds()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.LocalVariable (id: 2890)
		(name ''node'')
		(parentBehaviouralEntity (ref: 1761)))
	(FAMIX.Parameter (id: 2891)
		(name ''anArgument'')
		(parentBehaviouralEntity (ref: 2892)))
	(FAMIX.Access (id: 2893)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 834)))
	(FAMIX.Method (id: 1232)
		(name ''owner'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''owner'')
		(sourceAnchor (ref: 2821)))
	(FAMIX.Parameter (id: 2102)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 988)))
	(FAMIX.Parameter (id: 2894)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 224)))
	(FAMIX.Reference (id: 2895)
		(source (ref: 1820))
		(sourceAnchor (ref: 1821))
		(target (ref: 2896)))
	(FAMIX.Comment (id: 2897)
		(container (ref: 275))
		(content ''"Does a side effect. Remove a the node corresponding to the object provided as argument"''))
	(FAMIX.Invocation (id: 2898)
		(receiver (ref: 663))
		(sender (ref: 661))
		(signature ''domain()'')
		(sourceAnchor (ref: 662)))
	(FAMIX.Access (id: 2899)
		(accessor (ref: 192))
		(sourceAnchor (ref: 193))
		(variable (ref: 299)))
	(FAMIX.Parameter (id: 2900)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 154)))
	(FAMIX.Invocation (id: 2901)
		(receiver (ref: 1501))
		(sender (ref: 1499))
		(signature ''setUsefulHandlersForNodes()'')
		(sourceAnchor (ref: 1500)))
	(FAMIX.Invocation (id: 2902)
		(receiver (ref: 1505))
		(sender (ref: 1503))
		(signature ''translateBy:bounded:(Object,Object)'')
		(sourceAnchor (ref: 1504)))
	(FAMIX.LocalVariable (id: 2903)
		(name ''n'')
		(parentBehaviouralEntity (ref: 993)))
	(FAMIX.Invocation (id: 2904)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 2905)
		(accessor (ref: 1237))
		(sourceAnchor (ref: 1791))
		(variable (ref: 1375)))
	(FAMIX.Method (id: 1629)
		(name ''setModel:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''setModel:'')
		(sourceAnchor (ref: 2906)))
	(FAMIX.Access (id: 2907)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 834)))
	(FAMIX.Parameter (id: 2908)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 795)))
	(FAMIX.Invocation (id: 2909)
		(sender (ref: 1831))
		(signature ''includesKey:(Object)'')
		(sourceAnchor (ref: 1832)))
	(FAMIX.Access (id: 2910)
		(accessor (ref: 889))
		(sourceAnchor (ref: 890))
		(variable (ref: 2911)))
	(FAMIX.Invocation (id: 2912)
		(receiver (ref: 2201))
		(sender (ref: 1851))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1852)))
	(FAMIX.Access (id: 2913)
		(accessor (ref: 2768))
		(sourceAnchor (ref: 2769))
		(variable (ref: 768)))
	(FAMIX.Access (id: 2914)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 2915)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1766)))
	(FAMIX.Method (id: 2916)
		(name ''toPositions'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''toPositions'')
		(sourceAnchor (ref: 2917)))
	(FAMIX.Access (id: 2918)
		(accessor (ref: 2345))
		(isWrite true)
		(sourceAnchor (ref: 2346))
		(variable (ref: 306)))
	(FAMIX.Access (id: 2919)
		(accessor (ref: 360))
		(sourceAnchor (ref: 361))
		(variable (ref: 2920)))
	(FAMIX.Invocation (id: 2921)
		(sender (ref: 248))
		(signature ''extent:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Comment (id: 2922)
		(container (ref: 374))
		(content ''"Evaluate aBlock for element of the receiver, and return the largest result."''))
	(FAMIX.Access (id: 2923)
		(accessor (ref: 1547))
		(sourceAnchor (ref: 1548))
		(variable (ref: 2160)))
	(FAMIX.Class (id: 322)
		(name ''MONode class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 2924)
		(receiver (ref: 1793))
		(sender (ref: 1804))
		(signature ''new()'')
		(sourceAnchor (ref: 1805)))
	(FAMIX.Access (id: 2925)
		(accessor (ref: 1949))
		(sourceAnchor (ref: 1950))
		(variable (ref: 1951)))
	(FAMIX.Access (id: 2926)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 1814)))
	(FAMIX.Method (id: 2927)
		(name ''isLineLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''isLineLayout'')
		(sourceAnchor (ref: 2928)))
	(FAMIX.Invocation (id: 2929)
		(sender (ref: 69))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Parameter (id: 2217)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 1155)))
	(FAMIX.Invocation (id: 2930)
		(receiver (ref: 2056))
		(sender (ref: 13))
		(signature ''origin:width:height:(Object,Object,Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Parameter (id: 1728)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 290)))
	(FAMIX.Invocation (id: 2931)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 284)))
	(FAMIX.LocalVariable (id: 2932)
		(name ''v'')
		(parentBehaviouralEntity (ref: 1050)))
	(FAMIX.Method (id: 300)
		(name ''incomingEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''incomingEdges'')
		(sourceAnchor (ref: 301)))
	(FAMIX.Invocation (id: 2933)
		(receiver (ref: 1904))
		(sender (ref: 658))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Invocation (id: 2934)
		(receiver (ref: 1173))
		(sender (ref: 1124))
		(signature ''globalLookupNode:(Object)'')
		(sourceAnchor (ref: 1125)))
	(FAMIX.Comment (id: 2935)
		(container (ref: 761))
		(content ''"Return the width of the shape, for the giving graph element"''))
	(FAMIX.Invocation (id: 2936)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''removeAllNodes()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Reference (id: 2937)
		(source (ref: 29))
		(sourceAnchor (ref: 30))
		(target (ref: 460)))
	(FAMIX.Access (id: 2938)
		(accessor (ref: 2203))
		(sourceAnchor (ref: 2760))
		(variable (ref: 2939)))
	(FAMIX.Method (id: 159)
		(name ''numberOfLinesOfCode'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 1374))
		(signature ''numberOfLinesOfCode'')
		(sourceAnchor (ref: 160)))
	(FAMIX.Invocation (id: 2940)
		(receiver (ref: 1843))
		(sender (ref: 294))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Access (id: 2941)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 606)))
	(FAMIX.Invocation (id: 2942)
		(receiver (ref: 181))
		(sender (ref: 740))
		(signature ''removeNode:(Object)'')
		(sourceAnchor (ref: 741)))
	(FAMIX.Invocation (id: 2943)
		(receiver (ref: 2237))
		(sender (ref: 631))
		(signature ''initialize()'')
		(sourceAnchor (ref: 632)))
	(FAMIX.Invocation (id: 2944)
		(receiver (ref: 41))
		(sender (ref: 894))
		(signature ''with:(Object)'')
		(sourceAnchor (ref: 895)))
	(FAMIX.Access (id: 2945)
		(accessor (ref: 71))
		(sourceAnchor (ref: 72))
		(variable (ref: 73)))
	(FAMIX.Access (id: 2946)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 331)))
	(FAMIX.Access (id: 2947)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 2948)
		(sender (ref: 159))
		(signature ''lineCount()'')
		(sourceAnchor (ref: 160)))
	(FAMIX.Invocation (id: 2949)
		(receiver (ref: 2950))
		(sender (ref: 2951))
		(signature ''executeOnNode:(Object)'')
		(sourceAnchor (ref: 2952)))
	(FAMIX.Access (id: 2953)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 2954)))
	(FAMIX.Method (id: 124)
		(name ''externalEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''externalEdges'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Method (id: 2955)
		(name ''resetMetricCachesResursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 1)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''resetMetricCachesResursively'')
		(sourceAnchor (ref: 2956)))
	(FAMIX.LocalVariable (id: 2084)
		(name ''eachShape'')
		(parentBehaviouralEntity (ref: 327)))
	(FAMIX.Method (id: 1290)
		(name ''isVisibleInBounds:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''isVisibleInBounds:'')
		(sourceAnchor (ref: 1291)))
	(FAMIX.Invocation (id: 2957)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''resetCacheInEdges()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 2958)
		(accessor (ref: 2597))
		(isWrite true)
		(sourceAnchor (ref: 2598))
		(variable (ref: 2959)))
	(FAMIX.Invocation (id: 2960)
		(receiver (ref: 587))
		(sender (ref: 54))
		(signature ''shapeBoundsAt:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Access (id: 2961)
		(accessor (ref: 29))
		(sourceAnchor (ref: 30))
		(variable (ref: 28)))
	(FAMIX.Parameter (id: 2962)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 1104)))
	(FAMIX.Access (id: 2963)
		(accessor (ref: 2964))
		(isWrite true)
		(sourceAnchor (ref: 2965))
		(variable (ref: 113)))
	(FAMIX.Access (id: 2966)
		(accessor (ref: 408))
		(sourceAnchor (ref: 1241))
		(variable (ref: 407)))
	(FAMIX.Invocation (id: 2967)
		(sender (ref: 13))
		(signature ''<(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 848)
		(name ''setCacheForm:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''setCacheForm:'')
		(sourceAnchor (ref: 2968)))
	(FAMIX.Method (id: 1189)
		(name ''addIncomingEdge:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''addIncomingEdge:'')
		(sourceAnchor (ref: 1190)))
	(FAMIX.Invocation (id: 2969)
		(sender (ref: 13))
		(signature ''*(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 430)
		(name ''nodesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''nodesDo:'')
		(sourceAnchor (ref: 1022)))
	(FAMIX.Comment (id: 2970)
		(container (ref: 391))
		(content ''"Select the node"''))
	(FAMIX.Method (id: 1720)
		(name ''userCommands'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''userCommands'')
		(sourceAnchor (ref: 1721)))
	(FAMIX.Access (id: 2971)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1294)))
	(FAMIX.Invocation (id: 2972)
		(receiver (ref: 712))
		(sender (ref: 182))
		(signature ''origin()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 2973)
		(accessor (ref: 737))
		(sourceAnchor (ref: 2974))
		(variable (ref: 2975)))
	(FAMIX.Invocation (id: 2976)
		(receiver (ref: 2977))
		(sender (ref: 514))
		(signature ''methods()'')
		(sourceAnchor (ref: 2063)))
	(FAMIX.Access (id: 2978)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 2417)))
	(FAMIX.Invocation (id: 2979)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''valueWithArguments:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.LocalVariable (id: 457)
		(name ''edges'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Reference (id: 2980)
		(source (ref: 368))
		(sourceAnchor (ref: 369))
		(target (ref: 2981)))
	(FAMIX.Parameter (id: 640)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Access (id: 2982)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1136)))
	(FAMIX.Access (id: 2983)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1688)))
	(FAMIX.Invocation (id: 2984)
		(sender (ref: 443))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Invocation (id: 2985)
		(receiver (ref: 211))
		(sender (ref: 304))
		(signature ''new()'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Access (id: 2986)
		(accessor (ref: 963))
		(sourceAnchor (ref: 964))
		(variable (ref: 2987)))
	(FAMIX.Access (id: 2988)
		(accessor (ref: 108))
		(isWrite true)
		(sourceAnchor (ref: 109))
		(variable (ref: 512)))
	(FAMIX.Parameter (id: 2989)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1143)))
	(FAMIX.Parameter (id: 2565)
		(name ''oneBlockArg'')
		(parentBehaviouralEntity (ref: 1237)))
	(FAMIX.Access (id: 2990)
		(accessor (ref: 1055))
		(sourceAnchor (ref: 1496))
		(variable (ref: 1497)))
	(FAMIX.Method (id: 886)
		(name ''defaultLineShapeInstance'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultLineShapeInstance'')
		(sourceAnchor (ref: 887)))
	(FAMIX.Invocation (id: 2991)
		(receiver (ref: 2911))
		(sender (ref: 746))
		(signature ''updateBounds()'')
		(sourceAnchor (ref: 747)))
	(FAMIX.Parameter (id: 348)
		(name ''bounded'')
		(parentBehaviouralEntity (ref: 327)))
	(FAMIX.Invocation (id: 2992)
		(receiver (ref: 2993))
		(sender (ref: 8))
		(signature ''new()'')
		(sourceAnchor (ref: 9)))
	(FAMIX.Invocation (id: 2994)
		(receiver (ref: 1623))
		(sender (ref: 1388))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 1622)))
	(FAMIX.Method (id: 1605)
		(name ''cache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''cache'')
		(sourceAnchor (ref: 1606)))
	(FAMIX.Method (id: 1582)
		(name ''resetMetricCachesResursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetMetricCachesResursively'')
		(sourceAnchor (ref: 1583)))
	(FAMIX.Invocation (id: 2995)
		(receiver (ref: 2996))
		(sender (ref: 2837))
		(signature ''bounds()'')
		(sourceAnchor (ref: 2838)))
	(FAMIX.Access (id: 2997)
		(accessor (ref: 1519))
		(sourceAnchor (ref: 1520))
		(variable (ref: 2451)))
	(FAMIX.Invocation (id: 2998)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 2999)
		(accessor (ref: 858))
		(sourceAnchor (ref: 859))
		(variable (ref: 1871)))
	(FAMIX.Access (id: 3000)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 3001)))
	(FAMIX.Access (id: 3002)
		(accessor (ref: 1967))
		(sourceAnchor (ref: 1968))
		(variable (ref: 1966)))
	(FAMIX.Invocation (id: 3003)
		(sender (ref: 1426))
		(signature ''bounds()'')
		(sourceAnchor (ref: 1591)))
	(FAMIX.Access (id: 3004)
		(accessor (ref: 2667))
		(sourceAnchor (ref: 2668))
		(variable (ref: 3005)))
	(FAMIX.Method (id: 707)
		(name ''allNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''allNodes'')
		(sourceAnchor (ref: 708)))
	(FAMIX.Invocation (id: 3006)
		(sender (ref: 963))
		(signature ''ifNotNilDo:(Object)'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Access (id: 3007)
		(accessor (ref: 487))
		(sourceAnchor (ref: 488))
		(variable (ref: 3008)))
	(FAMIX.Access (id: 3009)
		(accessor (ref: 1357))
		(isWrite true)
		(sourceAnchor (ref: 1358))
		(variable (ref: 168)))
	(FAMIX.Invocation (id: 3010)
		(sender (ref: 283))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 3011)
		(accessor (ref: 537))
		(sourceAnchor (ref: 538))
		(variable (ref: 536)))
	(FAMIX.Access (id: 3012)
		(accessor (ref: 468))
		(sourceAnchor (ref: 1364))
		(variable (ref: 3013)))
	(FAMIX.Access (id: 3014)
		(accessor (ref: 106))
		(sourceAnchor (ref: 2162))
		(variable (ref: 604)))
	(FAMIX.Invocation (id: 3015)
		(sender (ref: 91))
		(signature ''yourself()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3016)
		(accessor (ref: 54))
		(isWrite true)
		(sourceAnchor (ref: 570))
		(variable (ref: 1614)))
	(FAMIX.Access (id: 3017)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 2021)))
	(FAMIX.Parameter (id: 1608)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Parameter (id: 3018)
		(name ''anEdge'')
		(parentBehaviouralEntity (ref: 1189)))
	(FAMIX.Invocation (id: 3019)
		(receiver (ref: 1814))
		(sender (ref: 84))
		(signature ''root()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Method (id: 136)
		(name ''originalPrintOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''originalPrintOn:'')
		(sourceAnchor (ref: 665)))
	(FAMIX.Reference (id: 3020)
		(source (ref: 473))
		(sourceAnchor (ref: 474))
		(target (ref: 1809)))
	(FAMIX.Access (id: 3021)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 50)))
	(FAMIX.Invocation (id: 3022)
		(receiver (ref: 1453))
		(sender (ref: 404))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 406)))
	(FAMIX.Access (id: 3023)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 793)))
	(FAMIX.LocalVariable (id: 924)
		(name ''newNodes'')
		(parentBehaviouralEntity (ref: 224)))
	(FAMIX.Invocation (id: 3024)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3025)
		(accessor (ref: 611))
		(sourceAnchor (ref: 612))
		(variable (ref: 2704)))
	(FAMIX.Access (id: 3026)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 2266)))
	(FAMIX.Access (id: 3027)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 2410)))
	(FAMIX.Comment (id: 3028)
		(container (ref: 260))
		(content ''"if I have more than 1 argument, then the valueOrArray is a collection"''))
	(FAMIX.Method (id: 2597)
		(name ''model:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''model:'')
		(sourceAnchor (ref: 2598)))
	(FAMIX.Invocation (id: 3029)
		(sender (ref: 516))
		(signature ''symbol()'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Access (id: 3030)
		(accessor (ref: 622))
		(sourceAnchor (ref: 623))
		(variable (ref: 1121)))
	(FAMIX.Reference (id: 3031)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 3032)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Parameter (id: 3033)
		(name ''amount'')
		(parentBehaviouralEntity (ref: 256)))
	(FAMIX.Comment (id: 3034)
		(container (ref: 602))
		(content ''"Answer the edges that are contained in myself. Note that the extremity of each edges may not necessarily be contained in myself."''))
	(FAMIX.Invocation (id: 3035)
		(sender (ref: 1338))
		(signature ''asIntegerPoint()'')
		(sourceAnchor (ref: 1339)))
	(FAMIX.Invocation (id: 3036)
		(sender (ref: 1345))
		(signature ''initialize()'')
		(sourceAnchor (ref: 1346)))
	(FAMIX.Access (id: 3037)
		(accessor (ref: 565))
		(sourceAnchor (ref: 566))
		(variable (ref: 3038)))
	(FAMIX.Access (id: 3039)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 67)))
	(FAMIX.Invocation (id: 3040)
		(receiver (ref: 3041))
		(sender (ref: 128))
		(signature ''root()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Invocation (id: 3042)
		(receiver (ref: 1653))
		(sender (ref: 1087))
		(signature ''edges:from:to:using:fromGlobal:toGlobal:(Object,Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 1088)))
	(FAMIX.Invocation (id: 3043)
		(sender (ref: 1397))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Method (id: 3044)
		(name ''root'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''root'')
		(sourceAnchor (ref: 3045)))
	(FAMIX.Method (id: 2726)
		(name ''toPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''toPositions:'')
		(sourceAnchor (ref: 2727)))
	(FAMIX.Access (id: 3046)
		(accessor (ref: 827))
		(sourceAnchor (ref: 1301))
		(variable (ref: 826)))
	(FAMIX.Invocation (id: 3047)
		(receiver (ref: 3048))
		(sender (ref: 814))
		(signature ''instVarNames()'')
		(sourceAnchor (ref: 815)))
	(FAMIX.Access (id: 3049)
		(accessor (ref: 2))
		(sourceAnchor (ref: 1619))
		(variable (ref: 3050)))
	(FAMIX.Invocation (id: 3051)
		(receiver (ref: 1646))
		(sender (ref: 182))
		(signature ''adhereTo:(Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Invocation (id: 3052)
		(sender (ref: 404))
		(signature ''inject:into:(Object,Object)'')
		(sourceAnchor (ref: 406)))
	(FAMIX.LocalVariable (id: 3053)
		(name ''v'')
		(parentBehaviouralEntity (ref: 290)))
	(FAMIX.Method (id: 3054)
		(name ''isDefaultNodeShape'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isDefaultNodeShape'')
		(sourceAnchor (ref: 3055)))
	(FAMIX.Invocation (id: 3056)
		(receiver (ref: 41))
		(sender (ref: 154))
		(signature ''with:(Object)'')
		(sourceAnchor (ref: 155)))
	(FAMIX.Invocation (id: 3057)
		(sender (ref: 505))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Parameter (id: 3058)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Invocation (id: 3059)
		(receiver (ref: 922))
		(sender (ref: 221))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Access (id: 3060)
		(accessor (ref: 470))
		(sourceAnchor (ref: 744))
		(variable (ref: 2509)))
	(FAMIX.Access (id: 3061)
		(accessor (ref: 2094))
		(sourceAnchor (ref: 2095))
		(variable (ref: 3062)))
	(FAMIX.Invocation (id: 3063)
		(sender (ref: 35))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Access (id: 3064)
		(accessor (ref: 318))
		(sourceAnchor (ref: 319))
		(variable (ref: 317)))
	(FAMIX.Invocation (id: 3065)
		(receiver (ref: 2360))
		(sender (ref: 2042))
		(signature ''attributes()'')
		(sourceAnchor (ref: 2359)))
	(FAMIX.Access (id: 3066)
		(accessor (ref: 1426))
		(sourceAnchor (ref: 1591))
		(variable (ref: 1590)))
	(FAMIX.Invocation (id: 3067)
		(receiver (ref: 2266))
		(sender (ref: 32))
		(signature ''updateWindow()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 3068)
		(accessor (ref: 99))
		(isWrite true)
		(sourceAnchor (ref: 100))
		(variable (ref: 2146)))
	(FAMIX.Access (id: 3069)
		(accessor (ref: 2808))
		(sourceAnchor (ref: 2809))
		(variable (ref: 3070)))
	(FAMIX.Invocation (id: 3071)
		(receiver (ref: 2004))
		(sender (ref: 374))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 375)))
	(FAMIX.Access (id: 3072)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 1041)))
	(FAMIX.Parameter (id: 3073)
		(name ''element'')
		(parentBehaviouralEntity (ref: 1388)))
	(FAMIX.Reference (id: 3074)
		(source (ref: 32))
		(sourceAnchor (ref: 33))
		(target (ref: 2700)))
	(FAMIX.LocalVariable (id: 1281)
		(name ''v'')
		(parentBehaviouralEntity (ref: 498)))
	(FAMIX.Invocation (id: 3075)
		(receiver (ref: 2008))
		(sender (ref: 707))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 708)))
	(FAMIX.Parameter (id: 1694)
		(name ''toGlobal'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Access (id: 3076)
		(accessor (ref: 1417))
		(sourceAnchor (ref: 1418))
		(variable (ref: 3077)))
	(FAMIX.Parameter (id: 3078)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 1397)))
	(FAMIX.Access (id: 3079)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 2051)))
	(FAMIX.Access (id: 3080)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 3081)
		(accessor (ref: 719))
		(sourceAnchor (ref: 720))
		(variable (ref: 3082)))
	(FAMIX.Comment (id: 3083)
		(container (ref: 2837))
		(content ''"return a relative origin (position of myself from my parent)"''))
	(FAMIX.Parameter (id: 1234)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 1087)))
	(FAMIX.Reference (id: 3084)
		(source (ref: 696))
		(sourceAnchor (ref: 697))
		(target (ref: 633)))
	(FAMIX.Method (id: 1676)
		(name ''source:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''source:'')
		(sourceAnchor (ref: 1677)))
	(FAMIX.Method (id: 388)
		(name ''defaultNodeShapeInstance'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''defaultNodeShapeInstance'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Invocation (id: 3085)
		(receiver (ref: 3086))
		(sender (ref: 2697))
		(signature ''moX:(Object)'')
		(sourceAnchor (ref: 2698)))
	(FAMIX.Access (id: 3087)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 3088)))
	(FAMIX.Access (id: 3089)
		(accessor (ref: 2951))
		(sourceAnchor (ref: 2952))
		(variable (ref: 3090)))
	(FAMIX.Invocation (id: 3091)
		(receiver (ref: 2872))
		(sender (ref: 560))
		(signature ''resetFormCacheResursively()'')
		(sourceAnchor (ref: 561)))
	(FAMIX.Invocation (id: 3092)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3093)
		(accessor (ref: 388))
		(sourceAnchor (ref: 389))
		(variable (ref: 387)))
	(FAMIX.Access (id: 3094)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1212)))
	(FAMIX.Access (id: 3095)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 12)))
	(FAMIX.Method (id: 377)
		(name ''updateWindow'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''updateWindow'')
		(sourceAnchor (ref: 378)))
	(FAMIX.Parameter (id: 1286)
		(name ''aValue'')
		(parentBehaviouralEntity (ref: 1140)))
	(FAMIX.Invocation (id: 3096)
		(receiver (ref: 1277))
		(sender (ref: 145))
		(signature ''new()'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Parameter (id: 2399)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 149)))
	(FAMIX.Access (id: 3097)
		(accessor (ref: 525))
		(sourceAnchor (ref: 526))
		(variable (ref: 2189)))
	(FAMIX.Access (id: 3098)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Method (id: 368)
		(name ''classReferences'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 1374))
		(signature ''classReferences'')
		(sourceAnchor (ref: 369)))
	(FAMIX.Access (id: 3099)
		(accessor (ref: 108))
		(sourceAnchor (ref: 109))
		(variable (ref: 1255)))
	(FAMIX.Invocation (id: 3100)
		(receiver (ref: 1467))
		(sender (ref: 195))
		(signature ''allSubclasses()'')
		(sourceAnchor (ref: 197)))
	(FAMIX.Access (id: 3101)
		(accessor (ref: 761))
		(sourceAnchor (ref: 762))
		(variable (ref: 3102)))
	(FAMIX.Invocation (id: 3103)
		(receiver (ref: 2559))
		(sender (ref: 80))
		(signature ''collect:(Object)'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Parameter (id: 2451)
		(name ''anAnnouncement'')
		(parentBehaviouralEntity (ref: 1519)))
	(FAMIX.Access (id: 3104)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 790)))
	(FAMIX.Invocation (id: 3105)
		(sender (ref: 938))
		(signature ''new()'')
		(sourceAnchor (ref: 939)))
	(FAMIX.LocalVariable (id: 2581)
		(name ''aSortBlock'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Access (id: 3106)
		(accessor (ref: 1002))
		(sourceAnchor (ref: 1003))
		(variable (ref: 2365)))
	(FAMIX.Invocation (id: 3107)
		(sender (ref: 388))
		(signature ''new()'')
		(sourceAnchor (ref: 389)))
	(FAMIX.LocalVariable (id: 2008)
		(name ''coll'')
		(parentBehaviouralEntity (ref: 707)))
	(FAMIX.Invocation (id: 3108)
		(receiver (ref: 3109))
		(sender (ref: 1207))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1208)))
	(FAMIX.Comment (id: 3110)
		(container (ref: 91))
		(content ''"purple"''))
	(FAMIX.Invocation (id: 3111)
		(receiver (ref: 179))
		(sender (ref: 177))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 178)))
	(FAMIX.Access (id: 3112)
		(accessor (ref: 2256))
		(sourceAnchor (ref: 2257))
		(variable (ref: 2686)))
	(FAMIX.Class (id: 593)
		(name ''MOViewRenderer'')
		(fanIn 0)
		(fanOut 1)
		(hierarchyNestingLevel 1)
		(numberOfAttributes 7)
		(numberOfComments 42)
		(numberOfLinesOfCode 489)
		(numberOfMethods 95)
		(numberOfParents 1)
		(numberOfStatements -95)
		(totalNumberOfChildren 0)
		(weightedMethodCount -95))
	(FAMIX.Parameter (id: 3113)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 1087)))
	(FAMIX.Parameter (id: 839)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 837)))
	(FAMIX.Invocation (id: 3114)
		(receiver (ref: 2439))
		(sender (ref: 248))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 3115)
		(accessor (ref: 938))
		(sourceAnchor (ref: 939))
		(variable (ref: 940)))
	(FAMIX.Invocation (id: 3116)
		(sender (ref: 1555))
		(signature ''*(Object)'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Access (id: 3117)
		(accessor (ref: 304))
		(sourceAnchor (ref: 305))
		(variable (ref: 2302)))
	(FAMIX.Access (id: 3118)
		(accessor (ref: 809))
		(sourceAnchor (ref: 810))
		(variable (ref: 808)))
	(FAMIX.Access (id: 3119)
		(accessor (ref: 44))
		(isWrite true)
		(sourceAnchor (ref: 46))
		(variable (ref: 73)))
	(FAMIX.Access (id: 3120)
		(accessor (ref: 1823))
		(sourceAnchor (ref: 2826))
		(variable (ref: 1822)))
	(FAMIX.Invocation (id: 3121)
		(receiver (ref: 2077))
		(sender (ref: 493))
		(signature ''ifEmpty:(Object)'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Invocation (id: 3122)
		(receiver (ref: 1862))
		(sender (ref: 1860))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 1861)))
	(FAMIX.Invocation (id: 3123)
		(sender (ref: 1101))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Access (id: 3124)
		(accessor (ref: 1585))
		(sourceAnchor (ref: 1586))
		(variable (ref: 1978)))
	(FAMIX.Access (id: 3125)
		(accessor (ref: 1218))
		(sourceAnchor (ref: 1219))
		(variable (ref: 3126)))
	(FAMIX.Access (id: 3127)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 3128)))
	(FAMIX.Invocation (id: 3129)
		(sender (ref: 478))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Method (id: 182)
		(name ''getBoundedTranslationStep:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 13)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''getBoundedTranslationStep:'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Access (id: 3130)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 922)))
	(FAMIX.Invocation (id: 3131)
		(receiver (ref: 1098))
		(sender (ref: 1096))
		(signature ''origin()'')
		(sourceAnchor (ref: 1097)))
	(FAMIX.Access (id: 3132)
		(accessor (ref: 798))
		(sourceAnchor (ref: 799))
		(variable (ref: 2767)))
	(FAMIX.Method (id: 3133)
		(name ''resetCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''resetCache'')
		(sourceAnchor (ref: 3134)))
	(FAMIX.Invocation (id: 3135)
		(sender (ref: 327))
		(signature ''isEmpty()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 3136)
		(accessor (ref: 1147))
		(sourceAnchor (ref: 1148))
		(variable (ref: 1146)))
	(FAMIX.Access (id: 3137)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 1329)))
	(FAMIX.Access (id: 3138)
		(accessor (ref: 443))
		(sourceAnchor (ref: 444))
		(variable (ref: 3139)))
	(FAMIX.Class (id: 93)
		(name ''Color class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Method (id: 294)
		(name ''edges:from:to:using:fromGlobal:toGlobal:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 14)
		(numberOfParameters 6)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:to:using:fromGlobal:toGlobal:'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Access (id: 3140)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1643)))
	(FAMIX.Invocation (id: 3141)
		(sender (ref: 69))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 3142)
		(receiver (ref: 779))
		(sender (ref: 777))
		(signature ''symbol()'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Access (id: 3143)
		(accessor (ref: 1087))
		(sourceAnchor (ref: 1088))
		(variable (ref: 3144)))
	(FAMIX.Access (id: 3145)
		(accessor (ref: 801))
		(sourceAnchor (ref: 802))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 3146)
		(receiver (ref: 1136))
		(sender (ref: 13))
		(signature ''key()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 3147)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3148)
		(receiver (ref: 1590))
		(sender (ref: 1426))
		(signature ''root()'')
		(sourceAnchor (ref: 1591)))
	(FAMIX.Access (id: 3149)
		(accessor (ref: 959))
		(sourceAnchor (ref: 960))
		(variable (ref: 958)))
	(FAMIX.Parameter (id: 3150)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 912)))
	(FAMIX.Access (id: 3151)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1016)))
	(FAMIX.Invocation (id: 3152)
		(receiver (ref: 41))
		(sender (ref: 602))
		(signature ''new()'')
		(sourceAnchor (ref: 603)))
	(FAMIX.Access (id: 3153)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 246)))
	(FAMIX.Parameter (id: 521)
		(name ''systemWindow'')
		(parentBehaviouralEntity (ref: 128)))
	(FAMIX.Access (id: 3154)
		(accessor (ref: 819))
		(sourceAnchor (ref: 2290))
		(variable (ref: 1058)))
	(FAMIX.Access (id: 3155)
		(accessor (ref: 294))
		(isWrite true)
		(sourceAnchor (ref: 295))
		(variable (ref: 1870)))
	(FAMIX.Invocation (id: 3156)
		(receiver (ref: 1935))
		(sender (ref: 756))
		(signature ''hasSelectedNodes()'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Access (id: 3157)
		(accessor (ref: 2612))
		(sourceAnchor (ref: 2613))
		(variable (ref: 1957)))
	(FAMIX.Method (id: 943)
		(name ''verticalLineLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''verticalLineLayout'')
		(sourceAnchor (ref: 944)))
	(FAMIX.Access (id: 3158)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 2395)))
	(FAMIX.Invocation (id: 3159)
		(receiver (ref: 1157))
		(sender (ref: 1155))
		(signature ''edgeShape()'')
		(sourceAnchor (ref: 1156)))
	(FAMIX.Reference (id: 3160)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 3161)
		(sender (ref: 76))
		(signature ''yourself()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Method (id: 1019)
		(name ''isVisibleInBounds:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''isVisibleInBounds:'')
		(sourceAnchor (ref: 1020)))
	(FAMIX.LocalVariable (id: 3162)
		(name ''newLocalBounds'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Comment (id: 3163)
		(container (ref: 283))
		(content ''"if I have more than 1 argument, then the valueOrArray is a collection"''))
	(FAMIX.Access (id: 3164)
		(accessor (ref: 1901))
		(sourceAnchor (ref: 2321))
		(variable (ref: 1900)))
	(FAMIX.Access (id: 3165)
		(accessor (ref: 1831))
		(sourceAnchor (ref: 1832))
		(variable (ref: 3166)))
	(FAMIX.LocalVariable (id: 3167)
		(name ''target'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Access (id: 3168)
		(accessor (ref: 2612))
		(sourceAnchor (ref: 2613))
		(variable (ref: 1957)))
	(FAMIX.Invocation (id: 3169)
		(receiver (ref: 1402))
		(sender (ref: 516))
		(signature ''key()'')
		(sourceAnchor (ref: 517)))
	(FAMIX.LocalVariable (id: 1557)
		(name ''deltaY'')
		(parentBehaviouralEntity (ref: 1555)))
	(FAMIX.Invocation (id: 3170)
		(receiver (ref: 977))
		(sender (ref: 929))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Method (id: 565)
		(name ''edges:to:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:to:'')
		(sourceAnchor (ref: 566)))
	(FAMIX.Access (id: 3171)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 209)))
	(FAMIX.Method (id: 48)
		(name ''edges:fromAll:to:using:fromGlobal:toGlobal:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 22)
		(numberOfParameters 6)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:fromAll:to:using:fromGlobal:toGlobal:'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Invocation (id: 3172)
		(sender (ref: 294))
		(signature ''resetElementsToDisplayCacheRecursively()'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Access (id: 3173)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Access (id: 3174)
		(accessor (ref: 861))
		(sourceAnchor (ref: 862))
		(variable (ref: 3175)))
	(FAMIX.Access (id: 3176)
		(accessor (ref: 360))
		(sourceAnchor (ref: 361))
		(variable (ref: 3177)))
	(FAMIX.Access (id: 3178)
		(accessor (ref: 943))
		(sourceAnchor (ref: 944))
		(variable (ref: 3179)))
	(FAMIX.Access (id: 3180)
		(accessor (ref: 154))
		(sourceAnchor (ref: 155))
		(variable (ref: 1382)))
	(FAMIX.Class (id: 1091)
		(name ''MOElementSelection class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3181)
		(accessor (ref: 1050))
		(sourceAnchor (ref: 1051))
		(variable (ref: 1119)))
	(FAMIX.Access (id: 3182)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 3183)))
	(FAMIX.Parameter (id: 2150)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 668)))
	(FAMIX.Invocation (id: 3184)
		(receiver (ref: 2024))
		(sender (ref: 592))
		(signature ''new()'')
		(sourceAnchor (ref: 594)))
	(FAMIX.Access (id: 3185)
		(accessor (ref: 308))
		(isWrite true)
		(sourceAnchor (ref: 618))
		(variable (ref: 1890)))
	(FAMIX.Access (id: 3186)
		(accessor (ref: 3187))
		(sourceAnchor (ref: 3188))
		(variable (ref: 3189)))
	(FAMIX.Comment (id: 3190)
		(container (ref: 689))
		(content ''"aFromBlock should return a collection, edges will be drawn from this collection to the element returned by aToBlock"''))
	(FAMIX.Parameter (id: 3126)
		(name ''elementShapeProperty'')
		(parentBehaviouralEntity (ref: 1218)))
	(FAMIX.Access (id: 3191)
		(accessor (ref: 525))
		(sourceAnchor (ref: 526))
		(variable (ref: 2325)))
	(FAMIX.Parameter (id: 3082)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 719)))
	(FAMIX.Parameter (id: 2648)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Invocation (id: 3192)
		(receiver (ref: 2630))
		(sender (ref: 819))
		(signature ''toPositions()'')
		(sourceAnchor (ref: 2290)))
	(FAMIX.Method (id: 1475)
		(name ''doExecute:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''doExecute:'')
		(sourceAnchor (ref: 3193)))
	(FAMIX.Access (id: 3194)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1281)))
	(FAMIX.Access (id: 3195)
		(accessor (ref: 493))
		(sourceAnchor (ref: 494))
		(variable (ref: 3196)))
	(FAMIX.Access (id: 3197)
		(accessor (ref: 611))
		(sourceAnchor (ref: 612))
		(variable (ref: 2621)))
	(FAMIX.Access (id: 3198)
		(accessor (ref: 1645))
		(sourceAnchor (ref: 2483))
		(variable (ref: 1644)))
	(FAMIX.Method (id: 672)
		(name ''allNodesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''allNodesDo:'')
		(sourceAnchor (ref: 673)))
	(FAMIX.Invocation (id: 3199)
		(receiver (ref: 507))
		(sender (ref: 505))
		(signature ''elementsToDisplay()'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Access (id: 3200)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 239)))
	(FAMIX.LocalVariable (id: 1439)
		(name ''state'')
		(parentBehaviouralEntity (ref: 149)))
	(FAMIX.Method (id: 1949)
		(name ''allEdgesConnectedToMe'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allEdgesConnectedToMe'')
		(sourceAnchor (ref: 1950)))
	(FAMIX.LocalVariable (id: 3201)
		(name ''x'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Invocation (id: 3202)
		(receiver (ref: 3203))
		(sender (ref: 894))
		(signature ''first()'')
		(sourceAnchor (ref: 895)))
	(FAMIX.Invocation (id: 3204)
		(receiver (ref: 3205))
		(sender (ref: 777))
		(signature ''class()'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Method (id: 2231)
		(name ''corner:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''corner:'')
		(sourceAnchor (ref: 3206)))
	(FAMIX.Class (id: 3207)
		(name ''BlockClosure'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 1)
		(numberOfLinesOfCode 13)
		(numberOfMethods 2)
		(numberOfParents 0)
		(numberOfStatements -2)
		(totalNumberOfChildren 0)
		(weightedMethodCount -2))
	(FAMIX.Invocation (id: 3208)
		(receiver (ref: 56))
		(sender (ref: 48))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Access (id: 3209)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 591)))
	(FAMIX.Method (id: 1043)
		(name ''bounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 13)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''bounds'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Method (id: 1441)
		(name ''cacheToPoint:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''cacheToPoint:'')
		(sourceAnchor (ref: 1442)))
	(FAMIX.Invocation (id: 3210)
		(receiver (ref: 1047))
		(sender (ref: 224))
		(signature ''with:during:(Object,Object)'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Method (id: 1826)
		(name ''printOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''printOn:'')
		(sourceAnchor (ref: 1827)))
	(FAMIX.Invocation (id: 3211)
		(receiver (ref: 1584))
		(sender (ref: 1582))
		(signature ''edgesDo:(Object)'')
		(sourceAnchor (ref: 1583)))
	(FAMIX.Access (id: 3212)
		(accessor (ref: 159))
		(sourceAnchor (ref: 160))
		(variable (ref: 158)))
	(FAMIX.Method (id: 80)
		(name ''nodes:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 16)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodes:using:'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Invocation (id: 3213)
		(receiver (ref: 3214))
		(sender (ref: 644))
		(signature ''root()'')
		(sourceAnchor (ref: 645)))
	(FAMIX.Invocation (id: 3215)
		(sender (ref: 237))
		(signature ''associationsDo:(Object)'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Method (id: 3216)
		(name ''removeAllNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 1)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''removeAllNodes'')
		(sourceAnchor (ref: 3217)))
	(FAMIX.Reference (id: 3218)
		(source (ref: 683))
		(sourceAnchor (ref: 684))
		(target (ref: 2056)))
	(FAMIX.Access (id: 3219)
		(accessor (ref: 342))
		(sourceAnchor (ref: 1895))
		(variable (ref: 3220)))
	(FAMIX.Parameter (id: 3077)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1417)))
	(FAMIX.Invocation (id: 3221)
		(sender (ref: 2272))
		(signature ''copy()'')
		(sourceAnchor (ref: 2273)))
	(FAMIX.Access (id: 3222)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 239)))
	(FAMIX.Invocation (id: 3223)
		(receiver (ref: 3224))
		(sender (ref: 3225))
		(signature ''defaultLineShapeClass()'')
		(sourceAnchor (ref: 3226)))
	(FAMIX.Access (id: 3227)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 3228)))
	(FAMIX.Reference (id: 3229)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 3230)
		(sender (ref: 243))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 244)))
	(FAMIX.Invocation (id: 3231)
		(receiver (ref: 3139))
		(sender (ref: 443))
		(signature ''bounds()'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 3232)
		(accessor (ref: 732))
		(sourceAnchor (ref: 733))
		(variable (ref: 731)))
	(FAMIX.Invocation (id: 3233)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''shape()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 3234)
		(accessor (ref: 1806))
		(sourceAnchor (ref: 1807))
		(variable (ref: 3235)))
	(FAMIX.Comment (id: 3236)
		(container (ref: 549))
		(content ''"Iterates over all the edges of the receiver."''))
	(FAMIX.Access (id: 3237)
		(accessor (ref: 638))
		(isWrite true)
		(sourceAnchor (ref: 639))
		(variable (ref: 3238)))
	(FAMIX.Access (id: 3239)
		(accessor (ref: 990))
		(sourceAnchor (ref: 991))
		(variable (ref: 3240)))
	(FAMIX.Invocation (id: 3241)
		(receiver (ref: 1034))
		(sender (ref: 934))
		(signature ''anyOne()'')
		(sourceAnchor (ref: 935)))
	(FAMIX.Invocation (id: 3242)
		(sender (ref: 221))
		(signature ''<=(Object)'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Comment (id: 3243)
		(container (ref: 248))
		(content ''"	node := self nodeForDomainValue: aValue."''))
	(FAMIX.Parameter (id: 651)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Method (id: 1169)
		(name ''nodeShape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodeShape:'')
		(sourceAnchor (ref: 1170)))
	(FAMIX.Invocation (id: 3244)
		(receiver (ref: 1916))
		(sender (ref: 391))
		(signature ''resetFormCacheUpToTheRoot()'')
		(sourceAnchor (ref: 392)))
	(FAMIX.Invocation (id: 3245)
		(receiver (ref: 1416))
		(sender (ref: 993))
		(signature ''root()'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Comment (id: 3246)
		(container (ref: 1519))
		(content ''"public method"''))
	(FAMIX.Access (id: 3247)
		(accessor (ref: 468))
		(sourceAnchor (ref: 1364))
		(variable (ref: 3248)))
	(FAMIX.Reference (id: 3249)
		(source (ref: 13))
		(sourceAnchor (ref: 14))
		(target (ref: 2056)))
	(FAMIX.Access (id: 3250)
		(accessor (ref: 932))
		(sourceAnchor (ref: 1893))
		(variable (ref: 1993)))
	(FAMIX.LocalVariable (id: 1323)
		(name ''maxWidth'')
		(parentBehaviouralEntity (ref: 35)))
	(FAMIX.Access (id: 3251)
		(accessor (ref: 177))
		(isWrite true)
		(sourceAnchor (ref: 178))
		(variable (ref: 179)))
	(FAMIX.Access (id: 3252)
		(accessor (ref: 423))
		(sourceAnchor (ref: 424))
		(variable (ref: 2811)))
	(FAMIX.Access (id: 3253)
		(accessor (ref: 2697))
		(sourceAnchor (ref: 2698))
		(variable (ref: 168)))
	(FAMIX.Invocation (id: 3254)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''doInitialize:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 3255)
		(receiver (ref: 3128))
		(sender (ref: 777))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Access (id: 3256)
		(accessor (ref: 1519))
		(sourceAnchor (ref: 1520))
		(variable (ref: 768)))
	(FAMIX.Access (id: 3257)
		(accessor (ref: 668))
		(sourceAnchor (ref: 1024))
		(variable (ref: 2115)))
	(FAMIX.Invocation (id: 3258)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 3259)
		(accessor (ref: 1043))
		(isWrite true)
		(sourceAnchor (ref: 1044))
		(variable (ref: 306)))
	(FAMIX.Invocation (id: 3260)
		(receiver (ref: 280))
		(sender (ref: 20))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Method (id: 1338)
		(name ''expandForEvent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''expandForEvent:'')
		(sourceAnchor (ref: 1339)))
	(FAMIX.Comment (id: 3261)
		(container (ref: 1441))
		(content ''"Set the extremity point"''))
	(FAMIX.Class (id: 3262)
		(name ''MORoot class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 3263)
		(receiver (ref: 52))
		(sender (ref: 13))
		(signature ''topLeft()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 2185)
		(name ''clearLookupCacheRecursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''clearLookupCacheRecursively'')
		(sourceAnchor (ref: 2186)))
	(FAMIX.Invocation (id: 3264)
		(sender (ref: 443))
		(signature ''origin()'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Invocation (id: 3265)
		(receiver (ref: 2773))
		(sender (ref: 13))
		(signature ''associationsDo:(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 3266)
		(accessor (ref: 1033))
		(sourceAnchor (ref: 2736))
		(variable (ref: 263)))
	(FAMIX.Access (id: 3267)
		(accessor (ref: 1354))
		(sourceAnchor (ref: 1355))
		(variable (ref: 1534)))
	(FAMIX.Reference (id: 3268)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 3269)
		(accessor (ref: 106))
		(sourceAnchor (ref: 2162))
		(variable (ref: 3270)))
	(FAMIX.Invocation (id: 3271)
		(receiver (ref: 2621))
		(sender (ref: 611))
		(signature ''attributes()'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Invocation (id: 3272)
		(receiver (ref: 56))
		(sender (ref: 48))
		(signature ''isNil()'')
		(sourceAnchor (ref: 49)))
	(FAMIX.LocalVariable (id: 764)
		(name ''coll'')
		(parentBehaviouralEntity (ref: 162)))
	(FAMIX.Class (id: 531)
		(name ''MOMinimumGridLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 3273)
		(receiver (ref: 3274))
		(sender (ref: 770))
		(signature ''new()'')
		(sourceAnchor (ref: 771)))
	(FAMIX.Parameter (id: 383)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 381)))
	(FAMIX.Invocation (id: 3275)
		(sender (ref: 1272))
		(signature ''area()'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Invocation (id: 3276)
		(receiver (ref: 346))
		(sender (ref: 344))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 345)))
	(FAMIX.Method (id: 2688)
		(name ''hasCachedForm'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''hasCachedForm'')
		(sourceAnchor (ref: 2689)))
	(FAMIX.Access (id: 3277)
		(accessor (ref: 2731))
		(sourceAnchor (ref: 2732))
		(variable (ref: 1880)))
	(FAMIX.Method (id: 2209)
		(name ''edges:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''edges:'')
		(sourceAnchor (ref: 2210)))
	(FAMIX.LocalVariable (id: 37)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 35)))
	(FAMIX.Method (id: 680)
		(name ''isFormsShape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isFormsShape'')
		(sourceAnchor (ref: 3278)))
	(FAMIX.Access (id: 3279)
		(accessor (ref: 1761))
		(sourceAnchor (ref: 1762))
		(variable (ref: 2890)))
	(FAMIX.Invocation (id: 3280)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 3281)
		(accessor (ref: 615))
		(sourceAnchor (ref: 616))
		(variable (ref: 614)))
	(FAMIX.Access (id: 3282)
		(accessor (ref: 1124))
		(sourceAnchor (ref: 1125))
		(variable (ref: 2047)))
	(FAMIX.Invocation (id: 3283)
		(receiver (ref: 729))
		(sender (ref: 294))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Parameter (id: 2262)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 1338)))
	(FAMIX.LocalVariable (id: 1865)
		(name ''node'')
		(parentBehaviouralEntity (ref: 498)))
	(FAMIX.Invocation (id: 3284)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''orange()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3285)
		(accessor (ref: 16))
		(isWrite true)
		(sourceAnchor (ref: 17))
		(variable (ref: 1432)))
	(FAMIX.Access (id: 3286)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Invocation (id: 3287)
		(receiver (ref: 3288))
		(sender (ref: 1709))
		(signature ''computeExtentFor:(Object)'')
		(sourceAnchor (ref: 1710)))
	(FAMIX.Invocation (id: 3289)
		(receiver (ref: 2262))
		(sender (ref: 1338))
		(signature ''position()'')
		(sourceAnchor (ref: 1339)))
	(FAMIX.Access (id: 3290)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 130)))
	(FAMIX.Invocation (id: 3291)
		(sender (ref: 498))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Invocation (id: 3292)
		(receiver (ref: 3293))
		(sender (ref: 929))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Access (id: 3294)
		(accessor (ref: 443))
		(sourceAnchor (ref: 444))
		(variable (ref: 2573)))
	(FAMIX.Parameter (id: 3295)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 894)))
	(FAMIX.LocalVariable (id: 52)
		(name ''oldReferencialBounds'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Invocation (id: 3296)
		(receiver (ref: 2663))
		(sender (ref: 2661))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 2662)))
	(FAMIX.Invocation (id: 3297)
		(receiver (ref: 512))
		(sender (ref: 510))
		(signature ''fromPositions()'')
		(sourceAnchor (ref: 511)))
	(FAMIX.Access (id: 3298)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 875)))
	(FAMIX.Invocation (id: 3299)
		(receiver (ref: 418))
		(sender (ref: 71))
		(signature ''defaultFromPositions()'')
		(sourceAnchor (ref: 72)))
	(FAMIX.Invocation (id: 3300)
		(receiver (ref: 357))
		(sender (ref: 304))
		(signature ''assert:(Object)'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Invocation (id: 3301)
		(receiver (ref: 6))
		(sender (ref: 4))
		(signature ''root()'')
		(sourceAnchor (ref: 5)))
	(FAMIX.Invocation (id: 3302)
		(receiver (ref: 2562))
		(sender (ref: 204))
		(signature ''model()'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Access (id: 3303)
		(accessor (ref: 271))
		(sourceAnchor (ref: 272))
		(variable (ref: 1432)))
	(FAMIX.Invocation (id: 3304)
		(receiver (ref: 26))
		(sender (ref: 24))
		(signature ''shape()'')
		(sourceAnchor (ref: 25)))
	(FAMIX.Invocation (id: 3305)
		(receiver (ref: 3306))
		(sender (ref: 1996))
		(signature ''model()'')
		(sourceAnchor (ref: 1997)))
	(FAMIX.Access (id: 3307)
		(accessor (ref: 102))
		(sourceAnchor (ref: 103))
		(variable (ref: 1261)))
	(FAMIX.Invocation (id: 3308)
		(receiver (ref: 512))
		(sender (ref: 426))
		(signature ''updateBounds:for:(Object,Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Invocation (id: 3309)
		(receiver (ref: 779))
		(sender (ref: 777))
		(signature ''shape()'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Parameter (id: 3310)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1676)))
	(FAMIX.Invocation (id: 3311)
		(receiver (ref: 1410))
		(sender (ref: 912))
		(signature ''nodeShape()'')
		(sourceAnchor (ref: 913)))
	(FAMIX.Access (id: 3312)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 3238)))
	(FAMIX.Access (id: 3313)
		(accessor (ref: 2885))
		(sourceAnchor (ref: 2886))
		(variable (ref: 850)))
	(FAMIX.Access (id: 3314)
		(accessor (ref: 801))
		(sourceAnchor (ref: 802))
		(variable (ref: 908)))
	(FAMIX.Access (id: 3315)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 3293)))
	(FAMIX.Access (id: 3316)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1047)))
	(FAMIX.Invocation (id: 3317)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3318)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 3319)))
	(FAMIX.Invocation (id: 3320)
		(sender (ref: 2367))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 2368)))
	(FAMIX.Access (id: 3321)
		(accessor (ref: 1357))
		(sourceAnchor (ref: 1358))
		(variable (ref: 2753)))
	(FAMIX.Access (id: 3322)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 2773)))
	(FAMIX.Invocation (id: 3323)
		(sender (ref: 426))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Invocation (id: 3324)
		(sender (ref: 260))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 3325)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Access (id: 3326)
		(accessor (ref: 583))
		(sourceAnchor (ref: 584))
		(variable (ref: 3327)))
	(FAMIX.Method (id: 3328)
		(name ''isNode'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''isNode'')
		(sourceAnchor (ref: 3329)))
	(FAMIX.Reference (id: 3330)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 3331)
		(receiver (ref: 3332))
		(sender (ref: 1785))
		(signature ''resetFormCacheSimply()'')
		(sourceAnchor (ref: 1786)))
	(FAMIX.Class (id: 997)
		(name ''IdentityDictionary class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3333)
		(accessor (ref: 1831))
		(sourceAnchor (ref: 1832))
		(variable (ref: 179)))
	(FAMIX.Invocation (id: 3334)
		(receiver (ref: 1045))
		(sender (ref: 1043))
		(signature ''shapeBoundsAt:ifPresent:(Object,Object)'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Parameter (id: 2127)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 858)))
	(FAMIX.LocalVariable (id: 2635)
		(name ''target'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Method (id: 1901)
		(name ''getTranslationStep:bounded:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''getTranslationStep:bounded:'')
		(sourceAnchor (ref: 2321)))
	(FAMIX.Access (id: 3335)
		(accessor (ref: 465))
		(sourceAnchor (ref: 466))
		(variable (ref: 787)))
	(FAMIX.Access (id: 3336)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 657)))
	(FAMIX.Comment (id: 3337)
		(container (ref: 858))
		(content ''"both aFromBlock and aToBlock must return a collection"''))
	(FAMIX.Access (id: 3338)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 852)))
	(FAMIX.Method (id: 1921)
		(name ''cacheToPoint'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''cacheToPoint'')
		(sourceAnchor (ref: 1922)))
	(FAMIX.Invocation (id: 3339)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''yellow()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3340)
		(receiver (ref: 3341))
		(sender (ref: 1421))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 1422)))
	(FAMIX.Access (id: 3342)
		(accessor (ref: 173))
		(sourceAnchor (ref: 174))
		(variable (ref: 435)))
	(FAMIX.Invocation (id: 3343)
		(receiver (ref: 3344))
		(sender (ref: 1761))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 1762)))
	(FAMIX.Comment (id: 3345)
		(container (ref: 1218))
		(content ''"aSymbol should start with #cache, else it will not be properly reseted"''))
	(FAMIX.Invocation (id: 3346)
		(receiver (ref: 3347))
		(sender (ref: 900))
		(signature ''new()'')
		(sourceAnchor (ref: 901)))
	(FAMIX.Invocation (id: 3348)
		(receiver (ref: 1467))
		(sender (ref: 195))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 197)))
	(FAMIX.Access (id: 3349)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Access (id: 3350)
		(accessor (ref: 2808))
		(isWrite true)
		(sourceAnchor (ref: 2809))
		(variable (ref: 3005)))
	(FAMIX.Invocation (id: 3351)
		(receiver (ref: 3038))
		(sender (ref: 565))
		(signature ''edges:from:to:(Object,Object,Object)'')
		(sourceAnchor (ref: 566)))
	(FAMIX.Class (id: 3352)
		(name ''BlockContext'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 1)
		(numberOfLinesOfCode 11)
		(numberOfMethods 1)
		(numberOfParents 0)
		(numberOfStatements -1)
		(totalNumberOfChildren 0)
		(weightedMethodCount -1))
	(FAMIX.Invocation (id: 3353)
		(sender (ref: 381))
		(signature ''announcer()'')
		(sourceAnchor (ref: 382)))
	(FAMIX.Parameter (id: 2322)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1901)))
	(FAMIX.Access (id: 3354)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Invocation (id: 3355)
		(sender (ref: 237))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 238)))
	(FAMIX.LocalVariable (id: 3088)
		(name ''anEntity'')
		(parentBehaviouralEntity (ref: 80)))
	(FAMIX.Parameter (id: 779)
		(name ''anotherMOElementShapeProperty'')
		(parentBehaviouralEntity (ref: 777)))
	(FAMIX.Method (id: 256)
		(name ''translatedBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1427))
		(signature ''translatedBy:'')
		(sourceAnchor (ref: 257)))
	(FAMIX.Reference (id: 3356)
		(source (ref: 84))
		(sourceAnchor (ref: 85))
		(target (ref: 2520)))
	(FAMIX.Invocation (id: 3357)
		(receiver (ref: 558))
		(sender (ref: 556))
		(signature ''isLineShape()'')
		(sourceAnchor (ref: 557)))
	(FAMIX.Parameter (id: 657)
		(name ''source'')
		(parentBehaviouralEntity (ref: 658)))
	(FAMIX.Access (id: 3358)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1186)))
	(FAMIX.Method (id: 777)
		(name ''='')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''='')
		(sourceAnchor (ref: 778)))
	(FAMIX.Comment (id: 3359)
		(container (ref: 377))
		(content ''"Refresh the content of the window. This happens when some shape change for example"''))
	(FAMIX.Access (id: 3360)
		(accessor (ref: 229))
		(isWrite true)
		(sourceAnchor (ref: 230))
		(variable (ref: 168)))
	(FAMIX.Parameter (id: 3361)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 1298)))
	(FAMIX.Access (id: 3362)
		(accessor (ref: 1207))
		(sourceAnchor (ref: 1208))
		(variable (ref: 3363)))
	(FAMIX.Comment (id: 3364)
		(container (ref: 286))
		(content ''"Initialization"''))
	(FAMIX.Invocation (id: 3365)
		(sender (ref: 2272))
		(signature ''center()'')
		(sourceAnchor (ref: 2273)))
	(FAMIX.Method (id: 988)
		(name ''attributeAt:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''attributeAt:'')
		(sourceAnchor (ref: 989)))
	(FAMIX.Access (id: 3366)
		(accessor (ref: 145))
		(sourceAnchor (ref: 146))
		(variable (ref: 845)))
	(FAMIX.Invocation (id: 3367)
		(receiver (ref: 2115))
		(sender (ref: 668))
		(signature ''edges:from:toAll:using:(Object,Object,Object,Object)'')
		(sourceAnchor (ref: 1024)))
	(FAMIX.Access (id: 3368)
		(accessor (ref: 1215))
		(sourceAnchor (ref: 1216))
		(variable (ref: 1214)))
	(FAMIX.Invocation (id: 3369)
		(receiver (ref: 181))
		(sender (ref: 327))
		(signature ''isRoot()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 3370)
		(sender (ref: 312))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 313)))
	(FAMIX.Access (id: 3371)
		(accessor (ref: 1007))
		(sourceAnchor (ref: 1008))
		(variable (ref: 1006)))
	(FAMIX.Invocation (id: 3372)
		(sender (ref: 124))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Access (id: 3373)
		(accessor (ref: 1019))
		(sourceAnchor (ref: 1020))
		(variable (ref: 1018)))
	(FAMIX.Access (id: 3374)
		(accessor (ref: 537))
		(isWrite true)
		(sourceAnchor (ref: 538))
		(variable (ref: 104)))
	(FAMIX.Invocation (id: 3375)
		(receiver (ref: 812))
		(sender (ref: 243))
		(signature ''copy()'')
		(sourceAnchor (ref: 244)))
	(FAMIX.Invocation (id: 3376)
		(receiver (ref: 1497))
		(sender (ref: 1055))
		(signature ''root()'')
		(sourceAnchor (ref: 1496)))
	(FAMIX.Method (id: 801)
		(name ''updateOwner'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 9)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''updateOwner'')
		(sourceAnchor (ref: 802)))
	(FAMIX.Invocation (id: 3377)
		(receiver (ref: 1078))
		(sender (ref: 1076))
		(signature ''nodeWith:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1077)))
	(FAMIX.Invocation (id: 3378)
		(sender (ref: 938))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Access (id: 3379)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2439)))
	(FAMIX.Access (id: 3380)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1935)))
	(FAMIX.Access (id: 3381)
		(accessor (ref: 20))
		(isWrite true)
		(sourceAnchor (ref: 21))
		(variable (ref: 2581)))
	(FAMIX.Parameter (id: 3382)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 332)))
	(FAMIX.Invocation (id: 3383)
		(receiver (ref: 475))
		(sender (ref: 473))
		(signature ''cache()'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Invocation (id: 3384)
		(sender (ref: 1345))
		(signature ''userDefinedEdges:(Object)'')
		(sourceAnchor (ref: 1346)))
	(FAMIX.Method (id: 1397)
		(name ''displayCacheOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''displayCacheOn:'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Invocation (id: 3385)
		(sender (ref: 260))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 3386)
		(accessor (ref: 48))
		(isWrite true)
		(sourceAnchor (ref: 49))
		(variable (ref: 600)))
	(FAMIX.Access (id: 3387)
		(accessor (ref: 1354))
		(sourceAnchor (ref: 1355))
		(variable (ref: 1760)))
	(FAMIX.Method (id: 2277)
		(name ''root'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''root'')
		(sourceAnchor (ref: 2278)))
	(FAMIX.Class (id: 1064)
		(name ''ConcreteShapeVisitor class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3388)
		(accessor (ref: 304))
		(isWrite true)
		(sourceAnchor (ref: 305))
		(variable (ref: 104)))
	(FAMIX.Invocation (id: 3389)
		(receiver (ref: 875))
		(sender (ref: 95))
		(signature ''root()'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 3390)
		(accessor (ref: 497))
		(sourceAnchor (ref: 2491))
		(variable (ref: 2831)))
	(FAMIX.Access (id: 3391)
		(accessor (ref: 1777))
		(sourceAnchor (ref: 1778))
		(variable (ref: 2419)))
	(FAMIX.LocalVariable (id: 428)
		(name ''figure'')
		(parentBehaviouralEntity (ref: 35)))
	(FAMIX.Invocation (id: 3392)
		(receiver (ref: 142))
		(sender (ref: 20))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Comment (id: 3393)
		(container (ref: 801))
		(content ''"This method is called after I have been cached into a bitmap.
	  I therefore have to tell to my owner to remove myself from the element to display since the bitmap will be displayed"''))
	(FAMIX.Reference (id: 3394)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 3395)
		(accessor (ref: 562))
		(sourceAnchor (ref: 563))
		(variable (ref: 1060)))
	(FAMIX.Invocation (id: 3396)
		(receiver (ref: 1705))
		(sender (ref: 827))
		(signature ''shape()'')
		(sourceAnchor (ref: 1301)))
	(FAMIX.Parameter (id: 3397)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 658)))
	(FAMIX.Invocation (id: 3398)
		(receiver (ref: 2156))
		(sender (ref: 2034))
		(signature ''edges:from:to:using:fromGlobal:toGlobal:(Object,Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 2155)))
	(FAMIX.Parameter (id: 2000)
		(name ''aStream'')
		(parentBehaviouralEntity (ref: 1826)))
	(FAMIX.Access (id: 3399)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1865)))
	(FAMIX.Class (id: 2624)
		(name ''Boolean class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Method (id: 1033)
		(name ''nodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''nodes'')
		(sourceAnchor (ref: 2736)))
	(FAMIX.Method (id: 1650)
		(name ''nodeForDomainValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''nodeForDomainValue:'')
		(sourceAnchor (ref: 1651)))
	(FAMIX.Class (id: 2627)
		(name ''MOWindowStatusChanged class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3400)
		(accessor (ref: 1349))
		(sourceAnchor (ref: 1350))
		(variable (ref: 3401)))
	(FAMIX.Access (id: 3402)
		(accessor (ref: 1555))
		(sourceAnchor (ref: 1556))
		(variable (ref: 1635)))
	(FAMIX.Invocation (id: 3403)
		(receiver (ref: 2799))
		(sender (ref: 1666))
		(signature ''doExecute:(Object)'')
		(sourceAnchor (ref: 1667)))
	(FAMIX.Invocation (id: 3404)
		(receiver (ref: 3405))
		(sender (ref: 437))
		(signature ''popup:(Object)'')
		(sourceAnchor (ref: 438)))
	(FAMIX.Method (id: 622)
		(name ''attributeAt:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''attributeAt:ifAbsent:'')
		(sourceAnchor (ref: 623)))
	(FAMIX.Invocation (id: 3406)
		(sender (ref: 248))
		(signature ''resetFormCache()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 3407)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Access (id: 3408)
		(accessor (ref: 672))
		(sourceAnchor (ref: 673))
		(variable (ref: 1899)))
	(FAMIX.Access (id: 3409)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 3162)))
	(FAMIX.Invocation (id: 3410)
		(sender (ref: 2042))
		(signature ''at:ifAbsentPut:(Object,Object)'')
		(sourceAnchor (ref: 2359)))
	(FAMIX.Invocation (id: 3411)
		(sender (ref: 498))
		(signature ''element:(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Parameter (id: 296)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Invocation (id: 3412)
		(receiver (ref: 3139))
		(sender (ref: 443))
		(signature ''bounds()'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 3413)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 521)))
	(FAMIX.Access (id: 3414)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1766)))
	(FAMIX.Access (id: 3415)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1016)))
	(FAMIX.Access (id: 3416)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 3417)))
	(FAMIX.Access (id: 3418)
		(accessor (ref: 1315))
		(sourceAnchor (ref: 1316))
		(variable (ref: 3419)))
	(FAMIX.Class (id: 2024)
		(name ''MOAnnouncer class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3420)
		(accessor (ref: 798))
		(sourceAnchor (ref: 799))
		(variable (ref: 797)))
	(FAMIX.Invocation (id: 3421)
		(receiver (ref: 1638))
		(sender (ref: 48))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Parameter (id: 3422)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 1019)))
	(FAMIX.Access (id: 3423)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 246)))
	(FAMIX.Invocation (id: 3424)
		(receiver (ref: 3425))
		(sender (ref: 414))
		(signature ''depth()'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Invocation (id: 3426)
		(receiver (ref: 3427))
		(sender (ref: 1272))
		(signature ''bounds()'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Method (id: 770)
		(name ''shape:key:'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''shape:key:'')
		(sourceAnchor (ref: 771)))
	(FAMIX.Invocation (id: 3428)
		(receiver (ref: 1935))
		(sender (ref: 756))
		(signature ''interaction()'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Access (id: 3429)
		(accessor (ref: 740))
		(sourceAnchor (ref: 741))
		(variable (ref: 181)))
	(FAMIX.LocalVariable (id: 130)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 128)))
	(FAMIX.Parameter (id: 519)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 473)))
	(FAMIX.Invocation (id: 3430)
		(receiver (ref: 1335))
		(sender (ref: 344))
		(signature ''new()'')
		(sourceAnchor (ref: 345)))
	(FAMIX.Access (id: 3431)
		(accessor (ref: 162))
		(sourceAnchor (ref: 163))
		(variable (ref: 764)))
	(FAMIX.Invocation (id: 3432)
		(receiver (ref: 352))
		(sender (ref: 350))
		(signature ''domain()'')
		(sourceAnchor (ref: 351)))
	(FAMIX.Invocation (id: 3433)
		(sender (ref: 1967))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1968)))
	(FAMIX.Access (id: 3434)
		(accessor (ref: 493))
		(sourceAnchor (ref: 494))
		(variable (ref: 3196)))
	(FAMIX.Invocation (id: 3435)
		(sender (ref: 443))
		(signature ''copy:(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Method (id: 154)
		(name ''node:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''node:using:'')
		(sourceAnchor (ref: 155)))
	(FAMIX.Invocation (id: 3436)
		(receiver (ref: 2851))
		(sender (ref: 111))
		(signature ''initialize()'')
		(sourceAnchor (ref: 112)))
	(FAMIX.Invocation (id: 3437)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Reference (id: 3438)
		(source (ref: 1263))
		(sourceAnchor (ref: 1264))
		(target (ref: 2205)))
	(FAMIX.Method (id: 120)
		(name ''shapeBounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shapeBounds'')
		(sourceAnchor (ref: 121)))
	(FAMIX.Invocation (id: 3439)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 3440)
		(sender (ref: 1101))
		(signature ''nodeWith:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Access (id: 3441)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 1661)))
	(FAMIX.Invocation (id: 3442)
		(receiver (ref: 317))
		(sender (ref: 318))
		(signature ''scaleBy:(Object)'')
		(sourceAnchor (ref: 319)))
	(FAMIX.Invocation (id: 3443)
		(receiver (ref: 41))
		(sender (ref: 39))
		(signature ''new()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 3444)
		(receiver (ref: 496))
		(sender (ref: 497))
		(signature ''shapeBoundsAt:ifPresent:(Object,Object)'')
		(sourceAnchor (ref: 2491)))
	(FAMIX.Invocation (id: 3445)
		(sender (ref: 683))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 684)))
	(FAMIX.Invocation (id: 3446)
		(sender (ref: 182))
		(signature ''not()'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Method (id: 2892)
		(name ''moValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 2460))
		(signature ''moValue:'')
		(sourceAnchor (ref: 3447)))
	(FAMIX.Invocation (id: 3448)
		(receiver (ref: 1818))
		(sender (ref: 189))
		(signature ''edgesDo:(Object)'')
		(sourceAnchor (ref: 336)))
	(FAMIX.Invocation (id: 3449)
		(receiver (ref: 2911))
		(sender (ref: 35))
		(signature ''updateBounds()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Access (id: 3450)
		(accessor (ref: 465))
		(sourceAnchor (ref: 466))
		(variable (ref: 2644)))
	(FAMIX.Invocation (id: 3451)
		(receiver (ref: 3452))
		(sender (ref: 99))
		(signature ''nodes()'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Access (id: 3453)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 653)))
	(FAMIX.Access (id: 3454)
		(accessor (ref: 1645))
		(sourceAnchor (ref: 2483))
		(variable (ref: 2548)))
	(FAMIX.Parameter (id: 2729)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 2034)))
	(FAMIX.Method (id: 1709)
		(name ''updateBounds:for:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''updateBounds:for:'')
		(sourceAnchor (ref: 1710)))
	(FAMIX.Access (id: 3455)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 1384)))
	(FAMIX.Invocation (id: 3456)
		(sender (ref: 498))
		(signature ''setAsMultiple()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Invocation (id: 3457)
		(receiver (ref: 2196))
		(sender (ref: 388))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Reference (id: 3458)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Invocation (id: 3459)
		(sender (ref: 1315))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 1316)))
	(FAMIX.Invocation (id: 3460)
		(receiver (ref: 845))
		(sender (ref: 145))
		(signature ''root()'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Invocation (id: 3461)
		(receiver (ref: 1016))
		(sender (ref: 48))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Invocation (id: 3462)
		(receiver (ref: 2456))
		(sender (ref: 404))
		(signature ''instVarNames()'')
		(sourceAnchor (ref: 406)))
	(FAMIX.Invocation (id: 3463)
		(sender (ref: 32))
		(signature ''draggable()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 3464)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 1564)))
	(FAMIX.Method (id: 283)
		(name ''moValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 3352))
		(signature ''moValue:'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Method (id: 177)
		(name ''attributes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''attributes'')
		(sourceAnchor (ref: 178)))
	(FAMIX.Access (id: 3465)
		(accessor (ref: 703))
		(sourceAnchor (ref: 704))
		(variable (ref: 3466)))
	(FAMIX.Invocation (id: 3467)
		(receiver (ref: 3468))
		(sender (ref: 1709))
		(signature ''extent:(Object)'')
		(sourceAnchor (ref: 1710)))
	(FAMIX.Invocation (id: 3469)
		(sender (ref: 493))
		(signature ''new()'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Access (id: 3470)
		(accessor (ref: 229))
		(isWrite true)
		(sourceAnchor (ref: 230))
		(variable (ref: 1764)))
	(FAMIX.Access (id: 3471)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 1331)))
	(FAMIX.Invocation (id: 3472)
		(sender (ref: 248))
		(signature ''origin()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 3473)
		(sender (ref: 2367))
		(signature ''copy()'')
		(sourceAnchor (ref: 2368)))
	(FAMIX.Invocation (id: 3474)
		(sender (ref: 283))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 3475)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Method (id: 2697)
		(name ''width:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''width:'')
		(sourceAnchor (ref: 2698)))
	(FAMIX.Invocation (id: 3476)
		(receiver (ref: 2439))
		(sender (ref: 248))
		(signature ''root()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 3477)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Access (id: 3478)
		(accessor (ref: 1397))
		(sourceAnchor (ref: 1398))
		(variable (ref: 3479)))
	(FAMIX.Access (id: 3480)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 1870)))
	(FAMIX.Access (id: 3481)
		(accessor (ref: 746))
		(sourceAnchor (ref: 747))
		(variable (ref: 2911)))
	(FAMIX.Parameter (id: 1126)
		(name ''aModel'')
		(parentBehaviouralEntity (ref: 1124)))
	(FAMIX.Access (id: 3482)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 1696)))
	(FAMIX.Method (id: 470)
		(name ''edge:from:to:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edge:from:to:'')
		(sourceAnchor (ref: 744)))
	(FAMIX.LocalVariable (id: 825)
		(name ''each'')
		(parentBehaviouralEntity (ref: 39)))
	(FAMIX.Access (id: 3483)
		(accessor (ref: 224))
		(isWrite true)
		(sourceAnchor (ref: 225))
		(variable (ref: 924)))
	(FAMIX.Method (id: 947)
		(name ''defaultAdjustWidthFor:and:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''defaultAdjustWidthFor:and:'')
		(sourceAnchor (ref: 948)))
	(FAMIX.Parameter (id: 3484)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 482)))
	(FAMIX.Class (id: 233)
		(name ''MOGraphElement'')
		(fanIn 2)
		(fanOut 1)
		(hierarchyNestingLevel 1)
		(numberOfAttributes 13)
		(numberOfComments 31)
		(numberOfLinesOfCode 284)
		(numberOfMethods 89)
		(numberOfParents 1)
		(numberOfStatements -89)
		(totalNumberOfChildren 3)
		(weightedMethodCount -89))
	(FAMIX.Access (id: 3485)
		(accessor (ref: 3187))
		(isWrite true)
		(sourceAnchor (ref: 3188))
		(variable (ref: 1004)))
	(FAMIX.Reference (id: 3486)
		(source (ref: 1406))
		(sourceAnchor (ref: 1407))
		(target (ref: 1809)))
	(FAMIX.Access (id: 3487)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1288)))
	(FAMIX.Access (id: 3488)
		(accessor (ref: 430))
		(sourceAnchor (ref: 1022))
		(variable (ref: 263)))
	(FAMIX.Access (id: 3489)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 687)))
	(FAMIX.Access (id: 3490)
		(accessor (ref: 809))
		(sourceAnchor (ref: 810))
		(variable (ref: 3491)))
	(FAMIX.Access (id: 3492)
		(accessor (ref: 1519))
		(sourceAnchor (ref: 1520))
		(variable (ref: 1521)))
	(FAMIX.Invocation (id: 3493)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''bounds()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 3494)
		(accessor (ref: 394))
		(sourceAnchor (ref: 395))
		(variable (ref: 3495)))
	(FAMIX.Access (id: 3496)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 3497)
		(sender (ref: 470))
		(signature ''first()'')
		(sourceAnchor (ref: 744)))
	(FAMIX.Invocation (id: 3498)
		(receiver (ref: 575))
		(sender (ref: 573))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 574)))
	(FAMIX.Invocation (id: 3499)
		(sender (ref: 2796))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 2797)))
	(FAMIX.Access (id: 3500)
		(accessor (ref: 693))
		(sourceAnchor (ref: 1328))
		(variable (ref: 1329)))
	(FAMIX.Reference (id: 3501)
		(source (ref: 1114))
		(sourceAnchor (ref: 1115))
		(target (ref: 633)))
	(FAMIX.Method (id: 1446)
		(name ''nodes:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodes:'')
		(sourceAnchor (ref: 1447)))
	(FAMIX.Invocation (id: 3502)
		(receiver (ref: 168))
		(sender (ref: 252))
		(signature ''y()'')
		(sourceAnchor (ref: 1659)))
	(FAMIX.Access (id: 3503)
		(accessor (ref: 473))
		(sourceAnchor (ref: 474))
		(variable (ref: 3504)))
	(FAMIX.Invocation (id: 3505)
		(receiver (ref: 288))
		(sender (ref: 549))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 550)))
	(FAMIX.Invocation (id: 3506)
		(sender (ref: 91))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3507)
		(receiver (ref: 56))
		(sender (ref: 48))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Invocation (id: 3508)
		(receiver (ref: 1766))
		(sender (ref: 498))
		(signature ''selectBoxBounds()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Comment (id: 3509)
		(container (ref: 1550))
		(content ''"Deselect the element"''))
	(FAMIX.Access (id: 3510)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 280)))
	(FAMIX.Comment (id: 3511)
		(container (ref: 774))
		(content ''"shape display: self on: aCanvas."''))
	(FAMIX.Parameter (id: 1529)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1527)))
	(FAMIX.Invocation (id: 3512)
		(receiver (ref: 521))
		(sender (ref: 128))
		(signature ''label()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 3513)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1268)))
	(FAMIX.Invocation (id: 3514)
		(sender (ref: 237))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Comment (id: 3515)
		(container (ref: 2048))
		(content ''"Set the shape cache to nil"''))
	(FAMIX.Access (id: 3516)
		(accessor (ref: 2034))
		(sourceAnchor (ref: 2155))
		(variable (ref: 2033)))
	(FAMIX.Reference (id: 3517)
		(source (ref: 186))
		(sourceAnchor (ref: 187))
		(target (ref: 2745)))
	(FAMIX.LocalVariable (id: 803)
		(name ''elems'')
		(parentBehaviouralEntity (ref: 801)))
	(FAMIX.Access (id: 3518)
		(accessor (ref: 938))
		(sourceAnchor (ref: 939))
		(variable (ref: 940)))
	(FAMIX.Invocation (id: 3519)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3520)
		(accessor (ref: 631))
		(isWrite true)
		(sourceAnchor (ref: 632))
		(variable (ref: 3005)))
	(FAMIX.Access (id: 3521)
		(accessor (ref: 478))
		(sourceAnchor (ref: 479))
		(variable (ref: 980)))
	(FAMIX.Invocation (id: 3522)
		(receiver (ref: 2464))
		(sender (ref: 1451))
		(signature ''origin()'')
		(sourceAnchor (ref: 1452)))
	(FAMIX.Invocation (id: 3523)
		(receiver (ref: 768))
		(sender (ref: 1519))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1520)))
	(FAMIX.Access (id: 3524)
		(accessor (ref: 514))
		(sourceAnchor (ref: 2063))
		(variable (ref: 2977)))
	(FAMIX.Access (id: 3525)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 2381)))
	(FAMIX.Access (id: 3526)
		(accessor (ref: 204))
		(sourceAnchor (ref: 205))
		(variable (ref: 203)))
	(FAMIX.Invocation (id: 3527)
		(receiver (ref: 3528))
		(sender (ref: 2272))
		(signature ''bounds()'')
		(sourceAnchor (ref: 2273)))
	(FAMIX.Method (id: 1269)
		(name ''announcer'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''announcer'')
		(sourceAnchor (ref: 1270)))
	(FAMIX.Access (id: 3529)
		(accessor (ref: 1806))
		(isWrite true)
		(sourceAnchor (ref: 1807))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 3530)
		(receiver (ref: 898))
		(sender (ref: 312))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 313)))
	(FAMIX.Invocation (id: 3531)
		(receiver (ref: 126))
		(sender (ref: 124))
		(signature ''noneSatisfy:(Object)'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Invocation (id: 3532)
		(receiver (ref: 148))
		(sender (ref: 149))
		(signature ''root:(Object)'')
		(sourceAnchor (ref: 150)))
	(FAMIX.Parameter (id: 3533)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 746)))
	(FAMIX.Access (id: 3534)
		(accessor (ref: 990))
		(isWrite true)
		(sourceAnchor (ref: 991))
		(variable (ref: 2258)))
	(FAMIX.Access (id: 3535)
		(accessor (ref: 99))
		(isWrite true)
		(sourceAnchor (ref: 100))
		(variable (ref: 832)))
	(FAMIX.Parameter (id: 691)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 689)))
	(FAMIX.Invocation (id: 3536)
		(receiver (ref: 37))
		(sender (ref: 35))
		(signature ''width:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Parameter (id: 2920)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 360)))
	(FAMIX.Invocation (id: 3537)
		(receiver (ref: 940))
		(sender (ref: 938))
		(signature ''isNil()'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Method (id: 638)
		(name ''edges:fromAll:toAll:using:fromGlobal:toGlobal:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 17)
		(numberOfParameters 6)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:fromAll:toAll:using:fromGlobal:toGlobal:'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Invocation (id: 3538)
		(sender (ref: 283))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 3539)
		(accessor (ref: 453))
		(sourceAnchor (ref: 454))
		(variable (ref: 455)))
	(FAMIX.Comment (id: 3540)
		(container (ref: 332))
		(content ''"Compute the extent of an element"''))
	(FAMIX.Invocation (id: 3541)
		(receiver (ref: 1935))
		(sender (ref: 756))
		(signature ''expandForEvent:(Object)'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Method (id: 453)
		(name ''withAllSubnodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''withAllSubnodes'')
		(sourceAnchor (ref: 454)))
	(FAMIX.Access (id: 3542)
		(accessor (ref: 388))
		(sourceAnchor (ref: 389))
		(variable (ref: 2196)))
	(FAMIX.Invocation (id: 3543)
		(receiver (ref: 606))
		(sender (ref: 207))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Reference (id: 3544)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 3545)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 977)))
	(FAMIX.Access (id: 3546)
		(accessor (ref: 1357))
		(isWrite true)
		(sourceAnchor (ref: 1358))
		(variable (ref: 3086)))
	(FAMIX.Reference (id: 3547)
		(source (ref: 80))
		(sourceAnchor (ref: 81))
		(target (ref: 322)))
	(FAMIX.Access (id: 3548)
		(accessor (ref: 1441))
		(isWrite true)
		(sourceAnchor (ref: 1442))
		(variable (ref: 614)))
	(FAMIX.Method (id: 2602)
		(name ''noInteraction'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''noInteraction'')
		(sourceAnchor (ref: 2603)))
	(FAMIX.Method (id: 3225)
		(name ''defaultLineShapeClass'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultLineShapeClass'')
		(sourceAnchor (ref: 3226)))
	(FAMIX.Invocation (id: 3549)
		(sender (ref: 182))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Method (id: 3550)
		(name ''shape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''shape'')
		(sourceAnchor (ref: 3551)))
	(FAMIX.Invocation (id: 3552)
		(receiver (ref: 936))
		(sender (ref: 934))
		(signature ''allSubclasses()'')
		(sourceAnchor (ref: 935)))
	(FAMIX.Invocation (id: 3553)
		(receiver (ref: 175))
		(sender (ref: 173))
		(signature ''allEdgesDo:(Object)'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Invocation (id: 3554)
		(sender (ref: 1996))
		(signature ''nodes()'')
		(sourceAnchor (ref: 1997)))
	(FAMIX.Invocation (id: 3555)
		(sender (ref: 482))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 483)))
	(FAMIX.Access (id: 3556)
		(accessor (ref: 696))
		(isWrite true)
		(sourceAnchor (ref: 697))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 3557)
		(receiver (ref: 2559))
		(sender (ref: 80))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Method (id: 676)
		(name ''edges:from:toAll:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 4)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:toAll:using:'')
		(sourceAnchor (ref: 677)))
	(FAMIX.Invocation (id: 3558)
		(receiver (ref: 956))
		(sender (ref: 707))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 708)))
	(FAMIX.Access (id: 3559)
		(accessor (ref: 268))
		(sourceAnchor (ref: 269))
		(variable (ref: 267)))
	(FAMIX.Access (id: 3560)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 1726)))
	(FAMIX.Invocation (id: 3561)
		(receiver (ref: 2975))
		(sender (ref: 737))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 2974)))
	(FAMIX.Invocation (id: 3562)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''layout()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 3563)
		(receiver (ref: 2565))
		(sender (ref: 1237))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 1791)))
	(FAMIX.Reference (id: 3564)
		(source (ref: 592))
		(sourceAnchor (ref: 594))
		(target (ref: 2024)))
	(FAMIX.Method (id: 631)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''initialize'')
		(sourceAnchor (ref: 632)))
	(FAMIX.Reference (id: 3565)
		(source (ref: 1469))
		(sourceAnchor (ref: 1470))
		(target (ref: 3566)))
	(FAMIX.Invocation (id: 3567)
		(sender (ref: 1757))
		(signature ''zOrder()'')
		(sourceAnchor (ref: 1758)))
	(FAMIX.Access (id: 3568)
		(accessor (ref: 2436))
		(sourceAnchor (ref: 2437))
		(variable (ref: 2608)))
	(FAMIX.Method (id: 8)
		(name ''title:'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''title:'')
		(sourceAnchor (ref: 9)))
	(FAMIX.Access (id: 3569)
		(accessor (ref: 16))
		(sourceAnchor (ref: 17))
		(variable (ref: 18)))
	(FAMIX.Access (id: 3570)
		(accessor (ref: 232))
		(sourceAnchor (ref: 234))
		(variable (ref: 3571)))
	(FAMIX.Comment (id: 3572)
		(container (ref: 1202))
		(content ''"True if aPoint is contained within the bounds of anElement graphical representation"''))
	(FAMIX.Parameter (id: 1869)
		(name ''aNumber'')
		(parentBehaviouralEntity (ref: 1867)))
	(FAMIX.Reference (id: 3573)
		(source (ref: 3225))
		(sourceAnchor (ref: 3226))
		(target (ref: 3224)))
	(FAMIX.Parameter (id: 3177)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 360)))
	(FAMIX.Invocation (id: 3574)
		(sender (ref: 963))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Access (id: 3575)
		(accessor (ref: 1469))
		(sourceAnchor (ref: 1470))
		(variable (ref: 3576)))
	(FAMIX.Invocation (id: 3577)
		(receiver (ref: 3578))
		(sender (ref: 560))
		(signature ''decreaseZoomBy:(Object)'')
		(sourceAnchor (ref: 561)))
	(FAMIX.Access (id: 3579)
		(accessor (ref: 470))
		(sourceAnchor (ref: 744))
		(variable (ref: 469)))
	(FAMIX.Method (id: 16)
		(name ''resetFormCacheUpToTheRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetFormCacheUpToTheRoot'')
		(sourceAnchor (ref: 17)))
	(FAMIX.Access (id: 3580)
		(accessor (ref: 746))
		(sourceAnchor (ref: 747))
		(variable (ref: 3533)))
	(FAMIX.Comment (id: 3581)
		(container (ref: 1672))
		(content ''"We do nothing since we are the root"''))
	(FAMIX.Invocation (id: 3582)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Method (id: 268)
		(name ''on:'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constructor'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''on:'')
		(sourceAnchor (ref: 269)))
	(FAMIX.Access (id: 3583)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 523)))
	(FAMIX.Access (id: 3584)
		(accessor (ref: 252))
		(sourceAnchor (ref: 1659))
		(variable (ref: 251)))
	(FAMIX.LocalVariable (id: 1925)
		(name ''v1'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Access (id: 3585)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 834)))
	(FAMIX.Access (id: 3586)
		(accessor (ref: 1357))
		(sourceAnchor (ref: 1358))
		(variable (ref: 3086)))
	(FAMIX.Access (id: 3587)
		(accessor (ref: 308))
		(sourceAnchor (ref: 618))
		(variable (ref: 1890)))
	(FAMIX.Access (id: 3588)
		(accessor (ref: 1769))
		(sourceAnchor (ref: 1770))
		(variable (ref: 3589)))
	(FAMIX.Access (id: 3590)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 1685)))
	(FAMIX.Method (id: 1132)
		(name ''userDefinedEdges:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''userDefinedEdges:'')
		(sourceAnchor (ref: 3591)))
	(FAMIX.Access (id: 3592)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 977)))
	(FAMIX.Access (id: 3593)
		(accessor (ref: 1189))
		(sourceAnchor (ref: 1190))
		(variable (ref: 299)))
	(FAMIX.LocalVariable (id: 1892)
		(name ''localEdges'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Method (id: 1002)
		(name ''initialize'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''initialize'')
		(sourceAnchor (ref: 1003)))
	(FAMIX.Access (id: 3594)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 2146)))
	(FAMIX.Access (id: 3595)
		(accessor (ref: 1523))
		(isWrite true)
		(sourceAnchor (ref: 1524))
		(variable (ref: 2911)))
	(FAMIX.Invocation (id: 3596)
		(receiver (ref: 2573))
		(sender (ref: 443))
		(signature ''form()'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Invocation (id: 3597)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''blue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Reference (id: 3598)
		(source (ref: 76))
		(sourceAnchor (ref: 77))
		(target (ref: 41)))
	(FAMIX.Invocation (id: 3599)
		(receiver (ref: 3008))
		(sender (ref: 487))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 488)))
	(FAMIX.Method (id: 1309)
		(name ''hasNode'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''hasNode'')
		(sourceAnchor (ref: 1310)))
	(FAMIX.Invocation (id: 3600)
		(sender (ref: 974))
		(signature ''bitXor:(Object)'')
		(sourceAnchor (ref: 975)))
	(FAMIX.Invocation (id: 3601)
		(receiver (ref: 2408))
		(sender (ref: 2406))
		(signature ''edges:from:to:(Object,Object,Object)'')
		(sourceAnchor (ref: 2407)))
	(FAMIX.Invocation (id: 3602)
		(receiver (ref: 67))
		(sender (ref: 683))
		(signature ''notNil()'')
		(sourceAnchor (ref: 684)))
	(FAMIX.Invocation (id: 3603)
		(sender (ref: 1820))
		(signature ''asSeconds()'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Access (id: 3604)
		(accessor (ref: 443))
		(sourceAnchor (ref: 444))
		(variable (ref: 3139)))
	(FAMIX.Parameter (id: 3605)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 525)))
	(FAMIX.Invocation (id: 3606)
		(receiver (ref: 782))
		(sender (ref: 124))
		(signature ''target()'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Access (id: 3607)
		(accessor (ref: 2892))
		(sourceAnchor (ref: 3447))
		(variable (ref: 3608)))
	(FAMIX.Invocation (id: 3609)
		(sender (ref: 308))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 618)))
	(FAMIX.Access (id: 3610)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 922)))
	(FAMIX.Invocation (id: 3611)
		(receiver (ref: 946))
		(sender (ref: 947))
		(signature ''width()'')
		(sourceAnchor (ref: 948)))
	(FAMIX.Method (id: 2173)
		(name ''zOrder'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''zOrder'')
		(sourceAnchor (ref: 2174)))
	(FAMIX.Access (id: 3612)
		(accessor (ref: 252))
		(sourceAnchor (ref: 1659))
		(variable (ref: 3086)))
	(FAMIX.Invocation (id: 3613)
		(receiver (ref: 2266))
		(sender (ref: 32))
		(signature ''interaction()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Parameter (id: 902)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 900)))
	(FAMIX.Access (id: 3614)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 441)))
	(FAMIX.Invocation (id: 3615)
		(receiver (ref: 2077))
		(sender (ref: 493))
		(signature ''anyOne()'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Method (id: 2436)
		(name ''width'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''width'')
		(sourceAnchor (ref: 2437)))
	(FAMIX.Invocation (id: 3616)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''bounds()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Parameter (id: 980)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 478)))
	(FAMIX.Invocation (id: 3617)
		(receiver (ref: 3618))
		(sender (ref: 2367))
		(signature ''nodes()'')
		(sourceAnchor (ref: 2368)))
	(FAMIX.Invocation (id: 3619)
		(receiver (ref: 3620))
		(sender (ref: 162))
		(signature ''edges()'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Access (id: 3621)
		(accessor (ref: 1650))
		(sourceAnchor (ref: 1651))
		(variable (ref: 3622)))
	(FAMIX.Invocation (id: 3623)
		(receiver (ref: 2648))
		(sender (ref: 48))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Access (id: 3624)
		(accessor (ref: 1435))
		(sourceAnchor (ref: 1436))
		(variable (ref: 1434)))
	(FAMIX.Access (id: 3625)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 3626)
		(accessor (ref: 2042))
		(sourceAnchor (ref: 2359))
		(variable (ref: 2041)))
	(FAMIX.Method (id: 3627)
		(name ''updateOwner'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''updateOwner'')
		(sourceAnchor (ref: 3628)))
	(FAMIX.Access (id: 3629)
		(accessor (ref: 560))
		(sourceAnchor (ref: 561))
		(variable (ref: 3578)))
	(FAMIX.Access (id: 3630)
		(accessor (ref: 756))
		(isWrite true)
		(sourceAnchor (ref: 757))
		(variable (ref: 67)))
	(FAMIX.Access (id: 3631)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 782)))
	(FAMIX.Method (id: 1378)
		(name ''remove'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''remove'')
		(sourceAnchor (ref: 1379)))
	(FAMIX.Comment (id: 3632)
		(container (ref: 861))
		(content ''"Remove anElement from the children of the receiver."''))
	(FAMIX.Access (id: 3633)
		(accessor (ref: 752))
		(sourceAnchor (ref: 3634))
		(variable (ref: 751)))
	(FAMIX.Access (id: 3635)
		(accessor (ref: 1354))
		(isWrite true)
		(sourceAnchor (ref: 1355))
		(variable (ref: 1760)))
	(FAMIX.Invocation (id: 3636)
		(sender (ref: 1080))
		(signature ''position()'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Access (id: 3637)
		(accessor (ref: 861))
		(sourceAnchor (ref: 862))
		(variable (ref: 3638)))
	(FAMIX.Method (id: 128)
		(name ''setDefaultHandlerForWindow:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 12)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''setDefaultHandlerForWindow:'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Comment (id: 3639)
		(container (ref: 426))
		(content ''"nodes have been located properly. Now, we need to update the size of me (i.e., the size of my shape)"''))
	(FAMIX.Comment (id: 3640)
		(container (ref: 1507))
		(content ''"- aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"''))
	(FAMIX.Invocation (id: 3641)
		(receiver (ref: 2412))
		(sender (ref: 795))
		(signature ''edges:from:to:using:fromGlobal:toGlobal:(Object,Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 2329)))
	(FAMIX.Parameter (id: 1732)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1341)))
	(FAMIX.Access (id: 3642)
		(accessor (ref: 1269))
		(sourceAnchor (ref: 1270))
		(variable (ref: 1268)))
	(FAMIX.Access (id: 3643)
		(accessor (ref: 312))
		(sourceAnchor (ref: 313))
		(variable (ref: 3644)))
	(FAMIX.Invocation (id: 3645)
		(receiver (ref: 1112))
		(sender (ref: 1110))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1111)))
	(FAMIX.Method (id: 260)
		(name ''moValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 3207))
		(signature ''moValue:'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Invocation (id: 3646)
		(receiver (ref: 263))
		(sender (ref: 1309))
		(signature ''isEmpty()'')
		(sourceAnchor (ref: 1310)))
	(FAMIX.Invocation (id: 3647)
		(receiver (ref: 2468))
		(sender (ref: 470))
		(signature ''edges:from:to:(Object,Object,Object)'')
		(sourceAnchor (ref: 744)))
	(FAMIX.Invocation (id: 3648)
		(receiver (ref: 68))
		(sender (ref: 69))
		(signature ''applyLayout()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Access (id: 3649)
		(accessor (ref: 894))
		(sourceAnchor (ref: 895))
		(variable (ref: 3295)))
	(FAMIX.Invocation (id: 3650)
		(receiver (ref: 1935))
		(sender (ref: 756))
		(signature ''interaction()'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Invocation (id: 3651)
		(receiver (ref: 3652))
		(sender (ref: 2796))
		(signature ''nodes()'')
		(sourceAnchor (ref: 2797)))
	(FAMIX.Parameter (id: 2108)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 1855)))
	(FAMIX.Parameter (id: 1408)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 1406)))
	(FAMIX.Invocation (id: 3653)
		(sender (ref: 95))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Method (id: 2538)
		(name ''resetMetricCachesUpToTheRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''resetMetricCachesUpToTheRoot'')
		(sourceAnchor (ref: 2539)))
	(FAMIX.Access (id: 3654)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1885)))
	(FAMIX.Invocation (id: 3655)
		(sender (ref: 35))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Method (id: 2)
		(name ''incomingAndOutgoingEdgesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''incomingAndOutgoingEdgesDo:'')
		(sourceAnchor (ref: 1619)))
	(FAMIX.Invocation (id: 3656)
		(receiver (ref: 3657))
		(sender (ref: 1877))
		(signature ''announcer()'')
		(sourceAnchor (ref: 1878)))
	(FAMIX.Access (id: 3658)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 126)))
	(FAMIX.LocalVariable (id: 1801)
		(name ''eachNode'')
		(parentBehaviouralEntity (ref: 224)))
	(FAMIX.Access (id: 3659)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 2327)))
	(FAMIX.Invocation (id: 3660)
		(sender (ref: 24))
		(signature ''computeBoundsFor:(Object)'')
		(sourceAnchor (ref: 25)))
	(FAMIX.Access (id: 3661)
		(accessor (ref: 1207))
		(sourceAnchor (ref: 1208))
		(variable (ref: 3109)))
	(FAMIX.Invocation (id: 3662)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''pink()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3663)
		(receiver (ref: 1159))
		(sender (ref: 136))
		(signature ''printOn:(Object)'')
		(sourceAnchor (ref: 665)))
	(FAMIX.Invocation (id: 3664)
		(receiver (ref: 2706))
		(sender (ref: 638))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Access (id: 3665)
		(accessor (ref: 195))
		(isWrite true)
		(sourceAnchor (ref: 197))
		(variable (ref: 450)))
	(FAMIX.Access (id: 3666)
		(accessor (ref: 672))
		(sourceAnchor (ref: 673))
		(variable (ref: 3667)))
	(FAMIX.Access (id: 3668)
		(accessor (ref: 1481))
		(sourceAnchor (ref: 1482))
		(variable (ref: 1004)))
	(FAMIX.Class (id: 405)
		(name ''Behavior'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 1)
		(numberOfLinesOfCode 10)
		(numberOfMethods 4)
		(numberOfParents 0)
		(numberOfStatements -4)
		(totalNumberOfChildren 0)
		(weightedMethodCount -4))
	(FAMIX.Method (id: 2406)
		(name ''edgesFromAssociations:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgesFromAssociations:'')
		(sourceAnchor (ref: 2407)))
	(FAMIX.Class (id: 3669)
		(name ''Form class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Comment (id: 3670)
		(container (ref: 746))
		(content ''"Expand the bounds of myself"''))
	(FAMIX.Access (id: 3671)
		(accessor (ref: 1555))
		(sourceAnchor (ref: 1556))
		(variable (ref: 1557)))
	(FAMIX.Access (id: 3672)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 3673)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 3425)))
	(FAMIX.Access (id: 3674)
		(accessor (ref: 1709))
		(sourceAnchor (ref: 1710))
		(variable (ref: 3288)))
	(FAMIX.Invocation (id: 3675)
		(receiver (ref: 1795))
		(sender (ref: 756))
		(signature ''position()'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Invocation (id: 3676)
		(receiver (ref: 306))
		(sender (ref: 1043))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Access (id: 3677)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 606)))
	(FAMIX.Invocation (id: 3678)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3679)
		(receiver (ref: 1255))
		(sender (ref: 108))
		(signature ''setDefaultHandlers()'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Access (id: 3680)
		(accessor (ref: 1269))
		(sourceAnchor (ref: 1270))
		(variable (ref: 3681)))
	(FAMIX.Access (id: 3682)
		(accessor (ref: 1406))
		(sourceAnchor (ref: 1407))
		(variable (ref: 2248)))
	(FAMIX.Invocation (id: 3683)
		(sender (ref: 248))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 3684)
		(sender (ref: 20))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.LocalVariable (id: 1029)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 32)))
	(FAMIX.Class (id: 2981)
		(name ''Association class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 3685)
		(sender (ref: 1777))
		(signature ''collect:(Object)'')
		(sourceAnchor (ref: 1778)))
	(FAMIX.Invocation (id: 3686)
		(receiver (ref: 188))
		(sender (ref: 189))
		(signature ''resetCacheResursively()'')
		(sourceAnchor (ref: 336)))
	(FAMIX.Invocation (id: 3687)
		(receiver (ref: 181))
		(sender (ref: 1272))
		(signature ''shouldCache()'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Invocation (id: 3688)
		(receiver (ref: 133))
		(sender (ref: 221))
		(signature ''sortBlock:(Object)'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Access (id: 3689)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 2894)))
	(FAMIX.Access (id: 3690)
		(accessor (ref: 963))
		(isWrite true)
		(sourceAnchor (ref: 964))
		(variable (ref: 940)))
	(FAMIX.Invocation (id: 3691)
		(receiver (ref: 1214))
		(sender (ref: 1215))
		(signature ''setDefaultHandlersMouseMove()'')
		(sourceAnchor (ref: 1216)))
	(FAMIX.Access (id: 3692)
		(accessor (ref: 1140))
		(sourceAnchor (ref: 1141))
		(variable (ref: 3693)))
	(FAMIX.Comment (id: 3694)
		(container (ref: 248))
		(content ''"We might have to update the bounds of the root"''))
	(FAMIX.Access (id: 3695)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 1197)))
	(FAMIX.Invocation (id: 3696)
		(receiver (ref: 1998))
		(sender (ref: 1996))
		(signature ''root()'')
		(sourceAnchor (ref: 1997)))
	(FAMIX.Access (id: 3697)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 779)))
	(FAMIX.Access (id: 3698)
		(accessor (ref: 770))
		(sourceAnchor (ref: 771))
		(variable (ref: 3699)))
	(FAMIX.Comment (id: 3700)
		(container (ref: 3044))
		(content ''"Answer the root node of this graph element, by recursively walking upwards the owner nodes."''))
	(FAMIX.Method (id: 658)
		(name ''addEdgeIn:from:to:model:shape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 5)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''addEdgeIn:from:to:model:shape:'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Parameter (id: 2221)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 350)))
	(FAMIX.Access (id: 3701)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1136)))
	(FAMIX.Access (id: 3702)
		(accessor (ref: 229))
		(sourceAnchor (ref: 230))
		(variable (ref: 231)))
	(FAMIX.Method (id: 443)
		(name ''cacheCanvas:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''cacheCanvas:'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 3703)
		(accessor (ref: 1761))
		(sourceAnchor (ref: 1762))
		(variable (ref: 2890)))
	(FAMIX.Invocation (id: 3704)
		(receiver (ref: 3705))
		(sender (ref: 212))
		(signature ''resetElementsToLookup()'')
		(sourceAnchor (ref: 213)))
	(FAMIX.LocalVariable (id: 3620)
		(name ''n'')
		(parentBehaviouralEntity (ref: 162)))
	(FAMIX.Parameter (id: 3706)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 516)))
	(FAMIX.Invocation (id: 3707)
		(receiver (ref: 3262))
		(sender (ref: 1002))
		(signature ''new()'')
		(sourceAnchor (ref: 1003)))
	(FAMIX.Invocation (id: 3708)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Method (id: 192)
		(name ''hasIncomingEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''hasIncomingEdges'')
		(sourceAnchor (ref: 193)))
	(FAMIX.Invocation (id: 3709)
		(receiver (ref: 3710))
		(sender (ref: 1757))
		(signature ''owner()'')
		(sourceAnchor (ref: 1758)))
	(FAMIX.Invocation (id: 3711)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''veryLightGray()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3712)
		(accessor (ref: 1785))
		(sourceAnchor (ref: 1786))
		(variable (ref: 3332)))
	(FAMIX.Access (id: 3713)
		(accessor (ref: 423))
		(sourceAnchor (ref: 424))
		(variable (ref: 2811)))
	(FAMIX.Class (id: 942)
		(name ''MOVerticalLineLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Method (id: 514)
		(name ''numberOfMethodsInherited'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 405))
		(signature ''numberOfMethodsInherited'')
		(sourceAnchor (ref: 2063)))
	(FAMIX.Parameter (id: 3714)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 1085)))
	(FAMIX.Access (id: 3715)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1935)))
	(FAMIX.Method (id: 308)
		(name ''nodeForDomainValues:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''nodeForDomainValues:'')
		(sourceAnchor (ref: 618)))
	(FAMIX.Access (id: 3716)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 653)))
	(FAMIX.Method (id: 1114)
		(name ''defaultNodeShapeClass'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''defaultNodeShapeClass'')
		(sourceAnchor (ref: 1115)))
	(FAMIX.Comment (id: 3717)
		(container (ref: 106))
		(content ''"Iterates over all the edges of the receiver."''))
	(FAMIX.Parameter (id: 1175)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 264)))
	(FAMIX.Invocation (id: 3718)
		(receiver (ref: 3086))
		(sender (ref: 252))
		(signature ''moY:(Object)'')
		(sourceAnchor (ref: 1659)))
	(FAMIX.Class (id: 3719)
		(name ''MOHorizontalDominanceTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 3720)
		(receiver (ref: 825))
		(sender (ref: 39))
		(signature ''value()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Method (id: 364)
		(name ''numberOfNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''numberOfNodes'')
		(sourceAnchor (ref: 365)))
	(FAMIX.Access (id: 3721)
		(accessor (ref: 468))
		(sourceAnchor (ref: 1364))
		(variable (ref: 2478)))
	(FAMIX.Access (id: 3722)
		(accessor (ref: 1421))
		(sourceAnchor (ref: 1422))
		(variable (ref: 3341)))
	(FAMIX.Access (id: 3723)
		(accessor (ref: 1507))
		(sourceAnchor (ref: 1798))
		(variable (ref: 3724)))
	(FAMIX.Invocation (id: 3725)
		(receiver (ref: 1255))
		(sender (ref: 108))
		(signature ''defaultNodeShapeClass()'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Comment (id: 3726)
		(container (ref: 969))
		(content ''"Return the extremity point"''))
	(FAMIX.Access (id: 3727)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 729)))
	(FAMIX.Method (id: 3728)
		(name ''resetElementsToDisplayCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetElementsToDisplayCache'')
		(sourceAnchor (ref: 3729)))
	(FAMIX.Reference (id: 3730)
		(source (ref: 221))
		(sourceAnchor (ref: 222))
		(target (ref: 133)))
	(FAMIX.Invocation (id: 3731)
		(receiver (ref: 1329))
		(sender (ref: 693))
		(signature ''interaction()'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Access (id: 3732)
		(accessor (ref: 1378))
		(sourceAnchor (ref: 1379))
		(variable (ref: 2840)))
	(FAMIX.Invocation (id: 3733)
		(receiver (ref: 633))
		(sender (ref: 696))
		(signature ''defaultNodeShapeInstance()'')
		(sourceAnchor (ref: 697)))
	(FAMIX.Parameter (id: 2362)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 1446)))
	(FAMIX.Access (id: 3734)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Invocation (id: 3735)
		(sender (ref: 473))
		(signature ''at:ifAbsentPut:(Object,Object)'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Access (id: 3736)
		(accessor (ref: 189))
		(sourceAnchor (ref: 336))
		(variable (ref: 1818)))
	(FAMIX.Access (id: 3737)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 2773)))
	(FAMIX.Access (id: 3738)
		(accessor (ref: 993))
		(sourceAnchor (ref: 994))
		(variable (ref: 1416)))
	(FAMIX.Invocation (id: 3739)
		(receiver (ref: 1292))
		(sender (ref: 1290))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 1291)))
	(FAMIX.Access (id: 3740)
		(accessor (ref: 189))
		(sourceAnchor (ref: 336))
		(variable (ref: 188)))
	(FAMIX.LocalVariable (id: 1858)
		(name ''tmpCanvas'')
		(parentBehaviouralEntity (ref: 505)))
	(FAMIX.Access (id: 3741)
		(accessor (ref: 1775))
		(sourceAnchor (ref: 2161))
		(variable (ref: 1774)))
	(FAMIX.Access (id: 3742)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Invocation (id: 3743)
		(receiver (ref: 263))
		(sender (ref: 264))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 265)))
	(FAMIX.Access (id: 3744)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 2266)))
	(FAMIX.Access (id: 3745)
		(accessor (ref: 858))
		(sourceAnchor (ref: 859))
		(variable (ref: 3746)))
	(FAMIX.Method (id: 408)
		(name ''elementAt:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 3)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 8)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''elementAt:ifAbsent:'')
		(sourceAnchor (ref: 1241)))
	(FAMIX.Class (id: 1972)
		(name ''MOFlowLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3747)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 641)))
	(FAMIX.Invocation (id: 3748)
		(receiver (ref: 2458))
		(sender (ref: 932))
		(signature ''resetFormCacheSimply()'')
		(sourceAnchor (ref: 1893)))
	(FAMIX.Invocation (id: 3749)
		(receiver (ref: 341))
		(sender (ref: 342))
		(signature ''perform:(Object)'')
		(sourceAnchor (ref: 1895)))
	(FAMIX.Invocation (id: 3750)
		(receiver (ref: 130))
		(sender (ref: 128))
		(signature ''newLabel()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 3751)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1885)))
	(FAMIX.Access (id: 3752)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 306)))
	(FAMIX.Invocation (id: 3753)
		(receiver (ref: 2896))
		(sender (ref: 1820))
		(signature ''now()'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Access (id: 3754)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 1928)))
	(FAMIX.Access (id: 3755)
		(accessor (ref: 1013))
		(sourceAnchor (ref: 1014))
		(variable (ref: 812)))
	(FAMIX.Method (id: 2616)
		(name ''doInitialize:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''doInitialize:'')
		(sourceAnchor (ref: 2617)))
	(FAMIX.Invocation (id: 3756)
		(receiver (ref: 2108))
		(sender (ref: 1855))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 1856)))
	(FAMIX.LocalVariable (id: 2040)
		(name ''oldPos'')
		(parentBehaviouralEntity (ref: 248)))
	(FAMIX.Invocation (id: 3757)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''orange()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 3758)
		(accessor (ref: 315))
		(sourceAnchor (ref: 869))
		(variable (ref: 3759)))
	(FAMIX.Invocation (id: 3760)
		(sender (ref: 1010))
		(signature ''nodeForDomainValue:(Object)'')
		(sourceAnchor (ref: 1011)))
	(FAMIX.Invocation (id: 3761)
		(receiver (ref: 1814))
		(sender (ref: 84))
		(signature ''root()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Class (id: 3762)
		(name ''MOMouseDrag class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3763)
		(accessor (ref: 894))
		(sourceAnchor (ref: 895))
		(variable (ref: 3203)))
	(FAMIX.Invocation (id: 3764)
		(receiver (ref: 1655))
		(sender (ref: 414))
		(signature ''translateBy:during:(Object,Object)'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Invocation (id: 3765)
		(receiver (ref: 1045))
		(sender (ref: 1043))
		(signature ''shape()'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Invocation (id: 3766)
		(receiver (ref: 1329))
		(sender (ref: 693))
		(signature ''selectElementsFromBox()'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Access (id: 3767)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 3167)))
	(FAMIX.Access (id: 3768)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 1870)))
	(FAMIX.LocalVariable (id: 1617)
		(name ''each'')
		(parentBehaviouralEntity (ref: 505)))
	(FAMIX.Invocation (id: 3769)
		(sender (ref: 408))
		(signature ''containsPoint:for:(Object,Object)'')
		(sourceAnchor (ref: 1241)))
	(FAMIX.Access (id: 3770)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 181)))
	(FAMIX.Method (id: 4)
		(name ''select'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''select'')
		(sourceAnchor (ref: 5)))
	(FAMIX.Invocation (id: 3771)
		(sender (ref: 1837))
		(signature ''corner()'')
		(sourceAnchor (ref: 1838)))
	(FAMIX.Invocation (id: 3772)
		(receiver (ref: 2439))
		(sender (ref: 248))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 3773)
		(receiver (ref: 2096))
		(sender (ref: 2094))
		(signature ''first()'')
		(sourceAnchor (ref: 2095)))
	(FAMIX.Comment (id: 3774)
		(container (ref: 408))
		(content ''"aPoint is relative coordinate."''))
	(FAMIX.Access (id: 3775)
		(accessor (ref: 1104))
		(sourceAnchor (ref: 1105))
		(variable (ref: 67)))
	(FAMIX.Access (id: 3776)
		(accessor (ref: 1101))
		(sourceAnchor (ref: 1102))
		(variable (ref: 1186)))
	(FAMIX.Access (id: 3777)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 181)))
	(FAMIX.Invocation (id: 3778)
		(receiver (ref: 104))
		(sender (ref: 102))
		(signature ''translateBy:(Object)'')
		(sourceAnchor (ref: 103)))
	(FAMIX.Access (id: 3779)
		(accessor (ref: 809))
		(sourceAnchor (ref: 810))
		(variable (ref: 808)))
	(FAMIX.Invocation (id: 3780)
		(receiver (ref: 3179))
		(sender (ref: 943))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 944)))
	(FAMIX.Method (id: 433)
		(name ''layout:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''layout:'')
		(sourceAnchor (ref: 434)))
	(FAMIX.Access (id: 3781)
		(accessor (ref: 264))
		(isWrite true)
		(sourceAnchor (ref: 265))
		(variable (ref: 263)))
	(FAMIX.Access (id: 3782)
		(accessor (ref: 719))
		(sourceAnchor (ref: 720))
		(variable (ref: 817)))
	(FAMIX.Access (id: 3783)
		(accessor (ref: 947))
		(sourceAnchor (ref: 948))
		(variable (ref: 1420)))
	(FAMIX.Access (id: 3784)
		(accessor (ref: 2710))
		(sourceAnchor (ref: 2711))
		(variable (ref: 3785)))
	(FAMIX.LocalVariable (id: 2021)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 693)))
	(FAMIX.Access (id: 3786)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 416)))
	(FAMIX.Invocation (id: 3787)
		(receiver (ref: 1552))
		(sender (ref: 1550))
		(signature ''resetFormCacheUpToTheRoot()'')
		(sourceAnchor (ref: 1551)))
	(FAMIX.Parameter (id: 3589)
		(name ''element'')
		(parentBehaviouralEntity (ref: 1769)))
	(FAMIX.LocalVariable (id: 2466)
		(name ''n'')
		(parentBehaviouralEntity (ref: 124)))
	(FAMIX.Reference (id: 3788)
		(source (ref: 20))
		(sourceAnchor (ref: 21))
		(target (ref: 2624)))
	(FAMIX.Access (id: 3789)
		(accessor (ref: 934))
		(sourceAnchor (ref: 935))
		(variable (ref: 1034)))
	(FAMIX.Access (id: 3790)
		(accessor (ref: 1278))
		(sourceAnchor (ref: 1279))
		(variable (ref: 1745)))
	(FAMIX.Access (id: 3791)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 3792)))
	(FAMIX.Invocation (id: 3793)
		(receiver (ref: 832))
		(sender (ref: 99))
		(signature ''at:ifPresent:(Object,Object)'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Invocation (id: 3794)
		(receiver (ref: 3719))
		(sender (ref: 1110))
		(signature ''new()'')
		(sourceAnchor (ref: 1111)))
	(FAMIX.Invocation (id: 3795)
		(receiver (ref: 2115))
		(sender (ref: 668))
		(signature ''edgeShape()'')
		(sourceAnchor (ref: 1024)))
	(FAMIX.Invocation (id: 3796)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3797)
		(receiver (ref: 779))
		(sender (ref: 777))
		(signature ''class()'')
		(sourceAnchor (ref: 778)))
	(FAMIX.Method (id: 3798)
		(name ''isChildShape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isChildShape'')
		(sourceAnchor (ref: 3799)))
	(FAMIX.Access (id: 3800)
		(accessor (ref: 1124))
		(sourceAnchor (ref: 1125))
		(variable (ref: 1126)))
	(FAMIX.Invocation (id: 3801)
		(receiver (ref: 793))
		(sender (ref: 95))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 3802)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 1068)))
	(FAMIX.Access (id: 3803)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1045)))
	(FAMIX.Access (id: 3804)
		(accessor (ref: 388))
		(sourceAnchor (ref: 389))
		(variable (ref: 1538)))
	(FAMIX.Invocation (id: 3805)
		(receiver (ref: 653))
		(sender (ref: 35))
		(signature ''nodes()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Invocation (id: 3806)
		(receiver (ref: 936))
		(sender (ref: 934))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 935)))
	(FAMIX.Access (id: 3807)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 2911)))
	(FAMIX.Access (id: 3808)
		(accessor (ref: 1855))
		(sourceAnchor (ref: 1856))
		(variable (ref: 2238)))
	(FAMIX.Access (id: 3809)
		(accessor (ref: 560))
		(sourceAnchor (ref: 561))
		(variable (ref: 2872)))
	(FAMIX.Invocation (id: 3810)
		(sender (ref: 99))
		(signature ''detect:ifNone:(Object,Object)'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Invocation (id: 3811)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Method (id: 1050)
		(name ''removeNodesWithValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeNodesWithValue:'')
		(sourceAnchor (ref: 1051)))
	(FAMIX.Access (id: 3812)
		(accessor (ref: 200))
		(sourceAnchor (ref: 201))
		(variable (ref: 702)))
	(FAMIX.LocalVariable (id: 2381)
		(name ''each'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Access (id: 3813)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 2864)))
	(FAMIX.Access (id: 3814)
		(accessor (ref: 162))
		(sourceAnchor (ref: 163))
		(variable (ref: 764)))
	(FAMIX.Access (id: 3815)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 1323)))
	(FAMIX.LocalVariable (id: 2384)
		(name ''root'')
		(parentBehaviouralEntity (ref: 993)))
	(FAMIX.Invocation (id: 3816)
		(sender (ref: 368))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 369)))
	(FAMIX.Access (id: 3817)
		(accessor (ref: 1973))
		(sourceAnchor (ref: 1974))
		(variable (ref: 3818)))
	(FAMIX.Invocation (id: 3819)
		(sender (ref: 947))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 948)))
	(FAMIX.Access (id: 3820)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 587)))
	(FAMIX.Invocation (id: 3821)
		(receiver (ref: 834))
		(sender (ref: 80))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Access (id: 3822)
		(accessor (ref: 872))
		(isWrite true)
		(sourceAnchor (ref: 873))
		(variable (ref: 3823)))
	(FAMIX.Invocation (id: 3824)
		(receiver (ref: 495))
		(sender (ref: 493))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Access (id: 3825)
		(accessor (ref: 173))
		(sourceAnchor (ref: 174))
		(variable (ref: 3826)))
	(FAMIX.Access (id: 3827)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 491)))
	(FAMIX.Method (id: 1218)
		(name ''hasCache:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''hasCache:'')
		(sourceAnchor (ref: 1219)))
	(FAMIX.Reference (id: 3828)
		(source (ref: 1002))
		(sourceAnchor (ref: 1003))
		(target (ref: 3262)))
	(FAMIX.Invocation (id: 3829)
		(sender (ref: 374))
		(signature ''negated()'')
		(sourceAnchor (ref: 375)))
	(FAMIX.Access (id: 3830)
		(accessor (ref: 498))
		(sourceAnchor (ref: 499))
		(variable (ref: 1766)))
	(FAMIX.Invocation (id: 3831)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''red()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3832)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 56)))
	(FAMIX.Access (id: 3833)
		(accessor (ref: 275))
		(isWrite true)
		(sourceAnchor (ref: 276))
		(variable (ref: 1384)))
	(FAMIX.LocalVariable (id: 1302)
		(name ''newShape'')
		(parentBehaviouralEntity (ref: 827)))
	(FAMIX.Method (id: 2507)
		(name ''treeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''treeLayout'')
		(sourceAnchor (ref: 2508)))
	(FAMIX.Parameter (id: 3759)
		(name ''anotherNode'')
		(parentBehaviouralEntity (ref: 315)))
	(FAMIX.Invocation (id: 3834)
		(sender (ref: 248))
		(signature ''isRoot()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Parameter (id: 1012)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1010)))
	(FAMIX.Invocation (id: 3835)
		(receiver (ref: 852))
		(sender (ref: 20))
		(signature ''isKindOf:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Invocation (id: 3836)
		(sender (ref: 80))
		(signature ''addNode:(Object)'')
		(sourceAnchor (ref: 81)))
	(FAMIX.Method (id: 1831)
		(name ''hasAttribute:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''hasAttribute:'')
		(sourceAnchor (ref: 1832)))
	(FAMIX.Invocation (id: 3837)
		(receiver (ref: 2811))
		(sender (ref: 423))
		(signature ''toPositions()'')
		(sourceAnchor (ref: 424)))
	(FAMIX.Access (id: 3838)
		(accessor (ref: 1007))
		(sourceAnchor (ref: 1008))
		(variable (ref: 1006)))
	(FAMIX.Method (id: 1007)
		(name ''setIfNilFromPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''setIfNilFromPositions:'')
		(sourceAnchor (ref: 1008)))
	(FAMIX.Access (id: 3839)
		(accessor (ref: 482))
		(sourceAnchor (ref: 483))
		(variable (ref: 3484)))
	(FAMIX.Invocation (id: 3840)
		(receiver (ref: 875))
		(sender (ref: 95))
		(signature ''addEdgeIn:from:to:model:shape:(Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Method (id: 99)
		(name ''nodeWith:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 9)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''nodeWith:ifAbsent:'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Invocation (id: 3841)
		(receiver (ref: 3842))
		(sender (ref: 433))
		(signature ''root()'')
		(sourceAnchor (ref: 434)))
	(FAMIX.Comment (id: 3843)
		(container (ref: 173))
		(content ''"Evaluate aBlock all its edges."''))
	(FAMIX.Access (id: 3844)
		(accessor (ref: 166))
		(isWrite true)
		(sourceAnchor (ref: 167))
		(variable (ref: 3086)))
	(FAMIX.Parameter (id: 1361)
		(name ''aNumber'')
		(parentBehaviouralEntity (ref: 207)))
	(FAMIX.Access (id: 3845)
		(accessor (ref: 1085))
		(sourceAnchor (ref: 1086))
		(variable (ref: 3714)))
	(FAMIX.Parameter (id: 1171)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 1169)))
	(FAMIX.Invocation (id: 3846)
		(receiver (ref: 502))
		(sender (ref: 69))
		(signature ''resetMetricCachesResursively()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 3847)
		(sender (ref: 1002))
		(signature ''translated()'')
		(sourceAnchor (ref: 1003)))
	(FAMIX.Access (id: 3848)
		(accessor (ref: 1605))
		(sourceAnchor (ref: 1606))
		(variable (ref: 1072)))
	(FAMIX.Access (id: 3849)
		(accessor (ref: 2094))
		(sourceAnchor (ref: 2095))
		(variable (ref: 3850)))
	(FAMIX.Class (id: 758)
		(name ''MOMouseDown class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 3851)
		(sender (ref: 1080))
		(signature ''r()'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Access (id: 3852)
		(accessor (ref: 1147))
		(isWrite true)
		(sourceAnchor (ref: 1148))
		(variable (ref: 1146)))
	(FAMIX.Parameter (id: 3013)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 468)))
	(FAMIX.Invocation (id: 3853)
		(sender (ref: 327))
		(signature ''isNil()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 3854)
		(sender (ref: 61))
		(signature ''size()'')
		(sourceAnchor (ref: 62)))
	(FAMIX.Class (id: 1277)
		(name ''MOHorizontalLineLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 3855)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 292)))
	(FAMIX.Access (id: 3856)
		(accessor (ref: 1155))
		(sourceAnchor (ref: 1156))
		(variable (ref: 1201)))
	(FAMIX.Reference (id: 3857)
		(source (ref: 414))
		(sourceAnchor (ref: 415))
		(target (ref: 3669)))
	(FAMIX.Invocation (id: 3858)
		(sender (ref: 443))
		(signature ''extent:(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 3859)
		(accessor (ref: 232))
		(sourceAnchor (ref: 234))
		(variable (ref: 3571)))
	(FAMIX.Invocation (id: 3860)
		(receiver (ref: 1688))
		(sender (ref: 39))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 3861)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 42)))
	(FAMIX.Access (id: 3862)
		(accessor (ref: 1043))
		(isWrite true)
		(sourceAnchor (ref: 1044))
		(variable (ref: 2417)))
	(FAMIX.Method (id: 2256)
		(name ''toPositions'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''toPositions'')
		(sourceAnchor (ref: 2257)))
	(FAMIX.Access (id: 3863)
		(accessor (ref: 204))
		(sourceAnchor (ref: 205))
		(variable (ref: 2562)))
	(FAMIX.Access (id: 3864)
		(accessor (ref: 1996))
		(sourceAnchor (ref: 1997))
		(variable (ref: 3306)))
	(FAMIX.Method (id: 271)
		(name ''elementsToDisplay'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''elementsToDisplay'')
		(sourceAnchor (ref: 272)))
	(FAMIX.Method (id: 426)
		(name ''applyLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 5)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 22)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''applyLayout'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 3865)
		(accessor (ref: 1826))
		(sourceAnchor (ref: 1827))
		(variable (ref: 1825)))
	(FAMIX.Access (id: 3866)
		(accessor (ref: 8))
		(sourceAnchor (ref: 9))
		(variable (ref: 2993)))
	(FAMIX.Access (id: 3867)
		(accessor (ref: 1640))
		(sourceAnchor (ref: 1641))
		(variable (ref: 768)))
	(FAMIX.Parameter (id: 3667)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 672)))
	(FAMIX.Access (id: 3868)
		(accessor (ref: 3869))
		(sourceAnchor (ref: 3870))
		(variable (ref: 1373)))
	(FAMIX.Invocation (id: 3871)
		(receiver (ref: 3872))
		(sender (ref: 529))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 530)))
	(FAMIX.Access (id: 3873)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 712)))
	(FAMIX.Method (id: 290)
		(name ''shapeBoundsAt:ifAbsentPut:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shapeBoundsAt:ifAbsentPut:'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Comment (id: 3874)
		(container (ref: 2612))
		(content ''"Answer the list of outgoing edges from myself"''))
	(FAMIX.LocalVariable (id: 3875)
		(name ''ann'')
		(parentBehaviouralEntity (ref: 84)))
	(FAMIX.Access (id: 3876)
		(accessor (ref: 2837))
		(sourceAnchor (ref: 2838))
		(variable (ref: 2996)))
	(FAMIX.LocalVariable (id: 1107)
		(name ''each'')
		(parentBehaviouralEntity (ref: 426)))
	(FAMIX.Access (id: 3877)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 1197)))
	(FAMIX.Access (id: 3878)
		(accessor (ref: 693))
		(isWrite true)
		(sourceAnchor (ref: 1328))
		(variable (ref: 954)))
	(FAMIX.Invocation (id: 3879)
		(sender (ref: 315))
		(signature ''source:(Object)'')
		(sourceAnchor (ref: 869)))
	(FAMIX.Invocation (id: 3880)
		(receiver (ref: 542))
		(sender (ref: 540))
		(signature ''new()'')
		(sourceAnchor (ref: 541)))
	(FAMIX.Access (id: 3881)
		(accessor (ref: 861))
		(sourceAnchor (ref: 862))
		(variable (ref: 263)))
	(FAMIX.Invocation (id: 3882)
		(receiver (ref: 2205))
		(sender (ref: 1263))
		(signature ''new()'')
		(sourceAnchor (ref: 1264)))
	(FAMIX.Access (id: 3883)
		(accessor (ref: 676))
		(sourceAnchor (ref: 677))
		(variable (ref: 759)))
	(FAMIX.Method (id: 69)
		(name ''applyLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 14)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''applyLayout'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 3884)
		(sender (ref: 498))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Reference (id: 3885)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Parameter (id: 3248)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 468)))
	(FAMIX.Parameter (id: 1541)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 470)))
	(FAMIX.Access (id: 3886)
		(accessor (ref: 1087))
		(sourceAnchor (ref: 1088))
		(variable (ref: 3113)))
	(FAMIX.Invocation (id: 3887)
		(receiver (ref: 1688))
		(sender (ref: 39))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 3888)
		(receiver (ref: 199))
		(sender (ref: 200))
		(signature ''originalPrintOn:(Object)'')
		(sourceAnchor (ref: 201)))
	(FAMIX.Invocation (id: 3889)
		(receiver (ref: 2872))
		(sender (ref: 560))
		(signature ''nodes()'')
		(sourceAnchor (ref: 561)))
	(FAMIX.Access (id: 3890)
		(accessor (ref: 493))
		(sourceAnchor (ref: 494))
		(variable (ref: 495)))
	(FAMIX.Invocation (id: 3891)
		(receiver (ref: 263))
		(sender (ref: 861))
		(signature ''remove:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 862)))
	(FAMIX.Invocation (id: 3892)
		(sender (ref: 91))
		(signature ''yourself()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 3893)
		(receiver (ref: 812))
		(sender (ref: 1724))
		(signature ''notEmpty()'')
		(sourceAnchor (ref: 1725)))
	(FAMIX.Method (id: 3894)
		(name ''defaultFromPositions'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''defaultFromPositions'')
		(sourceAnchor (ref: 3895)))
	(FAMIX.Parameter (id: 2559)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 80)))
	(FAMIX.Method (id: 3896)
		(name ''isZoomOn'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''isZoomOn'')
		(sourceAnchor (ref: 3897)))
	(FAMIX.Access (id: 3898)
		(accessor (ref: 116))
		(sourceAnchor (ref: 117))
		(variable (ref: 954)))
	(FAMIX.Access (id: 3899)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1718)))
	(FAMIX.Invocation (id: 3900)
		(sender (ref: 737))
		(signature ''at:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 2974)))
	(FAMIX.LocalVariable (id: 2977)
		(name ''el'')
		(parentBehaviouralEntity (ref: 514)))
	(FAMIX.Parameter (id: 3901)
		(name ''aValue'')
		(parentBehaviouralEntity (ref: 248)))
	(FAMIX.Access (id: 3902)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 1533)))
	(FAMIX.Access (id: 3903)
		(accessor (ref: 752))
		(isWrite true)
		(sourceAnchor (ref: 3634))
		(variable (ref: 3495)))
	(FAMIX.Invocation (id: 3904)
		(receiver (ref: 3327))
		(sender (ref: 583))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 584)))
	(FAMIX.Access (id: 3905)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1904)))
	(FAMIX.Invocation (id: 3906)
		(receiver (ref: 1331))
		(sender (ref: 35))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Method (id: 2796)
		(name ''deepApplyLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''deepApplyLayout'')
		(sourceAnchor (ref: 2797)))
	(FAMIX.Method (id: 91)
		(name ''lightColors'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 10)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 53)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 1385))
		(signature ''lightColors'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 3907)
		(accessor (ref: 4))
		(isWrite true)
		(sourceAnchor (ref: 5))
		(variable (ref: 3823)))
	(FAMIX.Access (id: 3908)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 3041)))
	(FAMIX.Invocation (id: 3909)
		(receiver (ref: 3910))
		(sender (ref: 1837))
		(signature ''bounds()'')
		(sourceAnchor (ref: 1838)))
	(FAMIX.Access (id: 3911)
		(accessor (ref: 324))
		(sourceAnchor (ref: 325))
		(variable (ref: 1295)))
	(FAMIX.Invocation (id: 3912)
		(sender (ref: 1080))
		(signature ''position()'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Parameter (id: 3913)
		(name ''aGraphElement'')
		(parentBehaviouralEntity (ref: 1421)))
	(FAMIX.Invocation (id: 3914)
		(sender (ref: 237))
		(signature ''symbol()'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Access (id: 3915)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Comment (id: 3916)
		(container (ref: 354))
		(content ''"Expand the bounds of myself"''))
	(FAMIX.Access (id: 3917)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 181)))
	(FAMIX.Parameter (id: 2845)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 565)))
	(FAMIX.Comment (id: 3918)
		(container (ref: 138))
		(content ''"Return true if the element is visible within the bounds, absolute bounds are tested for this"''))
	(FAMIX.Invocation (id: 3919)
		(sender (ref: 465))
		(signature ''first()'')
		(sourceAnchor (ref: 466)))
	(FAMIX.Comment (id: 3920)
		(container (ref: 99))
		(content ''"Not sure whether we should leave this method. Suspicious. AlexandreBergel 12/30/2010 18:16"''))
	(FAMIX.Invocation (id: 3921)
		(receiver (ref: 1584))
		(sender (ref: 1582))
		(signature ''resetMetricCaches()'')
		(sourceAnchor (ref: 1583)))
	(FAMIX.Access (id: 3922)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 591)))
	(FAMIX.Access (id: 3923)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Invocation (id: 3924)
		(receiver (ref: 687))
		(sender (ref: 308))
		(signature ''collect:(Object)'')
		(sourceAnchor (ref: 618)))
	(FAMIX.Access (id: 3925)
		(accessor (ref: 318))
		(sourceAnchor (ref: 319))
		(variable (ref: 2515)))
	(FAMIX.Class (id: 131)
		(name ''MORoot'')
		(fanIn 0)
		(fanOut 1)
		(hierarchyNestingLevel 3)
		(numberOfAttributes 6)
		(numberOfComments 16)
		(numberOfLinesOfCode 170)
		(numberOfMethods 37)
		(numberOfParents 1)
		(numberOfStatements -37)
		(totalNumberOfChildren 0)
		(weightedMethodCount -37))
	(FAMIX.Invocation (id: 3926)
		(receiver (ref: 2704))
		(sender (ref: 611))
		(signature ''match:(Object)'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Invocation (id: 3927)
		(receiver (ref: 41))
		(sender (ref: 468))
		(signature ''with:(Object)'')
		(sourceAnchor (ref: 1364)))
	(FAMIX.Invocation (id: 3928)
		(receiver (ref: 3929))
		(sender (ref: 672))
		(signature ''copy()'')
		(sourceAnchor (ref: 673)))
	(FAMIX.Reference (id: 3930)
		(source (ref: 32))
		(sourceAnchor (ref: 33))
		(target (ref: 1091)))
	(FAMIX.Access (id: 3931)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 2266)))
	(FAMIX.Access (id: 3932)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 2911)))
	(FAMIX.Comment (id: 3933)
		(container (ref: 195))
		(content ''"We take the first class, not perfect, but it should be enough for now"''))
	(FAMIX.Class (id: 2896)
		(name ''Time class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.LocalVariable (id: 3826)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 173)))
	(FAMIX.Invocation (id: 3934)
		(sender (ref: 1650))
		(signature ''detect:(Object)'')
		(sourceAnchor (ref: 1651)))
	(FAMIX.Invocation (id: 3935)
		(sender (ref: 1645))
		(signature ''updateWindow()'')
		(sourceAnchor (ref: 2483)))
	(FAMIX.Access (id: 3936)
		(accessor (ref: 858))
		(sourceAnchor (ref: 859))
		(variable (ref: 3937)))
	(FAMIX.Invocation (id: 3938)
		(receiver (ref: 41))
		(sender (ref: 1189))
		(signature ''new()'')
		(sourceAnchor (ref: 1190)))
	(FAMIX.Access (id: 3939)
		(accessor (ref: 388))
		(sourceAnchor (ref: 389))
		(variable (ref: 2196)))
	(FAMIX.Parameter (id: 3940)
		(name ''toGlobal'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Method (id: 1426)
		(name ''getRenderedForm'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''getRenderedForm'')
		(sourceAnchor (ref: 1591)))
	(FAMIX.Invocation (id: 3941)
		(receiver (ref: 1814))
		(sender (ref: 84))
		(signature ''root()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 3942)
		(receiver (ref: 818))
		(sender (ref: 819))
		(signature ''setIfNilFromPositions:(Object)'')
		(sourceAnchor (ref: 2290)))
	(FAMIX.Access (id: 3943)
		(accessor (ref: 232))
		(sourceAnchor (ref: 234))
		(variable (ref: 3944)))
	(FAMIX.Access (id: 3945)
		(accessor (ref: 1761))
		(sourceAnchor (ref: 1762))
		(variable (ref: 1959)))
	(FAMIX.Invocation (id: 3946)
		(receiver (ref: 3078))
		(sender (ref: 1397))
		(signature ''paintImage:at:(Object,Object)'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Invocation (id: 3947)
		(receiver (ref: 826))
		(sender (ref: 827))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 1301)))
	(FAMIX.Access (id: 3948)
		(accessor (ref: 3550))
		(sourceAnchor (ref: 3551))
		(variable (ref: 1161)))
	(FAMIX.LocalVariable (id: 209)
		(name ''keys'')
		(parentBehaviouralEntity (ref: 207)))
	(FAMIX.Access (id: 3949)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1904)))
	(FAMIX.Method (id: 1867)
		(name ''moY:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1427))
		(signature ''moY:'')
		(sourceAnchor (ref: 1868)))
	(FAMIX.Access (id: 3950)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 2864)))
	(FAMIX.Access (id: 3951)
		(accessor (ref: 3044))
		(sourceAnchor (ref: 3045))
		(variable (ref: 181)))
	(FAMIX.Comment (id: 3952)
		(container (ref: 408))
		(content ''"Answer the element at aPoint or evaluate aBlock if none. Note that this implementation assumes that children are always fully contained within their owner and is therefore very efficient."''))
	(FAMIX.Invocation (id: 3953)
		(receiver (ref: 3954))
		(sender (ref: 1761))
		(signature ''value()'')
		(sourceAnchor (ref: 1762)))
	(FAMIX.Invocation (id: 3955)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 3956)
		(accessor (ref: 848))
		(isWrite true)
		(sourceAnchor (ref: 2968))
		(variable (ref: 445)))
	(FAMIX.Access (id: 3957)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 1685)))
	(FAMIX.Invocation (id: 3958)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''shape()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Reference (id: 3959)
		(source (ref: 304))
		(sourceAnchor (ref: 305))
		(target (ref: 211)))
	(FAMIX.Comment (id: 3960)
		(container (ref: 1393))
		(content ''"True if metrics are cached"''))
	(FAMIX.Invocation (id: 3961)
		(sender (ref: 39))
		(signature ''copy()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.LocalVariable (id: 534)
		(name ''max'')
		(parentBehaviouralEntity (ref: 374)))
	(FAMIX.Invocation (id: 3962)
		(receiver (ref: 3405))
		(sender (ref: 437))
		(signature ''popup()'')
		(sourceAnchor (ref: 438)))
	(FAMIX.Invocation (id: 3963)
		(sender (ref: 275))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Invocation (id: 3964)
		(receiver (ref: 1306))
		(sender (ref: 374))
		(signature ''infinity()'')
		(sourceAnchor (ref: 375)))
	(FAMIX.Method (id: 1851)
		(name ''gridLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''gridLayout'')
		(sourceAnchor (ref: 1852)))
	(FAMIX.Invocation (id: 3965)
		(receiver (ref: 863))
		(sender (ref: 207))
		(signature ''scaleElement:by:(Object,Object)'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Invocation (id: 3966)
		(sender (ref: 929))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Method (id: 752)
		(name ''popup:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''popup:'')
		(sourceAnchor (ref: 3634)))
	(FAMIX.Invocation (id: 3967)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 3968)
		(receiver (ref: 41))
		(sender (ref: 638))
		(signature ''new()'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Invocation (id: 3969)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''owner()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 3970)
		(accessor (ref: 159))
		(sourceAnchor (ref: 160))
		(variable (ref: 158)))
	(FAMIX.Method (id: 1499)
		(name ''resetInteraction'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''resetInteraction'')
		(sourceAnchor (ref: 1500)))
	(FAMIX.Invocation (id: 3971)
		(receiver (ref: 582))
		(sender (ref: 884))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1611)))
	(FAMIX.Comment (id: 3972)
		(container (ref: 256))
		(content ''"For compatibility, used in layouts"''))
	(FAMIX.Parameter (id: 3973)
		(name ''anElementNode'')
		(parentBehaviouralEntity (ref: 1666)))
	(FAMIX.Invocation (id: 3974)
		(receiver (ref: 852))
		(sender (ref: 20))
		(signature ''<(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 3975)
		(accessor (ref: 35))
		(isWrite true)
		(sourceAnchor (ref: 36))
		(variable (ref: 1323)))
	(FAMIX.Invocation (id: 3976)
		(sender (ref: 478))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Method (id: 327)
		(name ''translateBy:bounded:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 27)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''translateBy:bounded:'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Method (id: 207)
		(name ''scaleBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 12)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''scaleBy:'')
		(sourceAnchor (ref: 208)))
	(FAMIX.LocalVariable (id: 2519)
		(name ''l'')
		(parentBehaviouralEntity (ref: 368)))
	(FAMIX.Invocation (id: 3977)
		(receiver (ref: 3681))
		(sender (ref: 1269))
		(signature ''defaultAnnouncer()'')
		(sourceAnchor (ref: 1270)))
	(FAMIX.Invocation (id: 3978)
		(receiver (ref: 1698))
		(sender (ref: 785))
		(signature ''elementsToLookup()'')
		(sourceAnchor (ref: 786)))
	(FAMIX.Method (id: 963)
		(name ''nodeShape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodeShape'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Invocation (id: 3979)
		(sender (ref: 268))
		(signature ''setModel:(Object)'')
		(sourceAnchor (ref: 269)))
	(FAMIX.Reference (id: 3980)
		(source (ref: 1110))
		(sourceAnchor (ref: 1111))
		(target (ref: 3719)))
	(FAMIX.Invocation (id: 3981)
		(receiver (ref: 3401))
		(sender (ref: 1349))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1350)))
	(FAMIX.LocalVariable (id: 1402)
		(name ''ass'')
		(parentBehaviouralEntity (ref: 516)))
	(FAMIX.Access (id: 3982)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2439)))
	(FAMIX.Reference (id: 3983)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 3984)
		(accessor (ref: 1503))
		(sourceAnchor (ref: 1504))
		(variable (ref: 3985)))
	(FAMIX.Invocation (id: 3986)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 3987)
		(sender (ref: 61))
		(signature ''keys()'')
		(sourceAnchor (ref: 62)))
	(FAMIX.Comment (id: 3988)
		(container (ref: 2778))
		(content ''"Answer the underlying model of this element."''))
	(FAMIX.Invocation (id: 3989)
		(receiver (ref: 1175))
		(sender (ref: 264))
		(signature ''setOwner:(Object)'')
		(sourceAnchor (ref: 265)))
	(FAMIX.Invocation (id: 3990)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''applyLayout()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 3991)
		(accessor (ref: 658))
		(isWrite true)
		(sourceAnchor (ref: 659))
		(variable (ref: 1904)))
	(FAMIX.Access (id: 3992)
		(accessor (ref: 1519))
		(sourceAnchor (ref: 1520))
		(variable (ref: 768)))
	(FAMIX.Parameter (id: 2211)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 2209)))
	(FAMIX.Access (id: 3993)
		(accessor (ref: 912))
		(sourceAnchor (ref: 913))
		(variable (ref: 3150)))
	(FAMIX.Method (id: 1777)
		(name ''domain'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''domain'')
		(sourceAnchor (ref: 1778)))
	(FAMIX.Access (id: 3994)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 1979)))
	(FAMIX.Method (id: 189)
		(name ''resetCacheResursively'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetCacheResursively'')
		(sourceAnchor (ref: 336)))
	(FAMIX.Access (id: 3995)
		(accessor (ref: 1397))
		(sourceAnchor (ref: 1398))
		(variable (ref: 3078)))
	(FAMIX.Parameter (id: 3996)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 676)))
	(FAMIX.Invocation (id: 3997)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''blue()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.LocalVariable (id: 2666)
		(name ''each'')
		(parentBehaviouralEntity (ref: 99)))
	(FAMIX.Access (id: 3998)
		(accessor (ref: 894))
		(isWrite true)
		(sourceAnchor (ref: 895))
		(variable (ref: 3203)))
	(FAMIX.Access (id: 3999)
		(accessor (ref: 200))
		(sourceAnchor (ref: 201))
		(variable (ref: 702)))
	(FAMIX.Access (id: 4000)
		(accessor (ref: 661))
		(sourceAnchor (ref: 662))
		(variable (ref: 4001)))
	(FAMIX.Invocation (id: 4002)
		(receiver (ref: 512))
		(sender (ref: 169))
		(signature ''fromPositions:(Object)'')
		(sourceAnchor (ref: 171)))
	(FAMIX.Access (id: 4003)
		(accessor (ref: 271))
		(isWrite true)
		(sourceAnchor (ref: 272))
		(variable (ref: 1432)))
	(FAMIX.Invocation (id: 4004)
		(sender (ref: 368))
		(signature ''copyWithout:(Object)'')
		(sourceAnchor (ref: 369)))
	(FAMIX.Invocation (id: 4005)
		(receiver (ref: 1910))
		(sender (ref: 1820))
		(signature ''asSeconds()'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Parameter (id: 3622)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1650)))
	(FAMIX.Comment (id: 4006)
		(container (ref: 827))
		(content ''"Copy the shape of the receiver and evaluates the block with the copy as argument"''))
	(FAMIX.Access (id: 4007)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 1296)))
	(FAMIX.Method (id: 248)
		(name ''forNode:do:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 6)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 33)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''forNode:do:'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Method (id: 2034)
		(name ''localEdges:from:to:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 4)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''localEdges:from:to:using:'')
		(sourceAnchor (ref: 2155)))
	(FAMIX.Access (id: 4008)
		(accessor (ref: 1967))
		(sourceAnchor (ref: 1968))
		(variable (ref: 4009)))
	(FAMIX.Access (id: 4010)
		(accessor (ref: 756))
		(isWrite true)
		(sourceAnchor (ref: 757))
		(variable (ref: 954)))
	(FAMIX.Invocation (id: 4011)
		(receiver (ref: 3196))
		(sender (ref: 493))
		(signature ''allSubclasses()'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Access (id: 4012)
		(accessor (ref: 2))
		(sourceAnchor (ref: 1619))
		(variable (ref: 3050)))
	(FAMIX.Invocation (id: 4013)
		(receiver (ref: 1833))
		(sender (ref: 1831))
		(signature ''attributes()'')
		(sourceAnchor (ref: 1832)))
	(FAMIX.Access (id: 4014)
		(accessor (ref: 1155))
		(sourceAnchor (ref: 1156))
		(variable (ref: 4015)))
	(FAMIX.Invocation (id: 4016)
		(receiver (ref: 4017))
		(sender (ref: 1550))
		(signature ''deselect()'')
		(sourceAnchor (ref: 1551)))
	(FAMIX.Method (id: 560)
		(name ''decreaseZoomBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''decreaseZoomBy:'')
		(sourceAnchor (ref: 561)))
	(FAMIX.Parameter (id: 2245)
		(name ''anAnnouncer'')
		(parentBehaviouralEntity (ref: 2243)))
	(FAMIX.Method (id: 4018)
		(name ''pink'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 1385))
		(signature ''pink'')
		(sourceAnchor (ref: 4019)))
	(FAMIX.Access (id: 4020)
		(accessor (ref: 596))
		(isWrite true)
		(sourceAnchor (ref: 2775))
		(variable (ref: 113)))
	(FAMIX.Invocation (id: 4021)
		(sender (ref: 20))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Invocation (id: 4022)
		(receiver (ref: 512))
		(sender (ref: 426))
		(signature ''isFormsShape()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Invocation (id: 4023)
		(sender (ref: 516))
		(signature ''shape()'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Access (id: 4024)
		(accessor (ref: 1056))
		(sourceAnchor (ref: 1057))
		(variable (ref: 445)))
	(FAMIX.Access (id: 4025)
		(accessor (ref: 707))
		(sourceAnchor (ref: 708))
		(variable (ref: 2008)))
	(FAMIX.Parameter (id: 4026)
		(name ''aGraph'')
		(parentBehaviouralEntity (ref: 4027)))
	(FAMIX.Invocation (id: 4028)
		(receiver (ref: 1460))
		(sender (ref: 1458))
		(signature ''announcer()'')
		(sourceAnchor (ref: 1459)))
	(FAMIX.Access (id: 4029)
		(accessor (ref: 1298))
		(sourceAnchor (ref: 1299))
		(variable (ref: 3361)))
	(FAMIX.Method (id: 3187)
		(name ''root:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''root:'')
		(sourceAnchor (ref: 3188)))
	(FAMIX.Invocation (id: 4030)
		(sender (ref: 207))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 208)))
	(FAMIX.LocalVariable (id: 250)
		(name ''node'')
		(parentBehaviouralEntity (ref: 248)))
	(FAMIX.Access (id: 4031)
		(accessor (ref: 514))
		(sourceAnchor (ref: 2063))
		(variable (ref: 2062)))
	(FAMIX.Invocation (id: 4032)
		(receiver (ref: 2864))
		(sender (ref: 275))
		(signature ''edges()'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Invocation (id: 4033)
		(receiver (ref: 3466))
		(sender (ref: 703))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 704)))
	(FAMIX.Access (id: 4034)
		(accessor (ref: 1720))
		(sourceAnchor (ref: 1721))
		(variable (ref: 1722)))
	(FAMIX.Invocation (id: 4035)
		(receiver (ref: 3652))
		(sender (ref: 2796))
		(signature ''applyLayout()'')
		(sourceAnchor (ref: 2797)))
	(FAMIX.Access (id: 4036)
		(accessor (ref: 529))
		(sourceAnchor (ref: 530))
		(variable (ref: 3872)))
	(FAMIX.Parameter (id: 2271)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 2269)))
	(FAMIX.Access (id: 4037)
		(accessor (ref: 929))
		(sourceAnchor (ref: 930))
		(variable (ref: 977)))
	(FAMIX.LocalVariable (id: 1749)
		(name ''newRelativePosition'')
		(parentBehaviouralEntity (ref: 327)))
	(FAMIX.Invocation (id: 4038)
		(receiver (ref: 1584))
		(sender (ref: 1582))
		(signature ''nodesDo:(Object)'')
		(sourceAnchor (ref: 1583)))
	(FAMIX.Invocation (id: 4039)
		(receiver (ref: 1957))
		(sender (ref: 1559))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 1560)))
	(FAMIX.Access (id: 4040)
		(accessor (ref: 212))
		(isWrite true)
		(sourceAnchor (ref: 213))
		(variable (ref: 122)))
	(FAMIX.Access (id: 4041)
		(accessor (ref: 1309))
		(sourceAnchor (ref: 1310))
		(variable (ref: 263)))
	(FAMIX.Method (id: 1215)
		(name ''setDefaultHandlers'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''setDefaultHandlers'')
		(sourceAnchor (ref: 1216)))
	(FAMIX.Method (id: 615)
		(name ''isCacheLoaded'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''isCacheLoaded'')
		(sourceAnchor (ref: 616)))
	(FAMIX.Access (id: 4042)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 521)))
	(FAMIX.Comment (id: 4043)
		(container (ref: 493))
		(content ''"Return the default line shape"''))
	(FAMIX.Access (id: 4044)
		(accessor (ref: 1491))
		(sourceAnchor (ref: 1598))
		(variable (ref: 1490)))
	(FAMIX.Access (id: 4045)
		(accessor (ref: 1519))
		(sourceAnchor (ref: 1520))
		(variable (ref: 2451)))
	(FAMIX.Invocation (id: 4046)
		(receiver (ref: 2088))
		(sender (ref: 1080))
		(signature ''target()'')
		(sourceAnchor (ref: 1081)))
	(FAMIX.Invocation (id: 4047)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''purple()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.LocalVariable (id: 2615)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 2616)))
	(FAMIX.Access (id: 4048)
		(accessor (ref: 309))
		(sourceAnchor (ref: 310))
		(variable (ref: 4049)))
	(FAMIX.Access (id: 4050)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 1749)))
	(FAMIX.Invocation (id: 4051)
		(receiver (ref: 246))
		(sender (ref: 13))
		(signature ''origin()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 4052)
		(receiver (ref: 1497))
		(sender (ref: 1055))
		(signature ''elementAt:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1496)))
	(FAMIX.Invocation (id: 4053)
		(receiver (ref: 239))
		(sender (ref: 237))
		(signature ''key()'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Invocation (id: 4054)
		(sender (ref: 644))
		(signature ''nodeForDomainValue:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 645)))
	(FAMIX.Invocation (id: 4055)
		(receiver (ref: 1058))
		(sender (ref: 819))
		(signature ''edgesDo:(Object)'')
		(sourceAnchor (ref: 2290)))
	(FAMIX.Invocation (id: 4056)
		(receiver (ref: 75))
		(sender (ref: 76))
		(signature ''gray()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 4057)
		(accessor (ref: 1676))
		(sourceAnchor (ref: 1677))
		(variable (ref: 3310)))
	(FAMIX.Access (id: 4058)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 547)))
	(FAMIX.Invocation (id: 4059)
		(receiver (ref: 4060))
		(sender (ref: 465))
		(signature ''nodes:forEach:(Object,Object)'')
		(sourceAnchor (ref: 466)))
	(FAMIX.Method (id: 1435)
		(name ''increaseZoom'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''increaseZoom'')
		(sourceAnchor (ref: 1436)))
	(FAMIX.Invocation (id: 4061)
		(receiver (ref: 203))
		(sender (ref: 204))
		(signature ''root()'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Invocation (id: 4062)
		(receiver (ref: 812))
		(sender (ref: 1984))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 1985)))
	(FAMIX.Access (id: 4063)
		(accessor (ref: 212))
		(sourceAnchor (ref: 213))
		(variable (ref: 3705)))
	(FAMIX.Invocation (id: 4064)
		(sender (ref: 443))
		(signature ''extent()'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Class (id: 2071)
		(name ''MOMorphPainterVisitor class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 4065)
		(accessor (ref: 1757))
		(sourceAnchor (ref: 1758))
		(variable (ref: 865)))
	(FAMIX.Access (id: 4066)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 3205)))
	(FAMIX.Method (id: 1491)
		(name ''deselect:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''deselect:'')
		(sourceAnchor (ref: 1598)))
	(FAMIX.Access (id: 4067)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 1212)))
	(FAMIX.Invocation (id: 4068)
		(receiver (ref: 1329))
		(sender (ref: 693))
		(signature ''expandForEvent:(Object)'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Access (id: 4069)
		(accessor (ref: 2203))
		(sourceAnchor (ref: 2760))
		(variable (ref: 2202)))
	(FAMIX.Reference (id: 4070)
		(source (ref: 4071))
		(sourceAnchor (ref: 4072))
		(target (ref: 322)))
	(FAMIX.Method (id: 910)
		(name ''isDefaultLineShape'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isDefaultLineShape'')
		(sourceAnchor (ref: 4073)))
	(FAMIX.Access (id: 4074)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2439)))
	(FAMIX.Method (id: 2512)
		(name ''selectionBoxCorner2'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''selectionBoxCorner2'')
		(sourceAnchor (ref: 2513)))
	(FAMIX.Access (id: 4075)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 1268)))
	(FAMIX.Access (id: 4076)
		(accessor (ref: 1582))
		(sourceAnchor (ref: 1583))
		(variable (ref: 1584)))
	(FAMIX.Method (id: 4077)
		(name ''isNode'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''isNode'')
		(sourceAnchor (ref: 4078)))
	(FAMIX.Access (id: 4079)
		(accessor (ref: 1855))
		(sourceAnchor (ref: 1856))
		(variable (ref: 2681)))
	(FAMIX.Access (id: 4080)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 3901)))
	(FAMIX.Method (id: 1181)
		(name ''hasSelectedNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''hasSelectedNodes'')
		(sourceAnchor (ref: 1182)))
	(FAMIX.Parameter (id: 3050)
		(name ''oneArgBlock'')
		(parentBehaviouralEntity (ref: 2)))
	(FAMIX.Access (id: 4081)
		(accessor (ref: 1709))
		(sourceAnchor (ref: 1710))
		(variable (ref: 3468)))
	(FAMIX.Invocation (id: 4082)
		(receiver (ref: 280))
		(sender (ref: 20))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 4083)
		(accessor (ref: 644))
		(sourceAnchor (ref: 645))
		(variable (ref: 3214)))
	(FAMIX.Access (id: 4084)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 12)))
	(FAMIX.Invocation (id: 4085)
		(receiver (ref: 4086))
		(sender (ref: 627))
		(signature ''withAllNodesDo:(Object)'')
		(sourceAnchor (ref: 628)))
	(FAMIX.Access (id: 4087)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 1816)))
	(FAMIX.Invocation (id: 4088)
		(receiver (ref: 1119))
		(sender (ref: 1050))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1051)))
	(FAMIX.Invocation (id: 4089)
		(receiver (ref: 2384))
		(sender (ref: 993))
		(signature ''allEdgesConnectedTo:(Object)'')
		(sourceAnchor (ref: 994)))
	(FAMIX.Class (id: 1376)
		(name ''Rectangle'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 19)
		(numberOfMethods 7)
		(numberOfParents 0)
		(numberOfStatements -7)
		(totalNumberOfChildren 0)
		(weightedMethodCount -7))
	(FAMIX.Invocation (id: 4090)
		(receiver (ref: 329))
		(sender (ref: 327))
		(signature ''translateAbsoluteCacheBy:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Invocation (id: 4091)
		(receiver (ref: 322))
		(sender (ref: 4071))
		(signature ''defaultNodeShapeClass()'')
		(sourceAnchor (ref: 4072)))
	(FAMIX.Access (id: 4092)
		(accessor (ref: 1050))
		(sourceAnchor (ref: 1051))
		(variable (ref: 2932)))
	(FAMIX.Invocation (id: 4093)
		(receiver (ref: 2464))
		(sender (ref: 1451))
		(signature ''corner()'')
		(sourceAnchor (ref: 1452)))
	(FAMIX.Access (id: 4094)
		(accessor (ref: 938))
		(sourceAnchor (ref: 939))
		(variable (ref: 2873)))
	(FAMIX.Access (id: 4095)
		(accessor (ref: 408))
		(sourceAnchor (ref: 1241))
		(variable (ref: 2591)))
	(FAMIX.Method (id: 252)
		(name ''height:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''height:'')
		(sourceAnchor (ref: 1659)))
	(FAMIX.Access (id: 4096)
		(accessor (ref: 232))
		(sourceAnchor (ref: 234))
		(variable (ref: 3944)))
	(FAMIX.Comment (id: 4097)
		(container (ref: 408))
		(content ''"we do not call elementsToDisplay since its content may have been modified because of the cache"''))
	(FAMIX.Access (id: 4098)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1016)))
	(FAMIX.Method (id: 1388)
		(name ''heightFor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isAbstract true)
		(isPublic true)
		(modifiers ''isAbstract'' ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''heightFor:'')
		(sourceAnchor (ref: 1622)))
	(FAMIX.Invocation (id: 4099)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 4100)
		(accessor (ref: 737))
		(sourceAnchor (ref: 2974))
		(variable (ref: 2604)))
	(FAMIX.Access (id: 4101)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 246)))
	(FAMIX.Invocation (id: 4102)
		(receiver (ref: 883))
		(sender (ref: 884))
		(signature ''nodes()'')
		(sourceAnchor (ref: 1611)))
	(FAMIX.Method (id: 95)
		(name ''edges:from:toAll:using:fromGlobal:toGlobal:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 21)
		(numberOfParameters 6)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:toAll:using:fromGlobal:toGlobal:'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Invocation (id: 4103)
		(sender (ref: 443))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 4104)
		(accessor (ref: 993))
		(sourceAnchor (ref: 994))
		(variable (ref: 1416)))
	(FAMIX.Invocation (id: 4105)
		(receiver (ref: 1384))
		(sender (ref: 275))
		(signature ''incomingEdges()'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Invocation (id: 4106)
		(sender (ref: 410))
		(signature ''center()'')
		(sourceAnchor (ref: 411)))
	(FAMIX.Method (id: 644)
		(name ''nodeForDomainValue:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodeForDomainValue:ifAbsent:'')
		(sourceAnchor (ref: 645)))
	(FAMIX.Access (id: 4107)
		(accessor (ref: 934))
		(isWrite true)
		(sourceAnchor (ref: 935))
		(variable (ref: 1034)))
	(FAMIX.Invocation (id: 4108)
		(receiver (ref: 2006))
		(sender (ref: 473))
		(signature ''value()'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Invocation (id: 4109)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''owner()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 4110)
		(receiver (ref: 977))
		(sender (ref: 929))
		(signature ''allOutcomingEdges()'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Invocation (id: 4111)
		(receiver (ref: 2169))
		(sender (ref: 963))
		(signature ''defaultNodeShapeInstance()'')
		(sourceAnchor (ref: 964)))
	(FAMIX.LocalVariable (id: 629)
		(name ''coll'')
		(parentBehaviouralEntity (ref: 627)))
	(FAMIX.Reference (id: 4112)
		(source (ref: 1246))
		(sourceAnchor (ref: 1247))
		(target (ref: 633)))
	(FAMIX.Invocation (id: 4113)
		(receiver (ref: 1600))
		(sender (ref: 13))
		(signature ''resetFormCacheResursively()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 4114)
		(accessor (ref: 932))
		(sourceAnchor (ref: 1893))
		(variable (ref: 2458)))
	(FAMIX.Invocation (id: 4115)
		(sender (ref: 20))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 4116)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Invocation (id: 4117)
		(receiver (ref: 41))
		(sender (ref: 76))
		(signature ''new()'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 4118)
		(sender (ref: 108))
		(signature ''withoutBorder()'')
		(sourceAnchor (ref: 109)))
	(FAMIX.Access (id: 4119)
		(accessor (ref: 368))
		(sourceAnchor (ref: 369))
		(variable (ref: 2519)))
	(FAMIX.Access (id: 4120)
		(accessor (ref: 1446))
		(sourceAnchor (ref: 1447))
		(variable (ref: 1445)))
	(FAMIX.Invocation (id: 4121)
		(receiver (ref: 428))
		(sender (ref: 35))
		(signature ''height()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Reference (id: 4122)
		(source (ref: 658))
		(sourceAnchor (ref: 659))
		(target (ref: 3224)))
	(FAMIX.LocalVariable (id: 717)
		(name ''each'')
		(parentBehaviouralEntity (ref: 69)))
	(FAMIX.Access (id: 4123)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 2323)))
	(FAMIX.Access (id: 4124)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 2530)))
	(FAMIX.Invocation (id: 4125)
		(sender (ref: 478))
		(signature ''==(Object)'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Access (id: 4126)
		(accessor (ref: 1629))
		(sourceAnchor (ref: 2906))
		(variable (ref: 1628)))
	(FAMIX.LocalVariable (id: 4127)
		(name ''b'')
		(parentBehaviouralEntity (ref: 497)))
	(FAMIX.Comment (id: 4128)
		(container (ref: 4))
		(content ''"Select the element. A selection box will surround the node"''))
	(FAMIX.Invocation (id: 4129)
		(sender (ref: 938))
		(signature ''ifNotNilDo:(Object)'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Invocation (id: 4130)
		(receiver (ref: 1177))
		(sender (ref: 318))
		(signature ''increaseZoomBy:(Object)'')
		(sourceAnchor (ref: 319)))
	(FAMIX.Invocation (id: 4131)
		(sender (ref: 1272))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 1273)))
	(FAMIX.Access (id: 4132)
		(accessor (ref: 443))
		(sourceAnchor (ref: 444))
		(variable (ref: 2573)))
	(FAMIX.Invocation (id: 4133)
		(sender (ref: 866))
		(signature ''zOrder()'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Access (id: 4134)
		(accessor (ref: 676))
		(sourceAnchor (ref: 677))
		(variable (ref: 675)))
	(FAMIX.Access (id: 4135)
		(accessor (ref: 149))
		(sourceAnchor (ref: 150))
		(variable (ref: 4136)))
	(FAMIX.Parameter (id: 1927)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 644)))
	(FAMIX.Access (id: 4137)
		(accessor (ref: 433))
		(sourceAnchor (ref: 434))
		(variable (ref: 1741)))
	(FAMIX.LocalVariable (id: 2717)
		(name ''node'')
		(parentBehaviouralEntity (ref: 1967)))
	(FAMIX.Reference (id: 4138)
		(source (ref: 212))
		(sourceAnchor (ref: 213))
		(target (ref: 211)))
	(FAMIX.Method (id: 224)
		(name ''nodes:using:forEach:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 12)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodes:using:forEach:'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Invocation (id: 4139)
		(receiver (ref: 1098))
		(sender (ref: 1096))
		(signature ''translateBy:(Object)'')
		(sourceAnchor (ref: 1097)))
	(FAMIX.Access (id: 4140)
		(accessor (ref: 124))
		(isWrite true)
		(sourceAnchor (ref: 125))
		(variable (ref: 126)))
	(FAMIX.Invocation (id: 4141)
		(sender (ref: 159))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 160)))
	(FAMIX.LocalVariable (id: 1649)
		(name ''each'')
		(parentBehaviouralEntity (ref: 1650)))
	(FAMIX.Parameter (id: 4142)
		(name ''collection'')
		(parentBehaviouralEntity (ref: 2726)))
	(FAMIX.Comment (id: 4143)
		(container (ref: 2964))
		(content ''"Disable metric caches"''))
	(FAMIX.Invocation (id: 4144)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Method (id: 102)
		(name ''translateAbsoluteCacheBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''translateAbsoluteCacheBy:'')
		(sourceAnchor (ref: 103)))
	(FAMIX.Invocation (id: 4145)
		(sender (ref: 473))
		(signature ''isCached()'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Parameter (id: 4146)
		(name ''aGraphElement'')
		(parentBehaviouralEntity (ref: 1984)))
	(FAMIX.Access (id: 4147)
		(accessor (ref: 95))
		(isWrite true)
		(sourceAnchor (ref: 96))
		(variable (ref: 2081)))
	(FAMIX.Invocation (id: 4148)
		(receiver (ref: 3576))
		(sender (ref: 1469))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1470)))
	(FAMIX.LocalVariable (id: 175)
		(name ''each'')
		(parentBehaviouralEntity (ref: 173)))
	(FAMIX.Invocation (id: 4149)
		(sender (ref: 204))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Method (id: 1855)
		(name ''scaleElement:by:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''scaleElement:by:'')
		(sourceAnchor (ref: 1856)))
	(FAMIX.Access (id: 4150)
		(accessor (ref: 770))
		(sourceAnchor (ref: 771))
		(variable (ref: 3274)))
	(FAMIX.Reference (id: 4151)
		(source (ref: 253))
		(sourceAnchor (ref: 254))
		(target (ref: 322)))
	(FAMIX.Access (id: 4152)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1045)))
	(FAMIX.Method (id: 2710)
		(name ''isNotRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''isNotRoot'')
		(sourceAnchor (ref: 2711)))
	(FAMIX.Method (id: 3869)
		(name ''target'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''target'')
		(sourceAnchor (ref: 3870)))
	(FAMIX.Comment (id: 4153)
		(container (ref: 248))
		(content ''"	node allEdgesDo: #resetCache. 
	node owner updateBounds.
	node nodes copy do: #remove.
"''))
	(FAMIX.Invocation (id: 4154)
		(receiver (ref: 1955))
		(sender (ref: 1104))
		(signature ''hasSelectionBox()'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Access (id: 4155)
		(accessor (ref: 290))
		(isWrite true)
		(sourceAnchor (ref: 291))
		(variable (ref: 3053)))
	(FAMIX.Access (id: 4156)
		(accessor (ref: 1901))
		(sourceAnchor (ref: 2321))
		(variable (ref: 2786)))
	(FAMIX.Access (id: 4157)
		(accessor (ref: 493))
		(sourceAnchor (ref: 494))
		(variable (ref: 2077)))
	(FAMIX.LocalVariable (id: 4158)
		(name ''each'')
		(parentBehaviouralEntity (ref: 465)))
	(FAMIX.Parameter (id: 4001)
		(name ''toGlobal'')
		(parentBehaviouralEntity (ref: 661)))
	(FAMIX.Access (id: 4159)
		(accessor (ref: 162))
		(sourceAnchor (ref: 163))
		(variable (ref: 3620)))
	(FAMIX.Method (id: 39)
		(name ''executeOnNode:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 18)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''executeOnNode:'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Parameter (id: 2572)
		(name ''aNumber'')
		(parentBehaviouralEntity (ref: 2187)))
	(FAMIX.Invocation (id: 4160)
		(receiver (ref: 977))
		(sender (ref: 929))
		(signature ''edgesDo:(Object)'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Invocation (id: 4161)
		(receiver (ref: 2439))
		(sender (ref: 248))
		(signature ''root()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Method (id: 487)
		(name ''edgeShape:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgeShape:'')
		(sourceAnchor (ref: 488)))
	(FAMIX.Method (id: 1820)
		(name ''shouldDeselect'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''shouldDeselect'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Access (id: 4162)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 2323)))
	(FAMIX.Invocation (id: 4163)
		(receiver (ref: 3102))
		(sender (ref: 761))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 762)))
	(FAMIX.Invocation (id: 4164)
		(receiver (ref: 1635))
		(sender (ref: 1555))
		(signature ''top()'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Access (id: 4165)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Access (id: 4166)
		(accessor (ref: 1143))
		(sourceAnchor (ref: 1144))
		(variable (ref: 2989)))
	(FAMIX.Method (id: 2243)
		(name ''setAnnouncer:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''setAnnouncer:'')
		(sourceAnchor (ref: 2244)))
	(FAMIX.Invocation (id: 4167)
		(sender (ref: 32))
		(signature ''on:do:(Object,Object)'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Comment (id: 4168)
		(container (ref: 505))
		(content ''"We display the subnodes"''))
	(FAMIX.LocalVariable (id: 2987)
		(name ''s'')
		(parentBehaviouralEntity (ref: 963)))
	(FAMIX.Invocation (id: 4169)
		(receiver (ref: 164))
		(sender (ref: 162))
		(signature ''edges()'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Access (id: 4170)
		(accessor (ref: 615))
		(sourceAnchor (ref: 616))
		(variable (ref: 971)))
	(FAMIX.Access (id: 4171)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Access (id: 4172)
		(accessor (ref: 4))
		(sourceAnchor (ref: 5))
		(variable (ref: 6)))
	(FAMIX.Access (id: 4173)
		(accessor (ref: 169))
		(sourceAnchor (ref: 171))
		(variable (ref: 961)))
	(FAMIX.Invocation (id: 4174)
		(receiver (ref: 1534))
		(sender (ref: 1354))
		(signature ''incomingEdges()'')
		(sourceAnchor (ref: 1355)))
	(FAMIX.Parameter (id: 2766)
		(name ''aGraph'')
		(parentBehaviouralEntity (ref: 2616)))
	(FAMIX.Access (id: 4175)
		(accessor (ref: 24))
		(sourceAnchor (ref: 25))
		(variable (ref: 26)))
	(FAMIX.Reference (id: 4176)
		(source (ref: 894))
		(sourceAnchor (ref: 895))
		(target (ref: 41)))
	(FAMIX.Access (id: 4177)
		(accessor (ref: 627))
		(sourceAnchor (ref: 628))
		(variable (ref: 2595)))
	(FAMIX.Comment (id: 4178)
		(container (ref: 4027))
		(content ''"Hook method"''))
	(FAMIX.Access (id: 4179)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Method (id: 602)
		(name ''edges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''edges'')
		(sourceAnchor (ref: 603)))
	(FAMIX.Access (id: 4180)
		(accessor (ref: 497))
		(sourceAnchor (ref: 2491))
		(variable (ref: 4127)))
	(FAMIX.Access (id: 4181)
		(accessor (ref: 516))
		(sourceAnchor (ref: 517))
		(variable (ref: 1402)))
	(FAMIX.Parameter (id: 226)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 224)))
	(FAMIX.Invocation (id: 4182)
		(receiver (ref: 181))
		(sender (ref: 801))
		(signature ''removeElementsToDisplay:(Object)'')
		(sourceAnchor (ref: 802)))
	(FAMIX.Access (id: 4183)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2439)))
	(FAMIX.Invocation (id: 4184)
		(sender (ref: 426))
		(signature ''applyOn:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Method (id: 315)
		(name ''from:to:'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''constructor'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''from:to:'')
		(sourceAnchor (ref: 869)))
	(FAMIX.Parameter (id: 3001)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 795)))
	(FAMIX.Invocation (id: 4185)
		(receiver (ref: 1016))
		(sender (ref: 48))
		(signature ''root()'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Access (id: 4186)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 2666)))
	(FAMIX.Parameter (id: 624)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 622)))
	(FAMIX.Parameter (id: 4187)
		(name ''anEdge'')
		(parentBehaviouralEntity (ref: 959)))
	(FAMIX.LocalVariable (id: 4188)
		(name ''each'')
		(parentBehaviouralEntity (ref: 723)))
	(FAMIX.Access (id: 4189)
		(accessor (ref: 2616))
		(sourceAnchor (ref: 2617))
		(variable (ref: 2615)))
	(FAMIX.LocalVariable (id: 2795)
		(name ''each'')
		(parentBehaviouralEntity (ref: 2796)))
	(FAMIX.Access (id: 4190)
		(accessor (ref: 324))
		(isWrite true)
		(sourceAnchor (ref: 325))
		(variable (ref: 1745)))
	(FAMIX.Invocation (id: 4191)
		(receiver (ref: 1084))
		(sender (ref: 1605))
		(signature ''new()'')
		(sourceAnchor (ref: 1606)))
	(FAMIX.Access (id: 4192)
		(accessor (ref: 672))
		(sourceAnchor (ref: 673))
		(variable (ref: 1899)))
	(FAMIX.Invocation (id: 4193)
		(receiver (ref: 1897))
		(sender (ref: 703))
		(signature ''new()'')
		(sourceAnchor (ref: 704)))
	(FAMIX.Access (id: 4194)
		(accessor (ref: 638))
		(sourceAnchor (ref: 639))
		(variable (ref: 3238)))
	(FAMIX.Invocation (id: 4195)
		(receiver (ref: 12))
		(sender (ref: 13))
		(signature ''height()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 4196)
		(accessor (ref: 774))
		(sourceAnchor (ref: 775))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 4197)
		(receiver (ref: 808))
		(sender (ref: 809))
		(signature ''edges:from:to:(Object,Object,Object)'')
		(sourceAnchor (ref: 810)))
	(FAMIX.Invocation (id: 4198)
		(receiver (ref: 231))
		(sender (ref: 229))
		(signature ''extent()'')
		(sourceAnchor (ref: 230)))
	(FAMIX.Reference (id: 4199)
		(source (ref: 2296))
		(sourceAnchor (ref: 2297))
		(target (ref: 2679)))
	(FAMIX.Access (id: 4200)
		(accessor (ref: 315))
		(sourceAnchor (ref: 869))
		(variable (ref: 2476)))
	(FAMIX.Access (id: 4201)
		(accessor (ref: 2778))
		(sourceAnchor (ref: 2779))
		(variable (ref: 2959)))
	(FAMIX.Access (id: 4202)
		(accessor (ref: 95))
		(isWrite true)
		(sourceAnchor (ref: 96))
		(variable (ref: 2954)))
	(FAMIX.Access (id: 4203)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 2449)))
	(FAMIX.Invocation (id: 4204)
		(sender (ref: 69))
		(signature ''corner:(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Access (id: 4205)
		(accessor (ref: 20))
		(isWrite true)
		(sourceAnchor (ref: 21))
		(variable (ref: 142)))
	(FAMIX.Invocation (id: 4206)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4207)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 793)))
	(FAMIX.Parameter (id: 4015)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 1155)))
	(FAMIX.Access (id: 4208)
		(accessor (ref: 2445))
		(sourceAnchor (ref: 2583))
		(variable (ref: 445)))
	(FAMIX.Parameter (id: 292)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 290)))
	(FAMIX.Invocation (id: 4209)
		(receiver (ref: 1047))
		(sender (ref: 224))
		(signature ''nodes:using:(Object,Object)'')
		(sourceAnchor (ref: 225)))
	(FAMIX.Access (id: 4210)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 641)))
	(FAMIX.Access (id: 4211)
		(accessor (ref: 108))
		(isWrite true)
		(sourceAnchor (ref: 109))
		(variable (ref: 67)))
	(FAMIX.Access (id: 4212)
		(accessor (ref: 900))
		(sourceAnchor (ref: 901))
		(variable (ref: 3347)))
	(FAMIX.Access (id: 4213)
		(accessor (ref: 707))
		(isWrite true)
		(sourceAnchor (ref: 708))
		(variable (ref: 2008)))
	(FAMIX.Method (id: 1724)
		(name ''hasSelection'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''hasSelection'')
		(sourceAnchor (ref: 1725)))
	(FAMIX.Parameter (id: 3228)
		(name ''object'')
		(parentBehaviouralEntity (ref: 275)))
	(FAMIX.Method (id: 1967)
		(name ''translateBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''translateBy:'')
		(sourceAnchor (ref: 1968)))
	(FAMIX.Access (id: 4214)
		(accessor (ref: 756))
		(sourceAnchor (ref: 757))
		(variable (ref: 1795)))
	(FAMIX.Parameter (id: 3166)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 1831)))
	(FAMIX.Access (id: 4215)
		(accessor (ref: 983))
		(isWrite true)
		(sourceAnchor (ref: 2388))
		(variable (ref: 1146)))
	(FAMIX.Invocation (id: 4216)
		(receiver (ref: 2024))
		(sender (ref: 1640))
		(signature ''new()'')
		(sourceAnchor (ref: 1641)))
	(FAMIX.Method (id: 969)
		(name ''cacheFromPoint'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''cacheFromPoint'')
		(sourceAnchor (ref: 970)))
	(FAMIX.Invocation (id: 4217)
		(receiver (ref: 1538))
		(sender (ref: 388))
		(signature ''ifEmpty:(Object)'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Parameter (id: 2029)
		(name ''aModel'')
		(parentBehaviouralEntity (ref: 204)))
	(FAMIX.Invocation (id: 4218)
		(receiver (ref: 4219))
		(sender (ref: 3133))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 3134)))
	(FAMIX.Parameter (id: 4220)
		(name ''symbols'')
		(parentBehaviouralEntity (ref: 1007)))
	(FAMIX.Invocation (id: 4221)
		(receiver (ref: 3238))
		(sender (ref: 638))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 639)))
	(FAMIX.LocalVariable (id: 649)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 354)))
	(FAMIX.Reference (id: 4222)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 4223)
		(accessor (ref: 426))
		(isWrite true)
		(sourceAnchor (ref: 577))
		(variable (ref: 425)))
	(FAMIX.Invocation (id: 4224)
		(receiver (ref: 1781))
		(sender (ref: 1218))
		(signature ''cache()'')
		(sourceAnchor (ref: 1219)))
	(FAMIX.Access (id: 4225)
		(accessor (ref: 689))
		(sourceAnchor (ref: 690))
		(variable (ref: 2353)))
	(FAMIX.Parameter (id: 3183)
		(name ''toGlobal'')
		(parentBehaviouralEntity (ref: 795)))
	(FAMIX.Invocation (id: 4226)
		(receiver (ref: 280))
		(sender (ref: 20))
		(signature ''isSymbol()'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Invocation (id: 4227)
		(sender (ref: 1309))
		(signature ''not()'')
		(sourceAnchor (ref: 1310)))
	(FAMIX.Method (id: 1055)
		(name ''elementAt:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''elementAt:'')
		(sourceAnchor (ref: 1496)))
	(FAMIX.Access (id: 4228)
		(accessor (ref: 388))
		(isWrite true)
		(sourceAnchor (ref: 389))
		(variable (ref: 1538)))
	(FAMIX.Parameter (id: 2004)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 374)))
	(FAMIX.Invocation (id: 4229)
		(sender (ref: 95))
		(signature ''resetElementsToDisplayCacheRecursively()'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Invocation (id: 4230)
		(receiver (ref: 4231))
		(sender (ref: 2577))
		(signature ''decreaseZoomBy:(Object)'')
		(sourceAnchor (ref: 2578)))
	(FAMIX.Access (id: 4232)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Access (id: 4233)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 2133)))
	(FAMIX.Invocation (id: 4234)
		(sender (ref: 878))
		(signature ''removeKey:(Object)'')
		(sourceAnchor (ref: 879)))
	(FAMIX.Method (id: 212)
		(name ''resetCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 8)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetCache'')
		(sourceAnchor (ref: 213)))
	(FAMIX.Access (id: 4235)
		(accessor (ref: 505))
		(sourceAnchor (ref: 506))
		(variable (ref: 512)))
	(FAMIX.Access (id: 4236)
		(accessor (ref: 2916))
		(sourceAnchor (ref: 2917))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 4237)
		(sender (ref: 69))
		(signature ''corner:(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 4238)
		(receiver (ref: 450))
		(sender (ref: 195))
		(signature ''anyOne()'')
		(sourceAnchor (ref: 197)))
	(FAMIX.Invocation (id: 4239)
		(receiver (ref: 42))
		(sender (ref: 43))
		(signature ''source()'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Invocation (id: 4240)
		(receiver (ref: 633))
		(sender (ref: 631))
		(signature ''defaultLineShapeInstance()'')
		(sourceAnchor (ref: 632)))
	(FAMIX.Invocation (id: 4241)
		(sender (ref: 658))
		(signature ''and:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Invocation (id: 4242)
		(receiver (ref: 4243))
		(sender (ref: 1237))
		(signature ''forNode:do:(Object,Object)'')
		(sourceAnchor (ref: 1791)))
	(FAMIX.Invocation (id: 4244)
		(receiver (ref: 2640))
		(sender (ref: 1085))
		(signature ''root()'')
		(sourceAnchor (ref: 1086)))
	(FAMIX.Parameter (id: 4245)
		(name ''element'')
		(parentBehaviouralEntity (ref: 761)))
	(FAMIX.Invocation (id: 4246)
		(receiver (ref: 366))
		(sender (ref: 364))
		(signature ''nodes()'')
		(sourceAnchor (ref: 365)))
	(FAMIX.Invocation (id: 4247)
		(receiver (ref: 379))
		(sender (ref: 377))
		(signature ''root()'')
		(sourceAnchor (ref: 378)))
	(FAMIX.Invocation (id: 4248)
		(receiver (ref: 2006))
		(sender (ref: 473))
		(signature ''value()'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Access (id: 4249)
		(accessor (ref: 2034))
		(sourceAnchor (ref: 2155))
		(variable (ref: 4250)))
	(FAMIX.Invocation (id: 4251)
		(sender (ref: 443))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Invocation (id: 4252)
		(receiver (ref: 385))
		(sender (ref: 20))
		(signature ''size()'')
		(sourceAnchor (ref: 21)))
	(FAMIX.LocalVariable (id: 2954)
		(name ''target'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Method (id: 2661)
		(name ''horizontalLineLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''horizontalLineLayout'')
		(sourceAnchor (ref: 2662)))
	(FAMIX.Access (id: 4253)
		(accessor (ref: 1189))
		(sourceAnchor (ref: 1190))
		(variable (ref: 3018)))
	(FAMIX.Invocation (id: 4254)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Invocation (id: 4255)
		(receiver (ref: 393))
		(sender (ref: 391))
		(signature ''select()'')
		(sourceAnchor (ref: 392)))
	(FAMIX.Parameter (id: 1613)
		(name ''aValue'')
		(parentBehaviouralEntity (ref: 560)))
	(FAMIX.Parameter (id: 2706)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Access (id: 4256)
		(accessor (ref: 912))
		(sourceAnchor (ref: 913))
		(variable (ref: 1410)))
	(FAMIX.Comment (id: 4257)
		(container (ref: 932))
		(content ''"self edges do: [:edge | edge resetFormCacheResursively]."''))
	(FAMIX.Invocation (id: 4258)
		(receiver (ref: 158))
		(sender (ref: 159))
		(signature ''propertyValueAt:put:(Object,Object)'')
		(sourceAnchor (ref: 160)))
	(FAMIX.LocalVariable (id: 922)
		(name ''sorted'')
		(parentBehaviouralEntity (ref: 221)))
	(FAMIX.Invocation (id: 4259)
		(receiver (ref: 280))
		(sender (ref: 20))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Invocation (id: 4260)
		(receiver (ref: 412))
		(sender (ref: 410))
		(signature ''bounds()'')
		(sourceAnchor (ref: 411)))
	(FAMIX.Access (id: 4261)
		(accessor (ref: 478))
		(sourceAnchor (ref: 479))
		(variable (ref: 477)))
	(FAMIX.Method (id: 1223)
		(name ''resetElementsToLookupUpToTheRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''resetElementsToLookupUpToTheRoot'')
		(sourceAnchor (ref: 1224)))
	(FAMIX.Parameter (id: 1792)
		(name ''values'')
		(parentBehaviouralEntity (ref: 1237)))
	(FAMIX.Access (id: 4262)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 825)))
	(FAMIX.Parameter (id: 1661)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 327)))
	(FAMIX.Access (id: 4263)
		(accessor (ref: 200))
		(sourceAnchor (ref: 201))
		(variable (ref: 199)))
	(FAMIX.Reference (id: 4264)
		(source (ref: 638))
		(sourceAnchor (ref: 639))
		(target (ref: 41)))
	(FAMIX.Parameter (id: 1420)
		(name ''myBounds'')
		(parentBehaviouralEntity (ref: 947)))
	(FAMIX.Access (id: 4265)
		(accessor (ref: 1104))
		(sourceAnchor (ref: 1105))
		(variable (ref: 2962)))
	(FAMIX.Comment (id: 4266)
		(container (ref: 13))
		(content ''"check if it is valid"''))
	(FAMIX.Invocation (id: 4267)
		(sender (ref: 54))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Access (id: 4268)
		(accessor (ref: 827))
		(sourceAnchor (ref: 1301))
		(variable (ref: 1705)))
	(FAMIX.Invocation (id: 4269)
		(receiver (ref: 3693))
		(sender (ref: 1140))
		(signature ''attributes()'')
		(sourceAnchor (ref: 1141)))
	(FAMIX.Access (id: 4270)
		(accessor (ref: 1010))
		(sourceAnchor (ref: 1011))
		(variable (ref: 1692)))
	(FAMIX.Access (id: 4271)
		(accessor (ref: 1967))
		(sourceAnchor (ref: 1968))
		(variable (ref: 2717)))
	(FAMIX.Invocation (id: 4272)
		(sender (ref: 13))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 1207)
		(name ''removeElementsToDisplay:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeElementsToDisplay:'')
		(sourceAnchor (ref: 1208)))
	(FAMIX.Invocation (id: 4273)
		(receiver (ref: 619))
		(sender (ref: 308))
		(signature ''nodeForDomainValue:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 618)))
	(FAMIX.Comment (id: 4274)
		(container (ref: 537))
		(content ''"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."''))
	(FAMIX.Comment (id: 4275)
		(container (ref: 2718))
		(content ''"Answer the layout of the receiver."''))
	(FAMIX.Method (id: 4276)
		(name ''isEdge'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''isEdge'')
		(sourceAnchor (ref: 4277)))
	(FAMIX.Access (id: 4278)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 834)))
	(FAMIX.LocalVariable (id: 491)
		(name ''t2'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Invocation (id: 4279)
		(receiver (ref: 455))
		(sender (ref: 453))
		(signature ''allNodes()'')
		(sourceAnchor (ref: 454)))
	(FAMIX.Invocation (id: 4280)
		(receiver (ref: 2412))
		(sender (ref: 795))
		(signature ''edgeShape()'')
		(sourceAnchor (ref: 2329)))
	(FAMIX.Invocation (id: 4281)
		(receiver (ref: 2962))
		(sender (ref: 1104))
		(signature ''frameAndFillRectangle:fillColor:borderWidth:borderColor:(Object,Object,Object,Object)'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Access (id: 4282)
		(accessor (ref: 437))
		(sourceAnchor (ref: 438))
		(variable (ref: 3405)))
	(FAMIX.Invocation (id: 4283)
		(receiver (ref: 1074))
		(sender (ref: 866))
		(signature ''target()'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Parameter (id: 3985)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1503)))
	(FAMIX.Access (id: 4284)
		(accessor (ref: 2507))
		(sourceAnchor (ref: 2508))
		(variable (ref: 4285)))
	(FAMIX.Access (id: 4286)
		(accessor (ref: 959))
		(sourceAnchor (ref: 960))
		(variable (ref: 4187)))
	(FAMIX.Parameter (id: 2343)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 2112)))
	(FAMIX.Invocation (id: 4287)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Invocation (id: 4288)
		(receiver (ref: 3669))
		(sender (ref: 414))
		(signature ''extent:depth:(Object,Object)'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Access (id: 4289)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1816)))
	(FAMIX.Parameter (id: 4290)
		(name ''fromGlobal'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Invocation (id: 4291)
		(sender (ref: 1101))
		(signature ''firstSubnodeThat:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Invocation (id: 4292)
		(receiver (ref: 475))
		(sender (ref: 473))
		(signature ''shape()'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Comment (id: 4293)
		(container (ref: 1984))
		(content ''"An element is added to the list of selections when selected."''))
	(FAMIX.Access (id: 4294)
		(accessor (ref: 627))
		(sourceAnchor (ref: 628))
		(variable (ref: 629)))
	(FAMIX.Comment (id: 4295)
		(container (ref: 1921))
		(content ''"Return the extremity point"''))
	(FAMIX.Access (id: 4296)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 441)))
	(FAMIX.Access (id: 4297)
		(accessor (ref: 516))
		(sourceAnchor (ref: 517))
		(variable (ref: 4298)))
	(FAMIX.Access (id: 4299)
		(accessor (ref: 95))
		(isWrite true)
		(sourceAnchor (ref: 96))
		(variable (ref: 793)))
	(FAMIX.Method (id: 149)
		(name ''with:during:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''with:during:'')
		(sourceAnchor (ref: 150)))
	(FAMIX.Access (id: 4300)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Access (id: 4301)
		(accessor (ref: 1507))
		(sourceAnchor (ref: 1798))
		(variable (ref: 1506)))
	(FAMIX.Access (id: 4302)
		(accessor (ref: 1984))
		(sourceAnchor (ref: 1985))
		(variable (ref: 4146)))
	(FAMIX.Access (id: 4303)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Invocation (id: 4304)
		(receiver (ref: 3566))
		(sender (ref: 1469))
		(signature ''new()'')
		(sourceAnchor (ref: 1470)))
	(FAMIX.Comment (id: 4305)
		(container (ref: 3798))
		(content ''"True if I am a child shape. This method is intended to be overriden."''))
	(FAMIX.Method (id: 2964)
		(name ''disableCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''disableCache'')
		(sourceAnchor (ref: 2965)))
	(FAMIX.Reference (id: 4306)
		(source (ref: 1189))
		(sourceAnchor (ref: 1190))
		(target (ref: 41)))
	(FAMIX.Access (id: 4307)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 712)))
	(FAMIX.Invocation (id: 4308)
		(receiver (ref: 2911))
		(sender (ref: 746))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 747)))
	(FAMIX.Invocation (id: 4309)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''edges:(Object)'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 4310)
		(receiver (ref: 2133))
		(sender (ref: 221))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Comment (id: 4311)
		(container (ref: 1290))
		(content ''"Return true if the element is visible within the bounds, absolute bounds are tested for this"''))
	(FAMIX.Parameter (id: 3491)
		(name ''aBlockOrSelector'')
		(parentBehaviouralEntity (ref: 809)))
	(FAMIX.Invocation (id: 4312)
		(receiver (ref: 1865))
		(sender (ref: 498))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Access (id: 4313)
		(accessor (ref: 1547))
		(isWrite true)
		(sourceAnchor (ref: 1548))
		(variable (ref: 3823)))
	(FAMIX.Access (id: 4314)
		(accessor (ref: 149))
		(isWrite true)
		(sourceAnchor (ref: 150))
		(variable (ref: 1439)))
	(FAMIX.Method (id: 2345)
		(name ''resetCache'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''resetCache'')
		(sourceAnchor (ref: 2346)))
	(FAMIX.Invocation (id: 4315)
		(receiver (ref: 4316))
		(sender (ref: 1475))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 3193)))
	(FAMIX.Invocation (id: 4317)
		(receiver (ref: 2258))
		(sender (ref: 2256))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 2257)))
	(FAMIX.Invocation (id: 4318)
		(sender (ref: 248))
		(signature ''resetElementsToDisplayCacheRecursively()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 4319)
		(accessor (ref: 766))
		(sourceAnchor (ref: 767))
		(variable (ref: 2741)))
	(FAMIX.Access (id: 4320)
		(accessor (ref: 2094))
		(sourceAnchor (ref: 2095))
		(variable (ref: 2096)))
	(FAMIX.Reference (id: 4321)
		(source (ref: 374))
		(sourceAnchor (ref: 375))
		(target (ref: 1306)))
	(FAMIX.Access (id: 4322)
		(accessor (ref: 2616))
		(sourceAnchor (ref: 2617))
		(variable (ref: 2766)))
	(FAMIX.Invocation (id: 4323)
		(receiver (ref: 1818))
		(sender (ref: 189))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 336)))
	(FAMIX.Invocation (id: 4324)
		(receiver (ref: 168))
		(sender (ref: 2697))
		(signature ''x()'')
		(sourceAnchor (ref: 2698)))
	(FAMIX.Access (id: 4325)
		(accessor (ref: 1275))
		(sourceAnchor (ref: 4326))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 4327)
		(receiver (ref: 1916))
		(sender (ref: 391))
		(signature ''resetFormCache()'')
		(sourceAnchor (ref: 392)))
	(FAMIX.Invocation (id: 4328)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''resetFormCache()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 4329)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 779)))
	(FAMIX.Access (id: 4330)
		(accessor (ref: 189))
		(sourceAnchor (ref: 336))
		(variable (ref: 1818)))
	(FAMIX.Invocation (id: 4331)
		(receiver (ref: 812))
		(sender (ref: 1491))
		(signature ''remove:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 1598)))
	(FAMIX.Access (id: 4332)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 649)))
	(FAMIX.Invocation (id: 4333)
		(receiver (ref: 1745))
		(sender (ref: 1278))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1279)))
	(FAMIX.Access (id: 4334)
		(accessor (ref: 99))
		(sourceAnchor (ref: 100))
		(variable (ref: 3452)))
	(FAMIX.Invocation (id: 4335)
		(sender (ref: 1820))
		(signature ''>(Object)'')
		(sourceAnchor (ref: 1821)))
	(FAMIX.Invocation (id: 4336)
		(receiver (ref: 569))
		(sender (ref: 237))
		(signature ''cache()'')
		(sourceAnchor (ref: 238)))
	(FAMIX.Invocation (id: 4337)
		(receiver (ref: 3419))
		(sender (ref: 1315))
		(signature ''match:(Object)'')
		(sourceAnchor (ref: 1316)))
	(FAMIX.Parameter (id: 3090)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 2951)))
	(FAMIX.Invocation (id: 4338)
		(receiver (ref: 2056))
		(sender (ref: 683))
		(signature ''encompassing:(Object)'')
		(sourceAnchor (ref: 684)))
	(FAMIX.Access (id: 4339)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 830)))
	(FAMIX.Invocation (id: 4340)
		(sender (ref: 947))
		(signature ''*(Object)'')
		(sourceAnchor (ref: 948)))
	(FAMIX.Access (id: 4341)
		(accessor (ref: 1283))
		(sourceAnchor (ref: 1284))
		(variable (ref: 4342)))
	(FAMIX.Access (id: 4343)
		(accessor (ref: 2796))
		(sourceAnchor (ref: 2797))
		(variable (ref: 2795)))
	(FAMIX.Access (id: 4344)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 385)))
	(FAMIX.Parameter (id: 2599)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 2597)))
	(FAMIX.Parameter (id: 2530)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Access (id: 4345)
		(accessor (ref: 525))
		(sourceAnchor (ref: 526))
		(variable (ref: 3605)))
	(FAMIX.Access (id: 4346)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1093)))
	(FAMIX.Access (id: 4347)
		(accessor (ref: 212))
		(isWrite true)
		(sourceAnchor (ref: 213))
		(variable (ref: 104)))
	(FAMIX.Access (id: 4348)
		(accessor (ref: 777))
		(sourceAnchor (ref: 778))
		(variable (ref: 779)))
	(FAMIX.Access (id: 4349)
		(accessor (ref: 611))
		(sourceAnchor (ref: 612))
		(variable (ref: 610)))
	(FAMIX.Access (id: 4350)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2439)))
	(FAMIX.Invocation (id: 4351)
		(receiver (ref: 1951))
		(sender (ref: 1949))
		(signature ''root()'')
		(sourceAnchor (ref: 1950)))
	(FAMIX.Method (id: 766)
		(name ''interaction:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''interaction:'')
		(sourceAnchor (ref: 767)))
	(FAMIX.Access (id: 4352)
		(accessor (ref: 963))
		(sourceAnchor (ref: 964))
		(variable (ref: 940)))
	(FAMIX.Access (id: 4353)
		(accessor (ref: 1007))
		(sourceAnchor (ref: 1008))
		(variable (ref: 4220)))
	(FAMIX.Method (id: 516)
		(name ''hasCacheNamed:of:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''hasCacheNamed:of:'')
		(sourceAnchor (ref: 517)))
	(FAMIX.Invocation (id: 4354)
		(receiver (ref: 764))
		(sender (ref: 162))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Reference (id: 4355)
		(source (ref: 2507))
		(sourceAnchor (ref: 2508))
		(target (ref: 754)))
	(FAMIX.Access (id: 4356)
		(accessor (ref: 1397))
		(sourceAnchor (ref: 1398))
		(variable (ref: 3479)))
	(FAMIX.Invocation (id: 4357)
		(receiver (ref: 1760))
		(sender (ref: 1354))
		(signature ''addAll:(Object)'')
		(sourceAnchor (ref: 1355)))
	(FAMIX.Invocation (id: 4358)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4359)
		(accessor (ref: 627))
		(sourceAnchor (ref: 628))
		(variable (ref: 629)))
	(FAMIX.Invocation (id: 4360)
		(receiver (ref: 1186))
		(sender (ref: 1101))
		(signature ''globalLookupNode:(Object)'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Access (id: 4361)
		(accessor (ref: 2042))
		(sourceAnchor (ref: 2359))
		(variable (ref: 4362)))
	(FAMIX.Access (id: 4363)
		(accessor (ref: 1050))
		(sourceAnchor (ref: 1051))
		(variable (ref: 1049)))
	(FAMIX.Comment (id: 4364)
		(container (ref: 1272))
		(content ''"Answer whether or not the rendering of myself should be cached into a bitmap"''))
	(FAMIX.Access (id: 4365)
		(accessor (ref: 683))
		(sourceAnchor (ref: 684))
		(variable (ref: 67)))
	(FAMIX.Invocation (id: 4366)
		(receiver (ref: 3785))
		(sender (ref: 2710))
		(signature ''isRoot()'')
		(sourceAnchor (ref: 2711)))
	(FAMIX.Invocation (id: 4367)
		(receiver (ref: 41))
		(sender (ref: 1354))
		(signature ''new()'')
		(sourceAnchor (ref: 1355)))
	(FAMIX.Invocation (id: 4368)
		(receiver (ref: 41))
		(sender (ref: 294))
		(signature ''new()'')
		(sourceAnchor (ref: 295)))
	(FAMIX.LocalVariable (id: 2077)
		(name ''classes'')
		(parentBehaviouralEntity (ref: 493)))
	(FAMIX.Parameter (id: 4369)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 1140)))
	(FAMIX.Method (id: 493)
		(name ''defaultLineShapeInstance'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 11)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''defaultLineShapeInstance'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Invocation (id: 4370)
		(sender (ref: 1056))
		(signature ''not()'')
		(sourceAnchor (ref: 1057)))
	(FAMIX.Invocation (id: 4371)
		(receiver (ref: 1792))
		(sender (ref: 1237))
		(signature ''collect:(Object)'')
		(sourceAnchor (ref: 1791)))
	(FAMIX.Method (id: 344)
		(name ''narrowTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''narrowTreeLayout'')
		(sourceAnchor (ref: 345)))
	(FAMIX.Parameter (id: 4136)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 149)))
	(FAMIX.Access (id: 4372)
		(accessor (ref: 80))
		(isWrite true)
		(sourceAnchor (ref: 81))
		(variable (ref: 834)))
	(FAMIX.Access (id: 4373)
		(accessor (ref: 573))
		(sourceAnchor (ref: 574))
		(variable (ref: 575)))
	(FAMIX.Access (id: 4374)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 142)))
	(FAMIX.Method (id: 2532)
		(name ''source'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''source'')
		(sourceAnchor (ref: 2533)))
	(FAMIX.Invocation (id: 4375)
		(receiver (ref: 1564))
		(sender (ref: 929))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Invocation (id: 4376)
		(receiver (ref: 587))
		(sender (ref: 54))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Access (id: 4377)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 1679)))
	(FAMIX.Invocation (id: 4378)
		(receiver (ref: 1410))
		(sender (ref: 912))
		(signature ''nodes:using:forEach:(Object,Object,Object)'')
		(sourceAnchor (ref: 913)))
	(FAMIX.Invocation (id: 4379)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''bounds()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Method (id: 1973)
		(name ''flowLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''flowLayout'')
		(sourceAnchor (ref: 1974)))
	(FAMIX.LocalVariable (id: 142)
		(name ''aSortedCollection'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Access (id: 4380)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 649)))
	(FAMIX.Invocation (id: 4381)
		(sender (ref: 1309))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 1310)))
	(FAMIX.Parameter (id: 2753)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1357)))
	(FAMIX.Access (id: 4382)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 1031)))
	(FAMIX.LocalVariable (id: 1151)
		(name ''deltaX'')
		(parentBehaviouralEntity (ref: 947)))
	(FAMIX.Access (id: 4383)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1600)))
	(FAMIX.Access (id: 4384)
		(accessor (ref: 162))
		(isWrite true)
		(sourceAnchor (ref: 163))
		(variable (ref: 764)))
	(FAMIX.Method (id: 798)
		(name ''edgesToAll:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgesToAll:'')
		(sourceAnchor (ref: 799)))
	(FAMIX.Invocation (id: 4385)
		(receiver (ref: 2410))
		(sender (ref: 35))
		(signature ''y()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Invocation (id: 4386)
		(receiver (ref: 1766))
		(sender (ref: 498))
		(signature ''allNodes()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Comment (id: 4387)
		(container (ref: 934))
		(content ''"We take the first class, not perfect, but it should be enough for now"''))
	(FAMIX.Invocation (id: 4388)
		(receiver (ref: 387))
		(sender (ref: 388))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Access (id: 4389)
		(accessor (ref: 1451))
		(sourceAnchor (ref: 1452))
		(variable (ref: 2464)))
	(FAMIX.Invocation (id: 4390)
		(receiver (ref: 657))
		(sender (ref: 658))
		(signature ''notNil()'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Access (id: 4391)
		(accessor (ref: 2697))
		(sourceAnchor (ref: 2698))
		(variable (ref: 4392)))
	(FAMIX.Invocation (id: 4393)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''value()'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 4394)
		(accessor (ref: 2272))
		(sourceAnchor (ref: 2273))
		(variable (ref: 3528)))
	(FAMIX.Parameter (id: 3144)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 1087)))
	(FAMIX.Invocation (id: 4395)
		(receiver (ref: 4396))
		(sender (ref: 4018))
		(signature ''r:g:b:(Object,Object,Object)'')
		(sourceAnchor (ref: 4019)))
	(FAMIX.Access (id: 4397)
		(accessor (ref: 149))
		(sourceAnchor (ref: 150))
		(variable (ref: 148)))
	(FAMIX.Invocation (id: 4398)
		(receiver (ref: 4188))
		(sender (ref: 723))
		(signature ''model()'')
		(sourceAnchor (ref: 724)))
	(FAMIX.LocalVariable (id: 2456)
		(name ''el'')
		(parentBehaviouralEntity (ref: 404)))
	(FAMIX.Invocation (id: 4399)
		(receiver (ref: 3818))
		(sender (ref: 1973))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1974)))
	(FAMIX.Method (id: 2612)
		(name ''outgoingEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''outgoingEdges'')
		(sourceAnchor (ref: 2613)))
	(FAMIX.Access (id: 4400)
		(accessor (ref: 2726))
		(sourceAnchor (ref: 2727))
		(variable (ref: 4142)))
	(FAMIX.Access (id: 4401)
		(accessor (ref: 1199))
		(isWrite true)
		(sourceAnchor (ref: 1200))
		(variable (ref: 832)))
	(FAMIX.Access (id: 4402)
		(accessor (ref: 312))
		(sourceAnchor (ref: 313))
		(variable (ref: 898)))
	(FAMIX.Access (id: 4403)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1688)))
	(FAMIX.Method (id: 468)
		(name ''edge:from:to:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 4)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edge:from:to:using:'')
		(sourceAnchor (ref: 1364)))
	(FAMIX.Invocation (id: 4404)
		(receiver (ref: 1815))
		(sender (ref: 894))
		(signature ''value()'')
		(sourceAnchor (ref: 895)))
	(FAMIX.Invocation (id: 4405)
		(sender (ref: 195))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 197)))
	(FAMIX.Invocation (id: 4406)
		(receiver (ref: 41))
		(sender (ref: 1720))
		(signature ''new()'')
		(sourceAnchor (ref: 1721)))
	(FAMIX.Invocation (id: 4407)
		(sender (ref: 1181))
		(signature ''anySatisfy:(Object)'')
		(sourceAnchor (ref: 1182)))
	(FAMIX.Method (id: 2837)
		(name ''origin'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''origin'')
		(sourceAnchor (ref: 2838)))
	(FAMIX.Access (id: 4408)
		(accessor (ref: 35))
		(isWrite true)
		(sourceAnchor (ref: 36))
		(variable (ref: 2410)))
	(FAMIX.Invocation (id: 4409)
		(receiver (ref: 750))
		(sender (ref: 173))
		(signature ''edges()'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Comment (id: 4410)
		(container (ref: 2272))
		(content ''"Answer the center of the graphical element"''))
	(FAMIX.Access (id: 4411)
		(accessor (ref: 672))
		(sourceAnchor (ref: 673))
		(variable (ref: 3667)))
	(FAMIX.Class (id: 3224)
		(name ''MOEdge class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 4412)
		(receiver (ref: 1045))
		(sender (ref: 1043))
		(signature ''shape()'')
		(sourceAnchor (ref: 1044)))
	(FAMIX.Access (id: 4413)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 457)))
	(FAMIX.Access (id: 4414)
		(accessor (ref: 1629))
		(isWrite true)
		(sourceAnchor (ref: 2906))
		(variable (ref: 2959)))
	(FAMIX.Invocation (id: 4415)
		(receiver (ref: 1006))
		(sender (ref: 1007))
		(signature ''fromPositions:(Object)'')
		(sourceAnchor (ref: 1008)))
	(FAMIX.Invocation (id: 4416)
		(receiver (ref: 1957))
		(sender (ref: 1559))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1560)))
	(FAMIX.Access (id: 4417)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 457)))
	(FAMIX.Class (id: 2700)
		(name ''MOElementDeselection class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Access (id: 4418)
		(accessor (ref: 993))
		(sourceAnchor (ref: 994))
		(variable (ref: 2384)))
	(FAMIX.Access (id: 4419)
		(accessor (ref: 2697))
		(sourceAnchor (ref: 2698))
		(variable (ref: 3086)))
	(FAMIX.Invocation (id: 4420)
		(sender (ref: 866))
		(signature ''zOrder()'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Invocation (id: 4421)
		(receiver (ref: 3850))
		(sender (ref: 2094))
		(signature ''nodes:(Object)'')
		(sourceAnchor (ref: 2095)))
	(FAMIX.Comment (id: 4422)
		(container (ref: 162))
		(content ''"return the recursively computed outgoing edges"''))
	(FAMIX.Comment (id: 4423)
		(container (ref: 426))
		(content ''"apply:bounds: does a side effect on b"''))
	(FAMIX.LocalVariable (id: 1594)
		(name ''e'')
		(parentBehaviouralEntity (ref: 221)))
	(FAMIX.Invocation (id: 4424)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''shape()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 4425)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 3058)))
	(FAMIX.Access (id: 4426)
		(accessor (ref: 169))
		(sourceAnchor (ref: 171))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 4427)
		(sender (ref: 770))
		(signature ''yourself()'')
		(sourceAnchor (ref: 771)))
	(FAMIX.Invocation (id: 4428)
		(receiver (ref: 181))
		(sender (ref: 3044))
		(signature ''root()'')
		(sourceAnchor (ref: 3045)))
	(FAMIX.Access (id: 4429)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Invocation (id: 4430)
		(sender (ref: 1223))
		(signature ''ifNotNilDo:(Object)'')
		(sourceAnchor (ref: 1224)))
	(FAMIX.Comment (id: 4431)
		(container (ref: 2112))
		(content ''"This method does not update the cache. Use adoptNewShape: if you wish to do so"''))
	(FAMIX.Invocation (id: 4432)
		(receiver (ref: 4433))
		(sender (ref: 4434))
		(signature ''r:g:b:(Object,Object,Object)'')
		(sourceAnchor (ref: 4435)))
	(FAMIX.Invocation (id: 4436)
		(receiver (ref: 817))
		(sender (ref: 719))
		(signature ''edges:fromAll:toAll:using:(Object,Object,Object,Object)'')
		(sourceAnchor (ref: 720)))
	(FAMIX.LocalVariable (id: 1610)
		(name ''n'')
		(parentBehaviouralEntity (ref: 707)))
	(FAMIX.Access (id: 4437)
		(accessor (ref: 848))
		(sourceAnchor (ref: 2968))
		(variable (ref: 847)))
	(FAMIX.Invocation (id: 4438)
		(sender (ref: 414))
		(signature ''acceptVisitor:(Object)'')
		(sourceAnchor (ref: 415)))
	(FAMIX.LocalVariable (id: 1904)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 658)))
	(FAMIX.LocalVariable (id: 246)
		(name ''oldLocalBounds'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Access (id: 4439)
		(accessor (ref: 2256))
		(isWrite true)
		(sourceAnchor (ref: 2257))
		(variable (ref: 2258)))
	(FAMIX.Access (id: 4440)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Invocation (id: 4441)
		(receiver (ref: 3363))
		(sender (ref: 1207))
		(signature ''removeElementToDisplay:(Object)'')
		(sourceAnchor (ref: 1208)))
	(FAMIX.Access (id: 4442)
		(accessor (ref: 430))
		(sourceAnchor (ref: 1022))
		(variable (ref: 263)))
	(FAMIX.Comment (id: 4443)
		(container (ref: 1043))
		(content ''"We check if  the shape if present"''))
	(FAMIX.Access (id: 4444)
		(accessor (ref: 465))
		(sourceAnchor (ref: 466))
		(variable (ref: 4060)))
	(FAMIX.LocalVariable (id: 50)
		(name ''source'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Invocation (id: 4445)
		(sender (ref: 327))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Parameter (id: 4392)
		(name ''aNumber'')
		(parentBehaviouralEntity (ref: 2697)))
	(FAMIX.Invocation (id: 4446)
		(sender (ref: 48))
		(signature ''or:(Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Access (id: 4447)
		(accessor (ref: 866))
		(isWrite true)
		(sourceAnchor (ref: 867))
		(variable (ref: 865)))
	(FAMIX.Invocation (id: 4448)
		(receiver (ref: 1600))
		(sender (ref: 13))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Access (id: 4449)
		(accessor (ref: 2034))
		(sourceAnchor (ref: 2155))
		(variable (ref: 4450)))
	(FAMIX.Comment (id: 4451)
		(container (ref: 809))
		(content ''"The message edgesFrom: defines one edge per node. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block."''))
	(FAMIX.Access (id: 4452)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Access (id: 4453)
		(accessor (ref: 2538))
		(sourceAnchor (ref: 2539))
		(variable (ref: 2537)))
	(FAMIX.Method (id: 1349)
		(name ''radialTreeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''radialTreeLayout'')
		(sourceAnchor (ref: 1350)))
	(FAMIX.Access (id: 4454)
		(accessor (ref: 560))
		(sourceAnchor (ref: 561))
		(variable (ref: 1613)))
	(FAMIX.Access (id: 4455)
		(accessor (ref: 497))
		(sourceAnchor (ref: 2491))
		(variable (ref: 496)))
	(FAMIX.Comment (id: 4456)
		(container (ref: 91))
		(content ''"cyan"''))
	(FAMIX.Access (id: 4457)
		(accessor (ref: 1076))
		(sourceAnchor (ref: 1077))
		(variable (ref: 4458)))
	(FAMIX.Invocation (id: 4459)
		(receiver (ref: 1726))
		(sender (ref: 207))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Invocation (id: 4460)
		(receiver (ref: 52))
		(sender (ref: 13))
		(signature ''height()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 4461)
		(receiver (ref: 181))
		(sender (ref: 207))
		(signature ''updateBounds()'')
		(sourceAnchor (ref: 208)))
	(FAMIX.Access (id: 4462)
		(accessor (ref: 1650))
		(sourceAnchor (ref: 1651))
		(variable (ref: 2544)))
	(FAMIX.Method (id: 1010)
		(name ''nodeForDomainValue:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''nodeForDomainValue:'')
		(sourceAnchor (ref: 1011)))
	(FAMIX.Access (id: 4463)
		(accessor (ref: 159))
		(sourceAnchor (ref: 160))
		(variable (ref: 158)))
	(FAMIX.Access (id: 4464)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 1646)))
	(FAMIX.Invocation (id: 4465)
		(sender (ref: 756))
		(signature ''ifFalse:(Object)'')
		(sourceAnchor (ref: 757)))
	(FAMIX.Parameter (id: 1025)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 668)))
	(FAMIX.Invocation (id: 4466)
		(receiver (ref: 288))
		(sender (ref: 549))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 550)))
	(FAMIX.Access (id: 4467)
		(accessor (ref: 186))
		(sourceAnchor (ref: 187))
		(variable (ref: 185)))
	(FAMIX.Invocation (id: 4468)
		(receiver (ref: 3571))
		(sender (ref: 232))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 234)))
	(FAMIX.Access (id: 4469)
		(accessor (ref: 414))
		(sourceAnchor (ref: 415))
		(variable (ref: 1933)))
	(FAMIX.Access (id: 4470)
		(accessor (ref: 627))
		(sourceAnchor (ref: 628))
		(variable (ref: 4086)))
	(FAMIX.Invocation (id: 4471)
		(receiver (ref: 2160))
		(sender (ref: 1547))
		(signature ''root()'')
		(sourceAnchor (ref: 1548)))
	(FAMIX.Access (id: 4472)
		(accessor (ref: 543))
		(sourceAnchor (ref: 545))
		(variable (ref: 2124)))
	(FAMIX.Access (id: 4473)
		(accessor (ref: 212))
		(sourceAnchor (ref: 213))
		(variable (ref: 3705)))
	(FAMIX.Access (id: 4474)
		(accessor (ref: 192))
		(sourceAnchor (ref: 193))
		(variable (ref: 191)))
	(FAMIX.Access (id: 4475)
		(accessor (ref: 668))
		(sourceAnchor (ref: 1024))
		(variable (ref: 1626)))
	(FAMIX.Invocation (id: 4476)
		(receiver (ref: 2312))
		(sender (ref: 1769))
		(signature ''elementsToDisplay()'')
		(sourceAnchor (ref: 1770)))
	(FAMIX.Reference (id: 4477)
		(source (ref: 498))
		(sourceAnchor (ref: 499))
		(target (ref: 2896)))
	(FAMIX.Access (id: 4478)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 2864)))
	(FAMIX.Access (id: 4479)
		(accessor (ref: 1901))
		(sourceAnchor (ref: 2321))
		(variable (ref: 2322)))
	(FAMIX.Invocation (id: 4480)
		(receiver (ref: 130))
		(sender (ref: 128))
		(signature ''newLabel()'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Parameter (id: 3109)
		(name ''elements'')
		(parentBehaviouralEntity (ref: 1207)))
	(FAMIX.Access (id: 4481)
		(accessor (ref: 2367))
		(sourceAnchor (ref: 2368))
		(variable (ref: 3618)))
	(FAMIX.Reference (id: 4482)
		(source (ref: 1804))
		(sourceAnchor (ref: 1805))
		(target (ref: 1793)))
	(FAMIX.Access (id: 4483)
		(accessor (ref: 2718))
		(sourceAnchor (ref: 2719))
		(variable (ref: 1745)))
	(FAMIX.Invocation (id: 4484)
		(sender (ref: 315))
		(signature ''yourself()'')
		(sourceAnchor (ref: 869)))
	(FAMIX.Comment (id: 4485)
		(container (ref: 1645))
		(content ''"Copy the shape of the receiver and evaluates the block with the copy as argument"''))
	(FAMIX.LocalVariable (id: 56)
		(name ''sourceModels'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Invocation (id: 4486)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 4487)
		(accessor (ref: 2048))
		(isWrite true)
		(sourceAnchor (ref: 2049))
		(variable (ref: 495)))
	(FAMIX.Invocation (id: 4488)
		(sender (ref: 182))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 183)))
	(FAMIX.Invocation (id: 4489)
		(sender (ref: 1775))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 2161)))
	(FAMIX.Access (id: 4490)
		(accessor (ref: 32))
		(sourceAnchor (ref: 33))
		(variable (ref: 2266)))
	(FAMIX.Access (id: 4491)
		(accessor (ref: 963))
		(sourceAnchor (ref: 964))
		(variable (ref: 2169)))
	(FAMIX.Invocation (id: 4492)
		(sender (ref: 408))
		(signature ''reverse()'')
		(sourceAnchor (ref: 1241)))
	(FAMIX.Parameter (id: 2815)
		(name ''anArray'')
		(parentBehaviouralEntity (ref: 44)))
	(FAMIX.Access (id: 4493)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 2327)))
	(FAMIX.Reference (id: 4494)
		(source (ref: 693))
		(sourceAnchor (ref: 1328))
		(target (ref: 3762)))
	(FAMIX.Parameter (id: 4495)
		(name ''aVisitor'')
		(parentBehaviouralEntity (ref: 1860)))
	(FAMIX.Invocation (id: 4496)
		(sender (ref: 473))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 474)))
	(FAMIX.Method (id: 186)
		(name ''circleLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''circleLayout'')
		(sourceAnchor (ref: 187)))
	(FAMIX.Method (id: 683)
		(name ''selectBoxBounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''selectBoxBounds'')
		(sourceAnchor (ref: 684)))
	(FAMIX.LocalVariable (id: 1100)
		(name ''aNode'')
		(parentBehaviouralEntity (ref: 1101)))
	(FAMIX.Method (id: 4497)
		(name ''returnTrue'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 3207))
		(signature ''returnTrue'')
		(sourceAnchor (ref: 4498)))
	(FAMIX.Access (id: 4499)
		(accessor (ref: 354))
		(sourceAnchor (ref: 355))
		(variable (ref: 649)))
	(FAMIX.Method (id: 478)
		(name ''allEdgesConnectedTo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allEdgesConnectedTo:'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Access (id: 4500)
		(accessor (ref: 514))
		(sourceAnchor (ref: 2063))
		(variable (ref: 513)))
	(FAMIX.Access (id: 4501)
		(accessor (ref: 1189))
		(sourceAnchor (ref: 1190))
		(variable (ref: 299)))
	(FAMIX.Invocation (id: 4502)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4503)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 2908)))
	(FAMIX.Access (id: 4504)
		(accessor (ref: 1357))
		(sourceAnchor (ref: 1358))
		(variable (ref: 168)))
	(FAMIX.Invocation (id: 4505)
		(receiver (ref: 445))
		(sender (ref: 1056))
		(signature ''isNil()'')
		(sourceAnchor (ref: 1057)))
	(FAMIX.Access (id: 4506)
		(accessor (ref: 102))
		(sourceAnchor (ref: 103))
		(variable (ref: 104)))
	(FAMIX.Comment (id: 4507)
		(container (ref: 360))
		(content ''"aFromBlock returns a collection of starting nodes"''))
	(FAMIX.Method (id: 84)
		(name ''setDefaultHandlers'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 3)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 16)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''setDefaultHandlers'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Invocation (id: 4508)
		(receiver (ref: 462))
		(sender (ref: 327))
		(signature ''shapeBoundsAt:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Parameter (id: 1970)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 719)))
	(FAMIX.Parameter (id: 1811)
		(name ''myBounds'')
		(parentBehaviouralEntity (ref: 1555)))
	(FAMIX.Access (id: 4509)
		(accessor (ref: 1019))
		(sourceAnchor (ref: 1020))
		(variable (ref: 3422)))
	(FAMIX.LocalVariable (id: 22)
		(name ''b'')
		(parentBehaviouralEntity (ref: 20)))
	(FAMIX.Invocation (id: 4510)
		(receiver (ref: 2351))
		(sender (ref: 2296))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 2297)))
	(FAMIX.Access (id: 4511)
		(accessor (ref: 57))
		(isWrite true)
		(sourceAnchor (ref: 59))
		(variable (ref: 263)))
	(FAMIX.Access (id: 4512)
		(accessor (ref: 2796))
		(sourceAnchor (ref: 2797))
		(variable (ref: 3652)))
	(FAMIX.Parameter (id: 882)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 48)))
	(FAMIX.Invocation (id: 4513)
		(sender (ref: 248))
		(signature ''resetElementsToLookup()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 4514)
		(accessor (ref: 689))
		(sourceAnchor (ref: 690))
		(variable (ref: 4515)))
	(FAMIX.Invocation (id: 4516)
		(receiver (ref: 1041))
		(sender (ref: 260))
		(signature ''size()'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 4517)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Invocation (id: 4518)
		(sender (ref: 505))
		(signature ''origin()'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Reference (id: 4519)
		(source (ref: 95))
		(sourceAnchor (ref: 96))
		(target (ref: 41)))
	(FAMIX.Method (id: 974)
		(name ''hash'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 544))
		(signature ''hash'')
		(sourceAnchor (ref: 975)))
	(FAMIX.Invocation (id: 4520)
		(receiver (ref: 750))
		(sender (ref: 173))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 174)))
	(FAMIX.Invocation (id: 4521)
		(receiver (ref: 2365))
		(sender (ref: 1002))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 1003)))
	(FAMIX.Method (id: 1804)
		(name ''sugiyamaLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''sugiyamaLayout'')
		(sourceAnchor (ref: 1805)))
	(FAMIX.Access (id: 4522)
		(accessor (ref: 631))
		(isWrite true)
		(sourceAnchor (ref: 632))
		(variable (ref: 512)))
	(FAMIX.Access (id: 4523)
		(accessor (ref: 1877))
		(sourceAnchor (ref: 1878))
		(variable (ref: 3657)))
	(FAMIX.Comment (id: 4524)
		(container (ref: 1426))
		(content ''"Nodes need to be layouted before calling this method"''))
	(FAMIX.Invocation (id: 4525)
		(receiver (ref: 263))
		(sender (ref: 1309))
		(signature ''isNil()'')
		(sourceAnchor (ref: 1310)))
	(FAMIX.Invocation (id: 4526)
		(receiver (ref: 1715))
		(sender (ref: 1851))
		(signature ''new()'')
		(sourceAnchor (ref: 1852)))
	(FAMIX.Method (id: 1527)
		(name ''defaultNodeShapeInstance:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultNodeShapeInstance:'')
		(sourceAnchor (ref: 1528)))
	(FAMIX.Comment (id: 4527)
		(container (ref: 182))
		(content ''"We do not let the position to be outside of the parent"''))
	(FAMIX.Access (id: 4528)
		(accessor (ref: 182))
		(isWrite true)
		(sourceAnchor (ref: 183))
		(variable (ref: 1646)))
	(FAMIX.Invocation (id: 4529)
		(receiver (ref: 1225))
		(sender (ref: 1223))
		(signature ''resetElementsToLookupUpToTheRoot()'')
		(sourceAnchor (ref: 1224)))
	(FAMIX.Access (id: 4530)
		(accessor (ref: 404))
		(sourceAnchor (ref: 406))
		(variable (ref: 2633)))
	(FAMIX.Invocation (id: 4531)
		(receiver (ref: 282))
		(sender (ref: 283))
		(signature ''value()'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Invocation (id: 4532)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''shapeBoundsAt:put:(Object,Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 4533)
		(accessor (ref: 248))
		(isWrite true)
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 4534)
		(accessor (ref: 819))
		(sourceAnchor (ref: 2290))
		(variable (ref: 2630)))
	(FAMIX.Parameter (id: 3699)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 770)))
	(FAMIX.Invocation (id: 4535)
		(receiver (ref: 653))
		(sender (ref: 35))
		(signature ''nodes()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Invocation (id: 4536)
		(receiver (ref: 246))
		(sender (ref: 13))
		(signature ''height()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 4537)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Invocation (id: 4538)
		(sender (ref: 414))
		(signature ''negated()'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Parameter (id: 551)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 549)))
	(FAMIX.Parameter (id: 1068)
		(name ''wantedStepAsPoint'')
		(parentBehaviouralEntity (ref: 182)))
	(FAMIX.Invocation (id: 4539)
		(receiver (ref: 1685))
		(sender (ref: 290))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Method (id: 529)
		(name ''minimumGridLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''minimumGridLayout'')
		(sourceAnchor (ref: 530)))
	(FAMIX.Parameter (id: 3571)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 232)))
	(FAMIX.Invocation (id: 4540)
		(receiver (ref: 1362))
		(sender (ref: 95))
		(signature ''moValue:(Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Comment (id: 4541)
		(container (ref: 1278))
		(content ''"Answer the layout. If none is defined, answer the default layout"''))
	(FAMIX.Access (id: 4542)
		(accessor (ref: 1378))
		(sourceAnchor (ref: 1379))
		(variable (ref: 2840)))
	(FAMIX.Method (id: 354)
		(name ''expandToIncludePoint:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''expandToIncludePoint:'')
		(sourceAnchor (ref: 355)))
	(FAMIX.Access (id: 4543)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 1041)))
	(FAMIX.Invocation (id: 4544)
		(receiver (ref: 1779))
		(sender (ref: 1777))
		(signature ''model()'')
		(sourceAnchor (ref: 1778)))
	(FAMIX.LocalVariable (id: 3203)
		(name ''collection'')
		(parentBehaviouralEntity (ref: 894)))
	(FAMIX.Access (id: 4545)
		(accessor (ref: 1559))
		(isWrite true)
		(sourceAnchor (ref: 1560))
		(variable (ref: 1957)))
	(FAMIX.Access (id: 4546)
		(accessor (ref: 182))
		(sourceAnchor (ref: 183))
		(variable (ref: 1646)))
	(FAMIX.Invocation (id: 4547)
		(receiver (ref: 1814))
		(sender (ref: 84))
		(signature ''updateWindow()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Access (id: 4548)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Comment (id: 4549)
		(container (ref: 1640))
		(content ''"Answer the announcer of the receiver."''))
	(FAMIX.Method (id: 497)
		(name ''boundsFor:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''boundsFor:'')
		(sourceAnchor (ref: 2491)))
	(FAMIX.Invocation (id: 4550)
		(receiver (ref: 2864))
		(sender (ref: 275))
		(signature ''nodeForDomainValue:(Object)'')
		(sourceAnchor (ref: 276)))
	(FAMIX.LocalVariable (id: 2410)
		(name ''origin'')
		(parentBehaviouralEntity (ref: 35)))
	(FAMIX.Access (id: 4551)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 4552)))
	(FAMIX.Access (id: 4553)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 1362)))
	(FAMIX.Comment (id: 4554)
		(container (ref: 1223))
		(content ''"This method is used by forNode: aBlockOrSymbol whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean. 
	It is related to elementAt:"''))
	(FAMIX.Access (id: 4555)
		(accessor (ref: 108))
		(sourceAnchor (ref: 109))
		(variable (ref: 448)))
	(FAMIX.Parameter (id: 1443)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1441)))
	(FAMIX.Invocation (id: 4556)
		(receiver (ref: 3667))
		(sender (ref: 672))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 673)))
	(FAMIX.Invocation (id: 4557)
		(receiver (ref: 1074))
		(sender (ref: 866))
		(signature ''source()'')
		(sourceAnchor (ref: 867)))
	(FAMIX.Invocation (id: 4558)
		(receiver (ref: 1900))
		(sender (ref: 1901))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 2321)))
	(FAMIX.Invocation (id: 4559)
		(receiver (ref: 1078))
		(sender (ref: 1076))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 1077)))
	(FAMIX.Parameter (id: 896)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 894)))
	(FAMIX.Access (id: 4560)
		(accessor (ref: 1757))
		(sourceAnchor (ref: 1758))
		(variable (ref: 3710)))
	(FAMIX.LocalVariable (id: 2773)
		(name ''oldShapeBounds'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Access (id: 4561)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Invocation (id: 4562)
		(receiver (ref: 41))
		(sender (ref: 2094))
		(signature ''with:(Object)'')
		(sourceAnchor (ref: 2095)))
	(FAMIX.Access (id: 4563)
		(accessor (ref: 35))
		(isWrite true)
		(sourceAnchor (ref: 36))
		(variable (ref: 37)))
	(FAMIX.Method (id: 740)
		(name ''remove'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''remove'')
		(sourceAnchor (ref: 741)))
	(FAMIX.Invocation (id: 4564)
		(sender (ref: 248))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 4565)
		(receiver (ref: 521))
		(sender (ref: 128))
		(signature ''setLabel:(Object)'')
		(sourceAnchor (ref: 129)))
	(FAMIX.Access (id: 4566)
		(accessor (ref: 661))
		(sourceAnchor (ref: 662))
		(variable (ref: 663)))
	(FAMIX.Access (id: 4567)
		(accessor (ref: 1132))
		(sourceAnchor (ref: 3591))
		(variable (ref: 1131)))
	(FAMIX.Method (id: 2012)
		(name ''numberOfCachedMetrics'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''numberOfCachedMetrics'')
		(sourceAnchor (ref: 2013)))
	(FAMIX.Access (id: 4568)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1047)))
	(FAMIX.Reference (id: 4569)
		(source (ref: 84))
		(sourceAnchor (ref: 85))
		(target (ref: 758)))
	(FAMIX.Invocation (id: 4570)
		(sender (ref: 770))
		(signature ''shape:(Object)'')
		(sourceAnchor (ref: 771)))
	(FAMIX.Invocation (id: 4571)
		(receiver (ref: 908))
		(sender (ref: 801))
		(signature ''externalEdges()'')
		(sourceAnchor (ref: 802)))
	(FAMIX.Invocation (id: 4572)
		(sender (ref: 43))
		(signature ''addOutgoingEdge:(Object)'')
		(sourceAnchor (ref: 1163)))
	(FAMIX.Method (id: 627)
		(name ''allOutcomingEdges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''allOutcomingEdges'')
		(sourceAnchor (ref: 628)))
	(FAMIX.Comment (id: 4573)
		(container (ref: 1823))
		(content ''"Set the extremity point"''))
	(FAMIX.Method (id: 350)
		(name ''edgeFrom:to:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgeFrom:to:'')
		(sourceAnchor (ref: 351)))
	(FAMIX.Method (id: 318)
		(name ''increaseZoomBy:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''increaseZoomBy:'')
		(sourceAnchor (ref: 319)))
	(FAMIX.Parameter (id: 3319)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 237)))
	(FAMIX.Invocation (id: 4574)
		(receiver (ref: 3705))
		(sender (ref: 212))
		(signature ''resetMetricCaches()'')
		(sourceAnchor (ref: 213)))
	(FAMIX.Invocation (id: 4575)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4576)
		(accessor (ref: 493))
		(isWrite true)
		(sourceAnchor (ref: 494))
		(variable (ref: 2077)))
	(FAMIX.Invocation (id: 4577)
		(receiver (ref: 2894))
		(sender (ref: 224))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 225)))
	(FAMIX.LocalVariable (id: 1381)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 275)))
	(FAMIX.Invocation (id: 4578)
		(receiver (ref: 56))
		(sender (ref: 48))
		(signature ''isCollection()'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Access (id: 4579)
		(accessor (ref: 3133))
		(sourceAnchor (ref: 3134))
		(variable (ref: 4219)))
	(FAMIX.Method (id: 732)
		(name ''fadeLayout'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''fadeLayout'')
		(sourceAnchor (ref: 733)))
	(FAMIX.Access (id: 4580)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 2559)))
	(FAMIX.Invocation (id: 4581)
		(receiver (ref: 439))
		(sender (ref: 437))
		(signature ''delete()'')
		(sourceAnchor (ref: 438)))
	(FAMIX.Access (id: 4582)
		(accessor (ref: 154))
		(sourceAnchor (ref: 155))
		(variable (ref: 2900)))
	(FAMIX.Method (id: 746)
		(name ''expandToIncludePoint:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''expandToIncludePoint:'')
		(sourceAnchor (ref: 747)))
	(FAMIX.Invocation (id: 4583)
		(receiver (ref: 2108))
		(sender (ref: 1855))
		(signature ''shapeBoundsAt:(Object)'')
		(sourceAnchor (ref: 1856)))
	(FAMIX.LocalVariable (id: 2449)
		(name ''source'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Parameter (id: 3937)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 858)))
	(FAMIX.LocalVariable (id: 220)
		(name ''b'')
		(parentBehaviouralEntity (ref: 221)))
	(FAMIX.Comment (id: 4584)
		(container (ref: 91))
		(content ''"gray"''))
	(FAMIX.Method (id: 1507)
		(name ''edges:from:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:from:'')
		(sourceAnchor (ref: 1798)))
	(FAMIX.Method (id: 938)
		(name ''edgeShape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edgeShape'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Method (id: 1523)
		(name ''canvas:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''canvas:'')
		(sourceAnchor (ref: 1524)))
	(FAMIX.Access (id: 4585)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 3162)))
	(FAMIX.Invocation (id: 4586)
		(receiver (ref: 875))
		(sender (ref: 95))
		(signature ''assert:description:(Object,Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 4587)
		(accessor (ref: 2577))
		(sourceAnchor (ref: 2578))
		(variable (ref: 4231)))
	(FAMIX.Invocation (id: 4588)
		(receiver (ref: 578))
		(sender (ref: 426))
		(signature ''hasNode()'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 4589)
		(accessor (ref: 1761))
		(sourceAnchor (ref: 1762))
		(variable (ref: 3344)))
	(FAMIX.Access (id: 4590)
		(accessor (ref: 947))
		(sourceAnchor (ref: 948))
		(variable (ref: 946)))
	(FAMIX.LocalVariable (id: 4552)
		(name ''ratioW'')
		(parentBehaviouralEntity (ref: 13)))
	(FAMIX.Invocation (id: 4591)
		(receiver (ref: 865))
		(sender (ref: 1757))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 1758)))
	(FAMIX.Access (id: 4592)
		(accessor (ref: 801))
		(isWrite true)
		(sourceAnchor (ref: 802))
		(variable (ref: 803)))
	(FAMIX.Access (id: 4593)
		(accessor (ref: 1499))
		(isWrite true)
		(sourceAnchor (ref: 1500))
		(variable (ref: 1268)))
	(FAMIX.Method (id: 229)
		(name ''translateTo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 1376))
		(signature ''translateTo:'')
		(sourceAnchor (ref: 230)))
	(FAMIX.Access (id: 4594)
		(accessor (ref: 676))
		(sourceAnchor (ref: 677))
		(variable (ref: 3996)))
	(FAMIX.Method (id: 1096)
		(name ''translateTo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''translateTo:'')
		(sourceAnchor (ref: 1097)))
	(FAMIX.Access (id: 4595)
		(accessor (ref: 1237))
		(sourceAnchor (ref: 1791))
		(variable (ref: 4243)))
	(FAMIX.Access (id: 4596)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 729)))
	(FAMIX.Comment (id: 4597)
		(container (ref: 111))
		(content ''"Each shape is cached per default"''))
	(FAMIX.Invocation (id: 4598)
		(receiver (ref: 18))
		(sender (ref: 16))
		(signature ''resetFormCacheSimply()'')
		(sourceAnchor (ref: 17)))
	(FAMIX.Access (id: 4599)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 1814)))
	(FAMIX.Invocation (id: 4600)
		(receiver (ref: 428))
		(sender (ref: 35))
		(signature ''width()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Access (id: 4601)
		(accessor (ref: 159))
		(sourceAnchor (ref: 160))
		(variable (ref: 158)))
	(FAMIX.Access (id: 4602)
		(accessor (ref: 993))
		(sourceAnchor (ref: 994))
		(variable (ref: 2903)))
	(FAMIX.Access (id: 4603)
		(accessor (ref: 2345))
		(isWrite true)
		(sourceAnchor (ref: 2346))
		(variable (ref: 614)))
	(FAMIX.Access (id: 4604)
		(accessor (ref: 360))
		(sourceAnchor (ref: 361))
		(variable (ref: 1571)))
	(FAMIX.Access (id: 4605)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 2439)))
	(FAMIX.Method (id: 837)
		(name ''target:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''target:'')
		(sourceAnchor (ref: 838)))
	(FAMIX.Invocation (id: 4606)
		(receiver (ref: 2495))
		(sender (ref: 1775))
		(signature ''userCommands()'')
		(sourceAnchor (ref: 2161)))
	(FAMIX.Parameter (id: 3792)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 658)))
	(FAMIX.Invocation (id: 4607)
		(receiver (ref: 1016))
		(sender (ref: 48))
		(signature ''addEdgeIn:from:to:model:shape:(Object,Object,Object,Object,Object)'')
		(sourceAnchor (ref: 49)))
	(FAMIX.Method (id: 1393)
		(name ''isCached'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isCached'')
		(sourceAnchor (ref: 1394)))
	(FAMIX.Invocation (id: 4608)
		(receiver (ref: 2501))
		(sender (ref: 408))
		(signature ''elementsToLookup()'')
		(sourceAnchor (ref: 1241)))
	(FAMIX.Invocation (id: 4609)
		(receiver (ref: 2773))
		(sender (ref: 13))
		(signature ''at:(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Reference (id: 4610)
		(source (ref: 1278))
		(sourceAnchor (ref: 1279))
		(target (ref: 1277)))
	(FAMIX.Invocation (id: 4611)
		(sender (ref: 13))
		(signature ''/(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Parameter (id: 3746)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 858)))
	(FAMIX.Access (id: 4612)
		(accessor (ref: 683))
		(sourceAnchor (ref: 684))
		(variable (ref: 954)))
	(FAMIX.Method (id: 1412)
		(name ''title:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''title:'')
		(sourceAnchor (ref: 1413)))
	(FAMIX.Invocation (id: 4613)
		(receiver (ref: 2365))
		(sender (ref: 1002))
		(signature ''title:(Object)'')
		(sourceAnchor (ref: 1003)))
	(FAMIX.Method (id: 4027)
		(name ''doPostOnGraph:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''doPostOnGraph:'')
		(sourceAnchor (ref: 4614)))
	(FAMIX.Invocation (id: 4615)
		(receiver (ref: 1993))
		(sender (ref: 932))
		(signature ''resetFormCacheResursively()'')
		(sourceAnchor (ref: 1893)))
	(FAMIX.Invocation (id: 4616)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 4617)
		(sender (ref: 91))
		(signature ''brightness()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4618)
		(accessor (ref: 2726))
		(sourceAnchor (ref: 2727))
		(variable (ref: 512)))
	(FAMIX.Invocation (id: 4619)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''cyan()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4620)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 4621)
		(accessor (ref: 1227))
		(sourceAnchor (ref: 2035))
		(variable (ref: 1226)))
	(FAMIX.Invocation (id: 4622)
		(receiver (ref: 1928))
		(sender (ref: 294))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Reference (id: 4623)
		(source (ref: 2661))
		(sourceAnchor (ref: 2662))
		(target (ref: 1277)))
	(FAMIX.Reference (id: 4624)
		(source (ref: 756))
		(sourceAnchor (ref: 757))
		(target (ref: 926)))
	(FAMIX.Access (id: 4625)
		(accessor (ref: 884))
		(sourceAnchor (ref: 1611))
		(variable (ref: 883)))
	(FAMIX.Access (id: 4626)
		(accessor (ref: 88))
		(sourceAnchor (ref: 89))
		(variable (ref: 2670)))
	(FAMIX.Invocation (id: 4627)
		(receiver (ref: 140))
		(sender (ref: 138))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 139)))
	(FAMIX.Comment (id: 4628)
		(container (ref: 719))
		(content ''"both aFromBlock and aToBlock must return a collection"''))
	(FAMIX.Invocation (id: 4629)
		(sender (ref: 381))
		(signature ''announce:(Object)'')
		(sourceAnchor (ref: 382)))
	(FAMIX.Method (id: 2708)
		(name ''isLineShape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 196))
		(signature ''isLineShape'')
		(sourceAnchor (ref: 4630)))
	(FAMIX.Access (id: 4631)
		(accessor (ref: 473))
		(sourceAnchor (ref: 474))
		(variable (ref: 2006)))
	(FAMIX.Access (id: 4632)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Comment (id: 4633)
		(container (ref: 801))
		(content ''"This method is used when the bitmap cache is set"''))
	(FAMIX.Invocation (id: 4634)
		(receiver (ref: 591))
		(sender (ref: 283))
		(signature ''size()'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 4635)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Invocation (id: 4636)
		(receiver (ref: 507))
		(sender (ref: 505))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 506)))
	(FAMIX.Method (id: 423)
		(name ''setIfNilToPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''setIfNilToPositions:'')
		(sourceAnchor (ref: 424)))
	(FAMIX.Invocation (id: 4637)
		(receiver (ref: 2679))
		(sender (ref: 2296))
		(signature ''new()'')
		(sourceAnchor (ref: 2297)))
	(FAMIX.LocalVariable (id: 3293)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 929)))
	(FAMIX.Invocation (id: 4638)
		(sender (ref: 91))
		(signature ''hue()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Access (id: 4639)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 428)))
	(FAMIX.Invocation (id: 4640)
		(receiver (ref: 3086))
		(sender (ref: 1357))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 1358)))
	(FAMIX.Access (id: 4641)
		(accessor (ref: 934))
		(sourceAnchor (ref: 935))
		(variable (ref: 936)))
	(FAMIX.Access (id: 4642)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 2327)))
	(FAMIX.Access (id: 4643)
		(accessor (ref: 2688))
		(sourceAnchor (ref: 2689))
		(variable (ref: 445)))
	(FAMIX.Access (id: 4644)
		(accessor (ref: 237))
		(sourceAnchor (ref: 238))
		(variable (ref: 569)))
	(FAMIX.Access (id: 4645)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 875)))
	(FAMIX.Access (id: 4646)
		(accessor (ref: 2406))
		(sourceAnchor (ref: 2407))
		(variable (ref: 4647)))
	(FAMIX.Parameter (id: 2053)
		(name ''model'')
		(parentBehaviouralEntity (ref: 658)))
	(FAMIX.Access (id: 4648)
		(accessor (ref: 795))
		(sourceAnchor (ref: 2329))
		(variable (ref: 1117)))
	(FAMIX.Invocation (id: 4649)
		(sender (ref: 275))
		(signature ''remove:ifAbsent:(Object,Object)'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Parameter (id: 2302)
		(name ''bounds'')
		(parentBehaviouralEntity (ref: 304)))
	(FAMIX.LocalVariable (id: 3306)
		(name ''each'')
		(parentBehaviouralEntity (ref: 1996)))
	(FAMIX.Access (id: 4650)
		(accessor (ref: 1426))
		(sourceAnchor (ref: 1591))
		(variable (ref: 1590)))
	(FAMIX.Invocation (id: 4651)
		(sender (ref: 327))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Reference (id: 4652)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 4653)
		(accessor (ref: 774))
		(sourceAnchor (ref: 775))
		(variable (ref: 4654)))
	(FAMIX.Invocation (id: 4655)
		(receiver (ref: 3944))
		(sender (ref: 232))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 234)))
	(FAMIX.Invocation (id: 4656)
		(sender (ref: 938))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Invocation (id: 4657)
		(receiver (ref: 416))
		(sender (ref: 414))
		(signature ''origin()'')
		(sourceAnchor (ref: 415)))
	(FAMIX.Access (id: 4658)
		(accessor (ref: 1475))
		(sourceAnchor (ref: 3193))
		(variable (ref: 4316)))
	(FAMIX.Access (id: 4659)
		(accessor (ref: 304))
		(isWrite true)
		(sourceAnchor (ref: 305))
		(variable (ref: 122)))
	(FAMIX.Access (id: 4660)
		(accessor (ref: 268))
		(sourceAnchor (ref: 269))
		(variable (ref: 920)))
	(FAMIX.Parameter (id: 1843)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Invocation (id: 4661)
		(receiver (ref: 2047))
		(sender (ref: 1124))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 1125)))
	(FAMIX.Comment (id: 4662)
		(container (ref: 182))
		(content ''"Return the real translation step when the translation is bounded"''))
	(FAMIX.Invocation (id: 4663)
		(sender (ref: 1949))
		(signature ''allEdgesConnectedTo:(Object)'')
		(sourceAnchor (ref: 1950)))
	(FAMIX.Comment (id: 4664)
		(container (ref: 232))
		(content ''"Evaluate aBlock with the receiver and all its nodes."''))
	(FAMIX.Invocation (id: 4665)
		(sender (ref: 260))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Invocation (id: 4666)
		(receiver (ref: 3792))
		(sender (ref: 658))
		(signature ''addLast:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Invocation (id: 4667)
		(sender (ref: 1555))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 1556)))
	(FAMIX.Method (id: 4668)
		(name ''isRoot'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''isRoot'')
		(sourceAnchor (ref: 4669)))
	(FAMIX.Invocation (id: 4670)
		(receiver (ref: 1369))
		(sender (ref: 938))
		(signature ''defaultLineShapeClass()'')
		(sourceAnchor (ref: 939)))
	(FAMIX.Access (id: 4671)
		(accessor (ref: 20))
		(sourceAnchor (ref: 21))
		(variable (ref: 491)))
	(FAMIX.Invocation (id: 4672)
		(receiver (ref: 1538))
		(sender (ref: 388))
		(signature ''anyOne()'')
		(sourceAnchor (ref: 389)))
	(FAMIX.Access (id: 4673)
		(accessor (ref: 430))
		(sourceAnchor (ref: 1022))
		(variable (ref: 4674)))
	(FAMIX.Access (id: 4675)
		(accessor (ref: 1338))
		(sourceAnchor (ref: 1339))
		(variable (ref: 1631)))
	(FAMIX.Invocation (id: 4676)
		(receiver (ref: 729))
		(sender (ref: 294))
		(signature ''resetInteraction()'')
		(sourceAnchor (ref: 295)))
	(FAMIX.LocalVariable (id: 1688)
		(name ''flat'')
		(parentBehaviouralEntity (ref: 39)))
	(FAMIX.Invocation (id: 4677)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''orange()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 4678)
		(sender (ref: 1406))
		(signature ''at:put:(Object,Object)'')
		(sourceAnchor (ref: 1407)))
	(FAMIX.Access (id: 4679)
		(accessor (ref: 433))
		(sourceAnchor (ref: 434))
		(variable (ref: 3842)))
	(FAMIX.Parameter (id: 3504)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 473)))
	(FAMIX.Access (id: 4680)
		(accessor (ref: 560))
		(sourceAnchor (ref: 561))
		(variable (ref: 2872)))
	(FAMIX.Parameter (id: 3954)
		(name ''aBlock2'')
		(parentBehaviouralEntity (ref: 1761)))
	(FAMIX.Access (id: 4681)
		(accessor (ref: 1076))
		(sourceAnchor (ref: 1077))
		(variable (ref: 1078)))
	(FAMIX.Method (id: 861)
		(name ''removeNode:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''removeNode:'')
		(sourceAnchor (ref: 862)))
	(FAMIX.Access (id: 4682)
		(accessor (ref: 2231))
		(sourceAnchor (ref: 3206))
		(variable (ref: 2230)))
	(FAMIX.Invocation (id: 4683)
		(receiver (ref: 717))
		(sender (ref: 69))
		(signature ''extent()'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 4684)
		(receiver (ref: 1323))
		(sender (ref: 35))
		(signature ''max:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Comment (id: 4685)
		(container (ref: 473))
		(content ''"aSymbol should start with #cache, else it will not be properly reseted"''))
	(FAMIX.Access (id: 4686)
		(accessor (ref: 1555))
		(sourceAnchor (ref: 1556))
		(variable (ref: 1635)))
	(FAMIX.Invocation (id: 4687)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''h:s:v:(Object,Object,Object)'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Reference (id: 4688)
		(source (ref: 468))
		(sourceAnchor (ref: 1364))
		(target (ref: 41)))
	(FAMIX.Invocation (id: 4689)
		(receiver (ref: 250))
		(sender (ref: 248))
		(signature ''owner()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Parameter (id: 3070)
		(name ''boolean'')
		(parentBehaviouralEntity (ref: 2808)))
	(FAMIX.Invocation (id: 4690)
		(sender (ref: 39))
		(signature ''isNil()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Invocation (id: 4691)
		(receiver (ref: 491))
		(sender (ref: 20))
		(signature ''isKindOf:(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 4692)
		(accessor (ref: 2538))
		(sourceAnchor (ref: 2539))
		(variable (ref: 2537)))
	(FAMIX.Invocation (id: 4693)
		(receiver (ref: 604))
		(sender (ref: 602))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 603)))
	(FAMIX.Parameter (id: 3417)
		(name ''fromGlobal'')
		(parentBehaviouralEntity (ref: 294)))
	(FAMIX.Method (id: 4694)
		(name ''defaultToPositions'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''defaultToPositions'')
		(sourceAnchor (ref: 4695)))
	(FAMIX.Method (id: 894)
		(name ''node:using:forIt:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 3)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''node:using:forIt:'')
		(sourceAnchor (ref: 895)))
	(FAMIX.Parameter (id: 4450)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 2034)))
	(FAMIX.Method (id: 4696)
		(name ''isEdge'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(kind ''constant'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 170))
		(signature ''isEdge'')
		(sourceAnchor (ref: 4697)))
	(FAMIX.Invocation (id: 4698)
		(receiver (ref: 2630))
		(sender (ref: 819))
		(signature ''fromPositions()'')
		(sourceAnchor (ref: 2290)))
	(FAMIX.Invocation (id: 4699)
		(receiver (ref: 3224))
		(sender (ref: 658))
		(signature ''from:to:(Object,Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Access (id: 4700)
		(accessor (ref: 1820))
		(sourceAnchor (ref: 1821))
		(variable (ref: 1910)))
	(FAMIX.Invocation (id: 4701)
		(receiver (ref: 3479))
		(sender (ref: 1397))
		(signature ''cacheForm()'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Invocation (id: 4702)
		(receiver (ref: 3196))
		(sender (ref: 493))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 494)))
	(FAMIX.Invocation (id: 4703)
		(receiver (ref: 2621))
		(sender (ref: 611))
		(signature ''attributes()'')
		(sourceAnchor (ref: 612)))
	(FAMIX.Access (id: 4704)
		(accessor (ref: 1417))
		(sourceAnchor (ref: 1418))
		(variable (ref: 3077)))
	(FAMIX.Invocation (id: 4705)
		(receiver (ref: 2069))
		(sender (ref: 894))
		(signature ''nodes:using:forEach:(Object,Object,Object)'')
		(sourceAnchor (ref: 895)))
	(FAMIX.Invocation (id: 4706)
		(receiver (ref: 782))
		(sender (ref: 124))
		(signature ''source()'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Invocation (id: 4707)
		(receiver (ref: 604))
		(sender (ref: 106))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 2162)))
	(FAMIX.Parameter (id: 3644)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 312)))
	(FAMIX.LocalVariable (id: 782)
		(name ''edge'')
		(parentBehaviouralEntity (ref: 124)))
	(FAMIX.Invocation (id: 4708)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Access (id: 4709)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 12)))
	(FAMIX.Parameter (id: 4458)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1076)))
	(FAMIX.Access (id: 4710)
		(accessor (ref: 638))
		(isWrite true)
		(sourceAnchor (ref: 639))
		(variable (ref: 1892)))
	(FAMIX.Access (id: 4711)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 1331)))
	(FAMIX.Invocation (id: 4712)
		(receiver (ref: 898))
		(sender (ref: 312))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 313)))
	(FAMIX.Invocation (id: 4713)
		(receiver (ref: 41))
		(sender (ref: 470))
		(signature ''with:(Object)'')
		(sourceAnchor (ref: 744)))
	(FAMIX.Parameter (id: 2656)
		(name ''aCollection'')
		(parentBehaviouralEntity (ref: 1345)))
	(FAMIX.Method (id: 391)
		(name ''select'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 6)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''select'')
		(sourceAnchor (ref: 392)))
	(FAMIX.Access (id: 4714)
		(accessor (ref: 124))
		(sourceAnchor (ref: 125))
		(variable (ref: 1682)))
	(FAMIX.Access (id: 4715)
		(accessor (ref: 543))
		(isWrite true)
		(sourceAnchor (ref: 545))
		(variable (ref: 850)))
	(FAMIX.Invocation (id: 4716)
		(sender (ref: 2))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1619)))
	(FAMIX.Access (id: 4717)
		(accessor (ref: 872))
		(sourceAnchor (ref: 873))
		(variable (ref: 871)))
	(FAMIX.LocalVariable (id: 2081)
		(name ''source'')
		(parentBehaviouralEntity (ref: 95)))
	(FAMIX.Invocation (id: 4718)
		(receiver (ref: 1835))
		(sender (ref: 723))
		(signature ''firstSubnodeThat:(Object)'')
		(sourceAnchor (ref: 724)))
	(FAMIX.Access (id: 4719)
		(accessor (ref: 878))
		(sourceAnchor (ref: 879))
		(variable (ref: 877)))
	(FAMIX.Invocation (id: 4720)
		(receiver (ref: 164))
		(sender (ref: 162))
		(signature ''allNodesDo:(Object)'')
		(sourceAnchor (ref: 163)))
	(FAMIX.Access (id: 4721)
		(accessor (ref: 1272))
		(sourceAnchor (ref: 1273))
		(variable (ref: 3427)))
	(FAMIX.Method (id: 2042)
		(name ''attributeAt:ifAbsentPut:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''attributeAt:ifAbsentPut:'')
		(sourceAnchor (ref: 2359)))
	(FAMIX.Access (id: 4722)
		(accessor (ref: 1223))
		(sourceAnchor (ref: 1224))
		(variable (ref: 1229)))
	(FAMIX.Access (id: 4723)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 1041)))
	(FAMIX.Access (id: 4724)
		(accessor (ref: 128))
		(sourceAnchor (ref: 129))
		(variable (ref: 1031)))
	(FAMIX.Access (id: 4725)
		(accessor (ref: 4018))
		(sourceAnchor (ref: 4019))
		(variable (ref: 4396)))
	(FAMIX.Invocation (id: 4726)
		(receiver (ref: 2439))
		(sender (ref: 248))
		(signature ''with:during:(Object,Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Method (id: 4071)
		(name ''defaultNodeShapeClass'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultNodeShapeClass'')
		(sourceAnchor (ref: 4072)))
	(FAMIX.Invocation (id: 4727)
		(sender (ref: 145))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 146)))
	(FAMIX.Reference (id: 4728)
		(source (ref: 2094))
		(sourceAnchor (ref: 2095))
		(target (ref: 41)))
	(FAMIX.Method (id: 2269)
		(name ''defaultLineShapeInstance:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''setter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''defaultLineShapeInstance:'')
		(sourceAnchor (ref: 2270)))
	(FAMIX.Access (id: 4729)
		(accessor (ref: 80))
		(isWrite true)
		(sourceAnchor (ref: 81))
		(variable (ref: 2377)))
	(FAMIX.Access (id: 4730)
		(accessor (ref: 689))
		(sourceAnchor (ref: 690))
		(variable (ref: 2353)))
	(FAMIX.Invocation (id: 4731)
		(receiver (ref: 2911))
		(sender (ref: 35))
		(signature ''ifNotNil:(Object)'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Class (id: 1894)
		(name ''Symbol'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 2)
		(numberOfMethods 1)
		(numberOfParents 0)
		(numberOfStatements -1)
		(totalNumberOfChildren 0)
		(weightedMethodCount -1))
	(FAMIX.Parameter (id: 4250)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 2034)))
	(FAMIX.Access (id: 4732)
		(accessor (ref: 611))
		(sourceAnchor (ref: 612))
		(variable (ref: 610)))
	(FAMIX.Access (id: 4733)
		(accessor (ref: 102))
		(sourceAnchor (ref: 103))
		(variable (ref: 4734)))
	(FAMIX.Access (id: 4735)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Invocation (id: 4736)
		(receiver (ref: 825))
		(sender (ref: 39))
		(signature ''value()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 4737)
		(accessor (ref: 35))
		(sourceAnchor (ref: 36))
		(variable (ref: 1323)))
	(FAMIX.Invocation (id: 4738)
		(sender (ref: 248))
		(signature ''not()'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Invocation (id: 4739)
		(sender (ref: 2))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 1619)))
	(FAMIX.Invocation (id: 4740)
		(receiver (ref: 2074))
		(sender (ref: 1260))
		(signature ''new()'')
		(sourceAnchor (ref: 2073)))
	(FAMIX.Invocation (id: 4741)
		(receiver (ref: 512))
		(sender (ref: 2916))
		(signature ''toPositions()'')
		(sourceAnchor (ref: 2917)))
	(FAMIX.Invocation (id: 4742)
		(sender (ref: 426))
		(signature ''computeBoundsFor:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 4743)
		(accessor (ref: 1837))
		(sourceAnchor (ref: 1838))
		(variable (ref: 3910)))
	(FAMIX.Access (id: 4744)
		(accessor (ref: 719))
		(sourceAnchor (ref: 720))
		(variable (ref: 817)))
	(FAMIX.Parameter (id: 4362)
		(name ''aBlock'')
		(parentBehaviouralEntity (ref: 2042)))
	(FAMIX.Invocation (id: 4745)
		(sender (ref: 1397))
		(signature ''origin()'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Method (id: 1315)
		(name ''attributeKeysMatching:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''attributeKeysMatching:'')
		(sourceAnchor (ref: 1316)))
	(FAMIX.Access (id: 4746)
		(accessor (ref: 80))
		(sourceAnchor (ref: 81))
		(variable (ref: 834)))
	(FAMIX.Access (id: 4747)
		(accessor (ref: 2951))
		(sourceAnchor (ref: 2952))
		(variable (ref: 2950)))
	(FAMIX.Access (id: 4748)
		(accessor (ref: 195))
		(sourceAnchor (ref: 197))
		(variable (ref: 450)))
	(FAMIX.Access (id: 4749)
		(accessor (ref: 43))
		(sourceAnchor (ref: 1163))
		(variable (ref: 42)))
	(FAMIX.Method (id: 1984)
		(name ''addSelection:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 3)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 131))
		(signature ''addSelection:'')
		(sourceAnchor (ref: 1985)))
	(FAMIX.Invocation (id: 4750)
		(receiver (ref: 2302))
		(sender (ref: 304))
		(signature ''isRectangle()'')
		(sourceAnchor (ref: 305)))
	(FAMIX.Access (id: 4751)
		(accessor (ref: 224))
		(sourceAnchor (ref: 225))
		(variable (ref: 1801)))
	(FAMIX.Access (id: 4752)
		(accessor (ref: 746))
		(sourceAnchor (ref: 747))
		(variable (ref: 2911)))
	(FAMIX.Method (id: 737)
		(name ''shapeBoundsAt:ifAbsent:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 2)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shapeBoundsAt:ifAbsent:'')
		(sourceAnchor (ref: 2974)))
	(FAMIX.Access (id: 4753)
		(accessor (ref: 221))
		(sourceAnchor (ref: 222))
		(variable (ref: 2422)))
	(FAMIX.Invocation (id: 4754)
		(sender (ref: 20))
		(signature ''<(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Access (id: 4755)
		(accessor (ref: 166))
		(sourceAnchor (ref: 167))
		(variable (ref: 598)))
	(FAMIX.Access (id: 4756)
		(accessor (ref: 473))
		(sourceAnchor (ref: 474))
		(variable (ref: 2006)))
	(FAMIX.Invocation (id: 4757)
		(sender (ref: 290))
		(signature ''at:(Object)'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Invocation (id: 4758)
		(receiver (ref: 3724))
		(sender (ref: 1507))
		(signature ''edges:from:to:(Object,Object,Object)'')
		(sourceAnchor (ref: 1798)))
	(FAMIX.Invocation (id: 4759)
		(sender (ref: 76))
		(signature ''add:(Object)'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Comment (id: 4760)
		(container (ref: 2015))
		(content ''"If the width or the heigh is below this size, then nested nodes and edges are not displayed"''))
	(FAMIX.Access (id: 4761)
		(accessor (ref: 866))
		(sourceAnchor (ref: 867))
		(variable (ref: 865)))
	(FAMIX.Parameter (id: 4515)
		(name ''aCollectionOfEntities'')
		(parentBehaviouralEntity (ref: 689)))
	(FAMIX.Invocation (id: 4762)
		(receiver (ref: 1456))
		(sender (ref: 478))
		(signature ''allEdges()'')
		(sourceAnchor (ref: 479)))
	(FAMIX.Method (id: 221)
		(name ''computeElementsToDisplay'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 7)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''computeElementsToDisplay'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Method (id: 1260)
		(name ''initializedInstance'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 405))
		(signature ''initializedInstance'')
		(sourceAnchor (ref: 2073)))
	(FAMIX.Access (id: 4763)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Access (id: 4764)
		(accessor (ref: 963))
		(sourceAnchor (ref: 964))
		(variable (ref: 940)))
	(FAMIX.Invocation (id: 4765)
		(receiver (ref: 181))
		(sender (ref: 327))
		(signature ''expandToIncludePoint:(Object)'')
		(sourceAnchor (ref: 328)))
	(FAMIX.Access (id: 4766)
		(accessor (ref: 260))
		(sourceAnchor (ref: 261))
		(variable (ref: 371)))
	(FAMIX.Invocation (id: 4767)
		(receiver (ref: 904))
		(sender (ref: 221))
		(signature ''zOrder()'')
		(sourceAnchor (ref: 222)))
	(FAMIX.Access (id: 4768)
		(accessor (ref: 672))
		(sourceAnchor (ref: 673))
		(variable (ref: 3929)))
	(FAMIX.Comment (id: 4769)
		(container (ref: 689))
		(content ''" aCollectionOfEntities is the collection of from which the edges are defined from."''))
	(FAMIX.Method (id: 951)
		(name ''diameter'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''diameter'')
		(sourceAnchor (ref: 952)))
	(FAMIX.Access (id: 4770)
		(accessor (ref: 938))
		(isWrite true)
		(sourceAnchor (ref: 939))
		(variable (ref: 940)))
	(FAMIX.Parameter (id: 4009)
		(name ''aPoint'')
		(parentBehaviouralEntity (ref: 1967)))
	(FAMIX.Access (id: 4771)
		(accessor (ref: 1096))
		(sourceAnchor (ref: 1097))
		(variable (ref: 1191)))
	(FAMIX.Access (id: 4772)
		(accessor (ref: 388))
		(isWrite true)
		(sourceAnchor (ref: 389))
		(variable (ref: 2196)))
	(FAMIX.Access (id: 4773)
		(accessor (ref: 4434))
		(sourceAnchor (ref: 4435))
		(variable (ref: 4433)))
	(FAMIX.Invocation (id: 4774)
		(receiver (ref: 2537))
		(sender (ref: 2538))
		(signature ''owner()'')
		(sourceAnchor (ref: 2539)))
	(FAMIX.Parameter (id: 1037)
		(name ''aCanvas'')
		(parentBehaviouralEntity (ref: 774)))
	(FAMIX.Invocation (id: 4775)
		(receiver (ref: 93))
		(sender (ref: 91))
		(signature ''red()'')
		(sourceAnchor (ref: 92)))
	(FAMIX.Invocation (id: 4776)
		(receiver (ref: 1904))
		(sender (ref: 658))
		(signature ''model:(Object)'')
		(sourceAnchor (ref: 659)))
	(FAMIX.Parameter (id: 1885)
		(name ''aModel'')
		(parentBehaviouralEntity (ref: 1101)))
	(FAMIX.Invocation (id: 4777)
		(receiver (ref: 940))
		(sender (ref: 963))
		(signature ''isNil()'')
		(sourceAnchor (ref: 964)))
	(FAMIX.Parameter (id: 2515)
		(name ''aValue'')
		(parentBehaviouralEntity (ref: 318)))
	(FAMIX.Access (id: 4778)
		(accessor (ref: 700))
		(sourceAnchor (ref: 701))
		(variable (ref: 986)))
	(FAMIX.Invocation (id: 4779)
		(sender (ref: 1451))
		(signature ''dist:(Object)'')
		(sourceAnchor (ref: 1452)))
	(FAMIX.Access (id: 4780)
		(accessor (ref: 13))
		(sourceAnchor (ref: 14))
		(variable (ref: 1600)))
	(FAMIX.Access (id: 4781)
		(accessor (ref: 1140))
		(sourceAnchor (ref: 1141))
		(variable (ref: 4369)))
	(FAMIX.Access (id: 4782)
		(accessor (ref: 39))
		(sourceAnchor (ref: 40))
		(variable (ref: 1288)))
	(FAMIX.Access (id: 4783)
		(accessor (ref: 1785))
		(sourceAnchor (ref: 1786))
		(variable (ref: 181)))
	(FAMIX.Parameter (id: 3419)
		(name ''regexp'')
		(parentBehaviouralEntity (ref: 1315)))
	(FAMIX.Invocation (id: 4784)
		(sender (ref: 2203))
		(signature ''at:(Object)'')
		(sourceAnchor (ref: 2760)))
	(FAMIX.Access (id: 4785)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 1814)))
	(FAMIX.Parameter (id: 3468)
		(name ''aBounds'')
		(parentBehaviouralEntity (ref: 1709)))
	(FAMIX.Invocation (id: 4786)
		(sender (ref: 13))
		(signature ''-(Object)'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Invocation (id: 4787)
		(sender (ref: 283))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 284)))
	(FAMIX.Access (id: 4788)
		(accessor (ref: 1304))
		(isWrite true)
		(sourceAnchor (ref: 1305))
		(variable (ref: 445)))
	(FAMIX.Comment (id: 4789)
		(container (ref: 426))
		(content ''"Layout the receiver and all its children."''))
	(FAMIX.Invocation (id: 4790)
		(receiver (ref: 2207))
		(sender (ref: 929))
		(signature ''resetCacheInEdges()'')
		(sourceAnchor (ref: 930)))
	(FAMIX.Access (id: 4791)
		(accessor (ref: 437))
		(sourceAnchor (ref: 438))
		(variable (ref: 3405)))
	(FAMIX.Method (id: 1989)
		(name ''edges'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''edges'')
		(sourceAnchor (ref: 1990)))
	(FAMIX.Access (id: 4792)
		(accessor (ref: 256))
		(sourceAnchor (ref: 257))
		(variable (ref: 3033)))
	(FAMIX.Invocation (id: 4793)
		(receiver (ref: 12))
		(sender (ref: 13))
		(signature ''width()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Method (id: 1147)
		(name ''elementsToLookup'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''elementsToLookup'')
		(sourceAnchor (ref: 1148)))
	(FAMIX.Method (id: 4434)
		(name ''purple'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 1385))
		(signature ''purple'')
		(sourceAnchor (ref: 4435)))
	(FAMIX.Invocation (id: 4794)
		(receiver (ref: 299))
		(sender (ref: 192))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 193)))
	(FAMIX.Access (id: 4795)
		(accessor (ref: 408))
		(sourceAnchor (ref: 1241))
		(variable (ref: 407)))
	(FAMIX.Access (id: 4796)
		(accessor (ref: 516))
		(sourceAnchor (ref: 517))
		(variable (ref: 3706)))
	(FAMIX.Parameter (id: 1755)
		(name ''aToBlock'')
		(parentBehaviouralEntity (ref: 360)))
	(FAMIX.Invocation (id: 4797)
		(sender (ref: 408))
		(signature ''detect:ifNone:(Object,Object)'')
		(sourceAnchor (ref: 1241)))
	(FAMIX.Invocation (id: 4798)
		(receiver (ref: 832))
		(sender (ref: 99))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 100)))
	(FAMIX.Invocation (id: 4799)
		(receiver (ref: 619))
		(sender (ref: 308))
		(signature ''nodeForDomainValues:(Object)'')
		(sourceAnchor (ref: 618)))
	(FAMIX.LocalVariable (id: 4800)
		(name ''each'')
		(parentBehaviouralEntity (ref: 894)))
	(FAMIX.Access (id: 4801)
		(accessor (ref: 737))
		(sourceAnchor (ref: 2974))
		(variable (ref: 736)))
	(FAMIX.Access (id: 4802)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 403)))
	(FAMIX.Invocation (id: 4803)
		(sender (ref: 934))
		(signature ''select:(Object)'')
		(sourceAnchor (ref: 935)))
	(FAMIX.Invocation (id: 4804)
		(receiver (ref: 768))
		(sender (ref: 2768))
		(signature ''notNil()'')
		(sourceAnchor (ref: 2769)))
	(FAMIX.Parameter (id: 3189)
		(name ''aMORoot'')
		(parentBehaviouralEntity (ref: 3187)))
	(FAMIX.Invocation (id: 4805)
		(receiver (ref: 263))
		(sender (ref: 861))
		(signature ''ifNil:(Object)'')
		(sourceAnchor (ref: 862)))
	(FAMIX.Access (id: 4806)
		(accessor (ref: 2231))
		(isWrite true)
		(sourceAnchor (ref: 3206))
		(variable (ref: 3086)))
	(FAMIX.Invocation (id: 4807)
		(sender (ref: 1996))
		(signature ''collect:(Object)'')
		(sourceAnchor (ref: 1997)))
	(FAMIX.Invocation (id: 4808)
		(sender (ref: 482))
		(signature ''corner:(Object)'')
		(sourceAnchor (ref: 483)))
	(FAMIX.Invocation (id: 4809)
		(receiver (ref: 1959))
		(sender (ref: 1761))
		(signature ''value:(Object)'')
		(sourceAnchor (ref: 1762)))
	(FAMIX.LocalVariable (id: 3238)
		(name ''edges'')
		(parentBehaviouralEntity (ref: 638)))
	(FAMIX.Invocation (id: 4810)
		(sender (ref: 69))
		(signature ''applyOn:(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 4811)
		(receiver (ref: 1552))
		(sender (ref: 1550))
		(signature ''resetFormCache()'')
		(sourceAnchor (ref: 1551)))
	(FAMIX.Invocation (id: 4812)
		(receiver (ref: 340))
		(sender (ref: 338))
		(signature ''subclassResponsibility()'')
		(sourceAnchor (ref: 339)))
	(FAMIX.LocalVariable (id: 1655)
		(name ''canvas'')
		(parentBehaviouralEntity (ref: 414)))
	(FAMIX.Access (id: 4813)
		(accessor (ref: 602))
		(isWrite true)
		(sourceAnchor (ref: 603))
		(variable (ref: 604)))
	(FAMIX.Comment (id: 4814)
		(container (ref: 91))
		(content ''"green"''))
	(FAMIX.Access (id: 4815)
		(accessor (ref: 1823))
		(isWrite true)
		(sourceAnchor (ref: 2826))
		(variable (ref: 971)))
	(FAMIX.Invocation (id: 4816)
		(receiver (ref: 4285))
		(sender (ref: 2507))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 2508)))
	(FAMIX.Reference (id: 4817)
		(source (ref: 344))
		(sourceAnchor (ref: 345))
		(target (ref: 1335)))
	(FAMIX.Invocation (id: 4818)
		(receiver (ref: 1294))
		(sender (ref: 39))
		(signature ''userDefinedEdges()'')
		(sourceAnchor (ref: 40)))
	(FAMIX.Access (id: 4819)
		(accessor (ref: 207))
		(sourceAnchor (ref: 208))
		(variable (ref: 606)))
	(FAMIX.Invocation (id: 4820)
		(receiver (ref: 1029))
		(sender (ref: 32))
		(signature ''isUnique()'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Parameter (id: 4821)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 1202)))
	(FAMIX.Access (id: 4822)
		(accessor (ref: 84))
		(sourceAnchor (ref: 85))
		(variable (ref: 83)))
	(FAMIX.Access (id: 4823)
		(accessor (ref: 1132))
		(isWrite true)
		(sourceAnchor (ref: 3591))
		(variable (ref: 4049)))
	(FAMIX.Comment (id: 4824)
		(container (ref: 414))
		(content ''"Nodes need to be layouted before calling this method"''))
	(FAMIX.Method (id: 1076)
		(name ''nodeWith:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''nodeWith:'')
		(sourceAnchor (ref: 1077)))
	(FAMIX.Invocation (id: 4825)
		(receiver (ref: 2399))
		(sender (ref: 149))
		(signature ''ensure:(Object)'')
		(sourceAnchor (ref: 150)))
	(FAMIX.Invocation (id: 4826)
		(receiver (ref: 1329))
		(sender (ref: 693))
		(signature ''updateWindow()'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Method (id: 4827)
		(name ''updateBounds'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 1)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''updateBounds'')
		(sourceAnchor (ref: 4828)))
	(FAMIX.Comment (id: 4829)
		(container (ref: 3627))
		(content ''"nothing to do here"''))
	(FAMIX.Access (id: 4830)
		(accessor (ref: 947))
		(sourceAnchor (ref: 948))
		(variable (ref: 1151)))
	(FAMIX.Access (id: 4831)
		(accessor (ref: 819))
		(sourceAnchor (ref: 2290))
		(variable (ref: 818)))
	(FAMIX.Method (id: 264)
		(name ''addNode:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 2)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 58))
		(signature ''addNode:'')
		(sourceAnchor (ref: 265)))
	(FAMIX.Access (id: 4832)
		(accessor (ref: 814))
		(sourceAnchor (ref: 815))
		(variable (ref: 3048)))
	(FAMIX.LocalVariable (id: 239)
		(name ''ass'')
		(parentBehaviouralEntity (ref: 237)))
	(FAMIX.Invocation (id: 4833)
		(receiver (ref: 441))
		(sender (ref: 124))
		(signature ''allNodes()'')
		(sourceAnchor (ref: 125)))
	(FAMIX.Access (id: 4834)
		(accessor (ref: 932))
		(sourceAnchor (ref: 1893))
		(variable (ref: 2458)))
	(FAMIX.Comment (id: 4835)
		(container (ref: 525))
		(content ''"Returns the MONode corresponding to the value anObject"''))
	(FAMIX.Parameter (id: 3062)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 2094)))
	(FAMIX.Method (id: 76)
		(name ''strongColors'')
		(cyclomaticComplexity -1)
		(hasClassScope true)
		(hierarchyNestingLevel 0)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 13)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 1385))
		(signature ''strongColors'')
		(sourceAnchor (ref: 77)))
	(FAMIX.Class (id: 3566)
		(name ''MOHorizontalTreeLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 4836)
		(receiver (ref: 875))
		(sender (ref: 95))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 96)))
	(FAMIX.Access (id: 4837)
		(accessor (ref: 1043))
		(isWrite true)
		(sourceAnchor (ref: 1044))
		(variable (ref: 306)))
	(FAMIX.Method (id: 819)
		(name ''initializeConnectionPositions:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''initializeConnectionPositions:'')
		(sourceAnchor (ref: 2290)))
	(FAMIX.Invocation (id: 4838)
		(receiver (ref: 2831))
		(sender (ref: 497))
		(signature ''computeBoundsFor:(Object)'')
		(sourceAnchor (ref: 2491)))
	(FAMIX.Invocation (id: 4839)
		(receiver (ref: 2864))
		(sender (ref: 275))
		(signature ''nodes()'')
		(sourceAnchor (ref: 276)))
	(FAMIX.Reference (id: 4840)
		(source (ref: 1973))
		(sourceAnchor (ref: 1974))
		(target (ref: 1972)))
	(FAMIX.Parameter (id: 3235)
		(name ''aFigure'')
		(parentBehaviouralEntity (ref: 1806)))
	(FAMIX.Access (id: 4841)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 729)))
	(FAMIX.Invocation (id: 4842)
		(receiver (ref: 2410))
		(sender (ref: 35))
		(signature ''x()'')
		(sourceAnchor (ref: 36)))
	(FAMIX.Invocation (id: 4843)
		(receiver (ref: 587))
		(sender (ref: 54))
		(signature ''shapeBoundsAt:ifAbsentPut:(Object,Object)'')
		(sourceAnchor (ref: 570)))
	(FAMIX.Invocation (id: 4844)
		(receiver (ref: 729))
		(sender (ref: 294))
		(signature ''lookupNode:globally:(Object,Object)'')
		(sourceAnchor (ref: 295)))
	(FAMIX.Parameter (id: 3240)
		(name ''anArray'')
		(parentBehaviouralEntity (ref: 990)))
	(FAMIX.Reference (id: 4845)
		(source (ref: 1354))
		(sourceAnchor (ref: 1355))
		(target (ref: 41)))
	(FAMIX.Method (id: 1996)
		(name ''domain'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 2)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''domain'')
		(sourceAnchor (ref: 1997)))
	(FAMIX.Access (id: 4846)
		(accessor (ref: 1550))
		(sourceAnchor (ref: 1551))
		(variable (ref: 4017)))
	(FAMIX.Invocation (id: 4847)
		(sender (ref: 69))
		(signature ''@(Object)'')
		(sourceAnchor (ref: 501)))
	(FAMIX.Invocation (id: 4848)
		(receiver (ref: 93))
		(sender (ref: 1104))
		(signature ''blue()'')
		(sourceAnchor (ref: 1105)))
	(FAMIX.Invocation (id: 4849)
		(receiver (ref: 1186))
		(sender (ref: 1101))
		(signature ''root()'')
		(sourceAnchor (ref: 1102)))
	(FAMIX.Access (id: 4850)
		(accessor (ref: 69))
		(sourceAnchor (ref: 501))
		(variable (ref: 502)))
	(FAMIX.Access (id: 4851)
		(accessor (ref: 76))
		(sourceAnchor (ref: 77))
		(variable (ref: 75)))
	(FAMIX.Invocation (id: 4852)
		(receiver (ref: 1620))
		(sender (ref: 2))
		(signature ''outgoingEdges()'')
		(sourceAnchor (ref: 1619)))
	(FAMIX.Access (id: 4853)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 591)))
	(FAMIX.Access (id: 4854)
		(accessor (ref: 560))
		(sourceAnchor (ref: 561))
		(variable (ref: 2872)))
	(FAMIX.Invocation (id: 4855)
		(receiver (ref: 1277))
		(sender (ref: 2661))
		(signature ''new()'')
		(sourceAnchor (ref: 2662)))
	(FAMIX.Invocation (id: 4856)
		(sender (ref: 192))
		(signature ''notNil()'')
		(sourceAnchor (ref: 193)))
	(FAMIX.Access (id: 4857)
		(accessor (ref: 426))
		(sourceAnchor (ref: 577))
		(variable (ref: 578)))
	(FAMIX.Invocation (id: 4858)
		(receiver (ref: 4342))
		(sender (ref: 1283))
		(signature ''layout:(Object)'')
		(sourceAnchor (ref: 1284)))
	(FAMIX.Invocation (id: 4859)
		(sender (ref: 204))
		(signature ''root()'')
		(sourceAnchor (ref: 205)))
	(FAMIX.Comment (id: 4860)
		(container (ref: 505))
		(content ''"We should not cache"''))
	(FAMIX.Access (id: 4861)
		(accessor (ref: 2796))
		(sourceAnchor (ref: 2797))
		(variable (ref: 3652)))
	(FAMIX.Method (id: 32)
		(name ''setUsefulHandlersForNodes'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 14)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''setUsefulHandlersForNodes'')
		(sourceAnchor (ref: 33)))
	(FAMIX.Access (id: 4862)
		(accessor (ref: 974))
		(sourceAnchor (ref: 975))
		(variable (ref: 850)))
	(FAMIX.Access (id: 4863)
		(accessor (ref: 468))
		(sourceAnchor (ref: 1364))
		(variable (ref: 467)))
	(FAMIX.Method (id: 2094)
		(name ''node:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''node:'')
		(sourceAnchor (ref: 2095)))
	(FAMIX.Invocation (id: 4864)
		(sender (ref: 443))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 444)))
	(FAMIX.Access (id: 4865)
		(accessor (ref: 1582))
		(sourceAnchor (ref: 1583))
		(variable (ref: 1584)))
	(FAMIX.Access (id: 4866)
		(accessor (ref: 248))
		(sourceAnchor (ref: 249))
		(variable (ref: 250)))
	(FAMIX.Access (id: 4867)
		(accessor (ref: 327))
		(sourceAnchor (ref: 328))
		(variable (ref: 462)))
	(FAMIX.Invocation (id: 4868)
		(receiver (ref: 1620))
		(sender (ref: 2))
		(signature ''incomingEdges()'')
		(sourceAnchor (ref: 1619)))
	(FAMIX.Parameter (id: 2393)
		(name ''aSymbol'')
		(parentBehaviouralEntity (ref: 1406)))
	(FAMIX.Method (id: 549)
		(name ''edgesDo:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''edgesDo:'')
		(sourceAnchor (ref: 550)))
	(FAMIX.Comment (id: 4869)
		(container (ref: 1855))
		(content ''"Scale an element by a value"''))
	(FAMIX.Parameter (id: 3638)
		(name ''anElement'')
		(parentBehaviouralEntity (ref: 861)))
	(FAMIX.Access (id: 4870)
		(accessor (ref: 48))
		(sourceAnchor (ref: 49))
		(variable (ref: 1638)))
	(FAMIX.Access (id: 4871)
		(accessor (ref: 827))
		(isWrite true)
		(sourceAnchor (ref: 1301))
		(variable (ref: 1302)))
	(FAMIX.Access (id: 4872)
		(accessor (ref: 1080))
		(sourceAnchor (ref: 1081))
		(variable (ref: 2088)))
	(FAMIX.Invocation (id: 4873)
		(receiver (ref: 1600))
		(sender (ref: 13))
		(signature ''resetCache()'')
		(sourceAnchor (ref: 14)))
	(FAMIX.Class (id: 2745)
		(name ''MOCircleLayout class'')
		(fanIn 0)
		(fanOut 0)
		(hierarchyNestingLevel 0)
		(isStub true)
		(numberOfAttributes 0)
		(numberOfComments 0)
		(numberOfLinesOfCode 0)
		(numberOfMethods 0)
		(numberOfParents 0)
		(numberOfStatements 0)
		(totalNumberOfChildren 0)
		(weightedMethodCount 0))
	(FAMIX.Invocation (id: 4874)
		(receiver (ref: 3479))
		(sender (ref: 1397))
		(signature ''absoluteBounds()'')
		(sourceAnchor (ref: 1398)))
	(FAMIX.Comment (id: 4875)
		(container (ref: 1406))
		(content ''"aSymbol should start with #cache, else it will not be properly reseted"''))
	(FAMIX.Access (id: 4876)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 657)))
	(FAMIX.Invocation (id: 4877)
		(receiver (ref: 1814))
		(sender (ref: 84))
		(signature ''root()'')
		(sourceAnchor (ref: 85)))
	(FAMIX.Method (id: 2951)
		(name ''applyOn:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 0)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 3)
		(numberOfParameters 1)
		(numberOfStatements -1)
		(parentType (ref: 45))
		(signature ''applyOn:'')
		(sourceAnchor (ref: 2952)))
	(FAMIX.Access (id: 4878)
		(accessor (ref: 1227))
		(isWrite true)
		(sourceAnchor (ref: 2035))
		(variable (ref: 1161)))
	(FAMIX.Access (id: 4879)
		(accessor (ref: 3728))
		(isWrite true)
		(sourceAnchor (ref: 3729))
		(variable (ref: 1432)))
	(FAMIX.Invocation (id: 4880)
		(sender (ref: 20))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 21)))
	(FAMIX.Parameter (id: 4881)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 1507)))
	(FAMIX.Access (id: 4882)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 2864)))
	(FAMIX.Invocation (id: 4883)
		(receiver (ref: 1064))
		(sender (ref: 774))
		(signature ''newElement:on:(Object,Object)'')
		(sourceAnchor (ref: 775)))
	(FAMIX.LocalVariable (id: 3578)
		(name ''node'')
		(parentBehaviouralEntity (ref: 560)))
	(FAMIX.Invocation (id: 4884)
		(sender (ref: 426))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Access (id: 4885)
		(accessor (ref: 723))
		(sourceAnchor (ref: 724))
		(variable (ref: 4188)))
	(FAMIX.Method (id: 360)
		(name ''edges:fromAll:to:using:'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(modifiers ''isPublic'')
		(numberOfComments 2)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 5)
		(numberOfParameters 4)
		(numberOfStatements -1)
		(parentType (ref: 593))
		(signature ''edges:fromAll:to:using:'')
		(sourceAnchor (ref: 361)))
	(FAMIX.Access (id: 4886)
		(accessor (ref: 162))
		(sourceAnchor (ref: 163))
		(variable (ref: 164)))
	(FAMIX.Invocation (id: 4887)
		(receiver (ref: 1685))
		(sender (ref: 290))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 291)))
	(FAMIX.Access (id: 4888)
		(accessor (ref: 294))
		(sourceAnchor (ref: 295))
		(variable (ref: 2635)))
	(FAMIX.Access (id: 4889)
		(accessor (ref: 894))
		(sourceAnchor (ref: 895))
		(variable (ref: 1815)))
	(FAMIX.Access (id: 4890)
		(accessor (ref: 13))
		(isWrite true)
		(sourceAnchor (ref: 14))
		(variable (ref: 4552)))
	(FAMIX.Access (id: 4891)
		(accessor (ref: 275))
		(sourceAnchor (ref: 276))
		(variable (ref: 1384)))
	(FAMIX.Access (id: 4892)
		(accessor (ref: 283))
		(sourceAnchor (ref: 284))
		(variable (ref: 282)))
	(FAMIX.Invocation (id: 4893)
		(sender (ref: 525))
		(signature ''=(Object)'')
		(sourceAnchor (ref: 526)))
	(FAMIX.Access (id: 4894)
		(accessor (ref: 661))
		(sourceAnchor (ref: 662))
		(variable (ref: 2816)))
	(FAMIX.Access (id: 4895)
		(accessor (ref: 48))
		(isWrite true)
		(sourceAnchor (ref: 49))
		(variable (ref: 3167)))
	(FAMIX.Comment (id: 4896)
		(container (ref: 611))
		(content ''"This help getting through concurent accesses"''))
	(FAMIX.Access (id: 4897)
		(accessor (ref: 368))
		(sourceAnchor (ref: 369))
		(variable (ref: 2386)))
	(FAMIX.Invocation (id: 4898)
		(receiver (ref: 371))
		(sender (ref: 260))
		(signature ''numArgs()'')
		(sourceAnchor (ref: 261)))
	(FAMIX.Access (id: 4899)
		(accessor (ref: 290))
		(sourceAnchor (ref: 291))
		(variable (ref: 3053)))
	(FAMIX.Access (id: 4900)
		(accessor (ref: 658))
		(sourceAnchor (ref: 659))
		(variable (ref: 3397)))
	(FAMIX.Access (id: 4901)
		(accessor (ref: 1645))
		(sourceAnchor (ref: 2483))
		(variable (ref: 2548)))
	(FAMIX.Parameter (id: 1525)
		(name ''anObject'')
		(parentBehaviouralEntity (ref: 1523)))
	(FAMIX.Comment (id: 4902)
		(container (ref: 756))
		(content ''"Install the default event handler for the root"''))
	(FAMIX.Comment (id: 4903)
		(container (ref: 35))
		(content ''"	minX := self children inject: 10000 into: [:min :figure | min min: (figure origin x)].
	minY := self children inject: 10000 into: [:min :figure | min min: (figure origin y)].
	bounds origin: minX @ minY"''))
	(FAMIX.Invocation (id: 4904)
		(sender (ref: 426))
		(signature ''ifTrue:ifFalse:(Object,Object)'')
		(sourceAnchor (ref: 577)))
	(FAMIX.Parameter (id: 489)
		(name ''aShape'')
		(parentBehaviouralEntity (ref: 487)))
	(FAMIX.Invocation (id: 4905)
		(receiver (ref: 797))
		(sender (ref: 798))
		(signature ''domain()'')
		(sourceAnchor (ref: 799)))
	(FAMIX.Invocation (id: 4906)
		(receiver (ref: 2896))
		(sender (ref: 498))
		(signature ''now()'')
		(sourceAnchor (ref: 499)))
	(FAMIX.Reference (id: 4907)
		(source (ref: 91))
		(sourceAnchor (ref: 92))
		(target (ref: 93)))
	(FAMIX.Access (id: 4908)
		(accessor (ref: 57))
		(isWrite true)
		(sourceAnchor (ref: 59))
		(variable (ref: 832)))
	(FAMIX.Access (id: 4909)
		(accessor (ref: 1507))
		(sourceAnchor (ref: 1798))
		(variable (ref: 4881)))
	(FAMIX.Parameter (id: 4647)
		(name ''associations'')
		(parentBehaviouralEntity (ref: 2406)))
	(FAMIX.Invocation (id: 4910)
		(receiver (ref: 67))
		(sender (ref: 693))
		(signature ''notNil()'')
		(sourceAnchor (ref: 1328)))
	(FAMIX.Access (id: 4911)
		(accessor (ref: 988))
		(sourceAnchor (ref: 989))
		(variable (ref: 1252)))
	(FAMIX.Access (id: 4912)
		(accessor (ref: 1709))
		(sourceAnchor (ref: 1710))
		(variable (ref: 3468)))
	(FAMIX.Access (id: 4913)
		(accessor (ref: 1761))
		(sourceAnchor (ref: 1762))
		(variable (ref: 3954)))
	(FAMIX.Invocation (id: 4914)
		(receiver (ref: 1194))
		(sender (ref: 638))
		(signature ''do:(Object)'')
		(sourceAnchor (ref: 639)))
	(FAMIX.Comment (id: 4915)
		(container (ref: 388))
		(content ''"We take the first class, not perfect, but it should be enough for now"''))
	(FAMIX.Access (id: 4916)
		(accessor (ref: 200))
		(sourceAnchor (ref: 201))
		(variable (ref: 199)))
	(FAMIX.Parameter (id: 1135)
		(name ''aFromBlock'')
		(parentBehaviouralEntity (ref: 350)))
	(FAMIX.Method (id: 1275)
		(name ''shape'')
		(cyclomaticComplexity -1)
		(hierarchyNestingLevel 1)
		(isPublic true)
		(kind ''getter'')
		(modifiers ''isPublic'')
		(numberOfComments 1)
		(numberOfConditionals -1)
		(numberOfLinesOfCode 4)
		(numberOfParameters 0)
		(numberOfStatements -1)
		(parentType (ref: 233))
		(signature ''shape'')
		(sourceAnchor (ref: 4326)))
	(FAMIX.Access (id: 4917)
		(accessor (ref: 1043))
		(sourceAnchor (ref: 1044))
		(variable (ref: 1045)))
	(FAMIX.Invocation (id: 4918)
		(receiver (ref: 168))
		(sender (ref: 166))
		(signature ''+(Object)'')
		(sourceAnchor (ref: 167)))
	(FAMIX.Invocation (id: 4919)
		(sender (ref: 398))
		(signature ''keys()'')
		(sourceAnchor (ref: 399)))
	(FAMIX.Parameter (id: 4298)
		(name ''symbol'')
		(parentBehaviouralEntity (ref: 516)))
	(FAMIX.LocalVariable (id: 2417)
		(name ''basicBounds'')
		(parentBehaviouralEntity (ref: 1043)))
	(FAMIX.Invocation (id: 4920)
		(receiver (ref: 2939))
		(sender (ref: 2203))
		(signature ''shapeBounds()'')
		(sourceAnchor (ref: 2760)))
	(FAMIX.Access (id: 4921)
		(accessor (ref: 1666))
		(sourceAnchor (ref: 1667))
		(variable (ref: 3973)))
	(FAMIX.Invocation (id: 4922)
		(sender (ref: 248))
		(signature ''ifTrue:(Object)'')
		(sourceAnchor (ref: 249)))
	(FAMIX.Access (id: 4923)
		(accessor (ref: 95))
		(sourceAnchor (ref: 96))
		(variable (ref: 875)))
	(FAMIX.Access (id: 4924)
		(accessor (ref: 54))
		(sourceAnchor (ref: 570))
		(variable (ref: 2323)))
	(FAMIX.Invocation (id: 4925)
		(receiver (ref: 1773))
		(sender (ref: 1511))
		(signature ''bounds()'')
		(sourceAnchor (ref: 1772)))
	(FAMIX.Access (id: 4926)
		(accessor (ref: 404))
		(sourceAnchor (ref: 406))
		(variable (ref: 1453)))
	(FAMIX.Access (id: 4927)
		(accessor (ref: 204))
		(sourceAnchor (ref: 205))
		(variable (ref: 2029)))
	(FAMIX.Comment (id: 4928)
		(container (ref: 2367))
		(content ''"We cannot use nodesDo: here since the list is modified while being iterated over"''))
	(FAMIX.LocalVariable (id: 2096)
		(name ''coll'')
		(parentBehaviouralEntity (ref: 2094)))
	(FAMIX.Invocation (id: 4929)
		(receiver (ref: 653))
		(sender (ref: 35))
		(signature ''error:(Object)'')
		(sourceAnchor (ref: 36))))'! !

!ObtainingAllModelClassesHistoriesTest methodsFor: 'utils' stamp: 'AlexandreBergel 9/30/2011 11:54'!
sampleMSE
	^ '(
	(FAMIX.Namespace (id: 1) (name ''aNamespace''))

	(FAMIX.Class (id: 2) (name ''ClassA'') (container (ref: 1)) (parentPackage (ref: 201)))
	(FAMIX.Method (name ''methodA1'') (signature ''methodA1()'') (parentType (ref: 2)) (LOC 2))
	(FAMIX.Attribute (name ''attributeA1'') (parentType (ref: 2)))

	(FAMIX.Class (id: 3) (name ''ClassB'') (container (ref: 1)) (isStub true) (parentPackage (ref: 201)))

	(FAMIX.Inheritance (subclass (ref: 3)) (superclass (ref: 2)))

	(FAMIX.Package (id: 201) (name ''aPackage''))
	(FAMIX.Package (id: 202) (name ''aPackage'') (parentPackage (ref: 201)))
)'! !

!ObtainingAllModelClassesHistoriesTest methodsFor: 'testing' stamp: 'SantiagoVidal 10/3/2011 09:12'!
testModelClasses
	| allModelClasses allHistoryModelClasses mooseSampleData sampleMooseModel hismoHistoryModel |
	mooseSampleData := MooseSampleData new.
	sampleMooseModel := (mooseSampleData readMSEString: self mondrianSampleModel)
				name: #'Simple model 5'.
				
	allModelClasses := sampleMooseModel allModelClasses.

	hismoHistoryModel := HismoModelHistory new.
	hismoHistoryModel addLastVersionForMooseModel: sampleMooseModel.
	hismoHistoryModel name: #'Sample history'.
	allHistoryModelClasses := hismoHistoryModel allClassHistories
				select: [:each | each last isStub not].
	self assert: allModelClasses size = allHistoryModelClasses size! !

!ObtainingAllModelClassesHistoriesTest methodsFor: 'testing' stamp: 'AlexandreBergel 9/30/2011 11:57'!
testStubAndHismo
	| allModelClasses allHistoryModelClasses sampleMooseModel hismoHistoryModel |
	
	sampleMooseModel := MooseModel new importFromMSEStream: self sampleMSE readStream.
				
	allModelClasses := sampleMooseModel allModelClasses.

	self assert: (sampleMooseModel allModelClasses size = 1).
	self assert: (sampleMooseModel allClasses size = 2).

	hismoHistoryModel := HismoModelHistory new.
	hismoHistoryModel addLastVersionForMooseModel: sampleMooseModel.
	allHistoryModelClasses := hismoHistoryModel allClassHistories
				select: [:each | each last isStub not].
	self assert: allModelClasses size = allHistoryModelClasses size! !

Object subclass: #AdditionalMetrics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Util'!

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/28/2012 10:05'!
accessOfLocalData: aMethod
	|ownDependencies superclasses dependencies parentClass|
	
	parentClass:=aMethod parentType.
	superclasses:=OrderedCollection new.
	parentClass allSuperclassesDo:[:aSuperClass|
		superclasses add: aSuperClass.
	].
	superclasses add:parentClass.
	ownDependencies:=OrderedCollection new.
	dependencies:= aMethod queryAllOutgoingAssociations.
	dependencies do:[:dependency|
		"Si la dependencia esta definida en mi clase agregar al vector"
		|parentType|
		parentType:=nil.
		(dependency isKindOf: FAMIXAccess)ifTrue:[
			parentType:=dependency accessor parentType.
		] ifFalse:[
			(dependency isKindOf: FAMIXReference)ifTrue:[
				parentType:=dependency target.
			] ifFalse:[
				(dependency isKindOf: FAMIXInvocation)ifTrue:[
					(dependency candidates size>0)ifTrue:[
						parentType:=(dependency candidates at:1) parentType.
					].
				] "ifFalse:[
					self halt.
				]."
			].
		].
		
		(self collection: superclasses contains: parentType) ifTrue:[
			ownDependencies add:parentType.
		].
		
	].
	
	^(ownDependencies size).! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/28/2012 09:20'!
accessToForeignData: class
	|classesAccesed superclasses dependencies|
	
	superclasses:=OrderedCollection new.
	
	class allSuperclassesDo:[:aSuperClass|
		superclasses add: aSuperClass.
	].
	classesAccesed:=OrderedCollection new.
	dependencies:= class queryAllOutgoingAssociations atClassScope. "Esto hay que eliminarlo"
	
	dependencies do:[:dependency|
		(self collection: classesAccesed contains: dependency) ifFalse:[
			(self collection: superclasses contains: dependency) ifFalse:[
				(class==dependency)ifFalse:[
					classesAccesed add:dependency.
				].
			].
		].	
	].

	^(classesAccesed size).! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 12:23'!
accessToForeignDataForAMethod: aMethod
	| classesAccesed dependencies |
	classesAccesed := self calculateATFD: aMethod.
	^ classesAccesed size! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 11:31'!
averageMethodWeight: aClass
	|nom wmc|
	nom:=aClass methods size.
	wmc:=aClass weightedMethodCount.
	
	(nom>0) ifTrue:[^wmc/nom].
	^0.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 11:18'!
baseClassOverridingRatio:aClass
	((aClass methods size )>0) ifTrue:[
		^ (aClass overridingMethods size )/ (aClass methods size).
	].
	^1.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 11:09'!
baseClassUsageRatio: aClass
	|protectedMethod protectedMethodsUsed protectedOperationsCalled protectedAccessCalled|
	protectedMethod:= self numberOfProtectedMembers: (aClass superclass).
	
	(protectedMethod <3) ifTrue:[^1].
	
	protectedOperationsCalled:= OrderedCollection new.
	aClass queryAllOutgoingInvocations do:[ :anInvocation |
		(anInvocation candidates size >0) ifTrue:[
			|targetMethod|
			targetMethod:=anInvocation candidates at:1.
			(targetMethod isProtected) ifTrue:[
				(self collection: protectedOperationsCalled contains: targetMethod) ifFalse:[
					protectedOperationsCalled add:targetMethod.
				]
			]	
		].
	].
	protectedMethodsUsed:= protectedOperationsCalled size.
	protectedAccessCalled:=OrderedCollection new.
	aClass queryOutgoingAccesses do:[ :anAccess |
		(anAccess accessor ==nil) ifFalse:[
			(anAccess accessor isProtected) ifTrue:[
				(self collection: protectedAccessCalled contains:  (anAccess accessor)) ifFalse:[
					protectedAccessCalled add: anAccess accessor.
				]
			]	
		].
	].
	protectedMethodsUsed:=protectedMethodsUsed+protectedAccessCalled size.
	protectedMethodsUsed:=protectedMethodsUsed+aClass overridingMethods size.
	
	^protectedMethodsUsed/protectedMethod.
! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/16/2012 11:37'!
calculateATFD: aMethod
	| classesAccesed superclasses parentClass |
	parentClass := aMethod parentType.
	superclasses := OrderedCollection new.
	parentClass allSuperclassesDo: [ :aSuperClass | superclasses add: aSuperClass ].
	superclasses add: parentClass.
	classesAccesed := OrderedCollection new.
	aMethod queryOutgoingAccesses
		do: [ :anAccesses | 
			| accessedClass |
			(anAccesses variable isKindOf: FAMIXLocalVariable)ifTrue:[accessedClass := anAccesses variable declaredType.] ifFalse:[accessedClass := anAccesses variable parentType.].
			
			(self collection: superclasses contains: accessedClass)
				ifFalse: [ classesAccesed add: accessedClass ] ].
	aMethod queryAllOutgoingInvocations
		do: [ :anInvocation | 
			anInvocation candidates size > 0
				ifTrue: [ 
					| methodTarget |
					methodTarget := anInvocation candidates at: 1.
					methodTarget isGetter
						ifTrue: [ 
							| methodClass |
							methodClass := methodTarget parentType.
							(self collection: superclasses contains: methodClass)
								ifFalse: [ classesAccesed add: methodClass ] ] ] ].
	^ classesAccesed! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 10:49'!
calculateChangingMethods: aMethod
	| superclasses uniqueInvocations |
	uniqueInvocations := OrderedCollection new.
	superclasses := OrderedCollection new.
	aMethod parentType allSuperclassesDo: [ :aSuperClass | superclasses add: aSuperClass ].
	superclasses add: aMethod parentType.
	aMethod parentType allSubclassesDo: [ :aSuperClass | superclasses add: aSuperClass ].
	aMethod queryAllIncomingInvocations
		do: [ :anInvocation | 
			| callingMethod |
			callingMethod := anInvocation sender.
			(self collection: uniqueInvocations contains: callingMethod)
				ifFalse: [ 
					(self collection: superclasses contains: callingMethod parentType)
						ifFalse: [ uniqueInvocations add: callingMethod ] ] ].
	^ uniqueInvocations! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 10:49'!
changinMethods: aMethod
	| uniqueInvocations |
	uniqueInvocations := self calculateChangingMethods: aMethod.
	^ uniqueInvocations size! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 10:54'!
changingClasses:aMethod
	|uniqueInvocations uniqueClasses|
	uniqueInvocations := self calculateChangingMethods: aMethod.
	uniqueClasses:=OrderedCollection new.
	uniqueInvocations do:[:anInvokedMethod|
		(self collection: uniqueClasses contains: (anInvokedMethod parentType))ifFalse:[
			uniqueClasses add:anInvokedMethod parentType.
		].
	].
	^uniqueClasses size.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/22/2012 15:45'!
collection: collection contains:class
	collection do:[:aclass|
		(aclass==class)ifTrue:[
			^true.
		].
	].
^false.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 15:59'!
couplingDispersion: aMethod
	|cint parentClass superclasses uniqueInvocations|
	cint:=self couplingIntensity: aMethod.
	(cint==0) ifTrue:[^0].
	
	parentClass:=aMethod parentType.
	superclasses:=OrderedCollection new.
	parentClass allSuperclassesDo:[:aSuperClass|
		superclasses add: aSuperClass.
	].
	superclasses add:parentClass.
	
	
	
	uniqueInvocations:=OrderedCollection new.
	aMethod queryAllOutgoingInvocations do:[:anInvocation|
		(anInvocation candidates size >0) ifTrue:[
			|targetMethod|
			targetMethod:=anInvocation candidates at:1.
			
				(targetMethod isConstructor | targetMethod isConstant | targetMethod isProtected) ifFalse:[
					|parentType|
					parentType:=targetMethod parentType.
					(self collection: superclasses contains: parentType) ifFalse:[
						(self collection: uniqueInvocations contains: parentType) ifFalse:[
							uniqueInvocations add: parentType.
						].
					].
					
				]	
		].
		
	].
	
		
	^ (uniqueInvocations size)/cint.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 15:50'!
couplingIntensity:aMethod
	|uniqueInvocations parentClass superclasses|
	
	parentClass:=aMethod parentType.
	superclasses:=OrderedCollection new.
	parentClass allSuperclassesDo:[:aSuperClass|
		superclasses add: aSuperClass.
	].
	superclasses add:parentClass.
	
	
	
	uniqueInvocations:=OrderedCollection new.
	aMethod queryAllOutgoingInvocations do:[:anInvocation|
		(anInvocation candidates size >0) ifTrue:[
			|targetMethod|
			targetMethod:=anInvocation candidates at:1.
			(self collection: uniqueInvocations contains: targetMethod) ifFalse:[
				(targetMethod isConstructor | targetMethod isConstant | targetMethod isProtected) ifFalse:[
					|parentType|
					parentType:=targetMethod parentType.
					(self collection: superclasses contains: parentType) ifFalse:[
						uniqueInvocations add: targetMethod.
					].
					
				]
			].	
		].
		
	].
	 ^uniqueInvocations size.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 12:25'!
foreignDataProvidersForAMethod: aMethod
	|classesAccesed uniqueClasses|
	classesAccesed := self calculateATFD: aMethod.
	uniqueClasses:=OrderedCollection new.
	classesAccesed do:[:class|
		(self collection: uniqueClasses contains: class) ifFalse:[
			uniqueClasses add: class.
		].
	].
	
	^ uniqueClasses size! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/27/2012 14:48'!
localityOfAttributesAccesses:aMethod
	|atfd ald|
	atfd:=self accessToForeignDataForAMethod: aMethod.
	ald:= self accessOfLocalData: aMethod.
	((atfd+ald)=0)ifTrue:[^1].
	^(ald/(atfd+ald))! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/24/2012 10:29'!
numberOfAccessedVariables:aMethod
	|count|
	count:=0.
	count:=count +aMethod accesses size.
	count:=count +aMethod localVariables size.
	count:=count +aMethod parameters size.
	^count.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 13:35'!
numberOfAddedServices: aClass
	|nas|
	nas:=0.
	aClass methodsDo: [:aMethod|
		(aMethod isOverriding | aMethod isConstructor | aMethod isGetter | aMethod isSetter) ifFalse: [
			(aMethod isPublic) ifTrue:[
				nas:=nas+1.	
			].		
		]
	].	

	^nas! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 10:04'!
numberOfProtectedMembers: aClass
	|count|
	count:=0.
	aClass attributes do:[:anAttribute|
		(anAttribute isProtected) ifTrue:[count:=count+1.]
	].
	aClass methodsDo: [:aMethod| 
		(aMethod isProtected) ifTrue:[count:=count+1.]
	].
	^count.! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 13:49'!
percentageOfNewlyAddedServices: aClass
	|allPublic|
	allPublic:=0.
	aClass methodsDo: [:aMethod|
		(aMethod isConstructor) ifFalse: [
			(aMethod isPublic) ifTrue:[
				allPublic:=allPublic+1.	
			].		
		]
	].	
	(allPublic==0) ifTrue:[^0].

	^(self numberOfAddedServices: aClass)/allPublic! !

!AdditionalMetrics class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/28/2012 11:09'!
weightOfAClass: aClass
	|temp den nom|
	den:=0.
	nom:=0.
	aClass methodsDo: [:aMethod|
		(aMethod isPublic) ifTrue:[
			(aMethod isConstructor) ifFalse:[
				nom:=nom+1.
				(aMethod isGetter | aMethod isSetter) ifTrue:[
					den:=den+1.
				].
			]
		]	
	].
	aClass attributes do:[:anAttribute|
		(anAttribute isPublic) ifTrue:[
			nom:=nom+1.
		]
	].
	(nom>0) ifTrue:[
		temp:=den/nom.
	] ifFalse:[
		(den==0) ifTrue:[
			temp:=0.
		] ifFalse:[
			temp:= Integer maxVal.
		].
	].
	^temp.! !

Object subclass: #AutomaticalCaseStudies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

AutomaticalCaseStudies class
	instanceVariableNames: 'weightedMethodCount'!

AutomaticalCaseStudies class
	instanceVariableNames: 'weightedMethodCount'!

!AutomaticalCaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/23/2011 12:41'!
calculateAverageCorrelationForHistory: history of: aBlockOrSymbol1 and: aBlockOrSymbol2
|correlation totalOfCases errorDuringCalculation|
	correlation:=0.
	totalOfCases:=0.
	history do:[:classHistory | 
		
			errorDuringCalculation:=false.
			[correlation:= correlation+ (classHistory correlationOf: aBlockOrSymbol1 and: aBlockOrSymbol2)] on: Error do:[ :ex | ex halt.. errorDuringCalculation:=true].
			errorDuringCalculation ifFalse:[totalOfCases:=totalOfCases+1].

	].
	(totalOfCases==0) ifTrue:[^0].
	^(correlation/totalOfCases).! !

!AutomaticalCaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/23/2011 12:48'!
calculateAverageCorrelationForHistoryClasses: history of: aBlockOrSymbol1 and: aBlockOrSymbol2
|correlation totalOfCases errorDuringCalculation|
	correlation:=0.
	totalOfCases:=0.
	history do:[:classHistory | 
		(classHistory evolutionOfNumberOfMethods = 0 and: [ classHistory evolutionOfNumberOfLinesOfCode = 0] ) ifFalse:[
			errorDuringCalculation:=false.
			[correlation:= correlation+ (classHistory correlationOf: aBlockOrSymbol1 and: aBlockOrSymbol2)] on: Error do:[ :ex | (ex printString ='Error: An array containts only one value') ifFalse:[ex halt]. errorDuringCalculation:=true].
			errorDuringCalculation ifFalse:[totalOfCases:=totalOfCases+1].
		].
	].
	(totalOfCases==0) ifTrue:[^0].
	^(correlation/totalOfCases).! !

!AutomaticalCaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/23/2011 20:21'!
createMatrixOfCorrelationsComplexityDependenciesForClasses
	|histories hismoModel classesHistories currentClassVersion fileStream LOCDependencieCorrelation errorDuringCalculation totalOfCases|

	histories:=MooseModel root allModels asArray.
	hismoModel := HismoModelHistory new.
	histories do: [:model | hismoModel addLastVersionForMooseModel: model].
	hismoModel name: #'HismoModel'.
	fileStream := FileStream forceNewFileNamed: 'output.txt'. 
	classesHistories:=hismoModel allClassHistories select: [:each | each last isStub not].
	fileStream nextPutAll: ' ';tab.
	fileStream nextPutAll: 'LOC';tab.
	fileStream nextPutAll: 'WMC';tab.
	fileStream nextPutAll: 'FanInFanOut/LOC';tab.
	fileStream nextPutAll: 'FanInFanOut/CC';tab;cr.
	
	
	
	fileStream nextPutAll: 'Dependencie';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieClass';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieClassWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope  size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependenciePackage';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab;cr.
	
	
	
	fileStream nextPutAll: 'DependenciePackageWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieNameSpace';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieNameSpaceWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c numberOfLinesOfCode)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistoryClasses: classesHistories of: [ :c | (c weightedMethodCount)*(((c fanIn)*(c fanOut))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab;cr.

	
	fileStream close.
! !

!AutomaticalCaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/23/2011 09:23'!
createMatrixOfCorrelationsComplexityDependenciesForMethods
	|histories hismoModel methodsHistories currentClassVersion fileStream LOCDependencieCorrelation errorDuringCalculation totalOfCases|

	histories:=MooseModel root allModels asArray.
	hismoModel := HismoModelHistory new.
	histories do: [:model | hismoModel addLastVersionForMooseModel: model].
	hismoModel name: #'HismoModel'.
	fileStream := FileStream forceNewFileNamed: 'output.txt'. 
	methodsHistories:=hismoModel allMethodHistories select: [:each | each last isStub not]."<------ Cambie aca"
	fileStream nextPutAll: ' ';tab.
	fileStream nextPutAll: 'LOC';tab.
	fileStream nextPutAll: 'CC';tab.
	fileStream nextPutAll: 'FanInFanOut/LOC';tab.
	fileStream nextPutAll: 'FanInFanOut/CC';tab;cr.
	
	
	
	fileStream nextPutAll: 'Dependencie';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieWithoutLoops';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'Dependencie(Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieWithoutLoops(Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieClass';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieClassWithoutLoops';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab;cr.
	
	
	
	fileStream nextPutAll: 'DependencieClass (Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations atClassScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieClassWithoutLoops (Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atClassScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependenciePackage';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependenciePackageWithoutLoops';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependenciePackage (Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations atPackageScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependenciePackageWithoutLoops (Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atPackageScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieNameSpace';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieNameSpaceWithoutLoops';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieNameSpace (Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations  atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations atNamespaceScope size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieNameSpaceWithoutLoops (Invocations)';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #numberOfLinesOfCode and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: #cyclomaticComplexity and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c numberOfLinesOfCode)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: methodsHistories of: [ :c | (c cyclomaticComplexity)*(((c incomingInvocations size)*(c outgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size]) printString;tab;cr.
	
	fileStream close.
! !

!AutomaticalCaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/23/2011 11:43'!
createMatrixOfCorrelationsComplexityDependenciesForPackages
	|histories hismoModel packagesHistories currentClassVersion fileStream LOCDependencieCorrelation errorDuringCalculation totalOfCases|

	histories:=MooseModel root allModels asArray.
	hismoModel := HismoModelHistory new.
	histories do: [:model | hismoModel addLastVersionForMooseModel: model].
	hismoModel name: #'HismoModel'.
	fileStream := FileStream forceNewFileNamed: 'output.txt'. 
	packagesHistories:=hismoModel allPackageHistories select: [:each | each last isStub not].
	fileStream nextPutAll: ' ';tab.
	fileStream nextPutAll: 'LOC';tab.
	fileStream nextPutAll: 'WMC';tab.
	fileStream nextPutAll: 'FanInFanOut/LOC';tab.
	fileStream nextPutAll: 'FanInFanOut/CC';tab;cr.
	
	
	
	fileStream nextPutAll: 'Dependencie';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies size]) printString;tab;cr.
	
	fileStream nextPutAll: 'DependencieWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieClass';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atClassScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieClassWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope  size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atClassScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependenciePackage';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atPackageScope size]) printString;tab;cr.
	
	
	
	fileStream nextPutAll: 'DependenciePackageWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atPackageScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieNameSpace';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies atNamespaceScope size]) printString;tab;cr.
	
	
	fileStream nextPutAll: 'DependencieNameSpaceWithoutLoop';tab.
	
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #totalNumberOfLinesOfCode and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: #weightedMethodCount and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c totalNumberOfLinesOfCode)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab.
	fileStream nextPutAll: (self calculateAverageCorrelationForHistory: packagesHistories of: [ :c | (c weightedMethodCount)*(((c queryAllIncomingInvocations size)*(c queryAllOutgoingInvocations size))squared)] and: [ :c | c queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size]) printString;tab;cr.
	
	fileStream close.
! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/14/2011 13:41'!
deleteAllMooseModel
	MooseModel root allModels do:[:model|model remove].! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/18/2011 10:30'!
easyLoaderCAnalyzer
| mooseModel packages task |
	Gofer new
		squeaksource: 'CAnalyzer';
		package: 'ConfigurationOfCAnalyzer';
		load.
	#('1.1' '1.2' '1.3' '1.4' '1.5' '1.6' '1.7' '1.8' '1.9' '1.10')
		do: [ :version | 
			| project |
			project := (Smalltalk at: #ConfigurationOfCAnalyzer) project version: version.
			[ 
			
			project load.	
			packages := self getRealPackagesFromVersion: project.

			mooseModel := MooseModel new.
			task := MooseSqueakClassCategoryImporterTask new.
			task importerClass: SmalltalkImporter.
			task importingContext mergeClassAndMetaclass.
			task model: mooseModel.
			task runCandidateOperator.
			task addFromPackagesNamed: packages.
			task runWithProgress.
			mooseModel name: 'CAnalyzer ' , version.
			mooseModel allMethods do: #numberOfLinesOfCode.
			mooseModel allMethods do: #cyclomaticComplexity.
			mooseModel allClasses do: #weightedMethodCount.
			mooseModel install ]
				on: Error
				do: [ :ex | 
					ex halt.
					Transcript show: 'cannot load version ' , version , '  ' , ex printString ] ]! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 12/8/2011 14:44'!
easyLoaderFilezilla
|mooseModel path stream wholePath matrixClasses matrixMethods matrixPackages|
	path:='/Users/santiago/Desktop/MSE Files/Filezilla/'.
	matrixClasses := Matrix rows: 4 columns: 8.
	1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

	matrixMethods:= Matrix rows: 4 columns: 8.
	1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

	matrixPackages:= Matrix rows: 4 columns: 6.
	1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].

	#('3.0.0' '3.0.5' '3.1.0' '3.1.5' '3.2.0' '3.2.5' '3.3.0' '3.3.5' '3.4.0' '3.5.0')do:[:version|
	mooseModel := MooseModel new.
	"model importFromMSE."
	wholePath:=path,'filezilla-',version,'.mse'.
	stream:=MultiByteFileStream readOnlyFileNamed:wholePath.
	mooseModel name: (FileDirectory baseNameFor: stream localName).
	mooseModel importFromMSEStream: stream.
	MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	
		(mooseModel allClasses reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixClasses at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixClasses at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).			
			
			"At class scope"
			(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).			
					
			"At package scope"
			(matrixClasses at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixClasses at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).			
			
			"At namespace scope"
			(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).			
						
			"Invocations"
			"General"
			(matrixClasses at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixClasses at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).			
			
			"At class scope"
			(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).			
			
			"At package scope"
			(matrixClasses at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 2 at:  7) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixClasses at: 4 at:  7) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
		
	
	].
(mooseModel allMethods reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			"self halt."
			"General"
			[(matrixMethods at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 2 at:  1) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixMethods at: 4 at:  1) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 2 at:  2) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixMethods at: 4 at:  2) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 2 at:  3) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixMethods at: 4 at:  3) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			(matrixMethods at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 2 at:  4) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixMethods at: 4 at:  4) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"Invocations"
			"General"
			(matrixMethods at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 2 at:  5) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixMethods at: 4 at:  5) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 2 at:  6) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixMethods at: 4 at:  6) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 2 at:  7) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixMethods at: 4 at:  7) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixMethods at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 2 at:  8) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixMethods at: 4 at:  8) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).	]on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].		
		].
	
		(mooseModel allNamespaces reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixPackages at: 1 at:  1) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 2 at:  1) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 3 at:  1) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixPackages at: 4 at:  1) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  2) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 2 at:  2) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 3 at:  2) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixPackages at: 4 at:  2) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  3) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  3) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  3) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  3) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size))."
			
			"Invocations"
			"General"
			(matrixPackages at: 1 at:  4) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  5) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 2 at:  5) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 3 at:  5) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixPackages at: 4 at:  5) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  6) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  6) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  6) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  6) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  8) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  8) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			"
		].
].
self saveMatrix: matrixClasses inFile: 'matrixClasses.txt' withHorizontalLabels:#('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'CLASES'.
	self saveMatrix: matrixMethods inFile: 'matrixMethods.txt' withHorizontalLabels:#('LOC' 'CC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'METHODS'.
	self saveMatrix: matrixPackages inFile: 'matrixPackages.txt' withHorizontalLabels:#('LOC' 'WMC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope') kind:'PACKAGES'.! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 12/2/2011 14:20'!
easyLoaderJFreeChart
|mooseModel path stream wholePath matrixClasses matrixMethods matrixPackages|
	path:='/Users/santiago/Desktop/MSE Files/'.
	matrixClasses := Matrix rows: 4 columns: 8.
	1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

	matrixMethods:= Matrix rows: 4 columns: 8.
	1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

	matrixPackages:= Matrix rows: 4 columns: 6.
	1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].

	#('1.0.0' '1.0.1' '1.0.2' '1.0.3' '1.0.4' '1.0.5' '1.0.6' '1.0.7' '1.0.8' '1.0.9' '1.0.10' '1.0.11' '1.0.12' '1.0.13')do:[:version|
	mooseModel := MooseModel new.
	"model importFromMSE."
	wholePath:=path,'jfreechart-',version,'.mse'.
	stream:=MultiByteFileStream readOnlyFileNamed:wholePath.
	mooseModel name: (FileDirectory baseNameFor: stream localName).
	mooseModel importFromMSEStream: stream.
	MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	
		(mooseModel allClasses reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixClasses at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixClasses at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).			
			
			"At class scope"
			(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).			
					
			"At package scope"
			(matrixClasses at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixClasses at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).			
			
			"At namespace scope"
			(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).			
						
			"Invocations"
			"General"
			(matrixClasses at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixClasses at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).			
			
			"At class scope"
			(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).			
			
			"At package scope"
			(matrixClasses at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 2 at:  7) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixClasses at: 4 at:  7) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
		
	
	].
(mooseModel allMethods reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			"self halt."
			"General"
			[(matrixMethods at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 2 at:  1) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixMethods at: 4 at:  1) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 2 at:  2) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixMethods at: 4 at:  2) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 2 at:  3) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixMethods at: 4 at:  3) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			(matrixMethods at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 2 at:  4) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixMethods at: 4 at:  4) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"Invocations"
			"General"
			(matrixMethods at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 2 at:  5) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixMethods at: 4 at:  5) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 2 at:  6) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixMethods at: 4 at:  6) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 2 at:  7) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixMethods at: 4 at:  7) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixMethods at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 2 at:  8) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixMethods at: 4 at:  8) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).	]on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].		
		].
	
		(mooseModel allNamespaces reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixPackages at: 1 at:  1) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 2 at:  1) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 3 at:  1) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixPackages at: 4 at:  1) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  2) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 2 at:  2) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 3 at:  2) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixPackages at: 4 at:  2) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  3) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  3) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  3) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  3) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size))."
			
			"Invocations"
			"General"
			(matrixPackages at: 1 at:  4) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  5) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 2 at:  5) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 3 at:  5) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixPackages at: 4 at:  5) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  6) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  6) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  6) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  6) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  8) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  8) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			"
		].
].
self saveMatrix: matrixClasses inFile: 'matrixClasses.txt' withHorizontalLabels:#('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'CLASES'.
	self saveMatrix: matrixMethods inFile: 'matrixMethods.txt' withHorizontalLabels:#('LOC' 'CC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'METHODS'.
	self saveMatrix: matrixPackages inFile: 'matrixPackages.txt' withHorizontalLabels:#('LOC' 'WMC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope') kind:'PACKAGES'.! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/23/2011 17:59'!
easyLoaderMondrian

| mooseModel packages task |

"#('2.10' '2.11' '2.13' '2.14' '2.15' '2.16' '2.17' '2.18' '2.19' '2.20' '2.21' '2.22' '2.23' '2.24' '2.25' '2.26' '2.27' '2.28' '2.29' '2.30' '2.31' '2.32' '2.33' '2.34' '2.35' '2.36' '2.37' '2.38' '2.39' '2.40' '2.41' '2.42' '2.43' '2.44' '2.45' '2.46' '2.47' '2.48' '2.49' '2.50' '2.51' '2.52' '2.53' '2.54' '2.55' '2.56' '2.57' '2.58' '2.59' '2.60' '2.61' '2.62' '2.63' '2.64' '2.65' '2.66' '2.67' '2.68' '2.69' '2.70' '2.71' '2.72' '2.73' '2.74' '2.75' '2.76' '2.77' '2.78' '2.79' '2.80' '2.81' '2.82' '2.83' '2.84' '2.85' '2.86' '2.87' '2.88' '2.89' '2.90' '2.91' '2.92' '2.93' '2.94' '2.95' '2.96' '2.97' '2.98' '2.99' '2.100' '2.101' '2.102' '2.103' '2.104' '2.105' '2.106' '2.107' '2.108' '2.109' '2.110' '2.111' '2.112' '2.113' '2.114' '2.115' '2.116' '2.117' '2.118' '2.119' '2.120' '2.121' '2.122' '2.123' '2.124')"
"#('2.11' '2.21' '2.31' '2.41' '2.51' '2.61' '2.71' '2.81' '2.91' '2.101' '2.111' '2.121' '2.129')"
#('2.11' '2.21'  '2.121' '2.129')
"#('2.11' '2.15' '2.19' '2.21' '2.25' '2.29' '2.31' '2.35' '2.39' '2.41' '2.45' '2.49' '2.51' '2.55' '2.59' '2.61' '2.65' '2.71' '2.75' '2.79' '2.81' '2.85' '2.89' '2.91' '2.95' '2.99' '2.101' '2.105' '2.109' '2.111' '2.115' '2.119' '2.121' '2.125' '2.129')"
"#('2.11' '2.13' '2.15' '2.17' '2.19' '2.21' '2.23' '2.25' '2.27' '2.29' '2.31' '2.33' '2.35' '2.37' '2.39' '2.41' '2.43' '2.45' '2.47' '2.49' '2.51' '2.53' '2.55' '2.57' '2.59' '2.61'  '2.63' '2.65' '2.67' '2.73' '2.75' '2.77' '2.79' '2.81' '2.83' '2.85' '2.87' '2.89' '2.91' '2.93'  '2.95' '2.97' '2.99' '2.101' '2.103' '2.105' '2.107' '2.109' '2.111' '2.113' '2.115' '2.117' '2.119' '2.121' '2.123' '2.125' '2.127' '2.129')" do: [:version |
       | project |
       project := (ConfigurationOfMondrian project version: version).
       [
               project load.
               "This is necessary by Moose to properly import"
               Gofer new
                       url: 'http://www.squeaksource.com/CollectionExtensions';
                       version: 'CollectionExtensions-TudorGirba.29';
                       load.

               packages := (project packages collect: #name) select: [:p | p beginsWith: 'Mondrian'].

               mooseModel := MooseModel new.
               task := MooseSqueakClassCategoryImporterTask new.
               task importerClass: SmalltalkImporter.
               task importingContext mergeClassAndMetaclass.
               task model: mooseModel.
               task runCandidateOperator.
               task addFromPackagesNamed: packages.
               task runWithProgress.
		
		.
		
               mooseModel name: 'Mondrian ', version.
	      MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	        " mooseModel allMethods do: #numberOfLinesOfCode.
               mooseModel allClasses do: #weightedMethodCount.
		   mooseModel allClasses do: #queryAllOutgoingDependencies."
               mooseModel install.

       ] on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].

]! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/30/2011 13:32'!
easyLoaderMondrian2
	| mooseModel packages task matrixClasses matrixMethods matrixPackages|
	matrixClasses := Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

matrixMethods:= Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

matrixPackages:= Matrix rows: 4 columns: 6.
1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].
	#('2.11' '2.15' '2.19' '2.21' '2.25' '2.29' '2.31' '2.35' '2.39' '2.41' '2.45' '2.49' '2.51' '2.55' '2.59' '2.61' '2.65' '2.70' '2.75' '2.79' '2.81' '2.85' '2.89' '2.91' '2.95' '2.99' '2.101' '2.105' '2.109' '2.111' '2.115' '2.119' '2.121' '2.125' '2.129' )
		do: [:t14 | 
			| t15 |
			t15 := ConfigurationOfMondrian project version: t14.
			[t15 load.
			Gofer new url: 'http://www.squeaksource.com/CollectionExtensions';
				 version: 'CollectionExtensions-TudorGirba.29';
				 load.
			packages := (t15 packages collect: #name)
						select: [:t16 | t16 beginsWith: 'Mondrian'].
			mooseModel := MooseModel new.
			task := MooseSqueakClassCategoryImporterTask new.
			task importerClass: SmalltalkImporter.
			task importingContext mergeClassAndMetaclass.
			task model: mooseModel.
			task runCandidateOperator.
			task addFromPackagesNamed: packages.
			task runWithProgress.
			t14 = '2.129'
				ifTrue: [self halt].
			mooseModel name: 'Mondrian ' , t14.
			MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
			(mooseModel allClasses reject: #isStub)
				do: [:t16 | 
					(matrixClasses at: 1 at: 1)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies size).
					(matrixClasses at: 2 at: 1)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies size).
					(matrixClasses at: 3 at: 1)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies size).
					(matrixClasses at: 4 at: 1)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies size).
					(matrixClasses at: 1 at: 2)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixClasses at: 2 at: 2)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixClasses at: 3 at: 2)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixClasses at: 4 at: 2)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixClasses at: 1 at: 3)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixClasses at: 2 at: 3)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixClasses at: 3 at: 3)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixClasses at: 4 at: 3)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixClasses at: 1 at: 4)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixClasses at: 2 at: 4)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixClasses at: 3 at: 4)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixClasses at: 4 at: 4)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixClasses at: 1 at: 5)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations size).
					(matrixClasses at: 2 at: 5)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations size).
					(matrixClasses at: 3 at: 5)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations size).
					(matrixClasses at: 4 at: 5)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations size).
					(matrixClasses at: 1 at: 6)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixClasses at: 2 at: 6)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixClasses at: 3 at: 6)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixClasses at: 4 at: 6)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixClasses at: 1 at: 7)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixClasses at: 2 at: 7)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixClasses at: 3 at: 7)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixClasses at: 4 at: 7)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixClasses at: 1 at: 8)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations atNamespaceScope size).
					(matrixClasses at: 2 at: 8)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations atNamespaceScope size).
					(matrixClasses at: 3 at: 8)
						add: (Array with: t16 numberOfLinesOfCode * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations atNamespaceScope size).
					(matrixClasses at: 4 at: 8)
						add: (Array with: t16 weightedMethodCount * (t16 fanIn * t16 fanOut) squared with: t16 queryAllOutgoingInvocations atNamespaceScope size)].
			(mooseModel allMethods reject: #isStub)
				do: [:t16 | 
					(matrixMethods at: 1 at: 1)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies size).
					(matrixMethods at: 2 at: 1)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingDependencies size).
					(matrixMethods at: 3 at: 1)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies size).
					(matrixMethods at: 4 at: 1)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies size).
					(matrixMethods at: 1 at: 2)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixMethods at: 2 at: 2)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixMethods at: 3 at: 2)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixMethods at: 4 at: 2)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixMethods at: 1 at: 3)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixMethods at: 2 at: 3)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixMethods at: 3 at: 3)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixMethods at: 4 at: 3)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixMethods at: 1 at: 4)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixMethods at: 2 at: 4)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixMethods at: 3 at: 4)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixMethods at: 4 at: 4)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atNamespaceScope size).
					(matrixMethods at: 1 at: 5)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations size).
					(matrixMethods at: 2 at: 5)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingInvocations size).
					(matrixMethods at: 3 at: 5)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations size).
					(matrixMethods at: 4 at: 5)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations size).
					(matrixMethods at: 1 at: 6)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixMethods at: 2 at: 6)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixMethods at: 3 at: 6)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixMethods at: 4 at: 6)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixMethods at: 1 at: 7)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixMethods at: 2 at: 7)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixMethods at: 3 at: 7)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixMethods at: 4 at: 7)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixMethods at: 1 at: 8)
						add: (Array with: t16 numberOfLinesOfCode with: t16 queryAllOutgoingInvocations atNamespaceScope size).
					(matrixMethods at: 2 at: 8)
						add: (Array with: t16 cyclomaticComplexity with: t16 queryAllOutgoingInvocations atNamespaceScope size).
					(matrixMethods at: 3 at: 8)
						add: (Array with: t16 numberOfLinesOfCode * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atNamespaceScope size).
					(matrixMethods at: 4 at: 8)
						add: (Array with: t16 cyclomaticComplexity * (t16 incomingInvocations size * t16 outgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atNamespaceScope size)].
			(mooseModel allPackages reject: #isStub)
				do: [:t16 | 
					(matrixPackages at: 1 at: 1)
						add: (Array with: t16 totalNumberOfLinesOfCode with: t16 queryAllOutgoingDependencies size).
					(matrixPackages at: 2 at: 1)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies size).
					(matrixPackages at: 3 at: 1)
						add: (Array with: t16 totalNumberOfLinesOfCode * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingDependencies size).
					(matrixPackages at: 4 at: 1)
						add: (Array with: t16 weightedMethodCount * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingDependencies size).
					(matrixPackages at: 1 at: 2)
						add: (Array with: t16 totalNumberOfLinesOfCode with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixPackages at: 2 at: 2)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixPackages at: 3 at: 2)
						add: (Array with: t16 totalNumberOfLinesOfCode * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixPackages at: 4 at: 2)
						add: (Array with: t16 weightedMethodCount * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atClassScope size).
					(matrixPackages at: 1 at: 3)
						add: (Array with: t16 totalNumberOfLinesOfCode with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixPackages at: 2 at: 3)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixPackages at: 3 at: 3)
						add: (Array with: t16 totalNumberOfLinesOfCode * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixPackages at: 4 at: 3)
						add: (Array with: t16 weightedMethodCount * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingDependencies atPackageScope size).
					(matrixPackages at: 1 at: 4)
						add: (Array with: t16 totalNumberOfLinesOfCode with: t16 queryAllOutgoingInvocations size).
					(matrixPackages at: 2 at: 4)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations size).
					(matrixPackages at: 3 at: 4)
						add: (Array with: t16 totalNumberOfLinesOfCode * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingInvocations size).
					(matrixPackages at: 4 at: 4)
						add: (Array with: t16 weightedMethodCount * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingInvocations size).
					(matrixPackages at: 1 at: 5)
						add: (Array with: t16 totalNumberOfLinesOfCode with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixPackages at: 2 at: 5)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixPackages at: 3 at: 5)
						add: (Array with: t16 totalNumberOfLinesOfCode * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixPackages at: 4 at: 5)
						add: (Array with: t16 weightedMethodCount * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atClassScope size).
					(matrixPackages at: 1 at: 6)
						add: (Array with: t16 totalNumberOfLinesOfCode with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixPackages at: 2 at: 6)
						add: (Array with: t16 weightedMethodCount with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixPackages at: 3 at: 6)
						add: (Array with: t16 totalNumberOfLinesOfCode * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atPackageScope size).
					(matrixPackages at: 4 at: 6)
						add: (Array with: t16 weightedMethodCount * (t16 queryAllIncomingInvocations size * t16 queryAllOutgoingInvocations size) squared with: t16 queryAllOutgoingInvocations atPackageScope size)]]
				on: Error
				do: [:t16 | 
					t16 halt.
					Transcript show: 'cannot load version ' , t14 , '  ' , t16 printString]].
	self
		saveMatrix: matrixClasses
		inFile: 'matrixClasses.txt'
		withHorizontalLabels: #('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC' )
		andVerticalLabels: #('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope' )
		kind: 'CLASES'.
	self
		saveMatrix: matrixMethods
		inFile: 'matrixMethods.txt'
		withHorizontalLabels: #('LOC' 'CC' 'OIII/LOC' 'OIII/CC' )
		andVerticalLabels: #('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope' )
		kind: 'METHODS'.
	self
		saveMatrix: matrixPackages
		inFile: 'matrixPackages.txt'
		withHorizontalLabels: #('LOC' 'WMC' 'OIII/LOC' 'OIII/CC' )
		andVerticalLabels: #('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' )
		kind: 'PACKAGES'! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'AlexandreBergel 11/17/2011 17:05'!
easyLoaderRoassal
	"
	self new easyLoaderRoassal
	"

	| mooseModel packages task |
	Gofer new
		squeaksource: 'Roassal';
		package: 'ConfigurationOfRoassal';
		load.
	#('1.0' '1.5' '1.10' '1.15' '1.20' '1.25' '1.30' '1.35' '1.40' '1.45' '1.50' '1.55' '1.58')
		do: [ :version | 
			| project |
			project := (Smalltalk at: #ConfigurationOfRoassal) project version: version.
			[ 
			
			project load.	
			packages := self getRealPackagesFromVersion: project.

			mooseModel := MooseModel new.
			task := MooseSqueakClassCategoryImporterTask new.
			task importerClass: SmalltalkImporter.
			task importingContext mergeClassAndMetaclass.
			task model: mooseModel.
			task runCandidateOperator.
			task addFromPackagesNamed: packages.
			task runWithProgress.
			mooseModel name: 'Roassal ' , version.
			mooseModel allMethods do: #numberOfLinesOfCode.
			mooseModel allMethods do: #cyclomaticComplexity.
			mooseModel allClasses do: #weightedMethodCount.
			mooseModel install ]
				on: Error
				do: [ :ex | 
					ex halt.
					Transcript show: 'cannot load version ' , version , '  ' , ex printString ] ]! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/30/2011 10:20'!
easyLoaderRoassal2

| mooseModel packages task matrixClasses matrixMethods matrixPackages|

matrixClasses := Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

matrixMethods:= Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

matrixPackages:= Matrix rows: 4 columns: 6.
1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].
Gofer new
		squeaksource: 'Roassal';
		package: 'ConfigurationOfRoassal';
		load.
	#('1.0' '1.5' '1.10' '1.15' '1.20' '1.25' '1.30' '1.35' '1.40' '1.45' '1.50' '1.55' '1.58') do: [:version |
       | project |
       project := ((Smalltalk at: #ConfigurationOfRoassal) project version: version).
	    [

	             project load.

	            "  (Object subclass: #MBConfigurationHelpCommand) compile: 'isActive'."

	             packages := (project packages collect: #name) select: [:p | p beginsWith: 'Roassal'].

               mooseModel := MooseModel new.
               task := MooseSqueakClassCategoryImporterTask new.
               task importerClass: SmalltalkImporter.
               task importingContext mergeClassAndMetaclass.
               task model: mooseModel.
               task runCandidateOperator.
               task addFromPackagesNamed: packages.
               task runWithProgress.
		
		
               mooseModel name: 'Roassal ', version.
	      MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	
		(mooseModel allClasses reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixClasses at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixClasses at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).			
			
			"General without loops"
			"(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size))."
			
			"At class scope"
			(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).			
			
			"At class scope without loops"
			"(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size))."
			
			"At package scope"
			(matrixClasses at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixClasses at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).			
			
			"At package scope without loops"
			"(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size))."
			
			"At namespace scope"
			(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).			
			
			"At namespace scope without loops"
		"	(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size))."	
			
			
			"Invocations"
			"General"
			(matrixClasses at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixClasses at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).			
			
			"General without loops"
			"(matrixClasses at: 1 at:  10) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 2 at:  10) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 3 at:  10) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size)).		
			(matrixClasses at: 4 at:  10) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size))."
			
			"At class scope"
			(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).			
			
			"At class scope without loops"
		"	(matrixClasses at: 1 at:  12) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 2 at:  12) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 3 at:  12) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size)).		
			(matrixClasses at: 4 at:  12) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size))."
			
			"At package scope"
			(matrixClasses at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 2 at:  7) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixClasses at: 4 at:  7) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At package scope without loops"
			"(matrixClasses at: 1 at:  14) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 2 at:  14) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 3 at:  14) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size)).		
			(matrixClasses at: 4 at:  14) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size))."
			
			"At namespace scope"
			(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
			
			"At namespace scope without loops"
			"(matrixClasses at: 1 at:  16) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 2 at:  16) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 3 at:  16) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size)).		
			(matrixClasses at: 4 at:  16) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size))."
		].
	
	(mooseModel allMethods reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixMethods at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 2 at:  1) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixMethods at: 4 at:  1) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 2 at:  2) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixMethods at: 4 at:  2) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 2 at:  3) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixMethods at: 4 at:  3) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			(matrixMethods at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 2 at:  4) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixMethods at: 4 at:  4) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"Invocations"
			"General"
			(matrixMethods at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 2 at:  5) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixMethods at: 4 at:  5) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 2 at:  6) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixMethods at: 4 at:  6) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 2 at:  7) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixMethods at: 4 at:  7) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixMethods at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 2 at:  8) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixMethods at: 4 at:  8) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
		].
		(mooseModel allPackages reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixPackages at: 1 at:  1) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 3 at:  1) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixPackages at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  2) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 3 at:  2) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixPackages at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  3) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixPackages at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixPackages at: 3 at:  3) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixPackages at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size))."
			
			"Invocations"
			"General"
			(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  5) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 3 at:  5) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixPackages at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  6) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixPackages at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixPackages at: 3 at:  6) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixPackages at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  8) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  8) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			"
		].

       ] on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].

].
	self saveMatrix: matrixClasses inFile: 'matrixClasses.txt' withHorizontalLabels:#('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'CLASES'.
	self saveMatrix: matrixMethods inFile: 'matrixMethods.txt' withHorizontalLabels:#('LOC' 'CC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'METHODS'.
	self saveMatrix: matrixPackages inFile: 'matrixPackages.txt' withHorizontalLabels:#('LOC' 'WMC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope') kind:'PACKAGES'.
	"matrixClasses inspect"! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/21/2011 09:20'!
easyLoaderSpy
| mooseModel packages task |
	Gofer new
		squeaksource: 'Spy';
		package: 'ConfigurationOfSpy';
		load.
	#("'1.0'" '1.5' '1.10' '1.15' '1.20' '1.25' '1.30' '1.35' '1.40' "'1.45' "'1.50' '1.55' '1.60' '1.65' '1.70' '1.75' '1.80' '1.83')
		do: [ :version | 
			| project |
			project := (Smalltalk at: #ConfigurationOfSpy) project version: version.
			[ 
			
			project load.	
			packages := self getRealPackagesFromVersion: project.

			mooseModel := MooseModel new.
			task := MooseSqueakClassCategoryImporterTask new.
			task importerClass: SmalltalkImporter.
			task importingContext mergeClassAndMetaclass.
			task model: mooseModel.
			task runCandidateOperator.
			task addFromPackagesNamed: packages.
			task runWithProgress.
			mooseModel name: 'Spy ' , version.
			mooseModel allMethods do: #numberOfLinesOfCode.
			mooseModel allMethods do: #cyclomaticComplexity.
			mooseModel allClasses do: #weightedMethodCount.
			mooseModel allClasses do: #numberOfLinesOfCode.
			mooseModel install ]
				on: Error
				do: [ :ex | 
					ex halt.
					Transcript show: 'cannot load version ' , version , '  ' , ex printString ] ]! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/29/2011 14:33'!
easyLoaderSpy2

| mooseModel packages task matrixClasses matrixMethods matrixPackages|

matrixClasses := Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

matrixMethods:= Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

matrixPackages:= Matrix rows: 4 columns: 6.
1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].
Gofer new
		squeaksource: 'Spy';
		package: 'ConfigurationOfSpy';
		load.
	
#("'1.0'" '1.5' '1.10' '1.15' '1.20' '1.25' '1.30' '1.35' '1.40' "'1.45' "'1.50' '1.55' '1.60' '1.65' '1.70' '1.75' '1.80' '1.83') do: [:version |
       | project |
       project := (Smalltalk at: #ConfigurationOfSpy) project version: version.
			[ 
			
			project load.	
			packages := self getRealPackagesFromVersion: project.

               mooseModel := MooseModel new.
               task := MooseSqueakClassCategoryImporterTask new.
               task importerClass: SmalltalkImporter.
               task importingContext mergeClassAndMetaclass.
               task model: mooseModel.
               task runCandidateOperator.
               task addFromPackagesNamed: packages.
               task runWithProgress.
		
		
               mooseModel name: 'Spy ', version.
	      MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	
		(mooseModel allClasses reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixClasses at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixClasses at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).			
			
			"General without loops"
			"(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size))."
			
			"At class scope"
			(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).			
			
			"At class scope without loops"
			"(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size))."
			
			"At package scope"
			(matrixClasses at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixClasses at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).			
			
			"At package scope without loops"
			"(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size))."
			
			"At namespace scope"
			(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).			
			
			"At namespace scope without loops"
		"	(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size))."	
			
			
			"Invocations"
			"General"
			(matrixClasses at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixClasses at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).			
			
			"General without loops"
			"(matrixClasses at: 1 at:  10) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 2 at:  10) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 3 at:  10) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size)).		
			(matrixClasses at: 4 at:  10) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size))."
			
			"At class scope"
			(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).			
			
			"At class scope without loops"
		"	(matrixClasses at: 1 at:  12) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 2 at:  12) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 3 at:  12) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size)).		
			(matrixClasses at: 4 at:  12) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size))."
			
			"At package scope"
			(matrixClasses at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 2 at:  7) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixClasses at: 4 at:  7) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At package scope without loops"
			"(matrixClasses at: 1 at:  14) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 2 at:  14) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 3 at:  14) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size)).		
			(matrixClasses at: 4 at:  14) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size))."
			
			"At namespace scope"
			(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
			
			"At namespace scope without loops"
			"(matrixClasses at: 1 at:  16) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 2 at:  16) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 3 at:  16) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size)).		
			(matrixClasses at: 4 at:  16) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size))."
		].
	
	(mooseModel allMethods reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixMethods at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 2 at:  1) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixMethods at: 4 at:  1) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 2 at:  2) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixMethods at: 4 at:  2) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 2 at:  3) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixMethods at: 4 at:  3) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			(matrixMethods at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 2 at:  4) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixMethods at: 4 at:  4) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"Invocations"
			"General"
			(matrixMethods at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 2 at:  5) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixMethods at: 4 at:  5) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 2 at:  6) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixMethods at: 4 at:  6) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 2 at:  7) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixMethods at: 4 at:  7) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixMethods at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 2 at:  8) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixMethods at: 4 at:  8) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
		].
		(mooseModel allPackages reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixPackages at: 1 at:  1) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 3 at:  1) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixPackages at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  2) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 3 at:  2) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixPackages at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  3) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixPackages at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixPackages at: 3 at:  3) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixPackages at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size))."
			
			"Invocations"
			"General"
			(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  5) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 3 at:  5) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixPackages at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  6) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixPackages at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixPackages at: 3 at:  6) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixPackages at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  8) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  8) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			"
		].

       ] on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].

].
	self saveMatrix: matrixClasses inFile: 'matrixClasses.txt' withHorizontalLabels:#('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'CLASES'.
	self saveMatrix: matrixMethods inFile: 'matrixMethods.txt' withHorizontalLabels:#('LOC' 'CC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'METHODS'.
	self saveMatrix: matrixPackages inFile: 'matrixPackages.txt' withHorizontalLabels:#('LOC' 'WMC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope') kind:'PACKAGES'.
	"matrixClasses inspect"! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'AlexandreBergel 11/17/2011 14:45'!
easyLoaderVersionner
	| mooseModel packages task cls |
	"Loading the configuration"
	Gofer new
	       squeaksource: 'Versionner';
	       package: 'ConfigurationOfVersionner';
	       load.

	#('1.0' '1.1' '1.2' '1.3' '1.4' '1.5' '1.6' '1.7' '1.8' '1.9' '1.10' '1.11' '1.12' '1.13' '1.14' '1.15' '1.16' '1.17' '1.18' '1.19')
	do: [:version |
	     | project |
	     project := ((Smalltalk at: #ConfigurationOfVersionner) project version: version).
	    [

	             project load.

	               cls := Object subclass: #MBConfigurationHelpCommand.
	               cls compile: 'isActive'.

	             packages := (project packages collect: #name) select: [:p | p beginsWith: 'Versionner'].

	             mooseModel := MooseModel new.
	             task := MooseSqueakClassCategoryImporterTask new.
	             task importerClass: SmalltalkImporter.
	             task importingContext mergeClassAndMetaclass.
	             task model: mooseModel.
	             task runCandidateOperator.
	             task addFromPackagesNamed: packages.
	             task runWithProgress.

	             mooseModel name: 'Versionner ', version.
	              mooseModel allMethods do: #numberOfLinesOfCode.
	             mooseModel allClasses do: #weightedMethodCount.
	             mooseModel install.

	    ] on: Error do: [ :ex | Transcript show: 'cannot load version ', version, '  ', ex printString.].

	]! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/29/2011 14:00'!
easyLoaderVersionner2

| mooseModel packages task matrixClasses matrixMethods matrixPackages|

matrixClasses := Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

matrixMethods:= Matrix rows: 4 columns: 8.
1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

matrixPackages:= Matrix rows: 4 columns: 6.
1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].
Gofer new
	       squeaksource: 'Versionner';
	       package: 'ConfigurationOfVersionner';
	       load.
	
#('1.0' '1.1' '1.2' '1.3' '1.4' '1.5' '1.6' '1.7' '1.8' '1.9' '1.10' '1.11' '1.12' '1.13' '1.14' '1.15' '1.16' '1.17' '1.18' '1.19') do: [:version |
       | project |
       project := ((Smalltalk at: #ConfigurationOfVersionner) project version: version).
	    [

	             project load.

	              (Object subclass: #MBConfigurationHelpCommand) compile: 'isActive'.

	             packages := (project packages collect: #name) select: [:p | p beginsWith: 'Versionner'].

               mooseModel := MooseModel new.
               task := MooseSqueakClassCategoryImporterTask new.
               task importerClass: SmalltalkImporter.
               task importingContext mergeClassAndMetaclass.
               task model: mooseModel.
               task runCandidateOperator.
               task addFromPackagesNamed: packages.
               task runWithProgress.
		
		
               mooseModel name: 'Versionner ', version.
	      MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	
		(mooseModel allClasses reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixClasses at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixClasses at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).			
			
			"General without loops"
			"(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size))."
			
			"At class scope"
			(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).			
			
			"At class scope without loops"
			"(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size))."
			
			"At package scope"
			(matrixClasses at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixClasses at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).			
			
			"At package scope without loops"
			"(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size))."
			
			"At namespace scope"
			(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).			
			
			"At namespace scope without loops"
		"	(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size))."	
			
			
			"Invocations"
			"General"
			(matrixClasses at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixClasses at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).			
			
			"General without loops"
			"(matrixClasses at: 1 at:  10) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 2 at:  10) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops size)).
			(matrixClasses at: 3 at:  10) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size)).		
			(matrixClasses at: 4 at:  10) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops size))."
			
			"At class scope"
			(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).			
			
			"At class scope without loops"
		"	(matrixClasses at: 1 at:  12) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 2 at:  12) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atClassScope size)).
			(matrixClasses at: 3 at:  12) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size)).		
			(matrixClasses at: 4 at:  12) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atClassScope size))."
			
			"At package scope"
			(matrixClasses at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 2 at:  7) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixClasses at: 4 at:  7) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At package scope without loops"
			"(matrixClasses at: 1 at:  14) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 2 at:  14) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atPackageScope size)).
			(matrixClasses at: 3 at:  14) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size)).		
			(matrixClasses at: 4 at:  14) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atPackageScope size))."
			
			"At namespace scope"
			(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
			
			"At namespace scope without loops"
			"(matrixClasses at: 1 at:  16) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 2 at:  16) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations withoutSelfLoops atNamespaceScope size)).
			(matrixClasses at: 3 at:  16) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size)).		
			(matrixClasses at: 4 at:  16) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies withoutSelfLoops atNamespaceScope size))."
		].
	
	(mooseModel allMethods reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixMethods at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 2 at:  1) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixMethods at: 4 at:  1) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 2 at:  2) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixMethods at: 4 at:  2) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 2 at:  3) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixMethods at: 4 at:  3) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			(matrixMethods at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 2 at:  4) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixMethods at: 4 at:  4) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"Invocations"
			"General"
			(matrixMethods at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 2 at:  5) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixMethods at: 4 at:  5) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 2 at:  6) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixMethods at: 4 at:  6) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 2 at:  7) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixMethods at: 4 at:  7) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixMethods at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 2 at:  8) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixMethods at: 4 at:  8) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
		].
		(mooseModel allPackages reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixPackages at: 1 at:  1) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 3 at:  1) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixPackages at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  2) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 3 at:  2) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixPackages at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  3) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixPackages at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixPackages at: 3 at:  3) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixPackages at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size))."
			
			"Invocations"
			"General"
			(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  5) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 3 at:  5) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixPackages at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  6) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixPackages at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixPackages at: 3 at:  6) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixPackages at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  8) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  8) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			"
		].

       ] on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].

].
	self saveMatrix: matrixClasses inFile: 'matrixClasses.txt' withHorizontalLabels:#('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'CLASES'.
	self saveMatrix: matrixMethods inFile: 'matrixMethods.txt' withHorizontalLabels:#('LOC' 'CC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'METHODS'.
	self saveMatrix: matrixPackages inFile: 'matrixPackages.txt' withHorizontalLabels:#('LOC' 'WMC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope') kind:'PACKAGES'.
	"matrixClasses inspect"! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 12/8/2011 11:42'!
easyLoaderVuze
|mooseModel path stream wholePath matrixClasses matrixMethods matrixPackages|
	path:='/Users/santiago/Desktop/MSE Files/Vuze/'.
	matrixClasses := Matrix rows: 4 columns: 8.
	1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixClasses at: y at: x put: Set new ] ].

	matrixMethods:= Matrix rows: 4 columns: 8.
	1 to: 4 do: [ :y | 1 to: 8 do: [ :x | matrixMethods at: y at: x put: Set new ] ].

	matrixPackages:= Matrix rows: 4 columns: 6.
	1 to: 4 do: [ :y | 1 to: 6 do: [ :x | matrixPackages at: y at: x put: Set new ] ].

	#('3.1.0.0' '4.0.0.0' '4.0.0.4' '4.1.0.0' '4.1.0.4' '4.2.0.0' '4.2.0.4' '4.3.0.0' '4.3.0.4' "'4.4.0.0' '4.4.0.4' '4.5.0.0' '4.5.0.4' '4.7.0.0'")do:[:version|
	mooseModel := MooseModel new.
	"model importFromMSE."
	wholePath:=path,'Vuze_',version,'.mse'.
	stream:=MultiByteFileStream readOnlyFileNamed:wholePath.
	mooseModel name: (FileDirectory baseNameFor: stream localName).
	mooseModel importFromMSEStream: stream.
	MooseComputeAllPrimitivePropertiesTask runOnModel: mooseModel.
	
		(mooseModel allClasses reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixClasses at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 2 at:  1) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixClasses at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixClasses at: 4 at:  1) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies size)).			
			
			"At class scope"
			(matrixClasses at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 2 at:  2) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixClasses at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixClasses at: 4 at:  2) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).			
					
			"At package scope"
			(matrixClasses at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 2 at:  3) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixClasses at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixClasses at: 4 at:  3) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).			
			
			"At namespace scope"
			(matrixClasses at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixClasses at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixClasses at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).			
						
			"Invocations"
			"General"
			(matrixClasses at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 2 at:  5) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixClasses at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixClasses at: 4 at:  5) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations size)).			
			
			"At class scope"
			(matrixClasses at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 2 at:  6) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixClasses at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixClasses at: 4 at:  6) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).			
			
			"At package scope"
			(matrixClasses at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 2 at:  7) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixClasses at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixClasses at: 4 at:  7) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixClasses at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixClasses at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixClasses at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls fanIn)*(cls fanOut))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
		
	
	].
(mooseModel allMethods reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			"self halt."
			"General"
			[(matrixMethods at: 1 at:  1) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 2 at:  1) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies size)).
			(matrixMethods at: 3 at:  1) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixMethods at: 4 at:  1) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  2) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 2 at:  2) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixMethods at: 3 at:  2) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixMethods at: 4 at:  2) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  3) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 2 at:  3) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			(matrixMethods at: 3 at:  3) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).		
			(matrixMethods at: 4 at:  3) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atPackageScope size)).
			
			"At namespace scope"
			(matrixMethods at: 1 at:  4) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 2 at:  4) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixMethods at: 3 at:  4) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixMethods at: 4 at:  4) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"Invocations"
			"General"
			(matrixMethods at: 1 at:  5) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 2 at:  5) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations size)).
			(matrixMethods at: 3 at:  5) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixMethods at: 4 at:  5) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixMethods at: 1 at:  6) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 2 at:  6) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixMethods at: 3 at:  6) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixMethods at: 4 at:  6) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixMethods at: 1 at:  7) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 2 at:  7) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atPackageScope size)).
			(matrixMethods at: 3 at:  7) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).		
			(matrixMethods at: 4 at:  7) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atPackageScope size)).			
			
			"At namespace scope"
			(matrixMethods at: 1 at:  8) add: (Array with: (cls numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 2 at:  8) add: (Array with: (cls cyclomaticComplexity) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixMethods at: 3 at:  8) add: (Array with: ((cls numberOfLinesOfCode)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixMethods at: 4 at:  8) add: (Array with: ((cls cyclomaticComplexity)*(((cls incomingInvocations size)*(cls outgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).	]on: Error do: [ :ex | ex halt. Transcript show: 'cannot load version ', version, '  ', ex printString. ].		
		].
	
		(mooseModel allNamespaces reject: #isStub) do: [ :cls | 
			"All Outgoing dependencies"
			
			"General"
			(matrixPackages at: 1 at:  1) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 2 at:  1) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies size)).
			(matrixPackages at: 3 at:  1) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).		
			(matrixPackages at: 4 at:  1) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  2) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 2 at:  2) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies atClassScope size)).
			(matrixPackages at: 3 at:  2) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).		
			(matrixPackages at: 4 at:  2) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  3) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  3) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  3) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  3) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  4) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingDependencies atNamespaceScope size))."
			
			"Invocations"
			"General"
			(matrixPackages at: 1 at:  4) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 2 at:  4) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations size)).
			(matrixPackages at: 3 at:  4) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).		
			(matrixPackages at: 4 at:  4) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations size)).
			
			"At class scope"
			(matrixPackages at: 1 at:  5) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 2 at:  5) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations atClassScope size)).
			(matrixPackages at: 3 at:  5) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).		
			(matrixPackages at: 4 at:  5) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atClassScope size)).
			
			"At package scope"
			(matrixPackages at: 1 at:  6) add: (Array with: (cls classes sum: #numberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  6) add: (Array with: (cls classes sum: #weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  6) add: (Array with: ((cls classes sum: #numberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  6) add: (Array with: ((cls classes sum: #weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			
			
			"At namespace scope"
			"(matrixPackages at: 1 at:  8) add: (Array with: (cls totalNumberOfLinesOfCode) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 2 at:  8) add: (Array with: (cls weightedMethodCount) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).
			(matrixPackages at: 3 at:  8) add: (Array with: ((cls totalNumberOfLinesOfCode)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).		
			(matrixPackages at: 4 at:  8) add: (Array with: ((cls weightedMethodCount)*(((cls queryAllIncomingInvocations size)*(cls queryAllOutgoingInvocations size))squared)) with: (cls queryAllOutgoingInvocations atNamespaceScope size)).			"
		].
].
self saveMatrix: matrixClasses inFile: 'matrixClasses.txt' withHorizontalLabels:#('LOC' 'WMC' 'FANIN/LOC' 'FANIN/WMC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'CLASES'.
	self saveMatrix: matrixMethods inFile: 'matrixMethods.txt' withHorizontalLabels:#('LOC' 'CC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'general at namespace scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope' 'Invocations at namespace scope') kind:'METHODS'.
	self saveMatrix: matrixPackages inFile: 'matrixPackages.txt' withHorizontalLabels:#('LOC' 'WMC' 'OIII/LOC' 'OIII/CC') andVerticalLabels:#('General' 'general at class Scope' 'general at package scope' 'Invocations' 'Invocations at class Scope' 'Invocations at package scope') kind:'PACKAGES'.! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'AlexandreBergel 11/21/2011 11:16'!
exportToTxt: aModelHistory
	"
	self new exportToTxt: (MooseModel root entities detect: [:m | m isKindOf: HismoModelHistory])
	"
	
	| fileStream classes hismoClassHistoryGroup famixClasses |
	fileStream := FileStream forceNewFileNamed: 'output.txt'. 

	"We remove all the stagnant classes"
	hismoClassHistoryGroup := aModelHistory allClassHistories.
	classes := hismoClassHistoryGroup reject: [ :cc | cc evolutionOfNumberOfMethods = 0 ]. 

	fileStream nextPutAll: 'Version'; tab.
	fileStream nextPutAll: 'ClassName'; tab.
	fileStream nextPutAll: 'WMC'; tab.
	fileStream nextPutAll: '#DEP'; tab.
	fileStream nextPutAll: 'NOM'; tab.
	fileStream nextPutAll: 'LOC'; tab.
	fileStream nextPutAll: '#DEP (class scope)'; tab.
	fileStream nextPutAll: '#DEP (package scope)'; tab.
	fileStream cr.

	classes do: [ :cls |
		cls versions collect: [ :famixClass |
			| c | 
			c := famixClass versionEntity.
			fileStream nextPutAll: famixClass referenceVersion versionName; tab.
			fileStream nextPutAll: c name; tab.
			
			fileStream nextPutAll: c weightedMethodCount  printString; tab.
			fileStream nextPutAll: c queryAllOutgoingDependencies size  printString; tab.
			fileStream nextPutAll: c numberOfMethods  printString; tab.
			fileStream nextPutAll: c numberOfLinesOfCode  printString; tab.
			fileStream nextPutAll: c queryAllOutgoingDependencies atClassScope size  printString; tab.
			fileStream nextPutAll: c queryAllOutgoingDependencies atPackageScope size  printString; tab.
			fileStream cr.
		]		 
	].
	fileStream close.! !

!AutomaticalCaseStudies methodsFor: 'util' stamp: 'AlexandreBergel 11/17/2011 16:05'!
getRealPackagesFromVersion: metacelloVersion
	"Return the list of RPackages that belongs to a metacello version
	
	self new getRealPackagesFromVersion: (ConfigurationOfSpirit project version: '1.1')
	"

	| metacelloPackages suffixes |
	
	"We get the metacello packages from the version number"	
	metacelloPackages := (metacelloVersion packages collect: #name).

	suffixes := (metacelloPackages collect: [:p | p copyUpToLast: $- ]) asSet.

	"We now get the real RPackages"
	^ RPackageOrganizer rpackageNames select: [ :p | suffixes anySatisfy: [:t | p beginsWith: t] ]! !

!AutomaticalCaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/21/2011 19:31'!
pearson: setValue1 and: setValue2
|result sum_sq_x sum_sq_y sum_coproduct mean_x mean_y sweep delta_x delta_y pop_sd_x pop_sd_y cov_x_y|
	
	result:=0.
	sum_sq_x:=0.
	sum_sq_y:=0.
	sum_coproduct:=0.
	mean_x:=setValue1 at: 1.
	mean_y:=setValue2 at: 1.
	3 "PUEDE SER 3"to: (setValue1 size +1) do:[:i|
		sweep:=(i-2)/(i-1).
		delta_x:=(setValue1 at: (i-1))-mean_x.
		delta_y:=(setValue2 at: (i-1))-mean_y.
		"Transcript show: ((delta_x * delta_x)*sweep )."
		sum_sq_x := (sum_sq_x + ((delta_x * delta_x)*sweep )).
            sum_sq_y :=  (sum_sq_y +(delta_y * delta_y * sweep)).
            sum_coproduct := (sum_coproduct +(delta_x * delta_y * sweep)).
            mean_x := (mean_x +(delta_x / (i-1))).
            mean_y := (mean_y +(delta_y / (i-1))).
		].
	pop_sd_x:=(sum_sq_x/(setValue1 size)) sqrt.
	pop_sd_y:=(sum_sq_y/(setValue1 size)) sqrt.
	cov_x_y := (sum_coproduct / (setValue1 size)).
	result := (cov_x_y / (pop_sd_x*pop_sd_y)).
	Transcript show: result.
"
        
        double pop_sd_x = (double) Math.sqrt(sum_sq_x/scores1.length);
        double pop_sd_y = (double) Math.sqrt(sum_sq_y/scores1.length);
        double cov_x_y = sum_coproduct / scores1.length;
        result = cov_x_y / (pop_sd_x*pop_sd_y);
        return result;"! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'SantiagoVidal 11/14/2011 13:26'!
runCaseStudies
	self easyLoaderCAnalyzer.
	self searchForUniClassPatterns.
	
	self easyLoaderSpy.
 	self searchForUniClassPatterns.
	
	self easyLoaderVersionner.
 	self searchForUniClassPatterns.
	
	self easyLoaderMondrian.
 	self searchForUniClassPatterns.! !

!AutomaticalCaseStudies methodsFor: 'util' stamp: 'SantiagoVidal 11/24/2011 13:56'!
saveMatrix:matrix inFile:fileName withHorizontalLabels:labelsArray andVerticalLabels: verticalLabels kind: kind
|fileStream aSetOfPoint|
	fileStream := FileStream forceNewFileNamed: fileName. 
	fileStream nextPutAll: kind; cr.
	1 to: matrix columnCount do:[:aColumn|
		1 to: matrix rowCount do:[:aRow|
				fileStream nextPutAll: (verticalLabels at:aColumn),'  ',(labelsArray at:aRow);cr.
				fileStream nextPutAll: 'X' ;tab.
				fileStream nextPutAll: 'Y'; cr.
				aSetOfPoint:=matrix at: aRow at: aColumn.
				aSetOfPoint asArray do:[:aPoint|
					fileStream nextPutAll: aPoint first printString;tab.
					fileStream nextPutAll: aPoint second printString;cr.
					].
				fileStream nextPutAll: '';cr;cr;cr;cr.
				
			].
		fileStream nextPutAll: '';cr;cr;cr;cr.
			"fileStream nextPutAll: (verticalLabels at:aColumn);cr.
			1 to: matrix rowCount do:[:aRow|
				fileStream nextPutAll: (labelsArray at:aRow);tab;tab.
				].
			fileStream nextPutAll: '';cr.
			1 to: matrix rowCount do:[:aRow|
				fileStream nextPutAll: 'X' ;tab.
				fileStream nextPutAll: 'Y'; tab..
				].
			fileStream nextPutAll: '';cr.
			1 to: matrix rowCount do:[:aRow|
				aSetOfPoint:=matrix at: aColumn at: aRow.
				aSetOfPoint asArray do:[:aPoint|
					fileStream nextPutAll: aPoint first printString;tab.
					fileStream nextPutAll: aPoint second printString; tab.
					].
				fileStream nextPutAll: '';cr.
				
			].
			fileStream nextPutAll: '';cr;cr;cr."
		].
	
	"1 to: 4 do: [ :y | 1 to: 16 do: [ :x | matrixClasses at: y at: x put: Set new ] ]."
	
	
	

	fileStream close.! !

!AutomaticalCaseStudies methodsFor: 'script mondrian easel' stamp: 'AlexandreBergel 11/21/2011 10:56'!
script1 

"do it in a class history group"

| classes view hismoClassHistoryGroup | 
view interaction action: #inspect.

"We remove all the stagnant classes"
classes := hismoClassHistoryGroup reject: [ :cc | cc evolutionOfNumberOfMethods = 0 ]. 

"Each large box is a class"
view nodes: (classes copyFrom: 1 to: 30) forEach: [:cls | 
	| thingsToSee versions diag1 diag2 diag3 |  
	thingsToSee := cls versions collect: #versionEntity.
	"versions := thingsToSee collect: [:c | {c versionName . c weightedMethodCount . c queryAllOutgoingDependencies size * 10 . c numberOfLinesOfCode }]."
	versions := thingsToSee collect: [:c | {'version' . c weightedMethodCount . (c queryAllOutgoingDependencies size * 10) . c numberOfLinesOfCode }].
	
	diag1 := ESDiagramRenderer new.
	(diag1 lineDiagram)
		y: #second;
		identifier: #first;
		yAxisLabel: 'WMC';
		rotatedLabels: true;
		regularAxis;
		defaultColor: Color blue;
		deviationValue: ( versions collect: #second) average;
		deviationDescription: 'average';
		preferredAxisMinY: ( ( versions collect: #second) min);
		models: versions.
	
	diag2 := ESDiagramRenderer new.
	(diag2 lineDiagram)
		y: #third;
		identifier: #first;
		yAxisLabel: 'outgoing dep';
		rotatedLabels: true;
		regularAxis;
		defaultColor: Color blue;
		deviationValue: ( versions collect: #third) average;
		deviationDescription: 'average';
		preferredAxisMinY: ( ( versions collect: #third) min);
		models: versions.

	diag3 := ESDiagramRenderer new.
	(diag3 lineDiagram)
		y: #fourth;
		identifier: #first;
		yAxisLabel: 'LoC';
		rotatedLabels: true;
		regularAxis;
		defaultColor: Color blue;
		deviationValue: ( versions collect: #fourth) average;
		deviationDescription: 'average';
		preferredAxisMinY: ( ( versions collect: #fourth) min);
		models: versions.

	view shape: (MOEyeSeeDiagramShape new).
	view nodes: {diag1 . diag2 . diag3}.
	
].
view verticalLineLayout.! !

!AutomaticalCaseStudies methodsFor: 'scripts' stamp: 'AlexandreBergel 11/17/2011 17:40'!
searchForUniClassPatterns
	| uniclassPattern histories history |

	histories:=MooseModel root allModels asArray.
	history := HismoModelHistory new.
	histories do: [:model | history addLastVersionForMooseModel: model].
	history name: #'HismoModel'.

	uniclassPattern:=ComplexityAndDependenceGeneral new.
	uniclassPattern searchForHitsInHistory:  history.
	uniclassPattern printResults.

	uniclassPattern:=ComplexityAndDependenceLOC new.
	uniclassPattern searchForHitsInHistory:  history.
	uniclassPattern printResults.

	uniclassPattern:=ComplexityAndDependencePackage new.
	uniclassPattern searchForHitsInHistory:  history.
	uniclassPattern printResults.

	uniclassPattern:=ComplexityAndDependenceClass new.
	uniclassPattern searchForHitsInHistory:  history.
	uniclassPattern printResults.

	uniclassPattern:=ComplexityAndDependenceNamespace new.
	uniclassPattern searchForHitsInHistory:  history.
	uniclassPattern printResults.

	"self deleteAllMooseModel."! !

Object subclass: #ChangeAnalyzer
	instanceVariableNames: 'tablesToPrintInExcell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-HistoryAnalyzer'!

!ChangeAnalyzer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/13/2012 16:48'!
analyzeHismoModel
	|hismoModel|
	hismoModel:=MooseModel root at:1.
	self calculatePercentageOfChangeForClasses: hismoModel.
	self calculateAverageOfChangesByVersion: hismoModel.
	self calculateAverageOfRallyOfChangeForClasses: hismoModel.
	self calculateNumberOfVersionsDistribution:hismoModel.
	Transcript show: 'Number of versions analyzed ', hismoModel versions size asString;cr.
	Transcript show:tablesToPrintInExcell;cr.! !

!ChangeAnalyzer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/27/2012 16:53'!
analyzeKindOfChangeForASystem: hismoModel
	|loc versions|
	versions := OrderedCollection new.
	
	hismoModel allModels do:[:aModelVersion|
		loc:=self locForAVersion: aModelVersion.
		versions
		add:
				((ESVersion new)
						versionNumber: aModelVersion name;
						loc: loc).
	].
	self showLineDiagram: versions.! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/3/2012 11:36'!
calculateAverageOfChange: aDictionary
|total|
	total:=0.
	aDictionary keys do:[:aClass|
		total:=total +(aDictionary at:aClass)
	].
	(aDictionary keys size==0) ifTrue:[^0].
	^ total/(aDictionary keys size)! !

!ChangeAnalyzer methodsFor: 'changeForVersions' stamp: 'SantiagoVidal 4/18/2012 18:49'!
calculateAverageOfChangesByVersion: aHismoModel
"Este metodo calcula para cada version cuantas clases cambiaron respecto a la version anterior. Solo se tienen en cuenta clases que existian en la version anterior"
	|classesHistories classesInVersion versions average variance averageOfNewClassesByVersion auxIndex|
	classesHistories:=aHismoModel allClassHistories select: [:each | each last isStub not].
	versions := OrderedCollection new.
	
	averageOfNewClassesByVersion:=OrderedCollection new.
	Transcript show: '+++++++++++++++++++++++++++++++++++++++++++++++++++';cr.
	Transcript show: 'Average of Change calculated By Version';cr.
	aHismoModel versions do:[:aVersion|
		|totalComputableClassForVersion totalClassesThatChanged totalOfNewClasses|
		totalOfNewClasses:=0.
		classesInVersion:=self obtainClassesForAVersion: aVersion from: classesHistories.
		totalComputableClassForVersion:=0.
		totalClassesThatChanged:=0.
		classesInVersion do:[:aClassInVersion|
			(aClassInVersion previousVersion ==nil)ifFalse:[
				totalComputableClassForVersion:=totalComputableClassForVersion+1.
				(self classVersionChanged: aClassInVersion) ifTrue:[
					totalClassesThatChanged:=totalClassesThatChanged+1
				].
			] ifTrue:[totalOfNewClasses:=totalOfNewClasses+1.].
		].
		(classesInVersion size>0)ifTrue:[
			averageOfNewClassesByVersion add: ((totalOfNewClasses*100)/(classesInVersion size)).
		] ifFalse:[averageOfNewClassesByVersion add:0].	

		(totalComputableClassForVersion>0) ifTrue:[
			
		Transcript show: '         version: ', aVersion versionEntity name, ' average: ',((totalClassesThatChanged/totalComputableClassForVersion)*100 )asFloat asString;cr.
		
		tablesToPrintInExcell:=tablesToPrintInExcell,  (((aVersion versionEntity name )subStrings:'.' )at:1),String tab,  (self formatNumber:((totalClassesThatChanged/totalComputableClassForVersion)*100)) ,String cr.
		
		versions
		add:
				((ChangeByVersion new)
						version: aVersion versionEntity name;
						averageChange: ((totalClassesThatChanged/totalComputableClassForVersion)*100 )).
		]
	
		
	].
	Transcript show: 'Average of new classes by version';cr.
	auxIndex:=1.
	aHismoModel versions do:[:aVersion|
		Transcript show: '         version: ', aVersion versionEntity name, ' average: ',(averageOfNewClassesByVersion at:auxIndex)asFloat asString;cr.
		
		tablesToPrintInExcell:=tablesToPrintInExcell,  (((aVersion versionEntity name )subStrings:'.' )at:1),String tab,  (self formatNumber:(averageOfNewClassesByVersion at:auxIndex)) ,String cr.
		auxIndex:=auxIndex+1.
	].

	average:=(versions collect: #averageChange) average.
	Transcript show: 'Average of change calculated by versions: ',(self formatNumber: average );cr.
	
	variance:=((versions collect: #averageChange) sum: [:each| (each -average)squared])/(versions size).
	Transcript show: '     The variance of the average is ', (self formatNumber: variance );cr.
	Transcript show: '     The standard deviation of the average is ', (self formatNumber: (variance sqrt ) );cr.
	
	
	Transcript show: '+++++++++++++++++++++++++++++++++++++++++++++++++++';cr.
	self createLineChartOfChanges: versions.! !

!ChangeAnalyzer methodsFor: 'rallyOfChanges' stamp: 'SantiagoVidal 4/14/2012 16:17'!
calculateAverageOfRallyOfChangeForClasses: aHismoModel
"Este metodo calcula el promedio de rally de cambios para las clases. Si la version 2 cambio, y la version 3 no cambio, el rally es igual a 1. Si la version 2 y 3 cambiaron y la 4 no cambio, rally=2"
|classesHistories averageRallyLenghForClass distributionOfRallyLenght|
	classesHistories:=aHismoModel allClassHistories select: [:each | each last isStub not].
	averageRallyLenghForClass:=Dictionary new.
	distributionOfRallyLenght:=Dictionary new.
	classesHistories do:[:classHistory | 
		|currentRallyLenght rallyLenghts|
		currentRallyLenght:=0.
		rallyLenghts:=OrderedCollection new.
		(classHistory versions size>1)ifTrue: [ 
			2 to: (classHistory versions size) do:[:versionNumber|
				|classVersion|
				classVersion:=classHistory versions at:versionNumber.
				(self classVersionChanged: classVersion) ifTrue:[
					currentRallyLenght:=currentRallyLenght+1] ifFalse:[(currentRallyLenght>0) ifTrue:[rallyLenghts add:currentRallyLenght]. currentRallyLenght:=0.].
			 ].
		].
		(rallyLenghts size>0)ifTrue:["Si solo tenia una version no lo tengo en cuenta"
			averageRallyLenghForClass at: classHistory  put: (self calculateAverageRallyLenghtForAClass:rallyLenghts).	
				self updateDistributionOfRallyLenght: distributionOfRallyLenght ralliesForAClassHistory: rallyLenghts.
		].	
	].
	Transcript show:'Average rally of changes lenght ', (self formatNumber: (self calculateAverageOfChange: averageRallyLenghForClass));cr.
	self printBiggestRallyChange: averageRallyLenghForClass.
	self printDistributionOfRallyLenghtsInPercentage: distributionOfRallyLenght.! !

!ChangeAnalyzer methodsFor: 'rallyOfChanges' stamp: 'SantiagoVidal 4/2/2012 14:04'!
calculateAverageRallyLenghtForAClass: rallyLenghts
	|total|
	total:=0.
	rallyLenghts do:[:aLenght|
		total:=total+aLenght.
	].
	^ (total/(rallyLenghts size))! !

!ChangeAnalyzer methodsFor: 'versionsDistibutions' stamp: 'SantiagoVidal 4/14/2012 16:26'!
calculateNumberOfVersionsDistribution: aHismoModel
	|classesHistories distribution|
	classesHistories:=aHismoModel allClassHistories select: [:each | each last isStub not].
	distribution:=Dictionary new.
	classesHistories do:[:classHistory | 
		|numberOfVersions ocurrences|
		numberOfVersions:=classHistory versions size.
		ocurrences:=distribution at: numberOfVersions ifAbsentPut:0.
		distribution at: numberOfVersions put:(ocurrences+1).
	].
	Transcript show:'Distribution of number of versions';cr.
	distribution keys sort do:[:aNumberOfVersions|
		Transcript show: '      Number of versions ',aNumberOfVersions asString, ' (equal to ', ((aNumberOfVersions/(aHismoModel versions size))*100) asFloat asString ,'% of total) ',(distribution at: aNumberOfVersions) asString;cr.
		
		tablesToPrintInExcell:=tablesToPrintInExcell, aNumberOfVersions asString, String tab,  (self formatNumber: ((aNumberOfVersions/(aHismoModel versions size))*100)),String tab,  (distribution at: aNumberOfVersions) asString,String cr.
	].! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/14/2012 15:41'!
calculatePercentageOfChangeForClasses: aHismoModel
"Este metodo calcula el porcentaje de cambios para las clases. Basicamente busca cual es el porcentaje de veces que el loc de una clase cambia con respecto a la version anterior. Finalmente hace un promedio de los porcentajes de todas las clases"
|classesHistories changePercentageForClass|
	classesHistories:=aHismoModel allClassHistories select: [:each | each last isStub not].
	changePercentageForClass:=Dictionary new.
	classesHistories do:[:classHistory | 
		|versionsWithChange versionsWithoutChange|
		versionsWithChange:=0.
		versionsWithoutChange:=0.
		(classHistory versions size>1)ifTrue: [ 
			2 to: (classHistory versions size) do:[:versionNumber|
				|classVersion|
				classVersion:=classHistory versions at:versionNumber.
				(self classVersionChanged: classVersion) ifTrue:[
					versionsWithChange:=versionsWithChange+1] 				ifFalse:[versionsWithoutChange:=versionsWithoutChange+1].
			 ].
		].
		(versionsWithChange+versionsWithoutChange>0)ifTrue:["Si solo tenia una version no lo tengo en cuenta"
			changePercentageForClass at: classHistory  put: (versionsWithChange/(versionsWithChange+versionsWithoutChange))*100.	
		].	
	].
	Transcript show:'The total average of change is (calculated for each class): ', (self formatNumber: (self calculateAverageOfChange: changePercentageForClass));cr.
	self printVarianceAndStandardDeviation: changePercentageForClass.
	self printClassesWithTheBiggestAndTheSmallestAverageOfChange:changePercentageForClass.
	self printDistributionOfChangeByClasses: changePercentageForClass.! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/2/2012 11:59'!
classVersionChanged:aHismoClassVersion
	^((aHismoClassVersion evolutionOfPropertyNamed: #numberOfLinesOfCode) ~= 0)! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/13/2012 09:06'!
createBarDiagramDistributionOfClassesChange: serie
	| diag diag2 diag3 |
	
	diag := (ESVerticalBarDiagram new)
		identifier: #rallyLenght;
		rotatedLabels: true;
		y: #average;
		leftGap: 0.2;
		rightGap: 0.5;
		regularAxis;
		defaultColor: Color blue;
		models: serie;
		yAxisLabel: 'Percentage of classes with a range % of change';
		yourself.
	diag3 := ESDiagramRenderer new.
	(diag3 compositeDiagram)
		add: diag;
		"add: diag2;"
		height: 300;
		width: 500.
	^ diag3 open! !

!ChangeAnalyzer methodsFor: 'rallyOfChanges' stamp: 'SantiagoVidal 4/10/2012 15:19'!
createBarDiagramDistributionOfRallyLenghts: serie
	| diag diag2 diag3 |
	
	diag := (ESVerticalBarDiagram new)
		identifier: #rallyLenght;
		rotatedLabels: true;
		y: #average;
		leftGap: 0.2;
		rightGap: 0.5;
		regularAxis;
		defaultColor: Color blue;
		models: serie;
		yAxisLabel: 'Average';
		yourself.
	diag3 := ESDiagramRenderer new.
	(diag3 compositeDiagram)
		add: diag;
		"add: diag2;"
		height: 300;
		width: 500.
	^ diag3 open! !

!ChangeAnalyzer methodsFor: 'changeForVersions' stamp: 'SantiagoVidal 4/10/2012 14:55'!
createLineChartOfChanges: versions

	| diag diag2 diag3|

	diag := ESDiagramRenderer new.
	(diag lineDiagram)
		y: #averageChange;
		identifier: #version;
		yAxisLabel: 'Average of Change';
		rotatedLabels: true;
		regularAxis;
		"valueAxis;"
		defaultColor: Color blue;
		deviationValue: (versions collect: #averageChange) average;
		deviationDescription: 'average';
		preferredAxisMinY: (versions minValue: #averageChange);
		models: versions.	"startLineAtZero;"
	^ diag open! !

!ChangeAnalyzer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/14/2012 15:38'!
formatNumber: aFloat
	|averageForTable|
	averageForTable:=(aFloat asFloat asString).
	averageForTable at: (averageForTable indexOf:$.)  put:$,.
	^averageForTable.! !

!ChangeAnalyzer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/13/2012 16:36'!
initialize 
	tablesToPrintInExcell:=''.! !

!ChangeAnalyzer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/27/2012 16:49'!
locForAVersion: aModelVersion
	|loc modelClasses|
	loc:=0.
	modelClasses:=aModelVersion allClasses select: [:each | each isStub not].
	modelClasses do:[:aClass|
		loc:=loc+aClass numberOfLinesOfCode.
	].
 	^loc. ! !

!ChangeAnalyzer methodsFor: 'changeForVersions' stamp: 'SantiagoVidal 4/10/2012 12:00'!
obtainClassesForAVersion: aVersion from: allClasses
	|ret|
	ret:=OrderedCollection new.
	allClasses do:[:aClassHistory|
		aClassHistory versions do:[:aClassVersion|
			(aClassVersion referenceVersion==aVersion) ifTrue:[ret add:aClassVersion.].
		].
	].
	^ret.! !

!ChangeAnalyzer methodsFor: 'rallyOfChanges' stamp: 'SantiagoVidal 4/12/2012 11:06'!
printBiggestRallyChange: averageRallyLenghForClass
|biggestClasses biggestAverage|
	biggestClasses:=OrderedCollection new.
	biggestAverage:=-1.
	averageRallyLenghForClass keys do:[:aClass|
		|change|
		change:=(averageRallyLenghForClass at:aClass).
		(change==biggestAverage)ifTrue:[biggestClasses add:aClass.].
		(change>biggestAverage)ifTrue:[
			biggestAverage:=change.
			biggestClasses:=OrderedCollection new.
			biggestClasses add:aClass.
		].
	].
	biggestClasses do:[:biggestClass|
		Transcript show: 'Biggest average of rally for a class: ', biggestClass name, ': ', biggestAverage asFloat asString;cr.
	].
	! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/13/2012 16:25'!
printClassesWithTheBiggestAndTheSmallestAverageOfChange:changePercentageForClass
|biggestClasses biggestAverage smallestClasses smallestAverage|
	smallestAverage:=101.
	biggestAverage:=-1.
	biggestClasses:=OrderedCollection new.
	smallestClasses:=OrderedCollection new.
	changePercentageForClass keys do:[:aClass|
		|change|
		change:=(changePercentageForClass at:aClass).
		(change==biggestAverage)ifTrue:[biggestClasses add: aClass.].
		(change>biggestAverage)ifTrue:[
			biggestAverage:=change.
			biggestClasses:=OrderedCollection new.
			biggestClasses add: aClass.
		].
		(change==smallestAverage)ifTrue:[smallestClasses add: aClass.].
		(change<smallestAverage)ifTrue:[
			smallestAverage:=change.
			smallestClasses:=OrderedCollection new.
			smallestClasses add: aClass.
		].
	].
	smallestClasses do:[:smallestClass|
		(smallestClass versions size >21) ifTrue:[
		Transcript show: '     Smallest average for a class: ', smallestClass name, ': ', smallestAverage asFloat asString, ' (',smallestClass versions size asString,' versions)';cr.].
	].
	
	biggestClasses do:[:biggestClass|
		(biggestClass versions size >5) ifTrue:[
		Transcript show: '     Biggest average for a class: ', biggestClass name, ': ', biggestAverage asFloat asString, ' (',biggestClass versions size asString,' versions)';cr.
		].
	].
	! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/14/2012 15:42'!
printDistributionOfChangeByClasses: changePercentageForClass
	"Todas las clases que considero tienen mas de una version"
	|distribution serie|
	distribution:=Dictionary new.
	serie:=OrderedCollection new.
	distribution at:0 put:0.
	distribution at:10 put:0.
	distribution at:20 put:0.
	distribution at:30 put:0.
	distribution at:40 put:0.
	distribution at:50 put:0.
	distribution at:60 put:0.
	distribution at:70 put:0.
	distribution at:80 put:0.
	distribution at:90 put:0.
	
	
	changePercentageForClass keys do:[:aClass|
		|change|
		change:=(changePercentageForClass at:aClass).
		(change<10)ifTrue:[distribution at:0 put:((distribution at:0)+1)]
		ifFalse:[(change<20)ifTrue:[distribution at:10 put:((distribution at:10)+1)]
		ifFalse:[(change<30)ifTrue:[distribution at:20 put:((distribution at:20)+1)]
		ifFalse:[(change<40)ifTrue:[distribution at:30 put:((distribution at:30)+1)]
		ifFalse:[(change<50)ifTrue:[distribution at:40 put:((distribution at:40)+1)]
		ifFalse:[(change<60)ifTrue:[distribution at:50 put:((distribution at:50)+1)]
		ifFalse:[(change<70)ifTrue:[distribution at:60 put:((distribution at:60)+1)]
		ifFalse:[(change<80)ifTrue:[distribution at:70 put:((distribution at:70)+1)]
		ifFalse:[(change<90)ifTrue:[distribution at:80 put:((distribution at:80)+1)]
		ifFalse:[distribution at:90 put:((distribution at:90)+1)].].].].].].].].].
	].
	Transcript show:'Distribution of average change for classes';cr.
	distribution keys sort do:[:aPercentageOfChange|
		|average averageForTable|
		average:=(((distribution at: aPercentageOfChange)/(changePercentageForClass keys size))*100).
		Transcript show: '      ',aPercentageOfChange asString, ' ',average asFloat asString,'%', ' (total occurrences: ', (distribution at: aPercentageOfChange) asString,')'  ;cr.
		
		
		tablesToPrintInExcell:=tablesToPrintInExcell,  (self formatNumber: average),String tab,  (distribution at: aPercentageOfChange) asString,String cr.
		
		
		serie add: ((DistributionGraphSerie new) average: average;rallyLenght: aPercentageOfChange asString).
	].

	self createBarDiagramDistributionOfClassesChange: serie.! !

!ChangeAnalyzer methodsFor: 'rallyOfChanges' stamp: 'SantiagoVidal 4/14/2012 16:23'!
printDistributionOfRallyLenghtsInPercentage: rallyDistribution
	|totalRallies serie|
	serie:=OrderedCollection new.
	totalRallies:=0.
	rallyDistribution keys do:[:aRallyLengh|
		totalRallies:=totalRallies+(rallyDistribution at:aRallyLengh).
	].
	Transcript show: 'Rally distribution on average';cr.
	rallyDistribution keys do:[:aRallyLengh|
		|average|
		average:=(((rallyDistribution at:aRallyLengh)/totalRallies)*100).
		
		Transcript show: '      ',aRallyLengh asString, ' ',average asFloat asString,'%', ' (total occurrences: ', (rallyDistribution at:aRallyLengh) asString,')'  ;cr.
		
		tablesToPrintInExcell:=tablesToPrintInExcell, aRallyLengh asString, String tab,  (self formatNumber: average),String tab,  (rallyDistribution at:aRallyLengh) asString,String cr.
		
		serie add: ((DistributionGraphSerie new) average: average;rallyLenght: aRallyLengh asString).
	].
	self createBarDiagramDistributionOfRallyLenghts: serie.! !

!ChangeAnalyzer methodsFor: 'changeForClasses' stamp: 'SantiagoVidal 4/14/2012 15:46'!
printVarianceAndStandardDeviation: changePercentageForClass
	|average squareOfDifferenceSum variance|
	average:=self calculateAverageOfChange: changePercentageForClass.
	squareOfDifferenceSum:=0.
	changePercentageForClass keys do:[:aClass|
		squareOfDifferenceSum:=squareOfDifferenceSum+ (((changePercentageForClass at:aClass)-average)squared).
	].
	variance:=(squareOfDifferenceSum/(changePercentageForClass keys size)).
	Transcript show: '     The variance of the average is ', (self formatNumber: variance);cr.
	Transcript show: '     The standard deviation of the average is ', (self formatNumber:(variance sqrt ));cr.! !

!ChangeAnalyzer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/27/2012 16:52'!
showLineDiagram: versions
	| diag |

	diag := ESDiagramRenderer new.
	(diag lineDiagram)
		y: #loc;
		identifier: #versionNumber;
		yAxisLabel: 'LoC';
		rotatedLabels: true;
		regularAxis;
		"valueAxis;"
		defaultColor: Color blue;
		"deviationValue: (self versions collect: #loc) average;
		deviationDescription: 'average';"
		preferredAxisMinY: (versions minValue: #loc);
		models: versions.	"startLineAtZero;"
	^ diag open! !

!ChangeAnalyzer methodsFor: 'rallyOfChanges' stamp: 'SantiagoVidal 4/10/2012 09:44'!
updateDistributionOfRallyLenght: aDictionary ralliesForAClassHistory: rallies
	rallies do:[:aRallyLengh|
		|totalOfThisLenght|
		totalOfThisLenght:=aDictionary at: aRallyLengh ifAbsentPut: 0.
		aDictionary at: aRallyLengh put:(totalOfThisLenght+1).
	].! !

Object subclass: #ChangeByVersion
	instanceVariableNames: 'averageChange version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-HistoryAnalyzer'!

!ChangeByVersion methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 12:28'!
averageChange
	^averageChange.! !

!ChangeByVersion methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 12:29'!
averageChange: anObject
	averageChange:=anObject.! !

!ChangeByVersion methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 12:28'!
version
	^version.! !

!ChangeByVersion methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 12:28'!
version: anObject
	version:=anObject! !

Object subclass: #DistributionGraphSerie
	instanceVariableNames: 'rallyLenght average'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-HistoryAnalyzer'!

!DistributionGraphSerie methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 15:08'!
average
	^average! !

!DistributionGraphSerie methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 15:09'!
average:anObject
	average:=anObject! !

!DistributionGraphSerie methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 15:08'!
rallyLenght
	^rallyLenght.! !

!DistributionGraphSerie methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/10/2012 15:08'!
rallyLenght: anObject
	rallyLenght:= anObject.! !

Object subclass: #HotSpotInstance
	instanceVariableNames: 'famixEntity kind entitiesAffected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-HotSpotsIdentifier'!

!HotSpotInstance methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 18:49'!
entitiesAffected
	^entitiesAffected! !

!HotSpotInstance methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 18:49'!
entitiesAffected: entities
	entitiesAffected:=entities.! !

!HotSpotInstance methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:37'!
famixEntity
	^famixEntity! !

!HotSpotInstance methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 09:20'!
famixEntity: anEntity
	famixEntity:=anEntity.! !

!HotSpotInstance methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:37'!
kind
	^kind! !

!HotSpotInstance methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 09:21'!
kind: aKindOfHotSpot 
	kind:=aKindOfHotSpot.! !

Object subclass: #HotSpotsVisualizer
	instanceVariableNames: 'mooseModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!HotSpotsVisualizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 12:15'!
createLegend: view
	view node: ProtoObject forIt: [
		view shape label "color:[:aHotSpot| aHotSpot color].".
		view node: self legendAsString.
		view verticalLineLayout.
	].! !

!HotSpotsVisualizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/18/2012 11:17'!
createVisualizationIn: view
	
	
	(mooseModel hotSpotsDetected =nil) ifTrue:[mooseModel detectHotSpots].
	
	
	
	self createLegend: view.
	
	self selectColorForNode: view with: mooseModel. 
	view nodes: (mooseModel allClasses select: [:each | each isStub not] )asOrderedCollection forEach: [ :each | 
		self selectColorForNode: view with: mooseModel.
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout.

	view addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].
	view addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].
	
	view raw translateBy: 0 @ 30.
	! !

!HotSpotsVisualizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/6/2012 09:53'!
legendAsString
	^ 'BrainClass blue (Class) #found=', (self numberOfHotSpotsFound:BrainClass)asString, String cr,
	   'BrainMethod brown (Method) #found=', (self numberOfHotSpotsFound: BrainMethod)asString, String cr,
	'DataClass cyan (Class) #found=', (self numberOfHotSpotsFound:DataClass)asString, String cr,
	'DispersedCoupling green (Method) #found=', (self numberOfHotSpotsFound:DispersedCoupling)asString, String cr,
	'FeatureEnvy orange (Method) #found=', (self numberOfHotSpotsFound:FeatureEnvy)asString, String cr,
	'GodClass pink (Class) #found=', (self numberOfHotSpotsFound:GodClass)asString, String cr,
	'IntensiveCoupling yellow (Method) #found=', (self numberOfHotSpotsFound:IntensiveCoupling)asString, String cr,
	'RefusedParentRequest magenta (Class) #found=', (self numberOfHotSpotsFound:RefusedParentRequest)asString, String cr,
	'ShotgunSurgery purple (Method) #found=', (self numberOfHotSpotsFound:ShotgunSurgery)asString, String cr,
	'TraditionBreaker gray (Class) #found=',(self numberOfHotSpotsFound:TraditionBreaker)asString .
	! !

!HotSpotsVisualizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/18/2012 11:11'!
mooseModel: aMooseModel
	mooseModel:=aMooseModel.! !

!HotSpotsVisualizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/6/2012 09:50'!
numberOfHotSpotsFound: aKindOfHotSpot
	|ret|
	ret:=0.
	mooseModel hotSpotsDetected keys do:[:anEntity|
		((mooseModel hotSpotsDetected) at: anEntity) do:[:aHotSpotInstance|
			(aHotSpotInstance kind =aKindOfHotSpot) ifTrue:[ret:=ret+1.]
		].
	].
	^ret.! !

!HotSpotsVisualizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 11:42'!
selectColorForNode:view with:aModel
	view shape rectangle borderColor:  [:aClass | 
			|hotSpotsInEntity|
			hotSpotsInEntity:=aModel hotSpotsDetected at: aClass ifAbsent:[nil].
			(hotSpotsInEntity=nil)ifTrue:[Color black]
			ifFalse: [
				(hotSpotsInEntity size>1) ifTrue:[Color red] ifFalse:[(hotSpotsInEntity at:1) kind color]
			].
		].! !

Object subclass: #MSESpiritImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!MSESpiritImporter methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 13:26'!
importMSEFile
	| model |
	model := SpiritModel new.
	model importFromMSE.
	model size > 0 ifTrue: [
		model install.
		"self addModel: model "]! !

Object subclass: #MilestoneVersionPair
	instanceVariableNames: 'milestone referencedVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!MilestoneVersionPair methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/19/2011 15:34'!
asString 
	^'(',milestone asString,' , ',referencedVersion asString,')'.! !

!MilestoneVersionPair methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/18/2011 10:47'!
setMilestone: m
 milestone:=m.! !

!MilestoneVersionPair methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/18/2011 10:48'!
setVersion: version
	referencedVersion:=version.! !

Object subclass: #MultiClassPatternSearchEngines
	instanceVariableNames: 'history threshold milestones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!MultiClassPatternSearchEngines class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:11'!
testMultiClassPatterns
	MultiClassPatternSearchEngines new identifyPatternsInHistory.! !

!MultiClassPatternSearchEngines class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:12'!
testUniClassPatterns
	MultiClassPatternSearchEngines new searchMilestones.! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 16:23'!
discoverPatternsInHits: hitsInAVersion! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/19/2011 15:03'!
foundMilestonesVersionInVersion: version with: historyOfHits forEntity: versionEntity currentModelVersion: currentModelVersion
|hitsOfAVersionForAMilestone ret indexOfCurrentVersion hitsInAVersion milestoneVersionPair entity|
ret:=OrderedCollection new.
indexOfCurrentVersion:=(history indexOf: currentModelVersion)+version.

(indexOfCurrentVersion>0 & (indexOfCurrentVersion<(history versions size))) ifTrue: [
	hitsInAVersion:=historyOfHits at: (history versions at: indexOfCurrentVersion).
	(hitsInAVersion keys) do: [:milestone|
		hitsOfAVersionForAMilestone:=hitsInAVersion at: milestone.
		entity:=self lookForEntity: versionEntity  inArray: hitsOfAVersionForAMilestone.
		(entity notNil) ifTrue:[
			milestoneVersionPair:=MilestoneVersionPair new.
			milestoneVersionPair setMilestone: milestone.
			milestoneVersionPair setVersion: entity referenceVersion.
			ret add:milestoneVersionPair.
		].
		
	].
].
^ret.! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 9/30/2011 10:43'!
history
^history.! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/19/2011 15:32'!
identifyPatternsInHistory
|hitsInAVersion historyOfHits hitsOfAVersionForAMilestone hitsOfAVersionForAMilestone2 patternForEntity patterns milestoneVersionPair pairsForPattern|
self loadMilestones.
milestones do:[:milestone| milestone searchForHitsInHistory: history].
historyOfHits:=self loadHitsForEachVersion.
patterns:=OrderedCollection new.
history versions do:[:modelVersion|
	"Para cada version miro si hay coincidencias para mas de un milestones en un mismo EntityModel"
	hitsInAVersion:=historyOfHits at: modelVersion.
	1 to: (hitsInAVersion keys size) do: [:i|
		hitsOfAVersionForAMilestone:=hitsInAVersion at: (hitsInAVersion keys at: i)."Este array tiene EntityElements de Hismo"
		hitsOfAVersionForAMilestone do:[:entity|
			"self halt."
			patternForEntity:=Pattern new.
			patternForEntity setEntityVersion: (entity versionEntity).
			milestoneVersionPair:=MilestoneVersionPair new.
			milestoneVersionPair setMilestone: (hitsInAVersion keys at: i).
			milestoneVersionPair setVersion: entity referenceVersion.
			patternForEntity addMilestoneVersionPair: milestoneVersionPair.
			(i+1) to: (hitsInAVersion keys size) do:[:j|
				hitsOfAVersionForAMilestone2:=hitsInAVersion at: (hitsInAVersion keys at: j).
				hitsOfAVersionForAMilestone2 do:[:entity2| (entity versionEntity=entity2 versionEntity)ifTrue: [milestoneVersionPair:=MilestoneVersionPair new.
			milestoneVersionPair setMilestone: (hitsInAVersion keys at: j).
			milestoneVersionPair setVersion: entity2 referenceVersion.
			patternForEntity addMilestoneVersionPair:milestoneVersionPair]. ].
			].
			"Si el threhold es distinto de 0 aca debo recorrer las otras historias chequeando lo mismo"
			(threshold>0) ifTrue:[
					1 to: threshold do:[:versionIndex|
						pairsForPattern:=self foundMilestonesVersionInVersion:versionIndex with: historyOfHits forEntity: (entity versionEntity) currentModelVersion:modelVersion.				
						pairsForPattern do:[:pair| patternForEntity addMilestoneVersionPair: pair].
						pairsForPattern:=self foundMilestonesVersionInVersion:versionIndex*(-1) with: historyOfHits forEntity: (entity versionEntity) currentModelVersion:modelVersion.
						pairsForPattern do:[:pair| patternForEntity addMilestoneVersionPair: pair].
					].
			].
			(patternForEntity size >1) ifTrue:[patterns add:patternForEntity.].
		].
		].
	"Luego hay que extenderlo para considerar el threshold"
		
	
	].
	Transcript show: patterns size.
	patterns do:[:p|Transcript show: p asString;cr.].
	! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/19/2011 14:59'!
initialize
"SpIRIT: Smart Identification Refactoring opportunITies"
|histories|
histories:=MooseModel root allModels asArray.
history := HismoModelHistory new.
histories do: [:model | history addLastVersionForMooseModel: model].
history name: #'Mondrian Core'.
threshold:=1.! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 10:47'!
loadHitsForEachVersion
|historyOfHits hitsInAVersion|
historyOfHits:=Dictionary new.
history versions do:[:modelVersion|
	hitsInAVersion:=Dictionary new.
	milestones do:[:milestone| hitsInAVersion at: milestone put: (milestone hitsInAVersion: modelVersion) ].
	historyOfHits at: modelVersion put:hitsInAVersion.
	].
^historyOfHits.! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 16:01'!
loadMilestones
milestones:=OrderedCollection new.
milestones add: (DeadClassMilestone new).
milestones add: (MostComplexClasses new).
milestones add: (SupernovaMilestone new).
"milestones add: (ComplexityAndDependenceRelationship new)."! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/19/2011 14:58'!
lookForEntity: versionEntity inArray: hitsOfAVersionForAMilestone

hitsOfAVersionForAMilestone do:[:entity|
	(entity versionEntity asString =versionEntity asString ) ifTrue: [
		^entity.	
	].
].
^nil.! !

!MultiClassPatternSearchEngines methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 16:01'!
searchMilestones
|milestone|
milestone:=DeadClassMilestone new.
milestone searchForHitsInHistory:  history. 
milestone printResults.

milestone:=MostComplexClasses new.
milestone searchForHitsInHistory:  history. 
milestone printResults.

milestone:=SupernovaMilestone new.
milestone searchForHitsInHistory:  history. 
milestone printResults.

"milestone:=ComplexityAndDependenceRelationship new.
milestone searchForHitsInHistory:  history. 
milestone printResults."! !

Object subclass: #Pattern
	instanceVariableNames: 'milestonesVersionsPairs entityVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!Pattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/18/2011 10:55'!
addMilestoneVersionPair: pair
	milestonesVersionsPairs add: pair.! !

!Pattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/19/2011 15:29'!
asString
	|ret|
	ret:=''.
	milestonesVersionsPairs do:[:pair|ret:=ret,' ',pair asString.].
	^'[',ret,'] ---> ',entityVersion asString.! !

!Pattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/18/2011 10:50'!
initialize 
 milestonesVersionsPairs:=OrderedCollection new.! !

!Pattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/18/2011 10:19'!
setEntityVersion:entity
	entityVersion:=entity.! !

!Pattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/18/2011 10:51'!
size
	^ milestonesVersionsPairs size.! !

Object subclass: #SPAnalizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!SPAnalizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 18:53'!
addHotSpotsInstancesFor: hotSpots ofKind: aKindOfHotSpot in: dictionary 
	hotSpots do:[:anEntity| 
		|array hsInstance| 
		array:=dictionary at: anEntity ifAbsentPut: OrderedCollection new. 
		hsInstance:= HotSpotInstance new. 
		hsInstance kind: aKindOfHotSpot. 
		hsInstance famixEntity: anEntity. array add:  hsInstance.
		hsInstance entitiesAffected: (aKindOfHotSpot new searchAffectedEntities: anEntity).
	].! !

!SPAnalizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/15/2012 09:59'!
analyse: aHismoModel! !

!SPAnalizer methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 11:31'!
analyseMooseModel: aMoseModel
	|classes methods hotSpots hotspotsByEntity|
	
	classes:=aMoseModel allClasses select: [:each | each isStub not].
	methods:=aMoseModel allMethods select: [:each | each isStub not].
	hotspotsByEntity:=Dictionary new.
	
	hotSpots:=classes select:[:aClass| (BrainClass new) analyze: aClass].
	self addHotSpotsInstancesFor: hotSpots ofKind: BrainClass in: hotspotsByEntity.
	
	hotSpots:=methods select:[:aMethod| (BrainMethod new) analyze: aMethod].
	self addHotSpotsInstancesFor: hotSpots ofKind: BrainMethod in: hotspotsByEntity.
	
	hotSpots:=classes select:[:aClass| (DataClass new) analyze: aClass].
	self addHotSpotsInstancesFor: hotSpots ofKind: DataClass in: hotspotsByEntity.
	
	hotSpots:=methods select:[:aMethod| (DispersedCoupling new) analyze: aMethod].
	self addHotSpotsInstancesFor: hotSpots ofKind: DispersedCoupling in: hotspotsByEntity.
	
	hotSpots:=methods select:[:aMethod| (FeatureEnvy new) analyze: aMethod].
	self addHotSpotsInstancesFor: hotSpots ofKind: FeatureEnvy in: hotspotsByEntity.
	
	hotSpots:=classes select:[:aClass| (GodClass new) analyze: aClass].
	self addHotSpotsInstancesFor: hotSpots ofKind: GodClass in: hotspotsByEntity.
	
	hotSpots:=methods select:[:aMethod| (IntensiveCoupling new) analyze: aMethod].
	self addHotSpotsInstancesFor: hotSpots ofKind: IntensiveCoupling in: hotspotsByEntity.
	
	hotSpots:=classes select:[:aClass| (RefusedParentRequest new) analyze: aClass].
	self addHotSpotsInstancesFor: hotSpots ofKind: RefusedParentRequest in: hotspotsByEntity.
	
	hotSpots:=methods select:[:aMethod| (ShotgunSurgery new) analyze: aMethod].
	self addHotSpotsInstancesFor: hotSpots ofKind: ShotgunSurgery in: hotspotsByEntity.
	
	hotSpots:=classes select:[:aClass| (TraditionBreaker new) analyze: aClass].
	self addHotSpotsInstancesFor: hotSpots ofKind: TraditionBreaker in: hotspotsByEntity.
	
	^hotspotsByEntity.! !

Object subclass: #SPHotSpot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

SPHotSpot subclass: #SPMultipleHotSpot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

SPHotSpot subclass: #SPSimpleHotSpot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

SPSimpleHotSpot subclass: #BrainClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!BrainClass class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:49'!
color
	^Color blue.! !

!BrainClass class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:06'!
kind
	^'BrainClass'! !

!BrainClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/24/2012 14:37'!
analyze: aClass
	|numberOfBrainMethods|
	(GodClass new analyze: aClass) ifTrue:[^false.].
	numberOfBrainMethods:= self numberOfBrainMethods: aClass.
	
	((numberOfBrainMethods >1) & (aClass numberOfLinesOfCode > Threshold LOCClassVeryHigh) & (aClass weightedMethodCount > Threshold WMCVeryHigh)) ifTrue:[^true].
	
	((numberOfBrainMethods==1) & (aClass numberOfLinesOfCode > (2*Threshold LOCClassVeryHigh)) & (aClass weightedMethodCount > (2*Threshold WMCVeryHigh))) ifTrue:[^true].
	
	^false.! !

!BrainClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/24/2012 10:46'!
numberOfBrainMethods: aClass
	|brainMethod count|
	brainMethod:=BrainMethod new.
	count:=0.
	aClass methodsDo: [:aMethod|
		(brainMethod analyze: aMethod) ifTrue:[count:=count+1.].
	].
	^count.! !

!BrainClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 15:35'!
searchAffectedEntities: aClass
"Son clases muy complejas que tienden a acumular una excesiva cantidad de inteligencia, usualmente en la forma de metodos afectados por BrainMethod"
"La refactorizacion esta dirgida a eliminar los brainMethods"
	^ aClass invokedClasses union: aClass invokingClasses ! !

SPSimpleHotSpot subclass: #BrainMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!BrainMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:49'!
color
	^Color brown.! !

!BrainMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:06'!
kind
	^'BrainMethod'! !

!BrainMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 16:37'!
analyze: aMethod
	((aMethod numberOfLinesOfCode > Threshold LOCVeryHigh) & ("(aMethod hierarchyNestingLevel)"(aMethod cyclomaticComplexity/2) >= Threshold deep) & (aMethod cyclomaticComplexity >= Threshold many) & ((AdditionalMetrics numberOfAccessedVariables: aMethod) >= Threshold sMemCap)) ifTrue:[^true.].
	^false.! !

!BrainMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 15:35'!
searchAffectedEntities: aMethod
"Es un metodo demasiado grande que centraliza la funcionalidad de una clase. Esto lo convierte en dificil de mantener y entender"
"El refactoring es complejo y depende de cada caso. Sin embargo, puede decirse que el peor caso es cuando el metodo debe dividirse y trasladarse a clases invocadas por el metodo y que invocan al metodo"
^ aMethod invokedClasses union: aMethod invokingClasses ! !

SPSimpleHotSpot subclass: #DataClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!DataClass class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:50'!
color
	^Color cyan.! !

!DataClass class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:07'!
kind
	^'DataClass'! !

!DataClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 10:00'!
analyze:aClass
	
	( 
		((AdditionalMetrics weightOfAClass: aClass)<Threshold oneThird) &    
		( 
			(((aClass numberOfAccessorMethods + aClass numberOfPublicAttributes)>Threshold few) &
			(aClass weightedMethodCount < Threshold WMCHigh)) |
			
			(((aClass numberOfAccessorMethods + aClass numberOfPublicAttributes)>Threshold many) &
			(aClass weightedMethodCount < Threshold WMCVeryHigh))
		
		
		)
		
	 )ifTrue:[^true].
	^false. ! !

!DataClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 15:18'!
searchAffectedEntities: aClass
"Los DataClass son clases que guardan informacion pero no tienen funcionalidad compleja. Por esta razon, el behavior asociado a la clase podria estar en otro lugar"
"Las entidades afectadas seran las clases clientes que llaman a la data class. Esto es asi porque metodos de estas clases seran trasladados a la data class o porque los datos guardados en la data class seran repartidos en  los clientes"
	^aClass invokingClasses."Devuelve las clases que invocan a esta clase"! !

SPSimpleHotSpot subclass: #DispersedCoupling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!DispersedCoupling class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:50'!
color
	^Color green.! !

!DispersedCoupling class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:07'!
kind
	^'DispersedCoupling'! !

!DispersedCoupling methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 15:32'!
analyze: aMethod
	(
		"(aMethod hierarchyNestingLevel > Threshold shallow) & Lo cambie porque no puedo calcular el maxnesting de un metodo"
		((aMethod cyclomaticComplexity/2) > Threshold shallow) & "Esto es lo mas parecido al nesting"
		( 
			(((AdditionalMetrics couplingIntensity: aMethod) > Threshold sMemCap) &
			((AdditionalMetrics couplingDispersion: aMethod)>= Threshold half)) 
			
		)
	) ifTrue:[^true].
	^false.! !

!DispersedCoupling methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 16:03'!
searchAffectedEntities: aMethod
"Este es el caso de un metodo que llama a muchos metodos que estan implementados en clases diferentes"
"El refactoring es similar a BrainMethod"
^ aMethod invokedClasses union: aMethod invokingClasses ! !

SPSimpleHotSpot subclass: #FeatureEnvy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!FeatureEnvy class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:50'!
color
	^Color orange.! !

!FeatureEnvy class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:07'!
kind
	^'FeatureEnvy'! !

!FeatureEnvy methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 11:11'!
analyze: aMethod
	(((AdditionalMetrics accessToForeignDataForAMethod: aMethod )> Threshold few) &((AdditionalMetrics foreignDataProvidersForAMethod: aMethod)<=Threshold few) &((AdditionalMetrics localityOfAttributesAccesses: aMethod)<Threshold oneThird))ifTrue:[^true].
	^false.! !

!FeatureEnvy methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 15:05'!
searchAffectedEntities: aMethod
"Son metodos que acceden a muchos datos de otras clases a traves de metodos o directamente. Esto podria ser un signo de que el metodo esta mal ubicado y deberia ser movido a otra clase"
"El refactoring propone trasladar el metodo (o parte de el) a la clase con la cual esta mas acoplado. Por esta razon la entidad afectada es la clase con la que esta mas acoplada. Sin embargo el peor caso es que el metodo se parta en otros metodos que se trasladen a cada una de las clases acopladas"
	^aMethod invokedClasses.
! !

SPSimpleHotSpot subclass: #GodClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!GodClass class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:51'!
color
	^Color pink.! !

!GodClass class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:07'!
kind
	^'GodClass'! !

!GodClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/24/2012 11:07'!
analyze: aClass
	(((AdditionalMetrics accessToForeignData: aClass) > Threshold few) & (aClass tightClassCohesion<Threshold  oneThird )& (aClass weightedMethodCount >= Threshold WMCVeryHigh)) ifTrue:[
		^true.
	].
	 ^false.! !

!GodClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 14:33'!
searchAffectedEntities: aClass
"GodClass es un code smell en el que una clase hace demasiadas cosas delegando detalles menores a clases triviales y usando informacion de otras clases. SI la clase esta en una parte del sistema que no se modifica entonces NO es un problema"
"Los componentes que afectaria su refactorizacion son las clases que colaboran con la clase. Por esta razon el peor caso es que todas las clases invocadas sean modificadas"
	^aClass invokedClasses.! !

SPSimpleHotSpot subclass: #IntensiveCoupling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!IntensiveCoupling class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:52'!
color
	^Color yellow.! !

!IntensiveCoupling class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:07'!
kind
	^'IntensiveCoupling'! !

!IntensiveCoupling methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 16:29'!
analyze: aMethod
	(
		"(aMethod hierarchyNestingLevel > Threshold shallow) &  Lo cambie porque no puedo calcular el maxnesting de un metodo"
		((aMethod cyclomaticComplexity/2) > Threshold shallow) & "Esto es lo mas parecido al nesting"
		( 
			(((AdditionalMetrics couplingIntensity: aMethod) > Threshold sMemCap) &
			((AdditionalMetrics couplingDispersion: aMethod)< Threshold half)) |
			
			(((AdditionalMetrics couplingIntensity: aMethod) > Threshold few) &
			((AdditionalMetrics couplingDispersion: aMethod)< Threshold oneQuarter))
			
		)
	) ifTrue:[^true].
	^false.! !

!IntensiveCoupling methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 15:48'!
searchAffectedEntities: aMethod
"Identifica el caso en el que un metodo solo llama metodos de una o unas pocas clases. Ademas, debe haber muchas llamadas a estos metodos."
"La refactorizacion se dara en la clase receptora de los cambios donde posiblemente deban crearse nuevos metodos"
	^aMethod invokedClasses.! !

SPSimpleHotSpot subclass: #RefusedParentRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!RefusedParentRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:52'!
color
	^Color magenta.! !

!RefusedParentRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:07'!
kind
	^'RefusedParentRequest'! !

!RefusedParentRequest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 11:34'!
analyze: aClass
   "Primero chequear que la clase tenga una superclass (mayor a Object) y que la superclass no sea una interface ni este en una libreria (es decir, esta dentro de allModel clases)"
	|superclass|
	superclass:=aClass superclass.
	(superclass ==nil) ifFalse:[
		(superclass isStub) ifFalse:[
			(superclass isInterface) ifFalse:[
				(
					((((AdditionalMetrics numberOfProtectedMembers: superclass)>Threshold few) &
					((AdditionalMetrics baseClassUsageRatio: aClass) < Threshold oneThird)) |
					((AdditionalMetrics baseClassOverridingRatio: aClass) < Threshold oneThird))
					&
					( 
						(((AdditionalMetrics averageMethodWeight: aClass)> Threshold AMWAvg) |
						(aClass weightedMethodCount >Threshold WMCAvg)) &
						((aClass methods size)>Threshold NOMAvg)
					
					)
				) ifTrue:[^true.].
			].
		].
	].
	^false.! !

!RefusedParentRequest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 19:21'!
searchAffectedEntities: aClass
|superclasses|
"Es una subclase que no utiliza los metodos de la superclase"
"La refactorizacion es muy compleja y depende de cada caso. Sin embargo puede decirse que el peor caso es cuando debe modificarse todos la cadena de padres de la clase"
	superclasses := OrderedCollection new.
	aClass allSuperclassesDo: [ :aSuperClass | superclasses add: aSuperClass ].
	^superclasses.! !

SPSimpleHotSpot subclass: #ShotgunSurgery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!ShotgunSurgery class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:52'!
color
	^Color purple.! !

!ShotgunSurgery class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:08'!
kind
	^'ShotgunSurgery'! !

!ShotgunSurgery methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/1/2012 10:31'!
analyze: aMethod
	(((AdditionalMetrics changinMethods: aMethod)> Threshold sMemCap) &
	 ( (AdditionalMetrics changingClasses: aMethod)  >Threshold many)
	)ifTrue:[
		(aMethod isConstructor | aMethod isConstant) ifFalse:[
			^true
		].
	].
	^false.! !

!ShotgunSurgery methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 16:09'!
searchAffectedEntities: aMethod
"Este es el caso de un metodo que es invocado por muchos metodos de diferentes clases. Si este metodo cambia habra que realizar muchos cambios pequeos en los callers"
"En general se traslada behavior de los callers a la clase del metodo"
^aMethod invokingClasses.! !

SPSimpleHotSpot subclass: #TraditionBreaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

!TraditionBreaker class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 10:53'!
color
	^Color gray.! !

!TraditionBreaker class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 12:08'!
kind
	^'TraditionBreaker'! !

!TraditionBreaker methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/29/2012 13:47'!
analyze: aClass
	|superclass|
	superclass:=aClass superclass.
	(superclass ==nil) ifFalse:[
		(superclass isStub) ifFalse:[
			(superclass isInterface) ifFalse:[
				(
					(((AdditionalMetrics numberOfAddedServices: aClass)>=Threshold NOMAvg)&
					((AdditionalMetrics percentageOfNewlyAddedServices: aClass)>=Threshold twoThirds)) &
					( (((AdditionalMetrics averageMethodWeight: aClass)>Threshold AMWAvg)|
					   (aClass weightedMethodCount >= Threshold WMCVeryHigh)) &
					   ((aClass methods size) >=Threshold NOMHigh))&
					( ((AdditionalMetrics averageMethodWeight: superclass)>Threshold AMWAvg)& 
					  ((superclass methods size) >(Threshold NOMHigh/2))&
					  (superclass weightedMethodCount >= (Threshold WMCVeryHigh/2)) 	
					)
				) ifTrue:[^true.].
			].
		].
	].
	^false.! !

!TraditionBreaker methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/5/2012 19:17'!
searchAffectedEntities: aClass
|superclasses|
"Es una subclase que solo agrega nueva funcionalidad pero que no especializa demasiado los servicios que hereda"
"La refactorizacion es muy compleja y depende de cada caso. Sin embargo puede decirse que el peor caso es cuando debe modificarse todos la cadena de padres de la clase"
	superclasses := OrderedCollection new.
	aClass allSuperclassesDo: [ :aSuperClass | superclasses add: aSuperClass ].
 ^superclasses.! !

Object subclass: #SpiritBrowser
	instanceVariableNames: 'browser'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'Spirit-UI'!

!SpiritBrowser class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/26/2012 16:02'!
getInstance
	instance ifNil: [instance := self basicNew initialize].
       ^instance! !

!SpiritBrowser class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/28/2012 09:40'!
icon
^Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: ('iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAIGNIUk0AAHolAACAgwAA+f8A
AIDpAAB1MAAA6mAAADqYAAAXb5JfxUYAAAAJcEhZcwAACxIAAAsSAdLdfvwAAAH/SURBVDhP
Y2AYaoCNHAdLqSrytjvbiJ51sRN9YG8pshNoSAKxBln4e8g+ry2x+T9tQt7/5Yta//e0xfyf
1OHyX1eDbyvQEC58Bol4OEq97GwM/H/k6Mn/r998+X/8+Ln/7z78+P/vz7P/5w8X/hcXZpyJ
0wB5Wa6KkmyT/6fPXPgPAoePHfyvYiEJZkPAs/+V+UZfcBpgYSywZ0pf1v/HT17/X752yf+6
7vL/pmHK/+cvnfN/49b1///8/vd/x7qs/zgNsDTmO7R4XsP/3XsP/dd3Uf5vGa7x3ylf479F
kMZ/xwCr/58/fvl/bHclbgO0ZRmX1Jd7/f/w8ef/v7/+/V+3Yc1/FTux/y8fvwWGAcgLf//P
mej7B5cLajgtHT/Ghqv+nzOjA+zjm7dv/g9LCPr/B6z5//8/nzf8d7QWvoRugDqficU+2Yy8
/+JJOf8VAnz/Z0Qq/Z/cV/r/wvkz0MD78v/7+9X/02LVfgI12yEMYGJKEQsM/aQ1feF/g1Vb
/4sHhPxnkFRcIMzPUurpJP40I0H//7qlKf97mlz+25oLHAdqtIFp1uDR0V2hUFT1X2/Juv9a
Mxb+FwsI/cgqJJSM5Dx+INsJiIOA2BjF2YwsLPuUa1v/G6zZ/l+5ru0/n6HpPqACdWKTKkid
pJCj22np5Mz3LAICVaRoBKkFAEoFAOpXDMNpAAAAAElFTkSuQmCC') readStream).! !

!SpiritBrowser class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/28/2012 09:25'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'SpiritBrowser')
"		order: 3; "
		parent: #Tools;
		label: 'SpiritBrowser';
		icon: self icon;
		action: [ self getInstance showBrowser ]! !

!SpiritBrowser methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/18/2012 11:14'!
actionsFor: aPresentation 
	|actions|
	actions:=OrderedCollection new.
	(aPresentation selection isKindOf: SpiritModel) ifTrue:[
		actions add: ((GLMGenericAction new) 
						action: [:each |each selection detectHotSpots]; 
						title: 'Find Hot Spots'; 
						yourself).
		actions add: ((GLMGenericAction new) 
						action: [:each | |selectionArray| selectionArray:=OrderedCollection new. selectionArray add: (each selection).
							(each pane port: #hotSpotsVisualizationSelection) value:selectionArray.]; 
						title: 'Visualize Hot Spots'; 
						yourself).
		actions add: ((GLMGenericAction new) 
						action: [:each | HeatMapWizard new openWizard: each" (each pane port: #heatMapSelection) value:(each selection)."]; 
						title: 'Visualize Heat Map'; 
						yourself).
		actions add: ((GLMGenericAction new) 
						action: [:each | |selectionArray| selectionArray:=OrderedCollection new. selectionArray add: (each selection).
							(each pane port: #logicalArchitectureSelection) value:selectionArray.]; 
						title: 'Visualize Logical Architecture'; 
						yourself).
	] ifFalse:[
	
	].
	^actions.! !

!SpiritBrowser methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/26/2012 16:04'!
browser
 ^browser.! !

!SpiritBrowser methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/4/2012 13:44'!
getSpiritModels: rootModel
	|spiritModel|
	
	spiritModel:=OrderedCollection new.
	spiritModel addAll: (rootModel allWithType:SpiritModel).
	spiritModel addAll: (rootModel allWithType:SpiritHismoModel).
	^spiritModel.! !

!SpiritBrowser methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/26/2012 16:04'!
new
^self shouldNotImplement! !

!SpiritBrowser methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/14/2012 12:12'!
refactoringsSuggestedBrowser
	|browserRefactoringSuggested|
	
	
	browserRefactoringSuggested:=GLMStacker new.
	browserRefactoringSuggested aPane: #refactoringsSuggested_List; aPane: #refactoringsSuggested_Advantages; aPane: #refactoringsSuggested_Disadvantages.
	browserRefactoringSuggested transmit to: #refactoringsSuggested_List; andShow: [:a | 
		a titleIcon: SpiritIcons wheelIcon; title:'Refactorings suggested'.
		a list display:#('refactorings A' 'refactorings B' 'refactorings C'); selectionAct: [self inform: 'refactoring applied'] entitled: 'Apply Refactoring'.
		a act: [":list :all | all add: (all size + 1) " ] 
				icon: GLMUIThemeExtraIcons glamorousAdd 
				entitled: 'Add refactoring'. 
		].
	browserRefactoringSuggested transmit to: #refactoringsSuggested_Advantages; andShow: [:a | a titleIcon: SpiritIcons thumbupIcon; title: 'Advantages'.]."Esto es por el bug de que no muestra los iconos"
	browserRefactoringSuggested transmit from:#refactoringsSuggested_List; to: #refactoringsSuggested_Advantages; andShow: [:a | 
		a titleIcon: SpiritIcons thumbupIcon; title: 'Advantages'.
		a text display:"[:x |  x first]"'advantages'.
	].
	browserRefactoringSuggested transmit to: #refactoringsSuggested_Disadvantages; andShow: [:a | a titleIcon: SpiritIcons thumbdownIcon; title: 'Disadvantages'.]."Esto es por el bug de que no muestra los iconos"
	browserRefactoringSuggested transmit from:#refactoringsSuggested_List; to: #refactoringsSuggested_Disadvantages; andShow: [:a | 
		a titleIcon: SpiritIcons thumbdownIcon; title: 'Disadvantages'.
		a text display:'disadvantages'.
	].
	browserRefactoringSuggested transmit from:#refactoringsSuggested_List; toOutsidePort: #selection.
	^browserRefactoringSuggested! !

!SpiritBrowser methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/18/2012 11:15'!
showBrowser
	| browserLocations|
	browser := GLMTabulator new.
	browser title: 'SPIRIT Browser'.
	
	
	
	browser
		row: #toolbar size:25;
   		row: [ :r | r column: #systems; column: #hotSpots; column: #locationsToRefactorize; column: #refactoringsSuggested; column: #affectedComponents; column: #refactoredCode]  "size: 200";
  		 row: #hotSpotInformation.
	
	browser transmit to: #toolbar; andShow: [:a | 
		a act: [HismoImporter new openWizard] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Add Hismo Model'.
		a act: [MSESpiritImporter new importMSEFile] icon: MooseIcons mooseImportMse entitled: 'Import Model from MSE file'.
	].

	browser transmit to: #systems; andShow: [:a | 
		a title: 'System Models'.
		a list display: [ :model | self getSpiritModels:model];
      	format: [ :model | model name ];
		updateOn: MooseEntityAdded from: [:root| root announcer ];
		dynamicActionsOnSelection: [:list | self actionsFor: list ]
	].
	
	browser transmit from: #systems; to: #hotSpots; andShow: [:a | 
		a title: 'Hot Spots'.
		a list
			beMultiple;
			"dynamicActions: [:list | self actionsFor: list];"
			filterOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each];
			display: [ ":model | model name"#('Hot spot 1' 'Hot spot 2' 'Hot spot 3' 'Hot spot 4') ];
			format: [:number | (number='Hot spot 1') ifTrue:[Text string: number printString attribute: TextColor red] ifFalse:[(number='Hot spot 4') ifTrue:[Text string: number printString attribute: (TextColor color: (Color fromArray: #(0.0 0.5 0.0)))] ifFalse:[Text string: number printString attribute: (TextColor color: (Color fromArray: #(1.0 0.78 0.05)))]]];
			helpMessage:  'Enter a filtering request (e.g., "each > 10")'.
		].
	
	
	
	browser transmit from: #hotSpots; to: #locationsToRefactorize; andShow: [:a | 
		a title: 'Locations'.
		a list
			beMultiple;
			"dynamicActions: [:list | self actionsFor: list];"
			filterOn: [:text :each | (Compiler evaluate: '[:each | ', text, ']') value: each];
			display: [" :model | "#('Metodo 1' 'Metodo 2' 'Metodo 3' 'Variable 1') ];
			"format: [:number | (number='Metodo 1') ifTrue:[Text string: number printString attribute: TextColor red] ifFalse:[(number='Variable 1') ifTrue:[Text string: number printString attribute: (TextColor color: (Color fromArray: #(0.0 0.5 0.0)))] ifFalse:[Text string: number printString attribute: (TextColor color: (Color fromArray: #(1.0 0.78 0.05)))]]];"
			helpMessage:  'Enter a filtering request (e.g., "each > 10")'.
		].

	
	

	browser transmit from: #locationsToRefactorize; to: #refactoringsSuggested; andShow: [:a | 
		a title: 'Refactorings'.
		
		a custom: self refactoringsSuggestedBrowser.
		"a list titleIcon: SpiritIcons wheelIcon; title:'Refactorings suggested';display:#('refactorings A' 'refactorings B' 'refactorings C'); selectionAct: [self inform: 'refactoring applied'] entitled: 'Apply Refactoring'; act: [] 
				icon: GLMUIThemeExtraIcons glamorousAdd 
				entitled: 'Add refactoring'. 
		a text titleIcon: SpiritIcons thumbupIcon; title: 'Advantages';display:'advantages'.
		a text titleIcon: SpiritIcons thumbdownIcon; title:'Disadvantages';display:'disadvantages'."
	].


	

	browser transmit from:#refactoringsSuggested; to: #affectedComponents; andShow: [:a | 
		a title: 'Affected Components'.
		a list display: #('Metodo A' 'Clase B' 'Metodo C' 'Variable D').
		"a list title: 'List'. a text title: 'Text' "].
	
	browser transmit from:#affectedComponents; to: #refactoredCode; andShow: [:a | 
		a title: 'Refactored Source'.
		a text display: 'I''m the refactorized source code of an affected component '.
		"a list title: 'List'. a text title: 'Text' "].
	
	
	
	
	browser transmit from: #systems; to: #hotSpotInformation; andShow: [:a | 
	  "Este deberia borrar el hotSpotInformation cuando se cambia de sistema. Ver si realmente se hace asi o si se hace solo"	
	].
	
	browser transmit from: #locationsToRefactorize; to: #hotSpotInformation; andShow: [:a | 
		a title: 'Source Code'.
		a text display:[ :x | 'I''m the source code of a hot spot',x asString ] .
		
	].
	
	browser transmit to: #hotSpotInformation; from: #systems port:#heatMapSelection;andShow: [:a | 
		a title: 'Heat Map'.
		a custom:SpiritVisualizationPane new openBrowser.
		
	].
	
	browser transmit to: #hotSpotInformation; from: #systems port:#logicalArchitectureSelection;andShow: [:a | 
		a title: 'Logical Architecture'.
		a roassal
                       "title: 'Visualization';"
                       painting: [:view :input| 
					|hm|
					
				
					hm:=LogicalArchitecture new .
					
					hm mooseModel: (input at: 1).
					hm visualizeLogicalArchitectureIn: view.
					
				] 
	].
	
	browser transmit to: #hotSpotInformation; from: #systems port:#hotSpotsVisualizationSelection;andShow: [:a | 
		a title: 'Hot Spots Locations'.
		a roassal
                       "title: 'Visualization';"
                       painting: [:view :input| 
					|hm|
					
				
					hm:=HotSpotsVisualizer new .
					
					hm mooseModel: (input at: 1).
					hm createVisualizationIn: view.
					
				] 
	].
	
	browser openOn: (SpiritModelManager getAllModels).! !

Object subclass: #SpiritHSCheckBox
	instanceVariableNames: 'selected checkBox parentPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!SpiritHSCheckBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 11:07'!
checkBox
	^checkBox! !

!SpiritHSCheckBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 11:07'!
checkBox: aCheckBox
	checkBox:=aCheckBox! !

!SpiritHSCheckBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/10/2012 19:03'!
initialize 
	selected:=false.! !

!SpiritHSCheckBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 11:12'!
parentPanel: aSpiritVisualizationPane
	parentPanel:=aSpiritVisualizationPane! !

!SpiritHSCheckBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/10/2012 19:05'!
visualizeHotSpot
	^selected! !

!SpiritHSCheckBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 11:13'!
visualizeHotSpot: aBoolean
	selected:=aBoolean.
	parentPanel theHSSelectedChange: self.! !

Object subclass: #SpiritHismoModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Core'!

Object subclass: #SpiritHotSpotInformationPane
	instanceVariableNames: 'browser'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'Spirit-UI'!

!SpiritHotSpotInformationPane class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 14:13'!
getInstance
	instance ifNil: [instance := self basicNew initialize].
       ^instance! !

!SpiritHotSpotInformationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 13:47'!
getBrowser
	

"	browser aPane: #HSInformation_SystemLogicalArchitecture; aPane: #HSInformation_BadSmellsPlaces; aPane: #HSInformation_BadSmellsHeatMap; aPane: #HSInformation_SourceCode."
	
	
	""
	^browser.! !

!SpiritHotSpotInformationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 13:46'!
initialize
	browser:=GLMStacker new.! !

!SpiritHotSpotInformationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 14:13'!
new
^self shouldNotImplement! !

!SpiritHotSpotInformationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 14:38'!
updateHeatMapPane
	[browser paneNamed:#HSInformation_BadSmellsHeatMap] on: NotFound do: [browser aPane: #HSInformation_BadSmellsHeatMap].

	browser transmit to: #HSInformation_BadSmellsHeatMap; andShow: [:a | 
		a title: 'Heat Map'.
		a text display: 'I''m the source code of a hot spot'.
	].! !

!SpiritHotSpotInformationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/15/2012 14:18'!
updateSourceCodePane
	
	[browser paneNamed:#HSInformation_SourceCode] on: NotFound do: [browser aPane: #HSInformation_SourceCode].

	browser transmit to: #HSInformation_SourceCode; andShow: [:a | 
		a title: 'Source Code'.
		a text display: 'I''m the source code of a hot spot'.
	].
! !

Object subclass: #SpiritIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!SpiritIcons class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/18/2012 14:09'!
thumbdownIcon
^Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self thumbdownIconContents readStream)! !

!SpiritIcons class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/18/2012 14:09'!
thumbdownIconContents
^'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAFXRFWHRDcmVhdGlvbiBUaW1l
AAfYAgENCSNeubr/AAAAB3RJTUUH2AIBDQ0GpNBIzAAAAAlwSFlzAAALEgAACxIB0t1+/AAA
AAlQTFRF////AAAAenp6QjdNhQAAAAF0Uk5TAEDm2GYAAAA8SURBVHjaY2DAAEyMjAyMMAAS
YAQjCEATgCpBVsHASJwKJjQVEGuRrYEymGDugIkgcdCdh1MJmgAGHwYAKtgAQnp2UroAAAAA
SUVORK5CYII='! !

!SpiritIcons class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/18/2012 14:13'!
thumbupIcon
^Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self thumbupIconContents readStream)! !

!SpiritIcons class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/18/2012 14:13'!
thumbupIconContents
^'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAFXRFWHRDcmVhdGlvbiBUaW1l
AAfYAgENCCo+fjMaAAAAB3RJTUUH2AIBDQs0Ol2+ygAAAAlwSFlzAAALEgAACxIB0t1+/AAA
AAlQTFRF////enp6AAAAYwg/bAAAAAF0Uk5TAEDm2GYAAAA3SURBVHjaY2DACZgw+Ez4BZgY
MAQwFDAyAQGIDWQwMDEhJBiYGGGqoUpQjEMVIEsFkrVQgMXTADH2AHfksN3UAAAAAElFTkSu
QmCC'! !

!SpiritIcons class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/18/2012 14:18'!
wheelIcon
^Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self wheelIconContents readStream)! !

!SpiritIcons class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/18/2012 14:20'!
wheelIconContents
^'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAACUUlEQVR42n2TS0iUURTH77mf
QbqxhUg4agU+ytTBJB9lkcUQQwZTIEQSQe6qVS1mF0TQIhHaBC2jCMIgWgTaJD0oXEhaGJMx
UWQpGbQocszE795+d+YbU1IvnDvn+T/n/r8zotY4HdFoiJ+ZB/39P1fLkaVGNBLRSiRfWTsr
nj7keXn3cc/5Cwtl1pgfxAr6E4n0igAHD+wv1F5en4iESe4mEhPR3YSstea4sqpKtI4b418c
eDTY8x9ApH1fjdZ6DFUjBpknvD4btb+58p2CTPq+v3nw6TO7CNDetlvcAWCUMevX4oVxepkw
/vj5C5MB2NvaUkFhH3paRFXjKgpyZwEboqIYvS7XzCo7zjVD+w/G97ukrbkpTuFl4rKE0SRm
B57P2a6mk6JbqOtU8A5uwzRl0tq4YzuVN/E0OAicxCU69HIkkUPbtbORgLqBeiIzRyZH9XGf
kqZwveAswv+GrsUBQmj49dh0DqApXOcoOgdwTwAwQM5hR7Y01ta0oNzBX66CCTido8nxezmA
hm3VEOzdBeRoAOCe8QTtiBA8j3JlkaTMdGoSpmPGmFd44dg7TfFVcR3+ETWPWSrh6soQJPUC
6b5/M1IWgLgrhWxA3JeQgOZhZAIrhX0h46mt2CJ0dES9xaxadQeyY16n+Gzy4yezbBO3bioN
M/+IzU4yh/xBCoPwd6QogyHqGysXejfxxS4DqCotKWDPr6HuYbRjAJ0k/4wrwo45AJ52SYuO
p6a+3l7x3+hOZclGcRyzJu0APsT1S3teOSBpx8H7qWm7NP8vZwnoZZ2y5tcAAAAASUVORK5C
YII='! !

Object subclass: #SpiritModelManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!SpiritModelManager class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/27/2012 10:44'!
getAllModels
^"#('Sistema A' 'Sistema B' 'Sistema C')"MooseModel root "allModelHistories".! !

Object subclass: #SpiritVisualizationPane
	instanceVariableNames: 'showAllHSCheckBox brainClassCheckBox brainMethodCheckBox dataClassCheckBox dispersedCouplingCheckBox featureEnvyCheckBox godClassCheckBox intensiveCouplingCheckBox refusedParentRequestCheckBox shotgunSurgeryCheckBox traditionBreakerCheckBox logicalArchitectureVisualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-UI'!

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 12:22'!
addCheckBoxesTo: panel
	traditionBreakerCheckBox:=self createCheckBoxWithName: 'Tradition Breaker' andAddTo:  panel.
	shotgunSurgeryCheckBox:=self createCheckBoxWithName: 'Shotgun Surgery' andAddTo:  panel.
	refusedParentRequestCheckBox:=self createCheckBoxWithName: 'Refused Parent Request' andAddTo:  panel.
	intensiveCouplingCheckBox:=self createCheckBoxWithName: 'Intensive Coupling' andAddTo:  panel.
	godClassCheckBox:=self createCheckBoxWithName: 'God Class' andAddTo:  panel.
	featureEnvyCheckBox:=self createCheckBoxWithName: 'Feature Envy' andAddTo:  panel.
	dispersedCouplingCheckBox:=self createCheckBoxWithName: 'Dispersed Coupling' andAddTo:  panel.
	dataClassCheckBox:=self createCheckBoxWithName: 'Data Class' andAddTo:  panel.
	brainMethodCheckBox:=self createCheckBoxWithName: 'Brain Method' andAddTo:  panel.
	brainClassCheckBox:=self createCheckBoxWithName: 'Brain Class' andAddTo:  panel.
	showAllHSCheckBox:=self createCheckBoxWithName: 'Show all code smells' andAddTo:  panel.
	
	showAllHSCheckBox visualizeHotSpot: true.
	showAllHSCheckBox checkBox updateSelection.! !

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 10:32'!
collectHSSelected
	|selectedHS|
	selectedHS:=OrderedCollection new.
	(showAllHSCheckBox checkBox isSelected) ifTrue:[
		selectedHS add: BrainClass.
		selectedHS add: BrainMethod.
		selectedHS add: DataClass.
		selectedHS add: DispersedCoupling.
		selectedHS add: FeatureEnvy.
		selectedHS add: GodClass.
		selectedHS add: IntensiveCoupling.
		selectedHS add: RefusedParentRequest.
		selectedHS add: ShotgunSurgery.
		selectedHS add: TraditionBreaker.
	] ifFalse:[
		(brainClassCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: BrainClass.
		].
		(brainMethodCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: BrainMethod.
		].
		(dataClassCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: DataClass.
		].
		(dispersedCouplingCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: DispersedCoupling.
		].
		(featureEnvyCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: FeatureEnvy.
		].
		(godClassCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: GodClass.
		].
		(intensiveCouplingCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: IntensiveCoupling.
		].
		(refusedParentRequestCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: RefusedParentRequest.
		].
		(shotgunSurgeryCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: ShotgunSurgery.
		].
		(traditionBreakerCheckBox checkBox isSelected) ifTrue:[
			selectedHS add: TraditionBreaker.
		].
	].
	^selectedHS! !

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 12:20'!
createCheckBoxWithName: aString andAddTo:pane
	|cb1 scb|
	scb:=SpiritHSCheckBox new.
	scb parentPanel: self.

	cb1:="CheckboxMorph new"(CheckboxMorph 
									on: scb
									selected: #visualizeHotSpot
									changeSelected: #visualizeHotSpot:).
	cb1 beCheckbox.
	cb1 label:aString.
	cb1 height:30.
	pane addMorph:cb1.
	scb checkBox: cb1.
	
	
	^scb! !

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/18/2012 10:56'!
openBrowser
	| browser panelMorph scrollPane|
	panelMorph:= PanelMorph new.
	
	panelMorph layoutPolicy: TableLayout new;
	listDirection: #topToBottom";
	wrapDirection:  #rightToLeft".
	panelMorph hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	scrollPane := GeneralScrollPane new.
	scrollPane 
		changeScrollerTableLayout;
		scrollTarget: panelMorph.
	
	self addCheckBoxesTo: panelMorph.
	
	
	
	browser := GLMTabulator new.
	browser column: #list size: 210; column: #preview.
	"browser title: 'Glamorous Icons'."
	

	browser transmit to: #list; andShow: [ :a | 
		a morph
			"title: ['Select Code Smells'];"
			display: [:symbol | "panelMorph"scrollPane
				 ]
	].

browser transmit "from:#list;" to: #preview; andShow: [:a | 
	"a list display: [#('Metodo 1' 'Metodo 2' 'Metodo 3' 'Variable 1')]"
	a roassal
                       "title: 'Visualization';"
                       painting: [:view :input| 
					|hm|
					
				
					hm:=(input at: 2) new .
					
					hm codeSmellsToVisualize: self collectHSSelected.
					hm mooseModel: (input at: 1).
					hm createVisualizationIn: view.
					logicalArchitectureVisualization:=hm.
					
				]  
].
	^browser"
browser openOn: MooseModel root allModels allModelClasses."! !

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 10:42'!
theHSSelectedChange: theSpiritHSCheckBoxChanged
	(theSpiritHSCheckBoxChanged=showAllHSCheckBox) ifTrue: [
		self updateCheckBoxEnable: (showAllHSCheckBox checkBox isSelected not).
	].
	self updateVisualization: (self collectHSSelected).! !

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/12/2012 11:19'!
updateCheckBoxEnable: aEnableValue
	brainClassCheckBox checkBox enabled: aEnableValue. 
	brainMethodCheckBox checkBox enabled: aEnableValue.
	dataClassCheckBox checkBox enabled: aEnableValue.
	dispersedCouplingCheckBox checkBox enabled: aEnableValue.
	featureEnvyCheckBox checkBox enabled: aEnableValue.
	godClassCheckBox checkBox enabled: aEnableValue.
	intensiveCouplingCheckBox checkBox enabled: aEnableValue.
	refusedParentRequestCheckBox checkBox enabled: aEnableValue.
	shotgunSurgeryCheckBox checkBox enabled: aEnableValue.
	traditionBreakerCheckBox checkBox enabled: aEnableValue.! !

!SpiritVisualizationPane methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 16:19'!
updateVisualization: hotSpotsToBeDetected
	(logicalArchitectureVisualization =nil) ifFalse:[
		logicalArchitectureVisualization codeSmellsToVisualize: hotSpotsToBeDetected.
		logicalArchitectureVisualization updateColors.
	]! !

Object subclass: #StatisticalThresholds
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Util'!

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:06'!
CallNONAvg
	^2.6.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:05'!
CallNONHigh
	^3.2.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:07'!
CallNONLow
	^2.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:07'!
FoutCallAvg
	^0.63.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:10'!
FoutCallHigh
	^0.69.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:09'!
FoutCallLow
	^0.57.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:01'!
LOCNONAvg
	^9.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:01'!
LOCNONHigh
	^13.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:01'!
LOCNONLow
	^6.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:11'!
NDDAvg
	^0.41.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:11'!
NDDHigh
	^0.6.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:10'!
NDDLow
	^0.20.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:02'!
NONNOCAvg
	^7.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:02'!
NONNOCHigh
	^9.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:03'!
NONNOCLow
	^4.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:03'!
NONNOPAvg
	^15.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:04'!
NONNOPHigh
	^24.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:03'!
NONNOPLow
	^6.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:00'!
cycloLOCAvg
	^0.21.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 12:00'!
cycloLOCHigh
	^0.25.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:59'!
cycloLOCLow
	^0.17.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:36'!
hitAvg
	^0.21.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:37'!
hitHigh
	^0.3.! !

!StatisticalThresholds class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:36'!
hitLow
	^0.1.! !

Object subclass: #Threshold
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit-Util'!

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:45'!
AMWAvg
	^ StatisticalThresholds cycloLOCAvg *  StatisticalThresholds LOCNONAvg.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:44'!
LOCClassVeryHigh
	^ StatisticalThresholds LOCNONHigh *  StatisticalThresholds NONNOCHigh * self outlierFactor.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:43'!
LOCVeryHigh
	^ StatisticalThresholds LOCNONHigh *  StatisticalThresholds NONNOCHigh *(self outlierFactor -1.0).! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:42'!
NOMAvg
	^ StatisticalThresholds NONNOCAvg.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:42'!
NOMHigh
	^ StatisticalThresholds NONNOCHigh.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:40'!
WMCAvg
	^ StatisticalThresholds cycloLOCAvg * StatisticalThresholds LOCNONAvg * StatisticalThresholds NONNOCAvg.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:41'!
WMCHigh
	^ StatisticalThresholds cycloLOCHigh * StatisticalThresholds LOCNONHigh * StatisticalThresholds NONNOCHigh.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/20/2012 09:41'!
WMCVeryHigh
	^ self WMCHigh * self outlierFactor.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:56'!
deep
	^3.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:55'!
few
	^2.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:57'!
half
	^0.5! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:56'!
many
	^4.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:54'!
none
	^0.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:56'!
oneQuarter
	^0.25.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:57'!
oneThird
	^0.333.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:58'!
outlierFactor
	^1.5.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:56'!
sMemCap
	^7.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:55'!
shallow
	^1.! !

!Threshold class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 2/17/2012 11:57'!
twoThirds
	^0.666! !

Object subclass: #UniClassPattern
	instanceVariableNames: 'hits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

UniClassPattern subclass: #ComplexityAndDependenceRelationship
	instanceVariableNames: 'grewInComplexity grewComplexityAndDependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

ComplexityAndDependenceRelationship subclass: #ComplexityAndDependenceClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!ComplexityAndDependenceClass methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/15/2011 10:28'!
isDependencieBiggerForCurrentClass: currentClassVersion andPreviousClass: previousClassVersion
|currentDependence previuosDependence|
currentDependence:=currentClassVersion queryAllOutgoingDependencies atClassScope size. 
		previuosDependence:=previousClassVersion queryAllOutgoingDependencies atClassScope size.
		(currentDependence>previuosDependence)ifTrue:[
			^ true.	
		].
	^ false.! !

ComplexityAndDependenceRelationship subclass: #ComplexityAndDependenceGeneral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!ComplexityAndDependenceGeneral methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/15/2011 10:01'!
isDependencieBiggerForCurrentClass: currentClassVersion andPreviousClass: previousClassVersion
|currentDependence previuosDependence|
currentDependence:=currentClassVersion queryAllOutgoingDependencies size. 
		previuosDependence:=previousClassVersion queryAllOutgoingDependencies size.
		(currentDependence>previuosDependence)ifTrue:[
			^ true.	
		].
	^ false.! !

ComplexityAndDependenceRelationship subclass: #ComplexityAndDependenceLOC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!ComplexityAndDependenceLOC methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/15/2011 10:02'!
isDependencieBiggerForCurrentClass: currentClassVersion andPreviousClass: previousClassVersion
|currentDependence previuosDependence|
		currentDependence:=#numberOfLinesOfCode value:currentClassVersion. 
		previuosDependence:=#numberOfLinesOfCode value: previousClassVersion.
		(currentDependence>previuosDependence)ifTrue:[
			^ true.
		].
	^ false.! !

ComplexityAndDependenceRelationship subclass: #ComplexityAndDependenceNamespace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!ComplexityAndDependenceNamespace methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/15/2011 10:28'!
isDependencieBiggerForCurrentClass: currentClassVersion andPreviousClass: previousClassVersion
|currentDependence previuosDependence|
currentDependence:=currentClassVersion queryAllOutgoingDependencies atNamespaceScope size. 
		previuosDependence:=previousClassVersion queryAllOutgoingDependencies atNamespaceScope size.
		(currentDependence>previuosDependence)ifTrue:[
			^ true.	
		].
	^ false.! !

!ComplexityAndDependenceRelationship methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:53'!
class: classHistory grewsInComplexityAndDependenceInVersion: lastVersion
|currentComplexity previousComplexity currentClassVersion previousClassVersion currentDependence previuosDependence|

	currentClassVersion:=(classHistory versions at: lastVersion).
	previousClassVersion:=(classHistory versions at: (lastVersion-1)).
	currentComplexity:=currentClassVersion weightedMethodCount.
	previousComplexity:=previousClassVersion weightedMethodCount.
	(currentComplexity>previousComplexity) ifTrue:[
		grewInComplexity:=grewInComplexity+1.
		(self isDependencieBiggerForCurrentClass: currentClassVersion andPreviousClass: previousClassVersion) ifTrue:[
			grewComplexityAndDependencies:=grewComplexityAndDependencies+1.
			^true
		].
		
	].
^false.! !

!ComplexityAndDependenceRelationship methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 13:56'!
hitsInAVersion: modelVersion
|ret|
ret:=OrderedCollection new.
hits do:[:classHistoryVersion|
	((classHistoryVersion referenceVersion)=modelVersion) ifTrue: [
					ret add:classHistoryVersion.
					]. 	
	].
^ ret.! !

!ComplexityAndDependenceRelationship methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 13:52'!
initialize
	super initialize.
	grewInComplexity:=0.
	grewComplexityAndDependencies:=0.! !

!ComplexityAndDependenceRelationship methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:52'!
isDependencieBiggerForCurrentClass: currentClassVersion andPreviousClass: previousClassVersion
	^self subclassResponsibility.! !

!ComplexityAndDependenceRelationship methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/15/2011 10:09'!
printResults
"Transcript show:'Hits for MostComplexClasses';cr. 
Transcript show:'Number of time in which the complexity grew ',grewInComplexity asString;cr. 
Transcript show:'Number of time in which the complexity and the dependencies grew together ',grewComplexityAndDependencies asString;cr.
 
hits do:[:classHistoryVersion|
	Transcript show: classHistoryVersion versionName,' ', classHistoryVersion referenceVersion versionName; cr.
	].
Transcript show: '';cr;cr."
Transcript show:'Hits for ',self name;cr. 
Transcript show:'Number of time in which the complexity grew ',grewInComplexity asString;cr. 
Transcript show:'Number of time in which the complexity and the dependencies grew together ',grewComplexityAndDependencies asString;cr.
(grewInComplexity>0) ifTrue:[Transcript show:'Percentage ',((grewComplexityAndDependencies*100)/grewInComplexity) asFloat asString;cr. ]. ! !

!ComplexityAndDependenceRelationship methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 13:57'!
searchForHitsInHistory: hismoModel
"This method looks for those versions of a class in which the complexity of the class increases as well as the dependences"
|classesHistories|
classesHistories:=hismoModel allClassHistories select: [:each | each last isStub not].

classesHistories do:[:classHistory | 
	"Transcript show:(classHistory name);cr."
	(classHistory versions size>1)ifTrue: [ 
		2 to: (classHistory versions size) do:[:i|
			(self class: classHistory grewsInComplexityAndDependenceInVersion:i) ifTrue:[hits add:(classHistory versions at:i).].
		].
	]. 
].! !

UniClassPattern subclass: #DeadClassMilestone
	instanceVariableNames: 'versionsDead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!DeadClassMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/12/2011 10:33'!
class: classHistory isDeadSinceVersion: numberOfVersionsDead startingAt: lastVersion
"This method checks if a class has changed in the last X (numberOfVersionsDead) versions starting at a specific version"
|currentLOC versionLOC|
	"(classHistory versions size >numberOfVersionsDead) 
	ifTrue: ["
		"self halt."
		currentLOC:=#numberOfLinesOfCode value: (classHistory versions at: lastVersion).
		1 to: numberOfVersionsDead do: [ :i |
			"self halt."
      		versionLOC := #numberOfLinesOfCode value: (classHistory versions at: (lastVersion-i)).
			(currentLOC-versionLOC~=0) ifTrue:[^false.].
    		].
		^ true.
		"] 
	ifFalse: [^false.]" ! !

!DeadClassMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 10:25'!
hitsInAVersion: modelVersion
|ret|
ret:=OrderedCollection new.
hits do:[:classHistoryVersion|
	((classHistoryVersion referenceVersion)=modelVersion) ifTrue: [
					ret add:classHistoryVersion.
					]. 	
	].
^ ret.! !

!DeadClassMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:08'!
initialize
	super initialize.
	versionsDead:=55.! !

!DeadClassMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:32'!
printResults
Transcript show:'Hits for DeadClass with versionsDead=',versionsDead asString;cr.  
hits do:[:classHistoryVersion|
	Transcript show: classHistoryVersion versionName,' ', classHistoryVersion referenceVersion versionName; cr.
	].
Transcript show: '';cr;cr.! !

!DeadClassMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:38'!
searchForHitsInHistory: hismoModel
"This method looks for all the versions of the classes in which a class was not changed in the last X versions"
|classesHistories|
classesHistories:=hismoModel allClassHistories select: [:each | each last isStub not].

classesHistories do:[:classHistory | 
	"Transcript show:(classHistory name);cr."
	(versionsDead<classHistory versions size)ifTrue: [ 
		(versionsDead+1) to: (classHistory versions size) do:[:i|
			(self class: classHistory isDeadSinceVersion: versionsDead startingAt:i) ifTrue:[hits add:(classHistory versions at:i).].
		].
	]. 
	
].! !

!DeadClassMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/3/2011 13:28'!
setVersionsDead: numberOfVersions
	versionsDead:=numberOfVersions.! !

UniClassPattern subclass: #MostComplexClasses
	instanceVariableNames: 'percentageOfComplexClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/13/2011 14:33'!
getClassEntityVersion: famixClass forHismoModel: model andVersion:version
|classesHistories|
	classesHistories:=model allClassHistories select: [:each | each last isStub not].
	classesHistories do:[:classHistory|
		"Transcript show: classHistory name;cr."
		(classHistory name=famixClass name) ifTrue: [
			(classHistory versions) do:[:classHistoryVersion|
				((classHistoryVersion referenceVersion)=version) ifTrue: [
					^ classHistoryVersion.
					]. 	
				]
			].		
	].
^ nil.! !

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 10:25'!
hitsInAVersion: modelVersion
|ret|
ret:=OrderedCollection new.
hits do:[:classHistoryVersion|
	((classHistoryVersion referenceVersion)=modelVersion) ifTrue: [
					ret add:classHistoryVersion.
					]. 	
	].
^ ret.! !

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:08'!
initialize
	super initialize.
	percentageOfComplexClasses:=5.! !

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:33'!
printResults
Transcript show:'Hits for MostComplexClasses with percentageOfComplexClasses=',percentageOfComplexClasses asString;cr.  
hits do:[:classHistoryVersion|
	Transcript show: classHistoryVersion versionName,' ', classHistoryVersion referenceVersion versionName; cr.
	].
Transcript show: '';cr;cr.! !

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:39'!
searchForHitsInHistory: hismoModel
"This method looks for all the versions of the classes in which a class was in the X% of the most complex classes. To know the complexity of a class weightedMethodCount is used"
|classesHistoriesForAVersion cyclomaticComplexityOfClasses totalOfMostComplexClasses complexClassesDictionary auxSmaller auxCurrentComplexityValue|


"Transcript show:(hismoModel versions size). "
hismoModel versions do:[:modelVersion|
	
	classesHistoriesForAVersion:=(modelVersion allClasses select: [:each | each isStub not]).
	totalOfMostComplexClasses:=((percentageOfComplexClasses*100)/(classesHistoriesForAVersion size)) asInteger.
	complexClassesDictionary:=SmallDictionary new.

	cyclomaticComplexityOfClasses:=OrderedCollection new.
	classesHistoriesForAVersion do:[:specificClassForAVersion|
		"Transcript  show: (specificClassForAVersion name);cr."
		"Transcript  show: (specificClassForAVersion weightedMethodCount);cr."
		auxCurrentComplexityValue:=specificClassForAVersion weightedMethodCount.
		(complexClassesDictionary size==totalOfMostComplexClasses) ifTrue: [
			"If the weightedMethodCount of this class is greater than the smaller value in the dictionary remove the latter and put the former"
			
			auxSmaller:=self smallerClassOfComplexity: complexClassesDictionary.
			((complexClassesDictionary at:auxSmaller)<auxCurrentComplexityValue) ifTrue:[
				complexClassesDictionary removeKey:auxSmaller.
				complexClassesDictionary at: specificClassForAVersion put:auxCurrentComplexityValue.
				].
			] ifFalse: [complexClassesDictionary at: specificClassForAVersion put:auxCurrentComplexityValue].
	].
	
	complexClassesDictionary keys do:[:aKey| hits add: (self getClassEntityVersion: aKey forHismoModel: hismoModel andVersion: modelVersion)].
].! !

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/5/2011 12:54'!
setPercentageOfComplexClasses: percentage
	percentageOfComplexClasses:=percentage.! !

!MostComplexClasses methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/12/2011 16:52'!
smallerClassOfComplexity:aDictionary
|smallerValue smallerClass|
smallerValue:=1000000.
aDictionary keys do:[:aKey| 
	((aDictionary at:aKey)<smallerValue)ifTrue:[
		smallerValue:=aDictionary at:aKey.
		smallerClass:=aKey.
	].
].
^smallerClass.
! !

UniClassPattern subclass: #SupernovaMilestone
	instanceVariableNames: 'percentageOfChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spirit'!

!SupernovaMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/13/2011 11:46'!
class: classHistory grewAsSupernovaInVersion: lastVersion
|currentLOC previousLOC percentageChanged|
currentLOC:=#numberOfLinesOfCode value: (classHistory versions at: lastVersion).
previousLOC:=#numberOfLinesOfCode value: (classHistory versions at: (lastVersion-1)).
(previousLOC==0)ifTrue:[^false.].
percentageChanged:=((currentLOC*100)/previousLOC)asInteger.
(percentageChanged>percentageOfChange) ifTrue: [^true.] ifFalse: [^false.] 
! !

!SupernovaMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 10:25'!
hitsInAVersion: modelVersion
|ret|
ret:=OrderedCollection new.
hits do:[:classHistoryVersion|
	((classHistoryVersion referenceVersion)=modelVersion) ifTrue: [
					ret add:classHistoryVersion.
					]. 	
	].
^ ret.! !

!SupernovaMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:07'!
initialize
	super initialize.
	percentageOfChange:=140.! !

!SupernovaMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:34'!
printResults
Transcript show:'Hits for Supernova with percentageOfChange=',percentageOfChange asString;cr.  
hits do:[:classHistoryVersion|
	Transcript show: classHistoryVersion versionName,' ', classHistoryVersion referenceVersion versionName; cr.
	].
Transcript show: '';cr;cr.! !

!SupernovaMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:39'!
searchForHitsInHistory: hismoModel
"This method looks for those versions of a class in which the class grows more than X% between to continuos versions"
|classesHistories|
classesHistories:=hismoModel allClassHistories select: [:each | each last isStub not].

classesHistories do:[:classHistory | 
	"Transcript show:(classHistory name);cr."
	(classHistory versions size>1)ifTrue: [ 
		2 to: (classHistory versions size) do:[:i|
			(self class: classHistory grewAsSupernovaInVersion:i) ifTrue:[hits add:(classHistory versions at:i).].
		].
	]. 
].! !

!SupernovaMilestone methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/13/2011 09:50'!
setPercentageOfChange: percentage
	percentageOfChange:=percentage. ! !

!UniClassPattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 10:18'!
hitsInAVersion: modelVersion
^self subclassResponsibility.! !

!UniClassPattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 11/14/2011 14:10'!
initialize
	hits:=OrderedCollection new.! !

!UniClassPattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:33'!
printResults
^self subclassResponsibility.! !

!UniClassPattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:35'!
results
^hits.! !

!UniClassPattern methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 10/17/2011 09:32'!
searchForHitsInHistory: hismoModel
^self subclassResponsibility. ! !
